SystemOrganization addCategory: #'Widgets-Text'!
SystemOrganization addCategory: #'Widgets-Core'!
SystemOrganization addCategory: #'Widgets-Support'!
SystemOrganization addCategory: #'Widgets-Views'!
SystemOrganization addCategory: #'Widgets-Views-Models'!
SystemOrganization addCategory: #'Widgets-Views-Support'!
SystemOrganization addCategory: #'Widgets-Dialogs'!
SystemOrganization addCategory: #'Widgets-Sandbox'!
SystemOrganization addCategory: #'Widgets-Sandbox-Tests'!
SystemOrganization addCategory: #'Widgets-Tests'!

DockingBarMorph subclass: #UiWorldToolbar
	instanceVariableNames: 'backgroundColor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Dialogs'!

!UiWorldToolbar class methodsFor: 'as yet unclassified' stamp: 'mt 12/14/2010 12:05:58.9'!
open

	(World submorphs detect: [:m | m isKindOf: self] ifNone: [])
		ifNotNil: [:tool | tool updateButtons].
		
	self new openInWorld.! !

!UiWorldToolbar methodsFor: 'private' stamp: 'mt 12/14/2010 13:12:26.718'!
definitions

	^ {
	{'Save'. UiSilkIcons diskIcon. Smalltalk. #saveSession. #iconOnly}.
	{'Quit'. UiSilkIcons doorInIcon. self. #quitSession. #iconOnly}.
	nil.
	{'Workspace'. UiSilkIcons applicationXpTerminalIcon. Workspace. #open. #iconOnly}.
	{'Transcript'. UiSilkIcons applicationViewListIcon. Transcript. #open. #iconOnly}.
	{'System Browser'. UiSilkIcons folderExploreIcon. Smalltalk at: #OBSystemBrowser ifAbsent: []. #open. #iconOnly}.
	{'Monticello Browser'. UiSilkIcons worldIcon. MCWorkingCopyBrowser. #open. #iconOnly}.
	{'Test Runner'. UiFugueIcons clipboardTaskIcon. "UiFugueIcons tickShieldIcon." TestRunner. #open. #iconOnly}.
	{'Preferences'. UiSilkIcons cogIcon. PreferenceBrowser. #open. #iconOnly}.
	nil.
	{'Start Profiler'. UiFugueIcons alarmClockSelectIcon. self. #startMessageTally. #iconOnly}.
	{'Collect Garbage'. UiFugueIcons broomIcon. Smalltalk. #garbageCollect. #iconOnly}.
	{'Close all debuggers'. UiSilkIcons bugDeleteIcon. Utilities. #closeAllDebuggers. #iconOnly}.
	{'Set author initials.'. UiSilkIcons vcardEditIcon. Utilities. #setAuthorInitials. #iconOnly}.
	nil.
	{'Morphic Designer'. UiFugueIcons leafIcon. Smalltalk at: #UiDesigner ifAbsent: []. #open. #iconOnly}.
	{'Ressource Monitor'. UiSilkIcons chartBarIcon. Smalltalk at: #UiRessourceMonitorDialog ifAbsent: []. #open. #iconOnly}.
	{'Icon Picker'. UiSilkIcons folderHeartIcon. Smalltalk at: #UiIconPickerDialog ifAbsent: []. #open. #iconOnly}.
	nil.
	{'Refresh Toolbar'. UiSilkIcons arrowRefreshSmallIcon. self. #updateButtons. #iconOnly}.
	{'Help Browser'. UiSilkIcons helpIcon. Smalltalk at: #HelpBrowser ifAbsent: []. #open. #iconOnly}.
	}! !

!UiWorldToolbar methodsFor: 'drawing' stamp: 'mt 12/14/2010 11:11:48.44'!
drawOn: aCanvas

	super drawOn: aCanvas.
	aCanvas
		line: self topLeft
		to: self topRight
		width: 1
		color: self color muchDarker.! !

!UiWorldToolbar methodsFor: 'initialization' stamp: 'mt 12/14/2010 13:19:48.174'!
initialize

	super initialize.
	
	self
		vResizing: #shrinkWrap;
		borderWidth: 0;
		color: (Color gray: 0.80);
		height: 22;
		layoutInset: (0@1 corner: 0@0);
		cellInset: 5.
	
	self updateButtons.! !

!UiWorldToolbar methodsFor: 'private' stamp: 'mt 12/14/2010 11:42:58.901'!
quitSession

	Smalltalk
		snapshot: (UserDialogBoxMorph 
			confirm: 'Save changes before quitting?' translated 
			orCancel: [^ self]
			at: World center)
		andQuit: true! !

!UiWorldToolbar methodsFor: 'private' stamp: 'mt 12/14/2010 11:28:49.808'!
separator

	^ UiContainer new
		borderStyle: (BorderStyle inset width: 1);
		vResizing: #spaceFill;
		hResizing: #rigid;
		layoutInset: 0;
		cellInset: 0;
		width: 2! !

!UiWorldToolbar methodsFor: 'private' stamp: 'mt 12/14/2010 11:37:28.37'!
startMessageTally
	(self confirm: 'MessageTally will start now,
and stop when the cursor goes
to the top of the screen') ifTrue:
		[MessageTally spyOn:
			[[Sensor peekMousePt y > 0] whileTrue: [World doOneCycle]]]! !

!UiWorldToolbar methodsFor: 'private' stamp: 'mt 12/14/2010 12:03:04.555'!
updateButtons

	| group |
	self removeAllMorphs.

	self definitions do: [:definition |
		| button |
		definition
			ifNil: [self addMorphBack: group; addMorphBack: self separator. group := nil.]
			ifNotNil: [
				group ifNil: [group := UiContainer new changeTableLayout; listDirection: #leftToRight; hResizing: #shrinkWrap; vResizing: #shrinkWrap; layoutInset: 0; cellInset: 0.].
				button := UiToolButton new
					text: definition first;
					icon: definition second;
					layoutInset: (2@2 corner: 2@2);
					balloonText: definition first;
					buttonStyle: definition fifth;
					autoRaise: true.
				
				definition third
					ifNil: [button enabled: false]
					ifNotNil: [:receiver | self connect: button signal: #clicked: to: definition third selector: definition fourth].
				group addMorphBack: button]].
		
	self addMorphBack: group.! !

!UiWorldToolbar methodsFor: 'private' stamp: 'mt 12/14/2010 13:31:12.683'!
updateColor

	"No change here."! !

!OrderedCollection methodsFor: '*widgets-support' stamp: 'mt 10/9/2010 15:41:33.496'!
reverseDetect: aBlock

	^ self reverseDetect: aBlock ifNone: [self errorNotFound: aBlock]! !

!OrderedCollection methodsFor: '*widgets-support' stamp: 'mt 10/9/2010 15:41:12.167'!
reverseDetect: aBlock ifNone: exceptionBlock

	self reverseDo: [:each | (aBlock value: each) ifTrue: [^ each]].
	^ exceptionBlock value	! !

!Morph class methodsFor: '*widgets-designer' stamp: 'mt 2/12/2011 12:26:11.435'!
isExperimentalWidgetClass
	"Indicate whether this widget CAN NOT be expected as feature-complete and stable and therefore SHOULD NOT BE USED."
	
	^ false! !

!Morph class methodsFor: '*widgets-designer' stamp: 'mt 6/28/2010 21:31:27.001'!
isWidgetClass

	^ false! !

!Morph class methodsFor: '*widgets-designer' stamp: 'mt 10/19/2010 13:31:11.159'!
widgetCategory
	
	^ 'Classic Morphs'! !

!Morph class methodsFor: '*widgets-designer' stamp: 'mt 10/19/2010 11:46:11.254'!
widgetClassIcon

	^ nil! !

!Morph class methodsFor: '*widgets-designer' stamp: 'mt 10/19/2010 13:38:38.799'!
widgetClassName

	^ self name! !

!Morph class methodsFor: '*widgets-designer' stamp: 'mt 10/28/2010 16:54:01.158'!
widgetProperties
	"Describe custom properties for this type of widget."
	
	^ {{'Morph'. #yourself} -> {
		#balloonText -> String.
		#balloonColor -> Object}}! !

!Morph class methodsFor: '*widgets-designer' stamp: 'mt 7/16/2010 11:22:50.821'!
widgetPropertiesToIgnore
	"Describe properties that should not appear in the designer."
	
	^ #()! !

!Morph methodsFor: '*widgets' stamp: 'mt 10/28/2010 16:50:18.038'!
balloonText: stringOrText

	^ self setBalloonText: stringOrText! !

!Morph methodsFor: '*widgets' stamp: 'mt 10/27/2010 20:21:50.604'!
frameFractions

	self layoutFrame ifNil: [^ 0@0 corner: 1@1].
	^ self layoutFrame leftFraction @ self layoutFrame topFraction
		corner:
		self layoutFrame rightFraction @ self layoutFrame bottomFraction! !

!Morph methodsFor: '*widgets' stamp: 'mt 10/27/2010 20:29:01.842'!
frameFractions: aRectangle

	| frame |
	frame := self layoutFrame ifNil: [LayoutFrame new].
	frame
		topFraction: aRectangle top;
		bottomFraction: aRectangle bottom;
		leftFraction: aRectangle left;
		rightFraction: aRectangle right.
	self layoutFrame: frame.
	self layoutChanged.! !

!Morph methodsFor: '*widgets' stamp: 'mt 10/28/2010 10:48:13.066'!
frameOffsets

	self layoutFrame ifNil: [^ 0@0 corner: 0@0].
	^ (self layoutFrame leftOffset ifNil: [0]) @ (self layoutFrame topOffset ifNil: [0])
		corner:
		(self layoutFrame rightOffset ifNil: [0]) @ (self layoutFrame bottomOffset ifNil: [0])! !

!Morph methodsFor: '*widgets' stamp: 'mt 10/27/2010 20:28:56.456'!
frameOffsets: aRectangle

	| frame |
	frame := self layoutFrame ifNil: [LayoutFrame new].
	frame
		topOffset: aRectangle top;
		bottomOffset: aRectangle bottom;
		leftOffset: aRectangle left;
		rightOffset: aRectangle right.
	self layoutFrame: frame.
	self layoutChanged.! !

!Morph methodsFor: '*widgets-events' stamp: 'mt 2/26/2011 14:10:01.188'!
grabKeyboard

	self activeHand newKeyboardFocus: self.  ! !

!Morph methodsFor: '*widgets-events' stamp: 'mt 2/26/2011 14:10:23.137'!
grabMouse

	self activeHand newMouseFocus: self.! !

!Morph methodsFor: '*widgets-events' stamp: 'mt 2/26/2011 14:14:31.513'!
hasKeyboard

	^ self activeHand keyboardFocus = self! !

!Morph methodsFor: '*widgets-events' stamp: 'mt 2/26/2011 14:14:44.687'!
hasMouse

	^ self activeHand mouseFocus = self! !

!Morph methodsFor: '*widgets' stamp: 'mt 10/27/2010 20:38:40.152'!
isUiContainer

	^ false! !

!Morph methodsFor: '*widgets-events-override' stamp: 'mt 2/26/2011 13:51:41.519'!
keyDown: anEvent
	"Handle a key down event. "
	
	self eventHandler isEventHandler
		ifTrue: [self eventHandler keyDown: anEvent fromMorph: self].! !

!Morph methodsFor: '*widgets-events-override' stamp: 'mt 2/26/2011 13:51:26.514'!
keyUp: anEvent
	"Handle a key up event. "
	
	self eventHandler isEventHandler
		ifTrue: [self eventHandler keyUp: anEvent fromMorph: self].! !

!Morph methodsFor: '*widgets-events-override' stamp: 'mt 2/26/2011 14:03:16.929'!
keyboardFocusChange: aBoolean
	"The message is sent to a morph when its keyboard focus change. The given argument indicates that the receiver is gaining keyboard focus (versus losing) the keyboard focus. Morphs that accept keystrokes should change their appearance in some way when they are the current keyboard focus."
	
	self eventHandler isEventHandler
		ifTrue: [self eventHandler keyboardFocusChange: aBoolean fromMorph: self].! !

!Morph methodsFor: '*widgets-events-override' stamp: 'mt 2/26/2011 13:46:30.171'!
mouseDown: evt 
	"Overridden to suppress #yellowButtonActivity for specific event handlers."

	self eventHandler isEventHandler
		ifTrue: [^ self eventHandler mouseDown: evt fromMorph: self].

	evt yellowButtonPressed
		ifTrue: ["First check for option (menu) click"
			^ self yellowButtonActivity: evt shiftPressed].
	self eventHandler
		ifNotNil: [self eventHandler mouseDown: evt fromMorph: self]
! !

!Morph methodsFor: '*widgets-events-override' stamp: 'mt 2/26/2011 14:27:52.602'!
mouseDownPriority
	"Return the default mouse down priority for the receiver"

	self eventHandler isEventHandler
		ifTrue: [^ self eventHandler mouseDownPriority].

	^ (self isPartsDonor or: [self isPartsBin])
		ifTrue:	[50]
		ifFalse:	[0]

	"The above is a workaround for the complete confusion between parts donors and parts bins. Morphs residing in a parts bin may or may not have the parts donor property set; if they have they may or may not actually handle events. To work around this, parts bins get an equal priority to parts donors so that when a morph in the parts bin does have the property set but does not handle the event we still get a copy from picking it up through the parts bin. Argh. This just *cries* for a cleanup."
	"And the above comment is Andreas's from 10/2000, which was formerly retrievable by a #flag: call which however caused a problem when trying to recompile the method from decompiled source."! !

!Morph methodsFor: '*widgets-events' stamp: 'mt 2/26/2011 14:11:25.922'!
releaseKeyboard

	self activeHand newKeyboardFocus: nil.! !

!Morph methodsFor: '*widgets-events' stamp: 'mt 2/26/2011 14:11:13.349'!
releaseMouse

	self activeHand newMouseFocus: nil.! !

Morph subclass: #UiAbstractSlider
	instanceVariableNames: 'currentValue minimum maximum orientation pageStep singleStep sliderDown sliderPosition tracking truncate'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Core'!

!UiAbstractSlider commentStamp: 'mt 2/11/2011 15:21:00.539' prior: 0!
This is a Squeak port of QAbstractSlider from the Nokia/Qt framework.!

!UiAbstractSlider methodsFor: 'accessing' stamp: 'mt 2/25/2011 10:44:02.309'!
currentValue

	^ currentValue ifNil: [0]! !

!UiAbstractSlider methodsFor: 'accessing' stamp: 'mt 2/25/2011 11:09:53.675'!
currentValue: aNumber

	| guardedValue |
	guardedValue := self guardedValue: aNumber.
	
	guardedValue = self currentValue ifTrue: [^ self].

	currentValue := guardedValue.
	
	self
		sliderChange: #valueChange;
		valueChanged: self currentValue.! !

!UiAbstractSlider methodsFor: 'actions' stamp: 'mt 2/26/2011 14:37:43.316'!
decreaseValueByPageStep

	self currentValue: self currentValue - self pageStep.  ! !

!UiAbstractSlider methodsFor: 'actions' stamp: 'mt 2/26/2011 14:37:32.985'!
decreaseValueBySingleStep

	self currentValue: self currentValue - self singleStep.  ! !

!UiAbstractSlider methodsFor: 'guarding' stamp: 'mt 2/25/2011 11:15:26.423'!
guardedValue: aNumber

	^ (self truncate
		ifTrue: [aNumber ceiling asInteger]
		ifFalse: [aNumber])
		min: self maximum
		max: self minimum! !

!UiAbstractSlider methodsFor: 'testing' stamp: 'mt 2/11/2011 16:30:22.079'!
hasTracking
	"Is #valueChanged: being emitted while the slider is dragged?"
	
	^ tracking! !

!UiAbstractSlider methodsFor: 'actions' stamp: 'mt 2/26/2011 14:37:48.965'!
increaseValueByPageStep

	self currentValue: self currentValue + self pageStep.  ! !

!UiAbstractSlider methodsFor: 'actions' stamp: 'mt 2/26/2011 14:37:26.474'!
increaseValueBySingleStep

	self currentValue: self currentValue + self singleStep.  ! !

!UiAbstractSlider methodsFor: 'initialization' stamp: 'mt 3/5/2011 12:14:40.369'!
initialize

	super initialize.
	
	self
		color: Color transparent;
		tracking: true;
		orientation: #horizontal;
		extent: 100@14;
		minimum: 0;
		maximum: 100;
		pageStep: 10;
		currentValue: 0;
		sliderPosition: 0;
		singleStep: 1.! !

!UiAbstractSlider methodsFor: 'testing' stamp: 'mt 2/11/2011 16:19:29.364'!
isSliderDown

	^ sliderDown! !

!UiAbstractSlider methodsFor: 'accessing' stamp: 'mt 2/25/2011 10:44:12.921'!
maximum

	^ maximum ifNil: [0]! !

!UiAbstractSlider methodsFor: 'accessing' stamp: 'mt 2/25/2011 11:14:42.57'!
maximum: aNumber

	| guardedValue |
	guardedValue := self truncate
		ifTrue: [aNumber ceiling asInteger]
		ifFalse: [aNumber].
	
	guardedValue = self maximum ifTrue: [^ self].
	
	maximum := guardedValue.
	
	self
		sliderChange: #rangeChange;
		rangeChanged: self range.! !

!UiAbstractSlider methodsFor: 'accessing' stamp: 'mt 2/25/2011 10:44:17.153'!
minimum

	^ minimum ifNil: [0]! !

!UiAbstractSlider methodsFor: 'accessing' stamp: 'mt 2/25/2011 11:14:39.382'!
minimum: aNumber

	| guardedValue |
	guardedValue := self truncate
		ifTrue: [aNumber ceiling asInteger]
		ifFalse: [aNumber].
		
	guardedValue = self minimum ifTrue: [^ self].
	
	minimum := guardedValue.
	
	self
		sliderChange: #rangeChange;
		rangeChanged: self range.! !

!UiAbstractSlider methodsFor: 'accessing' stamp: 'mt 2/11/2011 15:30:01.97'!
orientation

	^ orientation! !

!UiAbstractSlider methodsFor: 'accessing' stamp: 'mt 2/11/2011 15:59:09.449'!
orientation: aSymbol
	"#horizontal, #vertical"

	aSymbol = self orientation ifTrue: [^ self].

	orientation := aSymbol.
	
	self sliderChange: #orientationChange.! !

!UiAbstractSlider methodsFor: 'accessing' stamp: 'mt 3/1/2011 14:22:00.471'!
pageStep

	^ pageStep ifNil: [0]! !

!UiAbstractSlider methodsFor: 'accessing' stamp: 'mt 2/27/2011 17:25:34.93'!
pageStep: anInteger

	| guardedValue |
	guardedValue := anInteger min: self maximum.
	
	guardedValue = self pageStep ifTrue: [^ self].

	pageStep := guardedValue.
	
	self sliderChange: #stepsChange.! !

!UiAbstractSlider methodsFor: 'accessing' stamp: 'mt 2/11/2011 15:47:10.587'!
range
	
	^ self minimum to: self maximum! !

!UiAbstractSlider methodsFor: 'accessing' stamp: 'mt 2/25/2011 11:14:31.742'!
range: anInterval

	| guardedValue |
	guardedValue := self truncate
		ifTrue: [anInterval first ceiling asInteger to: anInterval last ceiling asInteger]
		ifFalse: [anInterval].
		
	guardedValue = self range ifTrue: [^ self].
	
	minimum := guardedValue first.
	maximum := guardedValue last.
	
	self
		sliderChange: #rangeChange;
		rangeChanged: self range.! !

!UiAbstractSlider methodsFor: 'signals' stamp: 'mt 2/11/2011 15:42:27.109'!
rangeChanged: anInterval

	self emit.! !

!UiAbstractSlider methodsFor: 'actions' stamp: 'mt 2/26/2011 17:17:26.272'!
setValueToMaximum
	
	self currentValue: self maximum.  ! !

!UiAbstractSlider methodsFor: 'actions' stamp: 'mt 2/26/2011 17:17:18.761'!
setValueToMinimum
	
	self currentValue: self minimum.  ! !

!UiAbstractSlider methodsFor: 'accessing' stamp: 'mt 2/11/2011 15:30:02.221'!
singleStep

	^ singleStep! !

!UiAbstractSlider methodsFor: 'accessing' stamp: 'mt 2/11/2011 16:18:02.19'!
singleStep: anInteger

	anInteger = self singleStep ifTrue: [^ self].

	singleStep := anInteger.
	
	self sliderChange: #stepsChange.! !

!UiAbstractSlider methodsFor: 'updating' stamp: 'mt 3/5/2011 12:14:02.902'!
sliderChange: aSliderChange
	"This is a local callback. Possible values: #rangeChange, #orientationChange, #stepsChange, #valueChange"
	
	aSliderChange = #valueChange ifTrue: [
		self sliderPosition: self currentValue].
	
	aSliderChange = #rangeChange ifTrue: [
		self sliderPosition: self sliderPosition.
		self currentValue: self currentValue].
	
	aSliderChange = #orientationChange ifTrue: [
		self extent: self height @ self width].! !

!UiAbstractSlider methodsFor: 'accessing' stamp: 'mt 2/19/2011 14:13:04.16'!
sliderDown: aBoolean

	aBoolean = self isSliderDown ifTrue: [^ self].

	sliderDown := aBoolean.
	
	"Synchronize on slider release."
	aBoolean
		ifFalse: [self currentValue: self sliderPosition].
	
	aBoolean
		ifTrue: [self sliderPressed]
		ifFalse: [self sliderReleased].! !

!UiAbstractSlider methodsFor: 'signals' stamp: 'mt 2/11/2011 15:43:18.329'!
sliderMoved: anInteger

	self emit.! !

!UiAbstractSlider methodsFor: 'accessing' stamp: 'mt 2/25/2011 10:44:22.745'!
sliderPosition

	^ sliderPosition ifNil: [0]! !

!UiAbstractSlider methodsFor: 'accessing' stamp: 'mt 2/25/2011 11:10:16.198'!
sliderPosition: aNumber

	| guardedValue |
	guardedValue := self guardedValue: aNumber.
	
	guardedValue = self sliderPosition ifTrue: [^ self].
	
	sliderPosition := guardedValue.
	
	self hasTracking ifTrue: [
		self currentValue: self sliderPosition].
	
	self sliderMoved: self sliderPosition.! !

!UiAbstractSlider methodsFor: 'signals' stamp: 'mt 2/11/2011 15:43:27.704'!
sliderPressed

	self emit.! !

!UiAbstractSlider methodsFor: 'signals' stamp: 'mt 2/11/2011 15:43:33.933'!
sliderReleased

	self emit.! !

!UiAbstractSlider methodsFor: 'accessing' stamp: 'mt 2/27/2011 16:24:46.16'!
tracking
	
	^ tracking! !

!UiAbstractSlider methodsFor: 'accessing' stamp: 'mt 2/19/2011 11:11:08.734'!
tracking: aBoolean
	"Lock the #sliderPosition to the #currentValue."
	
	tracking := aBoolean.! !

!UiAbstractSlider methodsFor: 'accessing' stamp: 'mt 2/25/2011 11:05:58.445'!
truncate
	"Are only integer values allowed?"
	
	^ truncate ifNil: [true]! !

!UiAbstractSlider methodsFor: 'accessing' stamp: 'mt 2/25/2011 11:07:12.284'!
truncate: aBoolean

	aBoolean = truncate ifTrue: [^ self].

	truncate := aBoolean.
	
	self truncate ifTrue: [
		self
			range: self range;
			currentValue: self currentValue].! !

!UiAbstractSlider methodsFor: 'signals' stamp: 'mt 2/11/2011 15:43:43.887'!
valueChanged: anInteger

	self emit.! !

UiAbstractSlider subclass: #UiSlider
	instanceVariableNames: 'pagingMorph sliderButton mouseDownSliderPosition mouseDownEventPosition'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Core'!

!UiSlider commentStamp: 'mt 2/27/2011 16:32:16.852' prior: 0!
pagingMorph ... a simple morph in background that indicates the range of this slider
sliderButton ... a button that can be dragged to change the slider position and the current slider value

Used to compute the new slider position during the dragging operation:

mouseDownSliderPosition ... value of the slider when the mouseDown event occured
mouseDownEventPosition ... pixel position of the mouseDown event when it occured

Morphic stepping is used for automatic page-step moving.

[Hold Left Click] ... scroll by page step up to click position
[Shift] + [Left Click] ... jump to specific value!

UiSlider subclass: #UiScrollBar
	instanceVariableNames: 'decreaseValueButton1 decreaseValueButton2 increaseValueButton'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Core'!

!UiScrollBar commentStamp: 'mt 2/27/2011 16:31:15.05' prior: 0!
!!!!!! Rename to UiScrollBar !!!!!!

A scroll bar is like a slider that as additional buttons to modify the current value. In addition, the slider extent is changed with respect to the current scroll bar #extent, #orientation, and #pageStep.!

!UiScrollBar class methodsFor: 'accessing' stamp: 'mt 2/27/2011 16:19:57.856'!
widgetClassIcon

	^ UiFugueIcons uiScrollBarHorizontalIcon! !

!UiScrollBar class methodsFor: 'accessing' stamp: 'mt 2/27/2011 16:18:27.526'!
widgetClassName

	^ 'Scroll Bar'! !

!UiScrollBar methodsFor: 'actions' stamp: 'mt 3/2/2011 09:17:57.288'!
doSliderMovement: aMouseMoveEvent
	"Only allow integer steps with mouse dragging."
	
	| value |
	self isStepping
		ifTrue: [^ mouseDownEventPosition := aMouseMoveEvent position].
	
	value := self orientation = #horizontal
		ifTrue: [self pixelToValue: aMouseMoveEvent position x - mouseDownEventPosition x]
		ifFalse: [self pixelToValue: aMouseMoveEvent position y - mouseDownEventPosition y].

	self sliderPosition: mouseDownSliderPosition + (self truncate
		ifTrue: [value reduce asInteger]
		ifFalse: [value]).
		
	self raiseButtons.! !

!UiScrollBar methodsFor: 'drawing' stamp: 'mt 3/1/2011 12:18:08.438'!
drawOn: aCanvas

	super drawOn: aCanvas.
	
	aCanvas
		frameRectangle: self outerBounds
		width: 1
		color: self color darker.! !

!UiScrollBar methodsFor: 'actions' stamp: 'mt 3/2/2011 09:21:30.987'!
finishSliderMovement: aMouseEvent

	super finishSliderMovement: aMouseEvent.  
	
	(self innerBounds containsPoint: aMouseEvent position)
		ifFalse: [self flattenButtons].! !

!UiScrollBar methodsFor: 'actions' stamp: 'mt 3/1/2011 12:08:39.422'!
flattenButtons

	mouseDownEventPosition ifNotNil: [^ self].

	{decreaseValueButton1. decreaseValueButton2. increaseValueButton} do: [:btn |
		btn fadeOut].! !

!UiScrollBar methodsFor: 'initialization' stamp: 'mt 2/27/2011 16:54:58.404'!
initialize

	super initialize.

	self color: (Color gray: 0.85).
		
	self
		removeAllMorphs;
		addMorphBack: decreaseValueButton1;  
		addMorphBack: pagingMorph;
		addMorphBack: decreaseValueButton2;
		addMorphBack: increaseValueButton;    
		addMorphFront: sliderButton;
		flattenButtons.! !

!UiScrollBar methodsFor: 'initialization' stamp: 'mt 2/27/2011 15:29:36.672'!
initializeEventHandler

	super initializeEventHandler.
	
	self connect: self eventHandler signal: #mouseEntered: toSelector: #raiseButtons.
	self connect: self eventHandler signal: #mouseLeaved: toSelector: #flattenButtons.

	"Keyboard interaction."
	self eventHandler on: Character arrowDown send: #increaseValueBySingleStep to: self.
	self eventHandler on: Character arrowUp send: #decreaseValueBySingleStep to: self.
	
	self eventHandler on: Character pageUp send: #decreaseValueByPageStep to: self.
	self eventHandler on: Character pageDown send: #increaseValueByPageStep to: self.! !

!UiScrollBar methodsFor: 'initialization' stamp: 'mt 3/1/2011 12:23:26.363'!
initializeSupportMorphs

	pagingMorph := Morph new
		color: Color transparent;
		hResizing: #spaceFill;
		vResizing: #spaceFill.
			
	sliderButton := UiScrollBarSliderButton new.
	
	decreaseValueButton1 := UiScrollBarArrowButton new.
	self connect: decreaseValueButton1 signal: #pressed toSelector: #decreaseValueBySingleStep.
	decreaseValueButton2 := UiScrollBarArrowButton new.
	self connect: decreaseValueButton2 signal: #pressed toSelector: #decreaseValueBySingleStep.
	increaseValueButton := UiScrollBarArrowButton new.
	self connect: increaseValueButton signal: #pressed toSelector: #increaseValueBySingleStep.! !

!UiScrollBar methodsFor: 'actions' stamp: 'mt 2/26/2011 20:50:37.799'!
jumpToValue: aMouseEvent
	"Jumps to the value under the mouse cursor if shift was pressed."
	
	| value |
	aMouseEvent shiftPressed ifFalse: [^ self].
	
	self orientation = #horizontal
		ifTrue: [value := self pixelToValue: aMouseEvent position x - pagingMorph left - (sliderButton width / 2)]
		ifFalse: [value := self pixelToValue: aMouseEvent position y - pagingMorph top - (sliderButton height / 2)].
		
	self sliderPosition: value.! !

!UiScrollBar methodsFor: 'geometry' stamp: 'mt 2/27/2011 15:57:52.429'!
outerBounds

	^ self bounds outsetBy: 1  ! !

!UiScrollBar methodsFor: 'converting' stamp: 'mt 3/7/2011 10:47:49.775'!
preferredSliderSize
	"Like #valueToPixel. Ignores the extent of the slider button."

	| abs |
	abs := (self range extent = 0 or: [self pageStep = 0])
		ifFalse: [(self range extent / self pageStep) + 1]
		ifTrue: [1].
	
	self orientation = #horizontal
		ifTrue: [^ pagingMorph width / abs].
		
	self orientation = #vertical
		ifTrue: [^ pagingMorph height / abs].
		
	^ 0! !

!UiScrollBar methodsFor: 'actions' stamp: 'mt 3/1/2011 12:08:43.666'!
raiseButtons

	{decreaseValueButton1. decreaseValueButton2. increaseValueButton} do: [:btn |
		btn fadeIn].! !

!UiScrollBar methodsFor: 'updating' stamp: 'mt 2/27/2011 15:32:23.619'!
sliderChange: aSliderChange

	super sliderChange: aSliderChange.
	  
	"Slider button extent indicates pageStep."
	aSliderChange = #stepsChange
		ifTrue: [self updateSliderButton].! !

!UiScrollBar methodsFor: 'actions' stamp: 'mt 2/26/2011 19:59:15.607'!
startSliderMovement: aMouseEvent

	mouseDownEventPosition := aMouseEvent position.
	
	(sliderButton innerBounds containsPoint: aMouseEvent position) ifTrue: [
		"Start slider dragging."
		mouseDownSliderPosition := self sliderPosition.
		^ self sliderDown: true].
		
	(pagingMorph innerBounds containsPoint: aMouseEvent position)	 ifTrue: [
		"Start slider stepping."
		^ self startStepping].! !

!UiScrollBar methodsFor: 'stepping' stamp: 'mt 2/26/2011 20:51:22.19'!
step
	"Automatically move the slider page-step-wise."
	
	| value |
	mouseDownEventPosition ifNil: [^ self stopStepping].
	
	self orientation = #horizontal
		ifTrue: [value := self pixelToValue: mouseDownEventPosition x - pagingMorph left - (sliderButton width / 2)]
		ifFalse: [value := self pixelToValue: mouseDownEventPosition y - pagingMorph top - (sliderButton height / 2)].
		
	value < self sliderPosition
		ifTrue: [self sliderPosition: (self sliderPosition - self pageStep max: value)]
		ifFalse: [self sliderPosition: (self sliderPosition + self pageStep min: value)].! !

!UiScrollBar methodsFor: 'updating' stamp: 'mt 3/1/2011 11:45:40.791'!
updateSliderButton
	"Reposition the support morph for the slider to #sliderPosition."
	
	| pt |
	self sliderPosition ifNil: [^ self].
	
	sliderButton orientation: self orientation.
	
	self orientation = #horizontal	ifTrue: [
		sliderButton
			width: self preferredSliderSize;
			height: self height.

		pt := ((self valueToPixel: self sliderPosition)
			"Add the offset considering the current position."
			+ pagingMorph left + (sliderButton width / 2))
			@ self center y.
			
		sliderButton center: pt].
		
	self orientation = #vertical ifTrue: [
		sliderButton
			width: self width;
			height: self preferredSliderSize.
		
		pt := self center x @(
			(self valueToPixel: self sliderPosition)
			+ pagingMorph top
			+ (sliderButton height / 2)).
			
		sliderButton center: pt].! !

!UiScrollBar methodsFor: 'updating' stamp: 'mt 2/26/2011 19:42:21.409'!
updateSupportMorphs

	self orientation = #horizontal ifTrue: [self listDirection: #leftToRight].  		
	self orientation = #vertical ifTrue: [self listDirection: #topToBottom].

	self
		updateValueButtons;
		updateSliderButton.! !

!UiScrollBar methodsFor: 'updating' stamp: 'mt 2/26/2011 19:50:01.67'!
updateValueButtons

	self orientation = #horizontal
		ifTrue: [
			decreaseValueButton1 arrow: #left; hResizing: #rigid; vResizing: #spaceFill; width: 14.
			decreaseValueButton2 arrow: #left; hResizing: #rigid; vResizing: #spaceFill; width: 14.
			increaseValueButton arrow: #right; hResizing: #rigid; vResizing: #spaceFill; width: 14]
		ifFalse: [
			decreaseValueButton1 arrow: #up; hResizing: #spaceFill; vResizing: #rigid; height: 14.
			decreaseValueButton2 arrow: #up; hResizing: #spaceFill; vResizing: #rigid; height: 14.
			increaseValueButton arrow: #down; hResizing: #spaceFill; vResizing: #rigid; height: 14]
! !

!UiSlider class methodsFor: 'testing' stamp: 'mt 2/27/2011 16:17:38.592'!
isWidgetClass

	^ true! !

!UiSlider class methodsFor: 'accessing' stamp: 'mt 2/27/2011 16:18:00.811'!
widgetCategory

	^ 'Input Widgets'! !

!UiSlider class methodsFor: 'accessing' stamp: 'mt 2/27/2011 16:19:41.058'!
widgetClassIcon

	^ UiFugueIcons uiSlider050Icon! !

!UiSlider class methodsFor: 'accessing' stamp: 'mt 2/27/2011 16:18:19.955'!
widgetClassName

	^ 'Slider'! !

!UiSlider class methodsFor: 'accessing' stamp: 'mt 2/27/2011 16:25:51.081'!
widgetProperties

	^ super widgetProperties, {{'Slider'. #yourself} -> {
		#orientation -> #(horizontal vertical).
		#minimum -> Integer.
		#maximum -> Integer.
		#currentValue -> Integer.
		#sliderPosition -> Integer.
		#tracking -> Boolean.
		#singleStep -> Integer.
		#pageStep -> Integer.
		#truncate -> Boolean.
		}}! !

!UiSlider class methodsFor: 'accessing' stamp: 'mt 2/27/2011 16:20:57.046'!
widgetPropertiesToIgnore

	^ #('TableLayout' 'ProportionalLayout' cellPositioning cellSpacing listCentering listSpacing minCellSize maxCellSize wrapCentering wrapDirection)! !

!UiSlider methodsFor: 'layout' stamp: 'mt 2/27/2011 15:55:22.353'!
adjustLayoutBounds

	super adjustLayoutBounds.
	self updateSliderButton. "Excluded from automatic layouting, so do it manually here."! !

!UiSlider methodsFor: 'actions' stamp: 'mt 2/26/2011 17:14:05.103'!
doSliderMovement: aMouseMoveEvent
	"Only allow integer steps with mouse dragging."
	
	| value |
	self isStepping
		ifTrue: [^ mouseDownEventPosition := aMouseMoveEvent position].
	
	value := self orientation = #horizontal
		ifTrue: [self pixelToValue: aMouseMoveEvent position x - mouseDownEventPosition x]
		ifFalse: [self pixelToValue: mouseDownEventPosition y - aMouseMoveEvent position y].

	self sliderPosition: mouseDownSliderPosition + (self truncate
		ifTrue: [value reduce asInteger]
		ifFalse: [value]).! !

!UiSlider methodsFor: 'geometry' stamp: 'mt 2/19/2011 11:59:01.107'!
extent: aPoint

	super extent: aPoint.	
	self updateSliderButton.! !

!UiSlider methodsFor: 'actions' stamp: 'mt 3/1/2011 14:13:25.91'!
finishSliderMovement: aMouseEvent

	self sliderDown: false.
	self stopStepping.
	
	mouseDownEventPosition := nil.! !

!UiSlider methodsFor: 'initialization' stamp: 'mt 2/26/2011 17:01:11.001'!
initialize

	self
		initializeSupportMorphs;
		initializeEventHandler.

	super initialize.

	self
		changeTableLayout;
		listCentering: #center.
		
	self
		addMorphBack: pagingMorph;
		addMorphFront: sliderButton.! !

!UiSlider methodsFor: 'initialization' stamp: 'mt 3/1/2011 14:07:28.021'!
initializeEventHandler

	self eventHandler: UiEventHandler new.

	self connect: self eventHandler signal: #mousePressed: toSelector: #startSliderMovement:.
	self connect: self eventHandler signal: #mouseMoved: toSelector: #doSliderMovement:.
	self connect: self eventHandler signal: #mouseReleased: toSelector: #finishSliderMovement:.

	self connect: self eventHandler signal: #mousePressed: toSelector: #jumpToValue:.

	"Keyboard interaction."
	self eventHandler on: Character arrowLeft send: #decreaseValueBySingleStep to: self.
	self eventHandler on: Character arrowRight send: #increaseValueBySingleStep to: self.
	self eventHandler on: Character arrowDown send: #decreaseValueBySingleStep to: self.
	self eventHandler on: Character arrowUp send: #increaseValueBySingleStep to: self.
	
	self eventHandler on: Character pageUp send: #increaseValueByPageStep to: self.
	self eventHandler on: Character pageDown send: #decreaseValueByPageStep to: self.
	
	self eventHandler on: Character home send: #setValueToMinimum to: self.
	self eventHandler on: Character end send: #setValueToMaximum to: self.! !

!UiSlider methodsFor: 'initialization' stamp: 'mt 2/27/2011 15:50:36.457'!
initializeSupportMorphs

	pagingMorph := Morph new
		borderStyle: (BorderStyle inset width: 1);
		color: (Color gray: 0.85);
		hResizing: #spaceFill;
		height: 5.  
			
	sliderButton := UiSliderButton new.! !

!UiSlider methodsFor: 'actions' stamp: 'mt 2/26/2011 17:09:05.644'!
jumpToValue: aMouseEvent
	"Jumps to the value under the mouse cursor if shift was pressed."
	
	| value |
	aMouseEvent shiftPressed ifFalse: [^ self].
	
	self orientation = #horizontal
		ifTrue: [value := self pixelToValue: aMouseEvent position x - self left - (sliderButton width / 2)]
		ifFalse: [value := self pixelToValue: self bottom - aMouseEvent position y - (sliderButton height / 2)].
		
	self sliderPosition: value.! !

!UiSlider methodsFor: 'converting' stamp: 'mt 2/27/2011 15:27:16.273'!
pixelToValue: anInteger

	self range extent = 0 ifTrue: [^ 0].

	self orientation = #horizontal
		ifTrue: [^ anInteger / ((pagingMorph width - sliderButton width) max: 1) * self range extent].
		
	self orientation = #vertical
		ifTrue: [^ anInteger / ((pagingMorph height - sliderButton height) max: 1) * self range extent].
		
	^ 0! !

!UiSlider methodsFor: 'updating' stamp: 'mt 2/19/2011 14:19:35.439'!
sliderChange: aSliderChange

	super sliderChange: aSliderChange.
	  
	aSliderChange = #orientationChange
		ifTrue: [self updateSupportMorphs].
	
	(#(rangeChange valueChange) includes: aSliderChange)
		ifTrue: [self updateSliderButton].! !

!UiSlider methodsFor: 'accessing' stamp: 'mt 2/19/2011 13:00:27.935'!
sliderDown: aBoolean
	"Overridden to pass it to the slider button."
	
	super sliderDown: aBoolean.
	sliderButton down: aBoolean.  ! !

!UiSlider methodsFor: 'actions' stamp: 'mt 3/1/2011 14:11:52.387'!
startSliderMovement: aMouseEvent

	mouseDownEventPosition := aMouseEvent position.
	
	((self orientation = #horizontal and: [aMouseEvent position x between: sliderButton left and: sliderButton right])
		or: [self orientation = #vertical and: [aMouseEvent position y between: sliderButton top and: sliderButton bottom]])
		ifTrue: [
			"Start slider dragging."
			mouseDownSliderPosition := self sliderPosition.
			self sliderDown: true]
		ifFalse: [
			"Start slider stepping."
			self startStepping]

! !

!UiSlider methodsFor: 'stepping' stamp: 'mt 3/1/2011 14:17:50.008'!
step
	"Automatically move the slider page-step-wise."
	
	| value |
	mouseDownEventPosition ifNil: [^ self stopStepping].
	
	self orientation = #horizontal
		ifTrue: [value := self pixelToValue: mouseDownEventPosition x - self left - (sliderButton width / 2)]
		ifFalse: [value := self pixelToValue: self bottom - mouseDownEventPosition y - (sliderButton height / 2)].
		
	value < self sliderPosition
		ifTrue: [self sliderPosition: (self sliderPosition - self pageStep max: value)]
		ifFalse: [self sliderPosition: (self sliderPosition + self pageStep min: value)].! !

!UiSlider methodsFor: 'stepping' stamp: 'mt 2/25/2011 11:19:16.835'!
stepTime

	^ 100! !

!UiSlider methodsFor: 'updating' stamp: 'mt 2/19/2011 12:44:26.793'!
updatePagingMorph

	pagingMorph
		extent: 5@5.

	self orientation = #horizontal ifTrue: [
		pagingMorph
			hResizing: #spaceFill;
			vResizing: #rigid].
		
	self orientation = #vertical ifTrue: [
		pagingMorph
			hResizing: #rigid;
			vResizing: #spaceFill].! !

!UiSlider methodsFor: 'updating' stamp: 'mt 2/27/2011 15:42:53.077'!
updateSliderButton
	"Reposition the support morph for the slider to #sliderPosition."
	
	| pt |
	self sliderPosition ifNil: [^ self].
	
	sliderButton orientation: self orientation.
	
	self orientation = #horizontal	ifTrue: [
		sliderButton extent: 10@self height.

		pt := ((self valueToPixel: self sliderPosition)
			"Add the offset considering the current position."
			+ self left + (sliderButton width / 2))
			@ self center y.
			
		sliderButton center: pt].
		
	self orientation = #vertical ifTrue: [
		sliderButton extent: self width@10.
		
		pt := self center x @(
			self bottom
			- (self valueToPixel: self sliderPosition)
			- (sliderButton height / 2)).
			
		sliderButton center: pt].! !

!UiSlider methodsFor: 'updating' stamp: 'mt 2/26/2011 17:01:19.52'!
updateSupportMorphs

	self orientation = #horizontal ifTrue: [self listDirection: #topToBottom].  		
	self orientation = #vertical ifTrue: [self listDirection: #leftToRight].

	self
		updatePagingMorph;
		updateSliderButton.! !

!UiSlider methodsFor: 'converting' stamp: 'mt 2/27/2011 15:27:35.001'!
valueToPixel: aNumber
	"Converts a given number to a portion of the extent of this slider."

	| abs |
	self range extent = 0 ifTrue: [^ 0].

	abs := ((aNumber - self minimum) / self range extent).
	
	self orientation = #horizontal
		ifTrue: [^ abs * (pagingMorph width - sliderButton width)].
		
	self orientation = #vertical
		ifTrue: [^ abs * (pagingMorph height - sliderButton height)].
		
	^ 0! !

Morph subclass: #UiButton
	instanceVariableNames: 'checkable checked down icon text autoExclusive enabled'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Core'!

!UiButton commentStamp: 'mt 6/20/2010 20:42:54.272' prior: 0!
Abstract button.!

!UiButton class methodsFor: 'accessing' stamp: 'mt 10/19/2010 13:28:38.684'!
widgetCategory
	
	^ 'Buttons'! !

!UiButton class methodsFor: 'properties' stamp: 'mt 2/19/2011 12:56:08.001'!
widgetProperties

	^ super widgetProperties, {{'Button'. #yourself} -> {
		#enabled -> Boolean.
		#icon -> Form.
		#text -> String.
		#color -> Object.
		#checkable -> Boolean.
		#checked -> Boolean.
		#autoExclusive -> Boolean}}! !

!UiButton class methodsFor: 'properties' stamp: 'mt 11/14/2010 15:58:39.299'!
widgetPropertiesToIgnore

	^ #('TableLayout' 'ProportionalLayout' cellPositioning cellSpacing listSpacing minCellSize maxCellSize wrapCentering wrapDirection)! !

!UiButton methodsFor: 'accessing' stamp: 'mt 6/21/2010 10:28:44.532'!
autoExclusive

	^ autoExclusive ifNil: [autoExclusive := false]! !

!UiButton methodsFor: 'accessing' stamp: 'mt 6/21/2010 10:31:03.542'!
autoExclusive: aBoolean

	autoExclusive == aBoolean ifTrue: [^ self].
	
	autoExclusive := aBoolean.
	
	aBoolean ifTrue: [self checkable: true].! !

!UiButton methodsFor: 'accessing' stamp: 'mt 9/1/2010 12:29:29.321'!
borderStyle: newStyle
	"Removed explicit #changed to use it in the #drawOn: message."
	
	newStyle = self borderStyle ifFalse:[
		(self canDrawBorder: newStyle) ifFalse:[
			"Replace the suggested border with a simple one"
			^self borderStyle: (BorderStyle width: newStyle width color: (newStyle trackColorFrom: self) color)].
		self setProperty: #borderStyle toValue: newStyle].! !

!UiButton methodsFor: 'accessing' stamp: 'mt 6/20/2010 19:51:52.944'!
checkable

	^ checkable ifNil: [checkable := false]! !

!UiButton methodsFor: 'accessing' stamp: 'mt 6/20/2010 19:48:57.047'!
checkable: aBoolean

	aBoolean == checkable ifTrue: [^ self].

	checkable := aBoolean.
	
	aBoolean ifFalse: [checked := false].! !

!UiButton methodsFor: 'accessing' stamp: 'mt 6/20/2010 19:51:46.981'!
checked

	^ checked ifNil: [checked := false]! !

!UiButton methodsFor: 'accessing' stamp: 'mt 10/27/2010 10:10:10.273'!
checked: aBoolean

	(aBoolean == checked or: [self checkable not])
		ifTrue: [^ self].	
	
	checked := aBoolean.
	
	self toggled: aBoolean.
	
	self redrawLater.
	
	"Handle auto-exclusiveness."
	(self autoExclusive and: [self checked])
		ifTrue: [self owner ifNotNil: [:group |
			group submorphs
				select: [:m | (m isKindOf: UiButton) and: [m ~= self]]
				thenDo: [:m | m checked: false]]].! !

!UiButton methodsFor: 'signals' stamp: 'mt 6/20/2010 19:35:59.853'!
clicked: isChecked

	self emit.! !

!UiButton methodsFor: 'actions' stamp: 'mt 3/2/2011 11:27:17.367'!
doClick
	"#click is reserved for morphic event handling. Simulate a button click."
	
	self toggle.
	self clicked: self checked.! !

!UiButton methodsFor: 'accessing' stamp: 'mt 6/20/2010 19:51:42.188'!
down

	^ down ifNil: [down := false]! !

!UiButton methodsFor: 'accessing' stamp: 'mt 6/20/2010 21:21:04.758'!
down: aBoolean

	aBoolean == down ifTrue: [^ self].
	
	down := aBoolean.
	
	self redrawLater.
	
	aBoolean
		ifFalse: [self toggle].! !

!UiButton methodsFor: 'accessing' stamp: 'mt 11/22/2010 10:44:41.643'!
enabled

	^ enabled ifNil: [enabled := true]! !

!UiButton methodsFor: 'accessing' stamp: 'mt 11/22/2010 10:44:56.115'!
enabled: aBoolean

	enabled := aBoolean.! !

!UiButton methodsFor: 'drawing' stamp: 'mt 2/26/2011 16:07:11.041'!
gradient
	"Generate a gradient based on the current color and geometry."

	| inverted baseColor |
	inverted := self down or: [self checked].
	baseColor := 	self hasKeyboard
		ifTrue: [(Color r: 0.5 g: 0.5 b: 1.0) muchLighter]
		ifFalse: [self color].
	baseColor := inverted
		ifTrue: [baseColor darker]
		ifFalse: [baseColor].
	
	^ (GradientFillStyle ramp: {
			0.0 -> (baseColor adjustBrightness: 0.1).
			0.1-> (baseColor adjustBrightness: 0.05).
			0.6 -> (baseColor darker)})
		origin: (inverted
			ifTrue: [self innerBounds bottomLeft]
			ifFalse: [self innerBounds topLeft]);
		direction: (inverted
			ifTrue: [0 @ self innerBounds height negated]
			ifFalse: [0 @ self innerBounds height]).! !

!UiButton methodsFor: 'accessing' stamp: 'mt 6/20/2010 19:34:04.67'!
icon

	^ icon! !

!UiButton methodsFor: 'accessing' stamp: 'mt 6/20/2010 20:07:08.152'!
icon: aForm

	icon := aForm.! !

!UiButton methodsFor: 'initialization' stamp: 'mt 2/26/2011 15:12:59.891'!
initialize

	super initialize.
	
	self initializeEventHandler.
	
	self
		color: (Color gray: 0.8);
		borderColor: (Color gray: 0.3);
		borderWidth: 1;
		extent: 50@25.! !

!UiButton methodsFor: 'initialization' stamp: 'mt 3/2/2011 11:35:27.302'!
initializeEventHandler

	self eventHandler: UiEventHandler new.
	self eventHandler grabKeyboardOnMouseEnter: false.
	
	self eventHandler setProperty: #handlesMouseDown toValue: [self enabled].
	self eventHandler setProperty: #handlesMouseUp toValue: [self enabled].
	
	self connect: self eventHandler signal: #mousePressed: toSelector: #grabKeyboard.
	
	self connect: self eventHandler signal: #mousePressed: toSelector: #press:.
	self connect: self eventHandler signal: #mouseReleased: toSelector: #release:.
	
	self connect: self eventHandler signal: #returnPressed toSelector: #doClick.! !

!UiButton methodsFor: 'actions' stamp: 'mt 3/2/2011 11:04:58.085'!
press: aMouseEvent

	self
		down: true;
		pressed.! !

!UiButton methodsFor: 'signals' stamp: 'mt 6/20/2010 19:36:09.523'!
pressed

	self emit.! !

!UiButton methodsFor: 'actions' stamp: 'mt 3/2/2011 11:04:52.662'!
release: aMouseEvent

	(self bounds containsPoint: aMouseEvent position)
		ifTrue: [self down: false; released; clicked: self checked]
		ifFalse: [down := false. self redrawLater].! !

!UiButton methodsFor: 'signals' stamp: 'mt 6/20/2010 19:36:14.649'!
released

	self emit.! !

!UiButton methodsFor: 'accessing' stamp: 'mt 6/20/2010 19:34:55.971'!
text

	^ text! !

!UiButton methodsFor: 'accessing' stamp: 'mt 10/27/2010 10:05:52.788'!
text: aStringOrText

	text := aStringOrText.! !

!UiButton methodsFor: 'actions' stamp: 'mt 6/21/2010 10:39:00.668'!
toggle

	(self autoExclusive and: [self checked])
		ifTrue: ["Must not toggle." ^ self].
	
	self checked: self checked not.! !

!UiButton methodsFor: 'signals' stamp: 'mt 6/20/2010 19:36:30.246'!
toggled: isChecked

	self emit.! !

UiButton subclass: #UiCompositeButton
	instanceVariableNames: 'box'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Core'!

!UiCompositeButton commentStamp: 'mt 3/5/2011 11:53:19.193' prior: 0!
This is a button that has an additional button embedded.!

UiCompositeButton subclass: #UiCheckBox
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Core'!

!UiCheckBox class methodsFor: 'testing' stamp: 'mt 6/29/2010 10:04:30.463'!
isWidgetClass

	^ true! !

!UiCheckBox class methodsFor: 'accessing' stamp: 'mt 10/19/2010 11:45:56.946'!
widgetClassIcon

	^ UiFugueIcons uiCheckBoxesIcon! !

!UiCheckBox class methodsFor: 'accessing' stamp: 'mt 6/30/2010 21:23:28.921'!
widgetClassName

	^ 'Check Box'! !

!UiCheckBox class methodsFor: 'properties' stamp: 'mt 10/28/2010 09:51:08.562'!
widgetPropertiesToIgnore

	^ super widgetPropertiesToIgnore, #('checkable')! !

!UiCheckBox methodsFor: 'initialization' stamp: 'mt 3/5/2011 11:55:37.001'!
boxClass

	^ UiCheckButtonBox! !

!UiCheckBox methodsFor: 'drawing' stamp: 'mt 2/26/2011 15:33:20.135'!
fullDrawOn: aCanvas

	super fullDrawOn: aCanvas.
	
	"Indicate checking state with an additional tick."
	box notNil & self checked ifTrue: [
		aCanvas
			line: box topLeft + (0@(box height // 2)) + (2@0)
			to: box bottomLeft + ((box width // 2)@0) - (0@2)
			width: 2
			color: (Color gray: 0.3).
		aCanvas
			line: box bottomLeft + ((box width // 2)@0) - (0@2)
			to: box topRight - (2@ -2)
			width: 2
			color: (Color gray: 0.3)].! !

!UiCheckBox methodsFor: 'initialization' stamp: 'mt 3/5/2011 11:57:22.644'!
initialize

	super initialize.
		
	self text: 'CheckBox'.! !

!UiCompositeButton methodsFor: 'initialization' stamp: 'mt 3/5/2011 11:53:57.984'!
boxClass

	^ self subclassResponsibility! !

!UiCompositeButton methodsFor: 'accessing' stamp: 'mt 3/5/2011 11:55:43.574'!
checked: aBoolean

	super checked: aBoolean.
	box ifNotNil: [:b | b down: aBoolean].! !

!UiCompositeButton methodsFor: 'accessing' stamp: 'mt 3/5/2011 11:55:47.699'!
down: aBoolean

	super down: aBoolean.
	box ifNotNil: [:b | b down: aBoolean | self checked].! !

!UiCompositeButton methodsFor: 'drawing' stamp: 'mt 3/5/2011 11:56:17.88'!
drawOn: aCanvas

	"Invisible."! !

!UiCompositeButton methodsFor: 'accessing' stamp: 'mt 3/5/2011 11:55:50.971'!
enabled: aBoolean

	super enabled: aBoolean.
	box ifNotNil: [:b | b enabled: aBoolean].
	self updateSubmorphs.! !

!UiCompositeButton methodsFor: 'accessing' stamp: 'mt 3/5/2011 11:55:53.785'!
icon: anIcon

	super icon: anIcon.
	self updateSubmorphs.! !

!UiCompositeButton methodsFor: 'initialization' stamp: 'mt 3/5/2011 12:00:36.429'!
initialize

	super initialize.
	
	self
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap;
		changeTableLayout;
		listDirection: #leftToRight;
		cellInset: 4;
		layoutInset: (2@0 corner: 2@0).
		
	self 
		checkable: true;
		updateSubmorphs.! !

!UiCompositeButton methodsFor: 'initialization' stamp: 'mt 3/5/2011 11:56:43.076'!
initializeEventHandler

	super initializeEventHandler.
	
	self eventHandler mouseDownPriority: 1.! !

!UiCompositeButton methodsFor: 'accessing' stamp: 'mt 3/5/2011 11:55:56.181'!
text: aText

	super text: aText.
	self updateSubmorphs.! !

!UiCompositeButton methodsFor: 'updating' stamp: 'mt 3/5/2011 11:57:45.947'!
updateSubmorphs

	self removeAllMorphs.
	
	box ifNil: [box := self boxClass new].
	
	self addMorphBack: box.
	self icon ifNotNil: [:i |
		self enabled
				ifTrue: [self addMorphBack: i asMorph]
				ifFalse: [self addMorphBack: i asGrayScale2 asMorph]].
	self text ifNotNil: [:t | 
		self enabled
				ifTrue: [self addMorphBack: t asHtmlText asMorph lock]
				ifFalse: [self addMorphBack: ('<font color="#444444>', t asString, '</font>') asHtmlText asMorph lock]].! !

UiCompositeButton subclass: #UiRadioButton
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Core'!

!UiRadioButton class methodsFor: 'testing' stamp: 'mt 3/5/2011 12:00:58.832'!
isWidgetClass

	^ true! !

!UiRadioButton class methodsFor: 'accessing' stamp: 'mt 3/5/2011 12:01:38.119'!
widgetClassIcon

	^ UiFugueIcons uiRadioButtonsIcon! !

!UiRadioButton class methodsFor: 'accessing' stamp: 'mt 3/5/2011 12:01:47.229'!
widgetClassName

	^ 'Radio Button'! !

!UiRadioButton class methodsFor: 'properties' stamp: 'mt 3/5/2011 12:02:08.606'!
widgetPropertiesToIgnore

	^ super widgetPropertiesToIgnore, #(checkable autoExclusive)! !

!UiRadioButton methodsFor: 'initialization' stamp: 'mt 3/5/2011 11:58:48.539'!
boxClass

	^ UiRadioButtonBox! !

!UiRadioButton methodsFor: 'drawing' stamp: 'mt 3/5/2011 11:59:23.645'!
fullDrawOn: aCanvas

	super fullDrawOn: aCanvas.
	
	box notNil & self checked ifTrue: [
		aCanvas
			fillOval: (box bounds insetBy: 3)
			color: (Color gray: 0.3)].! !

!UiRadioButton methodsFor: 'initialization' stamp: 'mt 3/5/2011 12:00:06.306'!
initialize

	super initialize.
		
	self
		autoExclusive: true;
		text: 'RadioButton'.! !

UiButton subclass: #UiPushButton
	instanceVariableNames: 'outerBorderWidth'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Core'!

!UiPushButton class methodsFor: 'testing' stamp: 'mt 6/28/2010 21:57:11.625'!
isWidgetClass

	^ true! !

!UiPushButton class methodsFor: 'accessing' stamp: 'mt 10/19/2010 11:49:23.805'!
widgetClassIcon

	^ UiFugueIcons uiButtonIcon! !

!UiPushButton class methodsFor: 'accessing' stamp: 'mt 6/30/2010 21:10:37.376'!
widgetClassName

	^ 'Push Button'! !

!UiPushButton methodsFor: 'drawing' stamp: 'mt 3/1/2011 12:20:42.891'!
drawOn: aCanvas

	self borderStyle: (
		(self down or: [self checked])
			ifFalse: [BorderStyle raised width: 1]
			ifTrue: [BorderStyle inset width: 1]).
		
	self setProperty: #fillStyle toValue: self gradient.
	
	super drawOn: aCanvas.

	aCanvas
		frameRectangle: self outerBounds
		width: self outerBorderWidth 
		color: (self hasKeyboard
			ifTrue: [(Color r: 0.5 g: 0.5 b: 1.0 alpha: 0.4) muchDarker]
			ifFalse: [self color muchDarker alpha: 0.4]).	
	aCanvas
		frameRoundRect: self outerBounds
		radius: 3
		width: self outerBorderWidth  
		color: (self hasKeyboard
			ifTrue: [(Color r: 0.5 g: 0.5 b: 1.0) muchDarker]
			ifFalse: [self color muchDarker]).! !

!UiPushButton methodsFor: 'drawing' stamp: 'mt 2/26/2011 15:34:10.381'!
drawSubmorphsOn: aCanvas
	"Shift submorphs if button is down or checked to give a better feedback."
	
	aCanvas
		translateBy: ((self down or: [self checked])
			ifTrue: [1@1]
			ifFalse: [0@0])
		during: [:c | super drawSubmorphsOn: c].! !

!UiPushButton methodsFor: 'accessing' stamp: 'mt 11/22/2010 10:46:52.411'!
enabled: aBoolean

	super enabled: aBoolean.
	self updateSubmorphs.! !

!UiPushButton methodsFor: 'accessing' stamp: 'mt 6/28/2010 22:03:25.81'!
icon: aForm

	super icon: aForm.
	self updateSubmorphs.! !

!UiPushButton methodsFor: 'initialization' stamp: 'mt 10/22/2010 11:29:23.131'!
initialize

	super initialize.
	
	self
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap;
		changeTableLayout;
		listDirection: #leftToRight;
		cellInset: 4;
		layoutInset: (2@0 corner: 2@0).
	
	self
		color: (Color gray: 0.8);
		text: 'PushButton';
		updateSubmorphs.! !

!UiPushButton methodsFor: 'accessing' stamp: 'mt 2/26/2011 20:07:00.698'!
outerBorderWidth

	^ outerBorderWidth ifNil: [outerBorderWidth := 1]! !

!UiPushButton methodsFor: 'accessing' stamp: 'mt 2/26/2011 20:07:27.461'!
outerBorderWidth: anInteger

	outerBorderWidth = anInteger ifTrue: [^ self].
	outerBorderWidth := anInteger.
	self redrawLater.! !

!UiPushButton methodsFor: 'geometry' stamp: 'mt 2/26/2011 20:07:46.451'!
outerBounds
	"Used for extra outline. See #draw."
	
	^ self bounds outsetBy: self outerBorderWidth! !

!UiPushButton methodsFor: 'accessing' stamp: 'mt 6/28/2010 22:03:18.543'!
text: aString

	super text: aString.
	self updateSubmorphs.! !

!UiPushButton methodsFor: 'updating' stamp: 'mt 2/19/2011 11:57:25.393'!
updateSubmorphs

	self removeAllMorphs.
		
	self icon ifNotNil: [:i | 
		self enabled
				ifTrue: [self addMorphBack: i asMorph]
				ifFalse: [self addMorphBack: i asGrayScale2 asMorph]].
	self text ifNotNil: [:t | 
		self enabled
				ifTrue: [self addMorphBack: t asHtmlText asMorph lock]
				ifFalse: [self addMorphBack: ('<font color="#444444>', t asString, '</font>') asHtmlText asMorph lock]].! !

UiPushButton subclass: #UiScrollBarArrowButton
	instanceVariableNames: 'flattened fadeAnimation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Support'!

!UiScrollBarArrowButton class methodsFor: 'testing' stamp: 'mt 2/27/2011 16:16:58.913'!
isWidgetClass

	^ false! !

!UiScrollBarArrowButton methodsFor: 'initialization' stamp: 'mt 3/1/2011 11:54:17.022'!
arrow: aSymbol
	"#up, #down, #left, #right"
	
	| form |
	form := (#(left down) includes: aSymbol)
		ifTrue: [UiSilkIcons bulletArrowDownIcon collectColors: [:c | c darker]]
		ifFalse: [UiSilkIcons bulletArrowUpIcon collectColors: [:c | c darker]].
		
	(#(left right) includes: aSymbol)
		ifTrue: [form := form rotateBy: #right centerAt: 8@8].
	
	self
		removeAllMorphs;
		addMorph: ((form clippedTo: 8@8) asMorph frameFractions: (0@0 corner: 1@1)).
		
	self submorphs first ignoresColorMappings: true.  ! !

!UiScrollBarArrowButton methodsFor: 'animations' stamp: 'mt 3/1/2011 12:10:51.032'!
fadeIn

	fadeAnimation
		ifNil: [^ self]
		ifNotNil: [:anim |
			anim unregister.
			fadeAnimation := nil].
	
	super fadeIn.! !

!UiScrollBarArrowButton methodsFor: 'animations' stamp: 'mt 3/1/2011 12:06:41.067'!
fadeOut

	fadeAnimation ifNil: [fadeAnimation := (AnimAlphaBlendAnimation
		fadeOutOn: self
		duration: 200)
		register;
		start: #keepWhenFinished].! !

!UiScrollBarArrowButton methodsFor: 'initialization' stamp: 'mt 3/1/2011 12:09:18.736'!
initialize

	flattened := false.
	
	super initialize.
	
	self
		changeProportionalLayout;
		hResizing: #rigid;
		vResizing: #rigid;
		extent: 14@14;
		listCentering: #center;
		arrow: #up.
		
	self eventHandler setProperty: #handlesMouseStillDown toValue: [true].
	self eventHandler setProperty: #handlesKeyboard toValue: [false].
	
	self connect: self eventHandler signal: #focusReceived toSelector: #passFocusToOwner.! !

!UiScrollBarArrowButton methodsFor: 'geometry' stamp: 'mt 2/26/2011 21:25:46.586'!
outerBounds

	^ self bounds outsetBy: 1  ! !

!UiScrollBarArrowButton methodsFor: 'initialization' stamp: 'mt 2/26/2011 21:07:13.055'!
passFocusToOwner

	self owner grabKeyboard.! !

UiPushButton subclass: #UiSliderButton
	instanceVariableNames: 'orientation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Support'!

!UiSliderButton commentStamp: 'mt 2/27/2011 15:45:52.758' prior: 0!
Special push button to be used in slider.!

UiSliderButton subclass: #UiScrollBarSliderButton
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Support'!

!UiScrollBarSliderButton commentStamp: 'mt 2/26/2011 17:45:21.609' prior: 0!
Special push button to be used in scrollbar.!

!UiScrollBarSliderButton methodsFor: 'updating' stamp: 'mt 2/26/2011 18:12:19.102'!
addGrip

	3 timesRepeat: [self addMorphBack: (Morph new
		extent: 2@2;
		height: 2;
		color: Color gray;
		borderStyle: (BorderStyle inset width: 1);
		hResizing: (self orientation = #horizontal ifTrue: [#rigid] ifFalse: [#spaceFill]);
		vResizing: (self orientation = #horizontal ifTrue: [#spaceFill] ifFalse: [#rigid]))].! !

!UiScrollBarSliderButton methodsFor: 'geometry' stamp: 'mt 2/26/2011 18:27:42.359'!
extent: aPoint

	super extent: (aPoint max: (10@10)).
	
	"Hide grips if too small."
	self submorphs ifEmpty: [self addGrip].
	(self orientation = #horizontal and: [self width < 14])
		ifTrue: [self removeAllMorphs].
	(self orientation = #vertical and: [self height < 14])
		ifTrue: [self removeAllMorphs].! !

!UiScrollBarSliderButton methodsFor: 'updating' stamp: 'mt 2/27/2011 15:42:02.554'!
update

	self removeAllMorphs.
	super update.
	self addGrip.! !

!UiSliderButton class methodsFor: 'testing' stamp: 'mt 2/27/2011 16:17:13.969'!
isWidgetClass

	^ false! !

!UiSliderButton methodsFor: 'drawing' stamp: 'mt 2/27/2011 15:39:23.902'!
gradient

	| inverted direction origin |
	inverted := self down or: [self checked].
	direction := self orientation = #horizontal
		ifTrue: [0 @ self innerBounds height]
		ifFalse: [self innerBounds width @ 0].
	origin := self orientation = #horizontal
		ifTrue: [inverted ifTrue: [self innerBounds bottomLeft] ifFalse: [self innerBounds topLeft]]
		ifFalse: [inverted ifTrue: [self innerBounds topRight] ifFalse: [self innerBounds topLeft]].
		
	inverted ifTrue: [direction := direction negated].

	^ super gradient
		origin: origin;
		direction: direction! !

!UiSliderButton methodsFor: 'initialization' stamp: 'mt 2/27/2011 15:44:32.199'!
initialize

	super initialize.
	
	self
		removeAllMorphs; "remove default icon and text"
		listCentering: #center;
		cellInset: 1;
		layoutInset: 2;  
		orientation: #horizontal;
		disableTableLayout: true.
		
	self eventHandler setProperty: #handlesMouseDown toValue: [false].! !

!UiSliderButton methodsFor: 'accessing' stamp: 'mt 2/27/2011 15:41:01.067'!
orientation

	^ orientation ifNil: [#horizontal]! !

!UiSliderButton methodsFor: 'accessing' stamp: 'mt 2/27/2011 15:41:02.552'!
orientation: aSymbol
	"#horizontal, #vertical"
	
	aSymbol = orientation ifTrue: [^ self].
	
	orientation := aSymbol.
	
	self update.! !

!UiSliderButton methodsFor: 'updating' stamp: 'mt 2/27/2011 15:41:34.974'!
update

	self extent: 14@14.
	
	self orientation = #horizontal
		ifTrue: [self
			listDirection: #leftToRight;
			hResizing: #rigid;
			vResizing: #spaceFill].
		
	self orientation = #vertical
		ifTrue: [self
			listDirection: #topToBottom;
			hResizing: #spaceFill;
			vResizing: #rigid].! !

UiButton subclass: #UiRadioButtonBox
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Support'!

!UiRadioButtonBox methodsFor: 'drawing' stamp: 'mt 3/5/2011 11:44:52.361'!
drawBorderOn: aCanvas

	| color1 color2 |
	(self down or: [self checked])
		ifTrue: [
			color1 := self color twiceDarker.
			color2 := self color twiceLighter]
		ifFalse: [
			color1 := self color twiceLighter.
			color2 := self color twiceDarker].
		
	aCanvas
		frameOval: self bounds
		color: color1.
		
	aCanvas clipBy: (self bounds translateBy: 0 @ (self bounds height * 0.75)) during: [:c1 |
		c1
			frameOval: self bounds
			color: color2].
		
	aCanvas clipBy: (self bounds translateBy: (self bounds width * 0.75) @ 0) during: [:c1 |
		c1
			frameOval: self bounds
			color: color2].! !

!UiRadioButtonBox methodsFor: 'drawing' stamp: 'mt 3/5/2011 12:04:13.007'!
drawOn: aCanvas

	self setProperty: #fillStyle toValue: self gradient.
	
	aCanvas
		fillOval: self bounds
		fillStyle: self fillStyle.

	self drawBorderOn: aCanvas.! !

!UiRadioButtonBox methodsFor: 'initialization' stamp: 'mt 3/5/2011 12:03:48.215'!
initialize

	super initialize.
	self extent: 12@12.! !

UiButton subclass: #UiToolButton
	instanceVariableNames: 'raised autoRaise buttonStyle'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Core'!

!UiToolButton commentStamp: 'mt 3/5/2011 11:22:33.102' prior: 0!
Supports #autoRaise and aligns icon and text according to different #buttonStyle.!

UiToolButton subclass: #UiCheckButtonBox
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Support'!

!UiCheckButtonBox class methodsFor: 'testing' stamp: 'mt 3/5/2011 12:15:45.982'!
isWidgetClass

	^ false! !

!UiCheckButtonBox methodsFor: 'initialization' stamp: 'mt 3/5/2011 11:55:14.331'!
initialize

	super initialize.
	
	self 
		checkable: false;
		hResizing: #rigid;
		vResizing: #rigid;
		icon: nil; text: nil;
		extent: 12@12.! !

!UiToolButton class methodsFor: 'testing' stamp: 'mt 6/28/2010 21:32:01.69'!
isWidgetClass

	^ true! !

!UiToolButton class methodsFor: 'accessing' stamp: 'mt 10/19/2010 11:50:15.247'!
widgetClassIcon

	^ UiFugueIcons uiButtonToggleIcon! !

!UiToolButton class methodsFor: 'accessing' stamp: 'mt 6/30/2010 21:11:24.018'!
widgetClassName

	^ 'Tool Button'! !

!UiToolButton class methodsFor: 'properties' stamp: 'mt 10/22/2010 11:40:45.982'!
widgetProperties

	^ super widgetProperties, {{'Tool Button'. #yourself} -> {
		#autoRaise -> Boolean.
		#buttonStyle -> #(iconOnly textOnly textBesideIcon textUnderIcon)}}! !

!UiToolButton methodsFor: 'accessing' stamp: 'mt 6/20/2010 20:08:09.225'!
autoRaise

	^ autoRaise ifNil: [autoRaise := false]! !

!UiToolButton methodsFor: 'accessing' stamp: 'mt 6/20/2010 20:36:20.019'!
autoRaise: aBoolean

	aBoolean == autoRaise ifTrue: [^ self].

	autoRaise := aBoolean.
	
	self raised: aBoolean not.! !

!UiToolButton methodsFor: 'accessing' stamp: 'mt 6/28/2010 22:36:21.335'!
buttonStyle

	^ buttonStyle ifNil: [buttonStyle := #textBesideIcon]! !

!UiToolButton methodsFor: 'accessing' stamp: 'mt 6/28/2010 22:37:57.741'!
buttonStyle: aStyle
	"#iconOnly #textOnly #textBesideIcon #textUnderIcon"

	aStyle = buttonStyle ifTrue: [^ self].
	
	buttonStyle := aStyle.
	
	self updateSubmorphs.! !

!UiToolButton methodsFor: 'drawing' stamp: 'mt 2/26/2011 15:55:11.418'!
drawOn: aCanvas

	self borderStyle: (
		(self down or: [self checked])
			ifFalse: [(self autoRaise not or: [self raised]) ifTrue: [BorderStyle raised width: 1] ifFalse: [nil]]
			ifTrue: [BorderStyle inset width: 1]).
		
	(self autoRaise not or: [self raised])
		ifTrue: [self setProperty: #fillStyle toValue: self gradient]
		ifFalse: [self removeProperty: #fillStyle].
	
	super drawOn: aCanvas.! !

!UiToolButton methodsFor: 'drawing' stamp: 'mt 10/19/2010 19:00:18.669'!
drawSubmorphsOn: aCanvas

	aCanvas
		translateBy: ((self down or: [self checked])
			ifTrue: [1@1]
			ifFalse: [0@0])
		during: [:c | super drawSubmorphsOn: c].! !

!UiToolButton methodsFor: 'accessing' stamp: 'mt 11/22/2010 10:47:06.006'!
enabled: aBoolean

	super enabled: aBoolean.
	self updateSubmorphs.! !

!UiToolButton methodsFor: 'actions' stamp: 'mt 2/26/2011 15:16:50.685'!
flatten

	self autoRaise ifTrue: [self raised: false].! !

!UiToolButton methodsFor: 'accessing' stamp: 'mt 6/20/2010 20:16:36.279'!
icon: aForm

	super icon: aForm.
	self updateSubmorphs.! !

!UiToolButton methodsFor: 'initialization' stamp: 'mt 10/22/2010 11:29:39.179'!
initialize

	super initialize.
	
	self
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap;
		changeTableLayout;
		cellInset: 4;
		layoutInset: (2@0 corner: 2@0).
	
	self
		color: (Color gray: 0.8);
		raised: true;
		text: 'ToolButton';
		updateSubmorphs.! !

!UiToolButton methodsFor: 'initialization' stamp: 'mt 2/26/2011 16:22:45.848'!
initializeEventHandler

	super initializeEventHandler.
	self eventHandler setProperty: #handlesMouseOver toValue: [self enabled].
	
	self connect: self eventHandler signal: #mouseEntered: toSelector: #raise.
	self connect: self eventHandler signal: #mouseLeaved: toSelector: #flatten.
	
	self eventHandler disconnectSignal: #mousePressed: from: self selector: #grabKeyboard.! !

!UiToolButton methodsFor: 'actions' stamp: 'mt 2/26/2011 15:17:01.592'!
raise

	self autoRaise ifTrue: [self raised: true].! !

!UiToolButton methodsFor: 'accessing' stamp: 'mt 6/20/2010 20:20:48.182'!
raised

	^ raised ifNil: [raised := true]! !

!UiToolButton methodsFor: 'accessing' stamp: 'mt 6/20/2010 20:55:53.198'!
raised: aBoolean

	aBoolean == raised ifTrue: [^ self].

	raised := aBoolean.
	self redrawLater.! !

!UiToolButton methodsFor: 'actions' stamp: 'mt 2/26/2011 15:17:36.308'!
release: aMouseEvent

	(self bounds containsPoint: aMouseEvent position)
		ifFalse: [self flatten].
		
	super release: aMouseEvent.! !

!UiToolButton methodsFor: 'accessing' stamp: 'mt 6/20/2010 20:16:46.914'!
text: aString

	super text: aString.
	self updateSubmorphs.! !

!UiToolButton methodsFor: 'updating' stamp: 'mt 11/22/2010 10:51:21.559'!
updateSubmorphs

	self	 removeAllMorphs.
	
	self buttonStyle = #textUnderIcon
		ifTrue: [self listDirection: #topToBottom]
		ifFalse: [self listDirection: #leftToRight].
	
	self icon ifNotNil: [:i | (self buttonStyle ~= #textOnly 
		or: [self text isNil]) ifTrue: [
			self enabled
				ifTrue: [self addMorphBack: i asMorph]
				ifFalse: [self addMorphBack: i asGrayScale2 asMorph]]].
	self text ifNotNil: [:t | (self buttonStyle ~= #iconOnly
		or: [self icon isNil]) ifTrue: [
			self enabled
				ifTrue: [self addMorphBack: t asHtmlText asMorph lock]
				ifFalse: [self addMorphBack: ('<font color="#444444>', t asString, '</font>') asHtmlText asMorph lock]]].! !

Morph subclass: #UiComboBox
	instanceVariableNames: 'button readOnlyButton lineEdit listWidget converter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Core'!

!UiComboBox class methodsFor: 'testing' stamp: 'mt 6/29/2010 16:31:40.618'!
isWidgetClass

	^ true! !

!UiComboBox class methodsFor: 'accessing' stamp: 'mt 10/19/2010 13:29:17.438'!
widgetCategory
	
	^ 'Input Widgets'! !

!UiComboBox class methodsFor: 'accessing' stamp: 'mt 10/19/2010 11:50:28.366'!
widgetClassIcon

	^ UiFugueIcons uiComboBoxIcon! !

!UiComboBox class methodsFor: 'accessing' stamp: 'mt 6/30/2010 21:23:12.475'!
widgetClassName

	^ 'Combo Box'! !

!UiComboBox class methodsFor: 'properties' stamp: 'mt 10/28/2010 16:52:41.237'!
widgetProperties

	^ super widgetProperties, {{'Combo Box'. #yourself} -> {
		#readOnly -> Boolean}}! !

!UiComboBox class methodsFor: 'properties' stamp: 'mt 10/27/2010 09:45:15.58'!
widgetPropertiesToIgnore

	^ #('TableLayout' 'ProportionalLayout' vResizing cellPositioning cellSpacing listCentering listSpacing minCellSize maxCellSize wrapCentering wrapDirection)! !

!UiComboBox methodsFor: 'adding' stamp: 'mt 11/22/2010 15:58:33.441'!
addIcon: anIcon text: aLabel

	listWidget addIcon: anIcon text: aLabel.
	
	listWidget items size = 1
		ifTrue: [self currentIndex: 1]! !

!UiComboBox methodsFor: 'adding' stamp: 'mt 10/14/2010 20:43:12.328'!
addText: aLabel

	listWidget addText: aLabel.
	
	listWidget items size = 1
		ifTrue: [self currentIndex: 1]! !

!UiComboBox methodsFor: 'updating' stamp: 'mt 11/22/2010 17:15:21.854'!
changed

	self fixHeight.
	super changed.! !

!UiComboBox methodsFor: 'accessing' stamp: 'mt 10/20/2010 14:19:31.999'!
clear

	listWidget clear.
	self updateCurrentRow: nil.! !

!UiComboBox methodsFor: 'accessing' stamp: 'mt 10/20/2010 14:55:55.354'!
color: aColor

	super color: aColor.
	readOnlyButton color: aColor.
	button color: aColor.
	listWidget borderColor: aColor muchDarker.! !

!UiComboBox methodsFor: 'accessing' stamp: 'mt 6/30/2010 09:57:53.22'!
converter

	^ converter ifNil: [converter := [:item | item]]! !

!UiComboBox methodsFor: 'accessing' stamp: 'mt 6/30/2010 09:57:11.326'!
converter: aBlock

	converter := aBlock.! !

!UiComboBox methodsFor: 'accessing' stamp: 'mt 6/30/2010 08:19:30.874'!
currentIndex

	^ listWidget currentRow! !

!UiComboBox methodsFor: 'accessing' stamp: 'mt 10/14/2010 20:42:53.745'!
currentIndex: anIndex

	listWidget currentRow: anIndex.
	self updateCurrentRow: anIndex.! !

!UiComboBox methodsFor: 'signals' stamp: 'mt 6/29/2010 17:11:28.048'!
currentIndexChanged: index text: text

	self emit.! !

!UiComboBox methodsFor: 'accessing' stamp: 'mt 6/30/2010 09:58:02.404'!
currentText

	^ self converter value: lineEdit theText! !

!UiComboBox methodsFor: 'drawing' stamp: 'mt 10/22/2010 11:18:07.179'!
drawOn: aCanvas

	aCanvas
		frameRoundRect: self outerBounds
		radius: 3
		width: 1
		color: self color muchDarker.! !

!UiComboBox methodsFor: 'finding' stamp: 'mt 10/20/2010 14:57:44.382'!
findText: aText

	listWidget items withIndexDo: [:item :index | item text = aText ifTrue: [^ index]].
	^ 0! !

!UiComboBox methodsFor: 'private' stamp: 'mt 11/22/2010 17:16:15.412'!
fixHeight

	self submorphs notEmpty ifTrue: [
		button height ~= self submorphs first
			ifTrue: [button height: self submorphs first height]].! !

!UiComboBox methodsFor: 'private' stamp: 'mt 10/21/2010 20:53:54.591'!
hideList

	listWidget delete.
	
	button checked: false.
	readOnlyButton checked: false.! !

!UiComboBox methodsFor: 'initialization' stamp: 'mt 11/22/2010 17:14:12.555'!
initialize

	super initialize.
	
	self
		vResizing: #shrinkWrap;
		changeTableLayout;
		listDirection: #leftToRight;
		cellPositioning: #topLeft;
		width: 150.
		
	button := UiToolButton new
		text: nil;
		checkable: true;
		vResizing: #rigid;
		icon: (UiSilkIcons bulletArrowDownIcon clippedTo: 8@8);
		layoutInset: (3@4 corner: 3@4).
	lineEdit := UiLineEdit new
		outerBorderWidth: 0.
	listWidget := UiListWidget new
		borderWidth: 1.
	
	readOnlyButton := UiToolButton new
		text: ' ';
		icon: nil;
		checkable: true;
		hResizing: #spaceFill.
	
	"Initialize the submorphs the first time."
	self readOnly: true.
		
	self connect: listWidget signal: #currentRowChanged: toSelector: #updateCurrentRow:.
	self connect: listWidget signal: #currentRowChanged: toSelector: #hideList.

	self connect: button signal: #toggled: toSelector: #listVisible:.
	self connect: readOnlyButton signal: #toggled: toSelector: #listVisible:.

	self connect: button signal: #pressed to: readOnlyButton selector: #toggle.
	self connect: readOnlyButton signal: #pressed to: button selector: #toggle.
	
	self color: (Color gray: 0.8).! !

!UiComboBox methodsFor: 'private' stamp: 'mt 6/29/2010 16:48:03.535'!
listVisible: aBoolean

	aBoolean
		ifTrue: [self showList]
		ifFalse: [self hideList].
! !

!UiComboBox methodsFor: 'geometry' stamp: 'mt 10/19/2010 19:16:12.484'!
outerBounds

	^ self bounds outsetBy: (1@1 corner: 1@1)! !

!UiComboBox methodsFor: 'accessing' stamp: 'mt 6/29/2010 16:38:37.021'!
readOnly

	^ lineEdit readOnly! !

!UiComboBox methodsFor: 'accessing' stamp: 'mt 9/20/2010 13:57:25.853'!
readOnly: aBoolean

	lineEdit readOnly: aBoolean.
	self updateSubmorphs.! !

!UiComboBox methodsFor: 'private' stamp: 'mt 10/24/2010 11:10:53.526'!
showList

	listWidget size = 0 ifTrue: [^ self].
	listWidget owner ifNotNil: [^ self].
	
	listWidget
		useOptimalSize;
		width: (self width + 2 max: listWidget width);
		height: (listWidget height min: 100);
		topLeft: (self localPointToGlobal: self bottomLeft) - (1@0);
		openInWorld;
		fadeIn.! !

!UiComboBox methodsFor: 'accessing' stamp: 'mt 10/20/2010 14:11:32.602'!
size

	^ listWidget size! !

!UiComboBox methodsFor: 'updating' stamp: 'mt 10/20/2010 14:15:18.676'!
updateCurrentRow: anIndex

	lineEdit theText: listWidget currentText.
	
	readOnlyButton text: lineEdit theText.
	readOnlyButton icon: listWidget currentIcon.
	
	self currentIndexChanged: anIndex text: (self converter value: lineEdit theText).! !

!UiComboBox methodsFor: 'updating' stamp: 'mt 11/22/2010 17:14:31.642'!
updateSubmorphs

	self removeAllMorphs.
	
	self
		addMorphBack: (self readOnly ifTrue: [readOnlyButton] ifFalse: [lineEdit]);
		addMorphBack: button.
		
	self fixHeight.! !

Morph subclass: #UiIconPickerDialog
	instanceVariableNames: 'iconSetCombo iconView infoLabel icon searchInput'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Dialogs'!

!UiIconPickerDialog commentStamp: 'mt 10/19/2010 11:08:01.295' prior: 0!
A useful dialog to help a developer to choose the right icon.!

!UiIconPickerDialog class methodsFor: 'instance creation' stamp: 'mt 10/14/2010 20:34:30.931'!
open

	self new open.! !

!UiIconPickerDialog methodsFor: 'actions' stamp: 'mt 10/21/2010 22:36:14.829'!
changeIconSet: anIndex

	iconView model iconSet: (UiIcons subclasses reversed at: anIndex).! !

!UiIconPickerDialog methodsFor: 'actions' stamp: 'mt 11/14/2010 15:28:10.992'!
changeSearch: nameFilter

	iconView model nameFilter: nameFilter asString.! !

!UiIconPickerDialog methodsFor: 'actions' stamp: 'mt 10/14/2010 20:47:24.871'!
chooseIcon: aModelIndex

	Clipboard clipboardText: (iconView model codeSnippetFor: aModelIndex).! !

!UiIconPickerDialog methodsFor: 'actions' stamp: 'mt 10/21/2010 22:11:41.636'!
chooseIconAndClose: aModelIndex

	aModelIndex ifNil: [^ self delete].
	icon := (iconView model iconFor: aModelIndex).
	self delete.! !

!UiIconPickerDialog methodsFor: 'actions' stamp: 'mt 10/22/2010 11:24:25.666'!
chooseIconCodeAndClose: aModelIndex

	aModelIndex ifNil: [^ self delete].
	icon := iconView model codeSnippetFor: aModelIndex.
	self delete.! !

!UiIconPickerDialog methodsFor: 'drawing' stamp: 'mt 10/22/2010 11:14:30.318'!
drawOn: aCanvas

	super drawOn: aCanvas.
	self owner == ActiveWorld
		ifTrue: [self drawShadowOn: aCanvas].! !

!UiIconPickerDialog methodsFor: 'drawing' stamp: 'mt 10/22/2010 11:14:03.92'!
drawShadowOn: aCanvas

	aCanvas
		line: self topRight + (0@3)
		to: self bottomRight
		color: (Color black alpha: 0.65).
		
	aCanvas
		line: self bottomLeft + (3@0)
		to: self bottomRight
		color: (Color black alpha: 0.65).
		
	aCanvas
		line: self topRight + (1@4)
		to: self bottomRight + (1@0)
		color: (Color black alpha: 0.5).
		
	aCanvas
		line: self bottomLeft + (4@1)
		to: self bottomRight + (0@1)
		color: (Color black alpha: 0.5).! !

!UiIconPickerDialog methodsFor: 'initialization' stamp: 'mt 11/14/2010 15:27:17.964'!
initialize

	super initialize.
	
	iconSetCombo := UiComboBox new hResizing: #spaceFill.
	UiIcons subclasses reverseDo: [:s | iconSetCombo addText: s name].
	self connect: iconSetCombo signal: #currentIndexChanged:text: toSelector: #changeIconSet:.
	
	iconView := UiListView new
		listOrientation: #vertical;
		model: (UiIconModel new showText: false);
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		borderStyle: (BorderStyle inset width: 1).
	self connect: iconView signal: #clicked: toSelector: #chooseIcon:.
	
	searchInput := UiLineEdit new
		helpText: 'Search...'.
	self connect: searchInput signal: #returnPressed: toSelector: #changeSearch:.
	
	self
		color: (Color gray: 0.9);
		changeTableLayout;
		listDirection: #topToBottom;
		layoutInset: 5;
		cellInset: 5;
		cellPositioning: #topLeft.
		
	self
		addMorphBack: (UiLabel new text: 'Select an icon set then pick an icon below. The code to get
the form will be copied into the <b>clipboard</b>.' asHtmlText);
		addMorphBack: iconSetCombo;
		addMorphBack: iconView;
		addMorphBack: searchInput.
		
	"Initial set."
	self changeIconSet: iconSetCombo currentIndex.! !

!UiIconPickerDialog methodsFor: 'initialization' stamp: 'mt 10/14/2010 20:59:07.38'!
open

	| c |
	c := self color.
	(self openInWindowLabeled: 'Icon Picker')
		extent: 350@300.
		
	self color: c.! !

!UiIconPickerDialog methodsFor: 'geometry' stamp: 'mt 10/22/2010 11:15:55.661'!
outerBounds

	^ self bounds outsetBy: (0@0 corner: 2@2)! !

!UiIconPickerDialog methodsFor: 'initialization' stamp: 'mt 10/22/2010 11:23:55.331'!
pickCodeForIcon

	self submorphs first delete.
	self
		borderWidth: 1;
		borderColor: (Color gray: 0.8) muchDarker;
		extent: 300@200.
	
	self connect: iconView signal: #clicked: toSelector: #chooseIconCodeAndClose:.
	
	self openInWorld.
	[self isInWorld] whileTrue: [ActiveWorld doOneSubCycle].

	^icon! !

!UiIconPickerDialog methodsFor: 'initialization' stamp: 'mt 10/21/2010 22:09:52.839'!
pickIcon

	self submorphs first delete.
	self
		borderWidth: 1;
		borderColor: (Color gray: 0.8) muchDarker;
		extent: 300@200.
	
	self connect: iconView signal: #clicked: toSelector: #chooseIconAndClose:.
	
	self openInWorld.
	[self isInWorld] whileTrue: [ActiveWorld doOneSubCycle].

	^icon! !

Morph subclass: #UiItemViewport
	instanceVariableNames: 'rows columns hoveredCell selectionColor selection selectionMode selectionBehavior verticalHeader horizontalHeader rowOrder columnOrder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Views-Support'!

!UiItemViewport commentStamp: 'mt 11/2/2010 12:48:55.736' prior: 0!
An item viewport represents the whole area where a model's items are layouted. Usually, items (just morphs) are created by using an item delegate that reads a model index and therefore model data. A viewport handles item selection.

There is a difference between a model index and a cell index. Cell indices are numbered in visual order (e.g., according to the current sorting) and may change as the sorting order changes, whereas model indices always address some data in the model and are not changed by the viewport (or view) only by the model itself. Additionally, cell indices to not have a hierarchy, i.e. a parent cell index, and are always two-dimensional.

All item morphs get additional properties, e.g., #modelIndex, #hasChildren, #isExpanded, to track different state or information changed or needed by event handling or drawing routines in the viewport.!

!UiItemViewport methodsFor: 'signals' stamp: 'mt 10/19/2010 10:28:08.197'!
activated: aModelIndex

	self emit.! !

!UiItemViewport methodsFor: 'add/remove' stamp: 'mt 2/17/2011 23:21:42.787'!
addMorph: aMorph atIndex: aModelIndex

	| col row indent |	
	aMorph setProperty: #modelIndex toValue: aModelIndex.
	aMorph setProperty: #isExpanded toValue: false.
	aMorph setProperty: #hasChildren toValue: aModelIndex hasChildren.
	
	row := self addRowFor: aModelIndex.
	row items add: aMorph.
	
	col := self columnFor: aModelIndex.
	col items add: aMorph beforeIndex: (rows indexOf: row).
	
	self addMorphBack: aMorph.
	
	"Correct indent."
	indent := 0.
	(aModelIndex column = 1) ifTrue: [
		| itemBefore |
		itemBefore := aMorph.
		[(itemBefore := col itemBefore: itemBefore)
			ifNil: [indent := self indent. false] "root"
			ifNotNil: [:item |
				"The item before is my parent. Add additional indentation."
				(item valueOfProperty: #modelIndex) = aModelIndex parent
					ifTrue: [indent := (item valueOfProperty: #indent) + self indent. false]
					ifFalse: ["The item before is my sibling. Use its indentation."
						(item valueOfProperty: #modelIndex) parent = aModelIndex parent
							ifTrue: [indent := item valueOfProperty: #indent. false]
							ifFalse: [true]]].
			] whileTrue: []].
	aMorph setProperty: #indent toValue: indent.! !

!UiItemViewport methodsFor: 'add/remove - private' stamp: 'mt 2/17/2011 23:14:28.722'!
addRowFor: aModelIndex
	"Adds a new row if needed. Returns the correct one if possible."
	
	| row isCorrectRow isPreviousSibling isParentRow currentPath |
	isCorrectRow := [:r | r parentModelIndex = aModelIndex parent
		and: [r firstModelIndex row = aModelIndex row]].
	isPreviousSibling := [:r | r parentModelIndex = aModelIndex parent 
		and: [r firstModelIndex row = (aModelIndex row - 1)]].
	isParentRow := [:r | r firstModelIndex = aModelIndex parent].
	
	currentPath := Stack new.
	rows detect: [:r |
		(isCorrectRow value: r)
			ifTrue: [row := r. true]
			ifFalse: [(currentPath isEmpty and: [(isParentRow value: r) or: [isPreviousSibling value: r]])
				ifTrue: [currentPath push: r. false]
				ifFalse: [	currentPath isEmpty ifTrue: [false] ifFalse: [
					[currentPath isEmpty not and: [currentPath top firstModelIndex ~= r parentModelIndex]]
						whileTrue: [currentPath pop].
					
					currentPath isEmpty
						ifTrue: [row := rows add: UiViewRowInfo new before: r. true "first child of parent"]
						ifFalse: [(isPreviousSibling value: r)
							ifTrue: [currentPath := Stack new. currentPath push: r. false]
							ifFalse: [currentPath push: r. false]]]]]
		] ifNone: [row := rows add: UiViewRowInfo new].
	
	^ row! !

!UiItemViewport methodsFor: 'rows/columns - to pixel' stamp: 'mt 10/16/2010 19:58:48.094'!
cellBoundsFor: aCellIndex

	| col row |
	(aCellIndex x > columns size
		or: [aCellIndex y > rows size])
		ifTrue: [^ 0@0 extent: 0@0].
	
	col := self columnAt: aCellIndex x.
	row := self rowAt: aCellIndex y.
	
	^ (self leftForColumn: col) @ (self topForRow: row)
		extent: col width @ row height! !

!UiItemViewport methodsFor: 'rows/columns - to cell' stamp: 'mt 10/17/2010 09:47:23.765'!
cellIndexFromPoint: aPoint
	"Given a point in pixel coordinates."
	
	| offset cellIndex |
	offset := self topLeft.
	cellIndex := 0@0.
	self columnsDo: [:colInfo |
		cellIndex := cellIndex + (1@0).
		self rowsDo: [:rowInfo |
			cellIndex := cellIndex + (0@1).
			((offset extent: colInfo width @ rowInfo height) containsPoint: aPoint)
				ifTrue: [^ cellIndex].
			offset := offset translateBy: 0 @ rowInfo height].
		offset := (offset x + colInfo width) @ self top.
		cellIndex := cellIndex x @ 0].
	
	^ nil! !

!UiItemViewport methodsFor: 'initialization' stamp: 'mt 11/3/2010 10:27:12.276'!
clear

	self selection clear.
	
	columns removeAll.
	rows removeAll.
	
	self removeAllMorphs.! !

!UiItemViewport methodsFor: 'event handling' stamp: 'mt 11/2/2010 12:13:05.791'!
click: evt

	| index |
	index := self modelIndexFor: (self cellIndexFromPoint: evt position).
	self
		clicked: index;
		activated: index.
	
	index ifNil: [^ self].
	
	"Open context menu."
	index menu ifNotNil: [:menu |
		evt yellowButtonPressed ifTrue: [menu popUpEvent: evt in: ActiveWorld]].! !

!UiItemViewport methodsFor: 'signals' stamp: 'mt 10/8/2010 16:05:54.303'!
clicked: aModelIndex

	self emit.! !

!UiItemViewport methodsFor: 'add/remove' stamp: 'mt 10/14/2010 09:45:01.756'!
collapseRow: aRowInfo

	| foundFirst predecessors |
	foundFirst := false.
	predecessors := {aRowInfo} asOrderedCollection.
	rows
		select: [:row |
			"Find all rows and subrows that need to be removed."
			(predecessors anySatisfy: [:pred | row parentModelIndex = pred firstModelIndex])
				ifTrue: [predecessors add: row. foundFirst := true]
				ifFalse: [foundFirst ifTrue: [predecessors := #()]. false]]
		thenDo: [:row | self removeRow: row].! !

!UiItemViewport methodsFor: 'rows/columns - to info' stamp: 'mt 10/16/2010 19:56:38.765'!
columnAt: index

	index > columns size
		ifTrue: [index - columns size timesRepeat: [columns add: UiViewColumnInfo new]].
	
	^ self columnOrder items: columns at: index! !

!UiItemViewport methodsFor: 'rows/columns - to pixel' stamp: 'mt 10/16/2010 19:58:57.129'!
columnBoundsFor: aColIndex

	| col |
	aColIndex > columns size
		ifTrue: [^ 0@0 extent: 0@0].
		
	col := self columnAt: aColIndex.
	
	^ (self leftForColumn: col) @ self top
		extent: col width @ self height! !

!UiItemViewport methodsFor: 'rows/columns - to info' stamp: 'mt 10/9/2010 11:26:53.355'!
columnFor: aModelIndex

	^ columns
		at: aModelIndex column
		ifAbsentPut: [UiViewColumnInfo new]! !

!UiItemViewport methodsFor: 'accessing' stamp: 'mt 10/16/2010 15:00:57.992'!
columnOrder

	^ columnOrder! !

!UiItemViewport methodsFor: 'accessing - private' stamp: 'mt 1/4/2011 10:23:35.14'!
columns
	"Returns all columns IGNORING CURRENT SORT ORDER."
	
	^ columns! !

!UiItemViewport methodsFor: 'enumerating - ordered' stamp: 'mt 10/17/2010 08:20:05.896'!
columnsDo: aBlock

	self columnOrder items: columns do: aBlock.! !

!UiItemViewport methodsFor: 'enumerating - ordered' stamp: 'mt 10/17/2010 08:20:10.134'!
columnsWithIndexDo: aBlock

	self columnOrder items: columns withIndexDo: aBlock.! !

!UiItemViewport methodsFor: 'signals' stamp: 'mt 10/20/2010 13:54:10.953'!
currentIndexChanged: aModelIndex

	self emit.! !

!UiItemViewport methodsFor: 'rows/columns - to model index' stamp: 'mt 10/20/2010 14:05:41.933'!
currentModelIndex

	^ self modelIndexFor: self selection currentCell! !

!UiItemViewport methodsFor: 'event handling' stamp: 'mt 2/17/2011 19:57:02.823'!
doubleClick: evt

	(self modelIndexFor: (self cellIndexFromPoint: evt position))
		ifNotNil: [:index |
			self
				doubleClicked: index;
				activated: index].! !

!UiItemViewport methodsFor: 'signals' stamp: 'mt 10/8/2010 16:05:00.799'!
doubleClicked: aModelIndex

	self emit.! !

!UiItemViewport methodsFor: 'drawing' stamp: 'mt 10/16/2010 14:30:59.752'!
drawCurrentCellOn: aCanvas

	self selection currentCell ifNil: [^ self].
	
	self selectionBehavior = #selectCells ifTrue: [
		self
			drawHighlightOn: aCanvas
			bounds: (self cellBoundsFor: self selection currentCell)
			color: self selectionColor darker.
		^ self].
		
	self selectionBehavior = #selectRows ifTrue: [
		self
			drawHighlightOn: aCanvas
			bounds: (self rowBoundsFor: self selection currentCell y)
			color: self selectionColor darker.
		^ self].
	
	self selectionBehavior = #selectColumns ifTrue: [
		self
			drawHighlightOn: aCanvas
			bounds: (self columnBoundsFor: self selection currentCell x)
			color: self selectionColor darker.
		^ self]! !

!UiItemViewport methodsFor: 'drawing' stamp: 'mt 10/11/2010 14:34:39.295'!
drawHighlightOn: aCanvas bounds: drawBounds color: aColor
	
	| gradient |

	gradient := (GradientFillStyle ramp: {
			0.0 -> Color white.
			0.1-> (aColor adjustBrightness: 0.05).
			0.6 -> (aColor darker)})
		origin: drawBounds topLeft;
		direction: 0 @ drawBounds height.
		
	aCanvas
		fillRoundRect: (drawBounds insetBy: (1@1 corner: 0@0))
		radius: 3
		fillStyle: gradient;
		frameRoundRect: (drawBounds outsetBy: (0@0 corner: 1@1))
		radius: 3
		width: 1
		color: aColor muchDarker.! !

!UiItemViewport methodsFor: 'drawing' stamp: 'mt 10/11/2010 14:41:13.054'!
drawHoveredCellOn: aCanvas

	self hoveredCell ifNil: [^ self].
	
	self selectionBehavior = #selectCells ifTrue: [
		self
			drawHighlightOn: aCanvas
			bounds: (self cellBoundsFor: self hoveredCell)
			color: self selectionColor muchLighter.
		^ self].
		
	self selectionBehavior = #selectRows ifTrue: [
		self
			drawHighlightOn: aCanvas
			bounds: (self rowBoundsFor: self hoveredCell y)
			color: self selectionColor muchLighter.
		^ self].
	
	self selectionBehavior = #selectColumns ifTrue: [
		self
			drawHighlightOn: aCanvas
			bounds: (self columnBoundsFor: self hoveredCell x)
			color: self selectionColor muchLighter.
		^ self]! !

!UiItemViewport methodsFor: 'drawing' stamp: 'mt 10/14/2010 13:16:54.342'!
drawOn: aCanvas
	
	self
		drawHoveredCellOn: aCanvas;
		drawSelectionOn: aCanvas;
		drawCurrentCellOn: aCanvas.
	super drawOn: aCanvas.! !

!UiItemViewport methodsFor: 'drawing' stamp: 'mt 10/11/2010 09:25:33.057'!
drawSelectionOn: aCanvas

	self selectionBehavior = #selectCells ifTrue: [
		self selection cells do: [:cell |
			self
				drawSelectionOn: aCanvas
				bounds: (self cellBoundsFor: cell)	].
			^ self].
		
	self selectionBehavior = #selectRows ifTrue: [
		(self selection cells collect: [:cell | cell y]) asSet do: [:rowIndex |
			self
				drawSelectionOn: aCanvas
				bounds: (self rowBoundsFor: rowIndex)].
		^ self].
	
	self selectionBehavior = #selectColumns ifTrue: [
		(self selection cells collect: [:cell | cell x]) asSet do: [:colIndex |
			self
				drawSelectionOn: aCanvas
				bounds: (self columnBoundsFor: colIndex)].
		^ self]! !

!UiItemViewport methodsFor: 'drawing' stamp: 'mt 10/11/2010 14:17:16.138'!
drawSelectionOn: aCanvas bounds: drawBounds
	
	self
		drawHighlightOn: aCanvas
		bounds: drawBounds
		color: self selectionColor.! !

!UiItemViewport methodsFor: 'drawing' stamp: 'mt 10/16/2010 20:02:30.608'!
drawSubmorphsOn: aCanvas 
	"Clip in cells. Optimized."
	
	| offset |
	submorphs isEmpty ifTrue: [^self].
	
	offset := self topLeft.
	self columnsWithIndexDo: [:colInfo :colIndex |
		
		self rowOrder items: colInfo items withIndexDo: [:item :rowIndex | | rowInfo |
			rowInfo := rows at: rowIndex.
			aCanvas
				clipBy: (offset extent: colInfo width @ rowInfo height)
				during: [:canvas | canvas fullDrawMorph: item].
			
			offset := offset translateBy: 0 @ rowInfo height].
		
		offset := (offset x + colInfo width) @ self top].! !

!UiItemViewport methodsFor: 'geometry' stamp: 'mt 10/10/2010 13:03:00.575'!
extent: aPoint

	super extent: aPoint.
	self resizedToWidth: aPoint x height: aPoint y.! !

!UiItemViewport methodsFor: 'signals' stamp: 'mt 10/11/2010 17:18:00.533'!
focusChanged: aRectangle
	"Indicate that a scrollable container should ensure the given area as visible."
	
	self emit.! !

!UiItemViewport methodsFor: 'event handling' stamp: 'mt 10/11/2010 14:52:42.129'!
handleMouseMove: anEvent

	super handleMouseMove: anEvent.
	
	anEvent wasHandled not
	"	and: [anEvent hand mouseFocus == self])"
		ifTrue: [self mouseMove: anEvent. anEvent wasHandled: true]! !

!UiItemViewport methodsFor: 'event handling' stamp: 'mt 10/11/2010 16:53:44.92'!
handlesKeyboard: evt

	^ true! !

!UiItemViewport methodsFor: 'event handling' stamp: 'mt 10/8/2010 15:30:36.577'!
handlesMouseDown: evt

	^ true! !

!UiItemViewport methodsFor: 'event handling' stamp: 'mt 10/11/2010 14:46:59'!
handlesMouseOver: evt

	^ true! !

!UiItemViewport methodsFor: 'accessing' stamp: 'mt 10/10/2010 14:00:05.566'!
horizontalHeader

	^ horizontalHeader! !

!UiItemViewport methodsFor: 'accessing' stamp: 'mt 10/10/2010 14:00:11.666'!
horizontalHeader: aMorph

	horizontalHeader := aMorph.! !

!UiItemViewport methodsFor: 'accessing' stamp: 'mt 10/11/2010 14:39:13.856'!
hoveredCell

	^ hoveredCell! !

!UiItemViewport methodsFor: 'accessing' stamp: 'mt 10/11/2010 17:13:05.489'!
hoveredCell: aPoint

	aPoint = hoveredCell
		ifTrue: [^ self].
		
	hoveredCell := aPoint.
	self redrawLater.! !

!UiItemViewport methodsFor: 'accessing' stamp: 'mt 10/16/2010 08:01:57.895'!
indent
	"Defines how much items of the first column will be moved to the left for each level - including the first one."
	
	^ 0! !

!UiItemViewport methodsFor: 'initialization' stamp: 'mt 10/18/2010 19:06:56.478'!
initialize

	super initialize.
	self color: Color transparent.
		
	rows := OrderedCollection new.
	columns := OrderedCollection new.
	
	rowOrder := UiItemOrder new.
	columnOrder := UiItemOrder new.
	
	self selectionMode: UiViewSingleSelection.! !

!UiItemViewport methodsFor: 'testing' stamp: 'mt 10/14/2010 10:50:19.462'!
isExpanded: aModelIndex

	^ aModelIndex isNil "the root is always expanded"
		or: [(self rowFor: aModelIndex) isExpanded]! !

!UiItemViewport methodsFor: 'signals' stamp: 'mt 2/28/2011 13:54:03.579'!
keyPressed: aKeyCharacter

	self emit.! !

!UiItemViewport methodsFor: 'event handling' stamp: 'mt 2/28/2011 13:56:42.201'!
keyStroke: evt

	| cc |
	cc := self selection currentCell.
	
	(({Character cr. Character lf. Character enter} includes: evt keyCharacter)
		and: [cc notNil])
		ifTrue: [
			self
				activated: self currentModelIndex;
				returnPressed: self currentModelIndex].

	"Manuall navigation."
	cc ifNil: [^ self selection add: 1@1 event: evt].

	evt keyCharacter = Character arrowUp
		ifTrue: [self selection add: (cc - (0@1) max: 1@1) event: evt].
		
	evt keyCharacter = Character arrowDown
		ifTrue: [self selection add: (cc + (0@1) min: (columns size @ rows size) max: 1@1) event: evt].
		
	evt keyCharacter = Character arrowLeft
		ifTrue: [self selection add: (cc - (1@0) max: 1@1) event: evt].
		
	evt keyCharacter = Character arrowRight
		ifTrue: [self selection add: (cc + (1@0) min: (columns size @ rows size) max: 1@1) event: evt].! !

!UiItemViewport methodsFor: 'rows/columns - to pixel' stamp: 'mt 10/16/2010 19:59:37.763'!
leftForColumn: aColumnInfo

	| result |
	result := self left.
	self columnsDo: [:col |
		col = aColumnInfo ifTrue: [^ result].
		result := result + col width].
	
	Error signal: 'Column info not found!!'.! !

!UiItemViewport methodsFor: 'rows/columns - to model index' stamp: 'mt 10/17/2010 09:23:15.593'!
modelIndexFor: aCellIndex

	aCellIndex ifNil: [^ nil].

	^ (self rowOrder items: (self columnAt: aCellIndex x) items at: aCellIndex y)
		valueOfProperty: #modelIndex! !

!UiItemViewport methodsFor: 'rows/columns - to morph' stamp: 'mt 11/2/2010 12:15:11.611'!
morphFor: aCellIndex

	^ (rows at: aCellIndex y) items at: aCellIndex x! !

!UiItemViewport methodsFor: 'event handling' stamp: 'mt 11/2/2010 12:16:23.113'!
mouseDown: evt

	| cell |
	cell := self cellIndexFromPoint: evt position.
	self selection
		add: cell
		event: evt.
	
	cell ifNotNil: [(self morphFor: cell) mouseDown: evt].
	
	evt hand
		waitForClicksOrDrag: self
		event: evt
		selectors: {#click:. #doubleClick:. nil. #startDrag:}
		threshold: 1. ! !

!UiItemViewport methodsFor: 'events-processing' stamp: 'mt 11/2/2010 12:14:09.641'!
mouseDownPriority
	"Should be great enough to catch all mouse-downs for item morphs."
	
	^ 25! !

!UiItemViewport methodsFor: 'event handling' stamp: 'mt 10/11/2010 16:57:04.191'!
mouseEnter: evt

	evt hand newKeyboardFocus: self.! !

!UiItemViewport methodsFor: 'event handling' stamp: 'mt 10/11/2010 14:49:23.957'!
mouseLeave: evt

	self hoveredCell: nil.! !

!UiItemViewport methodsFor: 'event handling' stamp: 'mt 10/11/2010 14:49:27.815'!
mouseMove: evt

	self hoveredCell: (self cellIndexFromPoint: evt position).! !

!UiItemViewport methodsFor: 'selection' stamp: 'mt 10/20/2010 14:06:02.419'!
onCurrentCellChanged

	self currentIndexChanged: self currentModelIndex.! !

!UiItemViewport methodsFor: 'selection' stamp: 'mt 10/20/2010 14:07:02.107'!
onSelectionChanged

	self selectionChanged: self selectedModelIndices.! !

!UiItemViewport methodsFor: 'add/remove - private' stamp: 'mt 10/14/2010 11:37:04.05'!
removeRow: aRowInfo

	aRowInfo items withIndexDo: [:item :index |
		(columns at: index) items remove: item].
	
	self removeAllMorphsIn: aRowInfo items.
	rows remove: aRowInfo.! !

!UiItemViewport methodsFor: 'add/remove' stamp: 'mt 10/14/2010 11:40:59.344'!
removeRowFor: aParentModelIndex at: rowIndex

	self removeRow: (rows detect: [:row |
		row parentModelIndex = aParentModelIndex and: [row firstModelIndex row = rowIndex]])! !

!UiItemViewport methodsFor: 'add/remove' stamp: 'mt 2/18/2011 00:03:54.437'!
replaceMorphWith: aMorph atIndex: aModelIndex

	| oldMorph col row indent |
	oldMorph := (rows detect: [:rowInfo | rowInfo includes: aModelIndex]) itemAt: aModelIndex.
	
	aMorph setProperty: #modelIndex toValue: aModelIndex.
	aMorph setProperty: #isExpanded toValue: (oldMorph valueOfProperty: #isExpanded).
	aMorph setProperty: #hasChildren toValue: aModelIndex hasChildren.
	
	row := self rowFor: aModelIndex.
	row items
		add: aMorph after: oldMorph;
		remove: oldMorph.
	
	col := self columnFor: aModelIndex.
	col items
		add: aMorph after: oldMorph;
		remove: oldMorph.
	
	self
		removeMorph: oldMorph;
		addMorphBack: aMorph.
	
	"Correct indent."
	indent := 0.
	(aModelIndex column = 1) ifTrue: [
		| itemBefore |
		itemBefore := aMorph.
		[(itemBefore := col itemBefore: itemBefore)
			ifNil: [indent := self indent. false] "root"
			ifNotNil: [:item |
				"The item before is my parent. Add additional indentation."
				(item valueOfProperty: #modelIndex) = aModelIndex parent
					ifTrue: [indent := (item valueOfProperty: #indent) + self indent. false]
					ifFalse: ["The item before is my sibling. Use its indentation."
						(item valueOfProperty: #modelIndex) parent = aModelIndex parent
							ifTrue: [indent := item valueOfProperty: #indent. false]
							ifFalse: [true]]].
			] whileTrue: []].
	aMorph setProperty: #indent toValue: indent.! !

!UiItemViewport methodsFor: 'signals' stamp: 'mt 10/10/2010 13:02:41.787'!
resizedToWidth: newWidth height: newHeight

	self emit.! !

!UiItemViewport methodsFor: 'signals' stamp: 'mt 2/28/2011 13:19:02.384'!
returnPressed: aModelIndex

	self emit.! !

!UiItemViewport methodsFor: 'rows/columns - to info' stamp: 'mt 10/16/2010 19:56:47.691'!
rowAt: index

	^ self rowOrder items: rows at: index! !

!UiItemViewport methodsFor: 'rows/columns - to pixel' stamp: 'mt 10/16/2010 19:59:07.12'!
rowBoundsFor: aRowIndex

	| row |
	aRowIndex > rows size
		ifTrue: [^ 0@0 extent: 0@0].
		
	row := self rowAt: aRowIndex.
	
	^ self left @ (self topForRow: row)
		extent: self width @ row height! !

!UiItemViewport methodsFor: 'rows/columns - to info' stamp: 'mt 10/9/2010 16:12:41.64'!
rowFor: aModelIndex

	^ rows detect: [:row | row includes: aModelIndex]! !

!UiItemViewport methodsFor: 'accessing' stamp: 'mt 10/16/2010 15:00:50.256'!
rowOrder

	^ rowOrder! !

!UiItemViewport methodsFor: 'accessing - private' stamp: 'mt 1/4/2011 10:23:22.573'!
rows
	"Returning all rows IGNORING CURRENT SORT ORDER."
	
	^ rows! !

!UiItemViewport methodsFor: 'enumerating - ordered' stamp: 'mt 10/16/2010 19:06:41.893'!
rowsDo: aBlock

	self rowOrder items: rows do: aBlock.! !

!UiItemViewport methodsFor: 'enumerating - ordered' stamp: 'mt 10/16/2010 19:49:38.102'!
rowsWithIndexDo: aBlock

	self rowOrder items: rows withIndexDo: aBlock.! !

!UiItemViewport methodsFor: 'rows/columns - to model index' stamp: 'mt 10/20/2010 14:07:17.985'!
selectedModelIndices

	^ self selection cells collect: [:cellIndex |
		self modelIndexFor: cellIndex]! !

!UiItemViewport methodsFor: 'selection' stamp: 'mt 10/10/2010 20:03:34.835'!
selection

	^ selection! !

!UiItemViewport methodsFor: 'selection' stamp: 'mt 10/20/2010 14:43:53.154'!
selection: aSelection

	selection := aSelection.
	
	self connect: aSelection signal: #selectionChanged toSelector: #redrawLater.
	self connect: aSelection signal: #selectionChanged toSelector: #updateFocus.
	self connect: aSelection signal: #currentCellChanged toSelector: #redrawLater.
	self connect: aSelection signal: #selectionChanged toSelector: #onSelectionChanged.
	self connect: aSelection signal: #currentCellChanged toSelector: #onCurrentCellChanged.
	
	self redrawLater.! !

!UiItemViewport methodsFor: 'selection' stamp: 'mt 10/14/2010 13:50:42.369'!
selectionBehavior

	^ selectionBehavior ifNil: [selectionBehavior := #selectCells]! !

!UiItemViewport methodsFor: 'selection' stamp: 'mt 10/11/2010 09:28:20.274'!
selectionBehavior: aSymbol
	"#selectCells, #selectRows, #selectColumns"

	selectionBehavior := aSymbol.
	self redrawLater.! !

!UiItemViewport methodsFor: 'signals' stamp: 'mt 10/20/2010 13:45:49.758'!
selectionChanged: someModelIndices

	self emit.! !

!UiItemViewport methodsFor: 'selection' stamp: 'mt 10/11/2010 14:30:17.153'!
selectionColor

	^ selectionColor ifNil: [selectionColor := Color r: 0.772 g: 0.858 b: 1.0]! !

!UiItemViewport methodsFor: 'selection' stamp: 'mt 10/8/2010 14:37:57.041'!
selectionColor: aColor

	selectionColor := aColor.! !

!UiItemViewport methodsFor: 'selection' stamp: 'mt 10/11/2010 09:04:47.949'!
selectionMode

	^ selectionMode! !

!UiItemViewport methodsFor: 'selection' stamp: 'mt 10/11/2010 09:04:07.606'!
selectionMode: aSelectionClass

	selectionMode := aSelectionClass.
	self selection: aSelectionClass new.! !

!UiItemViewport methodsFor: 'add/remove' stamp: 'mt 2/9/2011 16:07:05.386'!
setHeaderItem: aMorph atColumn: anInteger

	columns ifEmpty: [
		Transcript
			cr;
			show: '[UiTreeViewPort] Warning!! No columns to set the header!!'.
		^ self].

	(columns at: anInteger) headerItem: aMorph.! !

!UiItemViewport methodsFor: 'add/remove' stamp: 'mt 10/12/2010 11:50:38.889'!
setHeaderItem: aMorph atRow: anInteger

	(rows at: anInteger) headerItem: aMorph.! !

!UiItemViewport methodsFor: 'event handling' stamp: 'mt 10/19/2010 15:40:41.889'!
startDrag: evt 
	
	evt hand hasSubmorphs ifTrue: [^ self].
	self dragEnabled ifFalse: [^ self].
	
	[ | index ddm |
	
	(index := self modelIndexFor: (self cellIndexFromPoint: evt position))
		ifNil: [^ self].

	evt hand grabMorph: (TransferMorph withPassenger: index)]
		ensure: [Cursor normal show.
			evt hand releaseMouseFocus: self]! !

!UiItemViewport methodsFor: 'rows/columns - to pixel' stamp: 'mt 10/16/2010 19:59:22.557'!
topForRow: aRowInfo

	| result |
	result := self top.
	self rowsDo: [:row |
		row = aRowInfo ifTrue: [^ result].
		result := result + row height].
	
	Error signal: 'Row info not found!!'.! !

!UiItemViewport methodsFor: 'layouting' stamp: 'mt 10/16/2010 19:47:10.47'!
updateColumnsLayout

	| offset |
	self columnsDo: [:colInfo |
		offset := 0.
		self rowOrder items: colInfo items withIndexDo: [:item :rowIndex |
			| height |
			height := (rows at: rowIndex) height.
			colInfo vAlignment = #top
				ifTrue: [item top: offset].
			colInfo vAlignment = #center
				ifTrue: [item top: offset + (height - item height // 2)].
			colInfo vAlignment = #bottom
				ifTrue: [item bottom: offset + height].
							
			offset := offset + height]].! !

!UiItemViewport methodsFor: 'geometry' stamp: 'mt 10/11/2010 18:07:00.708'!
updateExtent

	self extent:
		(columns
			ifEmpty: [0]
			ifNotEmpty: [(columns collect: [:col | col width]) sum])
		@
		(rows
			ifEmpty: [0]
			ifNotEmpty: [(rows collect: [:row | row height]) sum])! !

!UiItemViewport methodsFor: 'layouting' stamp: 'mt 10/16/2010 18:00:37.584'!
updateFirstColumnIndent

	columns first items do: [:item |
		item left: item left + (item valueOfProperty: #indent)].! !

!UiItemViewport methodsFor: 'updating' stamp: 'mt 10/16/2010 08:23:31.568'!
updateFocus
	"The important part is always the current cell."
	
	self selection currentCell ifNotNil: [:cc |
		self focusChanged: (self cellBoundsFor: cc)].! !

!UiItemViewport methodsFor: 'layouting' stamp: 'mt 10/16/2010 19:45:11.53'!
updateHeaderLayout
	"Relayout changed header items."
	
	self horizontalHeader ifNotNil: [:hh |
		hh removeAllMorphs.
		self columnsDo: [:colInfo | hh addMorphBack: colInfo headerItem]].
	self verticalHeader ifNotNil: [:vh |
		vh removeAllMorphs.
		self rowsDo: [:rowInfo | vh addMorphBack: rowInfo headerItem]].! !

!UiItemViewport methodsFor: 'add/remove' stamp: 'mt 11/2/2010 10:14:06.585'!
updateIndex: newModelIndex oldIndex: formerModelIndex

	| morph |
	morph := (rows reverseDetect: [:rowInfo | rowInfo includes: formerModelIndex]) itemAt: formerModelIndex.
	morph setProperty: #modelIndex toValue: newModelIndex.! !

!UiItemViewport methodsFor: 'layouting' stamp: 'mt 10/16/2010 19:47:21.042'!
updateItemOrder

	"Sort after first column for now."
	self rowOrder updateWith: columns first items.! !

!UiItemViewport methodsFor: 'layouting' stamp: 'mt 10/16/2010 18:03:45.47'!
updateLayout

	columns ifEmpty: [^ self].
	
	self
		updateSizesOfRowsAndColumns;
		updateItemOrder;
		updateColumnsLayout;
		updateRowsLayout;
		updateFirstColumnIndent;
		updateHeaderLayout;
		updateExtent.! !

!UiItemViewport methodsFor: 'layouting' stamp: 'mt 10/16/2010 19:44:44.663'!
updateRowsLayout

	| offset |
	self rowsDo: [:rowInfo |
		offset := 0.
		self columnOrder items: rowInfo items withIndexDo: [:item :colIndex |
			| width hAlignment |
			width := (columns at: colIndex) width.
			hAlignment := (columns at: colIndex) hAlignment.
			hAlignment = #left
				ifTrue: [item left: offset].
			hAlignment = #center
				ifTrue: [item left: offset + (width - item width // 2)].
			hAlignment = #right
				ifTrue: [item right: offset + width].
			
			offset := offset + width]].! !

!UiItemViewport methodsFor: 'layouting' stamp: 'mt 10/16/2010 08:11:00.988'!
updateSizesOfRowsAndColumns

	columns do: [:column | column updateSize].
	rows do: [:row | row updateSize].! !

!UiItemViewport methodsFor: 'accessing' stamp: 'mt 10/10/2010 13:59:56.367'!
verticalHeader

	^ verticalHeader! !

!UiItemViewport methodsFor: 'accessing' stamp: 'mt 10/10/2010 13:59:50.126'!
verticalHeader: aMorph

	verticalHeader := aMorph.! !

UiItemViewport subclass: #UiListViewport
	instanceVariableNames: 'orientation maxItemExtent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Views-Support'!

!UiListViewport commentStamp: 'mt 11/2/2010 12:46:22.16' prior: 0!
A specialized item viewport that has different layout strategies for its items as they are only a list. See the #orientation: commment for more information about possible layouting.!

!UiListViewport methodsFor: 'as yet unclassified' stamp: 'mt 2/27/2011 16:11:29.694'!
addRowFor: aModelIndex
	"Adds a new row if needed. Returns the correct one if possible."
	
	| row isCorrectRow isPreviousSibling |
	isCorrectRow := [:r | r parentModelIndex = aModelIndex parent
		and: [r firstModelIndex row = aModelIndex row]].
	isPreviousSibling := [:r | r parentModelIndex = aModelIndex parent 
		and: [r firstModelIndex row = (aModelIndex row - 1)]].
	
	rows reverseDetect: [:r |
		(isCorrectRow value: r)
			ifTrue: [row := r. true]
			ifFalse: [(isPreviousSibling value: r)
				ifTrue: [row := rows add: UiViewRowInfo new after: r. true]
				ifFalse: [false]]
		] ifNone: [row := rows add: UiViewRowInfo new].
	
	^ row! !

!UiListViewport methodsFor: 'rows/columns - to pixel' stamp: 'mt 10/14/2010 17:21:49.457'!
cellBoundsFor: aCellIndex

	self orientation = #default
		ifTrue: [^ super cellBoundsFor: aCellIndex].

	^ (((aCellIndex - (1@1)) * maxItemExtent) + self topLeft)
		extent: maxItemExtent! !

!UiListViewport methodsFor: 'rows/columns - to cell' stamp: 'mt 10/17/2010 10:14:26.148'!
cellIndexFromPoint: aPoint
	"Given a point in pixel coordinates."
	
	| cell |
	self orientation = #default ifTrue: [
		| offset cellIndex |
		offset := self topLeft.
		cellIndex := 1@0.
		self rowsDo: [:rowInfo | 
			cellIndex := cellIndex + (0@1).
			((offset extent: self width @ rowInfo height) containsPoint: aPoint)
				ifTrue: [^ cellIndex].
			offset := offset translateBy: 0 @ rowInfo height].
	
		^ nil].
	
	cell := ((aPoint - self topLeft) // (maxItemExtent)) + (1@1).
	
	self orientation = #vertical
		ifTrue: [
			(cell x > self maxItemsPerLine
				or: [cell y - 1 * self maxItemsPerLine + cell x > rows size])
				ifTrue: [^ nil]]
		ifFalse: [
			(cell y > self maxItemsPerLine
				or: [cell x - 1 * self maxItemsPerLine + cell y > rows size])
				ifTrue: [^ nil]].
	
	^ cell! !

!UiListViewport methodsFor: 'drawing' stamp: 'mt 10/14/2010 17:21:08.76'!
drawSubmorphsOn: aCanvas 
	
	self orientation = #default
		ifTrue: [^ super drawSubmorphsOn: aCanvas].
		
	submorphs isEmpty ifTrue: [^self].	
	aCanvas
		clipBy: self clippingBounds
		during: [:canvas | submorphs reverseDo: [:m | canvas fullDrawMorph: m]]! !

!UiListViewport methodsFor: 'initialization' stamp: 'mt 10/14/2010 20:57:45.903'!
initialize

	super initialize.
	maxItemExtent := 1@1.
	self orientation: #default.! !

!UiListViewport methodsFor: 'accessing' stamp: 'mt 10/20/2010 14:33:09.036'!
maxItemExtent

	^ maxItemExtent! !

!UiListViewport methodsFor: 'calculation' stamp: 'mt 10/14/2010 15:23:06.979'!
maxItemsPerLine

	self orientation = #vertical
		ifTrue: [^ self width // maxItemExtent x]
		ifFalse: [^ self height // maxItemExtent y]! !

!UiListViewport methodsFor: 'rows/columns - to model index' stamp: 'mt 10/17/2010 10:01:36.664'!
modelIndexFor: aCellIndex

	self orientation = #default
		ifTrue: [^ super modelIndexFor: aCellIndex].

	aCellIndex ifNil: [^ nil].
	
	^ (self orientation = #vertical
		ifTrue: [self rowAt: aCellIndex y - 1 * self maxItemsPerLine + aCellIndex x]
		ifFalse: [self rowAt: aCellIndex x - 1 * self maxItemsPerLine + aCellIndex y]) firstModelIndex! !

!UiListViewport methodsFor: 'rows/columns - to morph' stamp: 'mt 11/11/2010 10:29:49.14'!
morphFor: aCellIndex

	self orientation = #default
		ifTrue: [^ super morphFor: aCellIndex].

	aCellIndex ifNil: [^ nil].
	
	^ (self orientation = #vertical
		ifTrue: [self rowAt: aCellIndex y - 1 * self maxItemsPerLine + aCellIndex x]
		ifFalse: [self rowAt: aCellIndex x - 1 * self maxItemsPerLine + aCellIndex y]) items first! !

!UiListViewport methodsFor: 'accessing' stamp: 'mt 10/20/2010 14:53:11.793'!
optimalSize

	columns ifEmpty: [^ 1@1].

	self orientation = #default ifTrue: [
		^ columns first optimalSize @ self height].
	
	self orientation = #vertical ifTrue: [
		^ maxItemExtent x @ self height].
	
	self orientation = #horizontal ifTrue: [
		^ self width @ maxItemExtent y].! !

!UiListViewport methodsFor: 'accessing' stamp: 'mt 10/14/2010 17:21:19.074'!
orientation

	^ orientation! !

!UiListViewport methodsFor: 'accessing' stamp: 'mt 10/14/2010 17:30:02.272'!
orientation: aSymbol
	"#vertical ... items go from left to right and break at width -> vertical scrolling
	#horizontal ... items go from top to bottom and break at height -> horizontal scrolling"

	aSymbol = orientation ifTrue: [^ self].
	orientation := aSymbol.
	
	orientation = #default
		ifTrue: [self selectionBehavior: #selectRows]
		ifFalse: [self selectionBehavior: #selectCells].! !

!UiListViewport methodsFor: 'geometry' stamp: 'mt 10/20/2010 14:53:43.833'!
updateExtent

	columns ifEmpty: [^ self].
	
	self orientation = #default ifTrue: [
		| newHeight optimalWidth |	
		newHeight := rows
			ifEmpty: [0]
			ifNotEmpty: [(rows collect: [:row | row height]) sum].
	
		optimalWidth := columns first optimalSize.
	
		^ optimalWidth < self owner width
			ifTrue: [self extent: self owner width - 5 @ newHeight]
			ifFalse: [self extent: optimalWidth @ newHeight]].
		
	self extent: (((self submorphBounds extent / maxItemExtent) ceiling * maxItemExtent)
		max: (self owner extent - 5)).! !

!UiListViewport methodsFor: 'layouting' stamp: 'mt 10/17/2010 10:03:25.756'!
updateLayout

	"There is no list wrapping in #default layout. Just use the super implementation."
	self orientation = #default
		ifTrue: [^ super updateLayout].	
	
	columns ifEmpty: [^ self].
	
	self
		updateItemOrder;
		updateMaxItemExtent;
		updateSingleColumnLayout;
		updateExtent.! !

!UiListViewport methodsFor: 'layouting' stamp: 'mt 10/16/2010 18:06:54.189'!
updateMaxItemExtent

	maxItemExtent := 1@1.
	columns first items do: [:item | maxItemExtent := maxItemExtent max: item extent].! !

!UiListViewport methodsFor: 'layouting' stamp: 'mt 10/17/2010 10:03:58.353'!
updateSingleColumnLayout

	| offset hAlignment |
	offset := self topLeft.
	hAlignment := columns first hAlignment.

	self rowOrder items: columns first items do: [:item |		
		hAlignment = #left
			ifTrue: [item topLeft: offset].
		hAlignment = #center
			ifTrue: [item topLeft: offset + ((maxItemExtent x - item width)//2 @0)].
		hAlignment = #right
			ifTrue: [item topRight: offset + (maxItemExtent x @ 0)].

		self orientation = #vertical
			ifTrue: [
				offset := offset + (maxItemExtent x @ 0).
				(offset x + maxItemExtent x)  > (self owner width - 5)
					ifTrue: [offset := self left @ (offset y + maxItemExtent y)]]
			ifFalse: [
				offset := offset + (0 @ maxItemExtent y).
				(offset y + maxItemExtent y)  > (self owner height - 5)
					ifTrue: [offset := (offset x + maxItemExtent x) @ self top]]].! !

UiItemViewport subclass: #UiTableViewport
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Views-Support'!

!UiTableViewport commentStamp: 'mt 11/2/2010 12:46:43.653' prior: 0!
A specialized viewport that can draw a grid.!

!UiTableViewport methodsFor: 'drawing' stamp: 'mt 10/14/2010 14:00:23.706'!
drawGridOn: aCanvas

	| offset |
	offset := self left.
	self columnsDo: [:colInfo | 
		offset := offset  + colInfo width.
		aCanvas
			line: offset @ self top
			to: offset @ self bottom
			color: (Color gray: 0.9)].
		
	offset := self top.
	self rowsDo: [:rowInfo | 
		offset := offset  + rowInfo height.
		aCanvas
			line: self left @ offset
			to: self right @ offset
			color: (Color gray: 0.9)].! !

!UiTableViewport methodsFor: 'drawing' stamp: 'mt 10/14/2010 13:57:07.344'!
drawOn: aCanvas

	self drawGridOn: aCanvas.
	super drawOn: aCanvas.! !

UiItemViewport subclass: #UiTreeViewport
	instanceVariableNames: 'indent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Views-Support'!

!UiTreeViewport commentStamp: 'mt 11/2/2010 12:47:08.195' prior: 0!
A specialized item viewport that handles hierarchical items in the first column.!

!UiTreeViewport methodsFor: 'event handling' stamp: 'mt 10/17/2010 09:58:48.421'!
click: evt

	| cell item |
	cell := self cellIndexFromPoint: evt position.
	cell ifNil: [^ self].
	
	item := (self rowAt: cell y) items at: 1.

	"Recognize a click on the decoration."
	(evt position x < item left
		and: [evt position x >= (item left - self indent)])
		ifTrue: [self decorationClicked: (item valueOfProperty: #modelIndex)].! !

!UiTreeViewport methodsFor: 'signals' stamp: 'mt 10/14/2010 13:13:30.709'!
decorationClicked: aModelIndex
	"Whenever the user clicks the expand/collapse decoration in front of an item."
	
	self emit.! !

!UiTreeViewport methodsFor: 'drawing' stamp: 'mt 10/14/2010 13:16:22.359'!
drawOn: aCanvas
	
	super drawOn: aCanvas.
	self drawTreeStructureOn: aCanvas.! !

!UiTreeViewport methodsFor: 'drawing' stamp: 'mt 10/17/2010 09:54:46.812'!
drawTreeStructureOn: aCanvas
	
	| first last |
	columns ifEmpty: [^ self].
	
	(self leftForColumn: columns first) < aCanvas clipRect left
		ifTrue: [^ self].
	
	first := self cellIndexFromPoint: (self bounds pointNearestTo: aCanvas clipRect topLeft).
	last := self cellIndexFromPoint: (self bounds pointNearestTo: aCanvas clipRect bottomLeft).

	first ifNil: [first := 1@1].
	last ifNil: [last := 1@rows size].
	
	last < first ifTrue: [^ self].

	first y to: last y do: [:rowIndex |
		| colIndex item cellBounds form |
		colIndex := self columnOrder unmapIndex: 1.
		cellBounds := self cellBoundsFor: colIndex@rowIndex.
		item := self columnOrder items: (self rowAt: rowIndex) items at: colIndex.
		form := UiSilkIcons bulletArrowDownIcon.
		form := (item valueOfProperty: #hasChildren)
			ifFalse: [nil]
			ifTrue: [(item valueOfProperty: #isExpanded)
				ifFalse: [form rotateBy: #left centerAt: 8@8]
				ifTrue: [form]].

		form ifNotNil: [
			aCanvas
				translucentImage: form
				at: (cellBounds left + ((item valueOfProperty: #indent) - self indent))
					@ (cellBounds top + (cellBounds height - form height // 2))]].! !

!UiTreeViewport methodsFor: 'accessing' stamp: 'mt 10/14/2010 13:14:25.565'!
indent

	^ indent ifNil: [indent := 12]! !

!UiTreeViewport methodsFor: 'initialization' stamp: 'mt 10/18/2010 19:09:04.846'!
initialize

	super initialize.
	
	rowOrder := UiTreeItemOrder new.
	
	self selectionBehavior: #selectRows.! !

!UiTreeViewport methodsFor: 'event handling' stamp: 'mt 2/28/2011 13:54:35.668'!
keyStroke: evt

	super keyStroke: evt.
	self keyPressed: evt keyCharacter.  ! !

Morph subclass: #UiLabel
	instanceVariableNames: 'form text'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Core'!

!UiLabel commentStamp: 'mt 7/4/2010 08:53:31.639' prior: 0!
I am a descriptive widget that explains some content of another widget near me. I can show a form or a text.!

!UiLabel class methodsFor: 'testing' stamp: 'mt 6/29/2010 19:06:41.567'!
isWidgetClass

	^ true! !

!UiLabel class methodsFor: 'accessing' stamp: 'mt 10/19/2010 13:29:53.936'!
widgetCategory
	
	^ 'Display Widgets'! !

!UiLabel class methodsFor: 'accessing' stamp: 'mt 10/19/2010 11:53:48.403'!
widgetClassIcon

	^ UiFugueIcons uiLabelIcon! !

!UiLabel class methodsFor: 'accessing' stamp: 'mt 6/30/2010 21:22:24.431'!
widgetClassName

	^ 'Label'! !

!UiLabel class methodsFor: 'accessing' stamp: 'mt 10/28/2010 16:52:55.134'!
widgetProperties

	^ super widgetProperties, {{'Label'. #yourself} -> {
		#text -> String.
		#form -> Form}}! !

!UiLabel methodsFor: 'accessing' stamp: 'mt 7/4/2010 08:35:24.982'!
form

	^ form! !

!UiLabel methodsFor: 'accessing' stamp: 'mt 7/4/2010 08:36:48.648'!
form: aForm

	form := aForm.
	self updateSubmorphs.! !

!UiLabel methodsFor: 'initialization' stamp: 'mt 7/4/2010 08:45:51.563'!
initialize

	super initialize.
	
	text := TextMorph new.
	text contents: 'Label'.
	text lock.
	
	self
		color: Color transparent;
		changeTableLayout;
		listDirection: #leftToRight;
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap;
		updateSubmorphs.! !

!UiLabel methodsFor: 'accessing' stamp: 'mt 7/4/2010 08:33:10.538'!
text

	^ text contents! !

!UiLabel methodsFor: 'accessing' stamp: 'mt 7/4/2010 08:44:15.376'!
text: aText

	text contents: aText asHtmlText.
	self updateSubmorphs.! !

!UiLabel methodsFor: 'accessing - private' stamp: 'mt 7/4/2010 08:46:07.552'!
textMorph

	^ text! !

!UiLabel methodsFor: 'updating' stamp: 'mt 7/4/2010 08:39:47.448'!
updateSubmorphs

	(self submorphs notEmpty and: [self form isNil] and: [self submorphs first == text])
		ifTrue: [^ self].

	self	 removeAllMorphs.
	
	self form
		ifNil: [self addMorphBack: text]
		ifNotNil: [self addMorphBack: form asMorph].! !

Morph subclass: #UiRessourceMonitorDialog
	instanceVariableNames: 'view refreshButton gcButton'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Dialogs'!

!UiRessourceMonitorDialog class methodsFor: 'instance creation' stamp: 'mt 10/24/2010 12:30:21.819'!
open

	^ self new open! !

!UiRessourceMonitorDialog methodsFor: 'initialization' stamp: 'mt 10/24/2010 19:50:24.318'!
initialize

	super initialize.
	refreshButton := UiPushButton new
		icon: UiFugueIcons arrowCircleDouble135Icon;
		text: 'Refresh'.
	gcButton := UiPushButton new
		icon: UiFugueIcons broomIcon;
		text: 'GC'.
	
	view := UiTableView new
		removeVerticalHeader;
		model: UiRessourceMonitorModel new;
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		borderStyle: (BorderStyle inset width: 1);
		setVAlignmentForColumn: 3 to: #center.
	
	self connect: refreshButton signal: #clicked: to: view selector: #reset.
	self connect: gcButton signal: #clicked: to: Smalltalk selector: #garbageCollect.
	
	self
		color: (Color gray: 0.9);
		changeTableLayout;
		listDirection: #topToBottom;
		layoutInset: 3;
		cellInset: 5.
		
	self addMorphBack: view; addMorphBack: (SwaRowPanel for: {gcButton. SwaHFiller new. refreshButton}).! !

!UiRessourceMonitorDialog methodsFor: 'initialization' stamp: 'mt 10/24/2010 12:29:56.994'!
open

	| c |
	c := self color.
	(self openInWindowLabeled: 'Ressource Monitor')
		extent: 350@300.
		
	self color: c.! !

Morph subclass: #UiScrollArea
	instanceVariableNames: 'horizontalScrollBar horizontalScrollBarPolicy verticalScrollBar verticalScrollBarPolicy cornerWidget transformMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Core'!

!UiScrollArea commentStamp: 'mt 3/7/2011 14:29:02.055' prior: 0!
Just set a #widget: and use it. :)!

UiScrollArea subclass: #UiAbstractItemView
	instanceVariableNames: 'model itemDelegates verticalHeader horizontalHeader vHeaderScroller hHeaderScroller animated'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Views'!

!UiAbstractItemView class methodsFor: 'testing' stamp: 'mt 3/7/2011 14:34:32.325'!
isWidgetClass

	^ false! !

!UiAbstractItemView class methodsFor: 'accessing' stamp: 'mt 10/19/2010 13:33:18.144'!
widgetCategory
	
	^ 'Item Views (Model-Based)'! !

!UiAbstractItemView class methodsFor: 'properties' stamp: 'mt 2/20/2011 19:22:48.735'!
widgetProperties

	^ {{'Item View'. #yourself} -> {
		#modelClass -> Object.
		#horizontalHeaderVisible -> Boolean.
		#verticalHeaderVisible -> Boolean.
		#selectionBehavior -> #(selectCells selectRows selectColumns).
		#selectionColor -> Object.
		#selectionMode -> Object}}! !

!UiAbstractItemView class methodsFor: 'properties' stamp: 'mt 10/28/2010 10:02:41.999'!
widgetPropertiesToIgnore

	^ #('TableLayout' 'ProportionalLayout')! !

!UiAbstractItemView methodsFor: 'signals' stamp: 'mt 10/19/2010 10:27:49.972'!
activated: aModelIndex
	"Single mouse click or pressing the return key."
	
	self emitAlways.! !

!UiAbstractItemView methodsFor: 'headers - add/remove' stamp: 'mt 10/19/2010 14:12:01.1'!
addHorizontalHeader

	self addMorph: hHeaderScroller.
	self updateLayout.! !

!UiAbstractItemView methodsFor: 'headers - add/remove' stamp: 'mt 10/19/2010 14:11:36.704'!
addVerticalHeader

	self addMorph: vHeaderScroller.
	self updateLayout.! !

!UiAbstractItemView methodsFor: 'accessing' stamp: 'mt 2/20/2011 18:50:04.606'!
animated

	^ animated ifNil: [animated := true]! !

!UiAbstractItemView methodsFor: 'accessing' stamp: 'mt 2/20/2011 18:49:46.161'!
animated: aBoolean

	animated := aBoolean.! !

!UiAbstractItemView methodsFor: 'rows/columns - sorting' stamp: 'mt 2/20/2011 18:26:27.079'!
autoSortBlock: aBlock
	"Specify the way rows will be sorted"
	
	self viewport rowOrder sortBlock: aBlock.
	self updateLayout.! !

!UiAbstractItemView methodsFor: 'model updates' stamp: 'mt 10/14/2010 13:09:27.159'!
changeColumnsFor: aParentModelIndex from: start to: end

	| index item |
	
	(self viewport isExpanded: aParentModelIndex)
		ifFalse: [^ self].
	
	1 to: (self model rowCountFor: aParentModelIndex) do: [:row |
		start to: end do: [:col |
			index := self model indexRow: row column: col parent: aParentModelIndex.
			item := (self itemDelegateFor: index) itemFor: index.
			self viewport replaceMorphWith: item atIndex: index.
			item fadeIn]].
	
	self updateLayout.! !

!UiAbstractItemView methodsFor: 'model updates' stamp: 'mt 2/20/2011 18:58:11.849'!
changeRowsFor: aParentModelIndex from: start to: end

	| index item |
	
	(self viewport isExpanded: aParentModelIndex)
		ifFalse: [^ self].
	
	start to: end do: [:row |
		1 to: (self model columnCountFor: aParentModelIndex) do: [:col |
			index := self model indexRow: row column: col parent: aParentModelIndex.
			item := (self itemDelegateFor: index) itemFor: index.
			self viewport replaceMorphWith: item atIndex: index.
			self isAnimated ifTrue: [item fadeIn]]].
	
	self updateLayout.! !

!UiAbstractItemView methodsFor: 'signals' stamp: 'mt 10/14/2010 20:26:04.229'!
clicked: aModelIndex

	self emitAlways.! !

!UiAbstractItemView methodsFor: 'signals' stamp: 'mt 10/20/2010 13:55:45.797'!
currentIndexChanged: aModelIndex

	self emitAlways.! !

!UiAbstractItemView methodsFor: 'selection' stamp: 'mt 10/20/2010 14:08:00.82'!
currentModelIndex

	^ self viewport currentModelIndex! !

!UiAbstractItemView methodsFor: 'item delegation' stamp: 'mt 10/9/2010 10:54:44.107'!
defaultItemDelegate

	^ itemDelegates at: #default! !

!UiAbstractItemView methodsFor: 'item delegation' stamp: 'mt 10/14/2010 15:43:43.148'!
defaultItemDelegate: aDelegate

	itemDelegates at: #default put: aDelegate.! !

!UiAbstractItemView methodsFor: 'rows/columns - sorting' stamp: 'mt 2/20/2011 18:26:10.098'!
disableAutoSort
	"No row sorting."
	
	self viewport rowOrder sortBlock: nil.
	self updateLayout.! !

!UiAbstractItemView methodsFor: 'signals' stamp: 'mt 10/14/2010 20:26:08.87'!
doubleClicked: aModelIndex

	self emitAlways.! !

!UiAbstractItemView methodsFor: 'rows/columns - sorting' stamp: 'mt 2/20/2011 18:26:03.768'!
enableAutoSort
	"Sort rows alphabetically in ascending order."
	
	self viewport rowOrder sortBlock: [:i1 :i2 |
		(i1 valueOfProperty: #text) asString <= (i2 valueOfProperty: #text) asString].
	
	self updateLayout.! !

!UiAbstractItemView methodsFor: 'model access' stamp: 'mt 10/11/2010 18:05:14.956'!
fillViewportFor: aModelIndex animated: aBoolean

	| index item |
	self model ifNil: [^ self].
	
	1 to: (self model rowCountFor: aModelIndex) do: [:row |
		1 to: (self model columnCountFor: aModelIndex) do: [:col |
			index := self model indexRow: row column: col parent: aModelIndex.
			item := (self itemDelegateFor: index) itemFor: index.
			self viewport addMorph: item atIndex: index.
			aBoolean ifTrue: [item fadeIn]]].! !

!UiAbstractItemView methodsFor: 'headers - testing' stamp: 'mt 10/14/2010 13:04:29.063'!
hasHorizontalHeader

	^ hHeaderScroller owner notNil! !

!UiAbstractItemView methodsFor: 'headers - testing' stamp: 'mt 10/14/2010 13:03:13.199'!
hasVerticalHeader

	^ vHeaderScroller owner notNil! !

!UiAbstractItemView methodsFor: 'headers - add/remove' stamp: 'mt 10/28/2010 10:07:05.122'!
horizontalHeaderVisible
		
	^ self hasHorizontalHeader! !

!UiAbstractItemView methodsFor: 'headers - add/remove' stamp: 'mt 10/28/2010 10:06:33.964'!
horizontalHeaderVisible: aBoolean

	aBoolean
		ifTrue: [self addHorizontalHeader]
		ifFalse: [self removeHorizontalHeader].! !

!UiAbstractItemView methodsFor: 'initialization' stamp: 'mt 3/7/2011 14:05:43.17'!
initialize

	"Initialize headers."
	verticalHeader := Morph new color: Color transparent; width: self scrollBarThickness; changeTableLayout; listDirection: #topToBottom.
	horizontalHeader := Morph new color: Color transparent; height: self scrollBarThickness; changeTableLayout; listDirection: #leftToRight.
	vHeaderScroller := UiTransformMorph new.
	hHeaderScroller := UiTransformMorph new.

	super initialize.
	
	self
		borderWidth: 0;
		color: Color white.
		
	self
		verticalScrollBarPolicy: #asNeeded;
		horizontalScrollBarPolicy: #asNeeded.
	
	"Initialize viewport."
	self widget: self viewportClass new.
	self connect: self viewport signal: #focusChanged: toSelector: #scrollToShow:.
	self connect: self viewport signal: #clicked: toSelector: #clicked:.
	self connect: self viewport signal: #doubleClicked: toSelector: #doubleClicked:.
	self connect: self viewport signal: #selectionChanged: toSelector: #selectionChanged:.
	self connect: self viewport signal: #currentIndexChanged: toSelector: #currentIndexChanged:.
	self connect: self viewport signal: #activated: toSelector: #activated:.
	self connect: self viewport signal: #returnPressed: toSelector: #returnPressed:.
	self viewport verticalHeader: verticalHeader.
	self viewport horizontalHeader: horizontalHeader.
	
	"Initialize item delegates."
	itemDelegates := Dictionary new.
	self defaultItemDelegate: UiSimpleItemDelegate new.
	
	"Initialize headers - Finish."
	verticalHeader connect: self viewport signal: #resizedToWidth:height: toSelector: #height: pattern: #(2).
	vHeaderScroller connect: self transformMorph signal: #verticalOffsetChanged: toSelector: #verticalOffset:.
	vHeaderScroller addMorph: verticalHeader.

	horizontalHeader connect: self viewport signal: #resizedToWidth:height: toSelector: #width:.
	hHeaderScroller connect: self transformMorph signal: #horizontalOffsetChanged: toSelector: #horizontalOffset:.
	hHeaderScroller addMorph: horizontalHeader.! !

!UiAbstractItemView methodsFor: 'model updates' stamp: 'mt 2/20/2011 18:57:47.046'!
insertRowsFor: aParentModelIndex from: start to: end

	| index item |
	
	(self viewport isExpanded: aParentModelIndex)
		ifFalse: [^ self].

	"Update trailing model indices."
	end + 1 to: (self model rowCountFor: aParentModelIndex) do: [:row |
		1 to: (self model columnCountFor: aParentModelIndex) do: [:col | | oldIndex |
			index := self model indexRow: row column: col parent: aParentModelIndex.
			oldIndex := self model indexRow: row - 1 - (end - start) column: col parent: aParentModelIndex.
			self viewport updateIndex: index oldIndex: oldIndex]].

	"Insert new rows."
	start to: end do: [:row |
		1 to: (self model columnCountFor: aParentModelIndex) do: [:col |
			index := self model indexRow: row column: col parent: aParentModelIndex.
			item := (self itemDelegateFor: index) itemFor: index.
			self viewport addMorph: item atIndex: index.
			self isAnimated ifTrue: [item fadeIn]]].
		
	self updateLayout.! !

!UiAbstractItemView methodsFor: 'testing' stamp: 'mt 2/20/2011 18:50:39.894'!
isAnimated
	"Show fading animations for item updates?"
	
	^ self animated! !

!UiAbstractItemView methodsFor: 'item delegation' stamp: 'mt 10/10/2010 10:34:00.872'!
itemDelegateFor: aModelIndex

	^ self defaultItemDelegate! !

!UiAbstractItemView methodsFor: 'initialization' stamp: 'mt 3/7/2011 11:47:04.514'!
model

	^ model! !

!UiAbstractItemView methodsFor: 'initialization' stamp: 'mt 3/7/2011 11:52:45.161'!
model: aModel

	self model ifNotNil: [:m | m disconnectAllSignals].
	
	model := aModel.
	self reset.
	
	self model ifNotNil: [:m |
		self connect: m signal: #modelReset toSelector: #reset.
		self connect: m signal: #rowsInsertedFor:from:to: toSelector: #insertRowsFor:from:to:.
		self connect: m signal: #rowsChangedFor:from:to: toSelector: #changeRowsFor:from:to:.
		self connect: m signal: #rowsRemovedFor:from:to: toSelector: #removeRowsFor:from:to:.].! !

!UiAbstractItemView methodsFor: 'model access' stamp: 'mt 10/28/2010 10:04:51.755'!
modelClass

	^ self model
		ifNil: [nil]
		ifNotNil: [:m | m class]! !

!UiAbstractItemView methodsFor: 'model access' stamp: 'mt 10/28/2010 10:08:12.426'!
modelClass: aClass

	aClass
		ifNil: [self model: nil]
		ifNotNil: [:c | self model: c new].! !

!UiAbstractItemView methodsFor: 'event handling' stamp: 'mt 11/2/2010 12:02:18.268'!
mouseDown: evt
	"Overridden to let the viewport decide what should happen with the event."

	self viewport mouseDown: (evt transformedBy: (scroller transformFrom: self)).! !

!UiAbstractItemView methodsFor: 'headers - add/remove' stamp: 'mt 10/19/2010 14:11:54.15'!
removeHorizontalHeader

	self removeMorph: hHeaderScroller.
	self updateLayout.! !

!UiAbstractItemView methodsFor: 'model updates' stamp: 'mt 11/2/2010 09:24:57.283'!
removeRowsFor: aParentModelIndex from: start to: end

	| index |
	(self viewport isExpanded: aParentModelIndex)
		ifFalse: [^ self].
	
	start to: end do: [:row |
		self viewport removeRowFor: aParentModelIndex at: row].
	
	"Update trailing model indices."
	start to: (self model rowCountFor: aParentModelIndex) do: [:row |
		1 to: (self model columnCountFor: aParentModelIndex) do: [:col | | oldIndex |
			index := self model indexRow: row column: col parent: aParentModelIndex.
			oldIndex := self model indexRow: row + 1 + (end - start) column: col parent: aParentModelIndex.
			self viewport updateIndex: index oldIndex: oldIndex]].
	
	self updateLayout.! !

!UiAbstractItemView methodsFor: 'headers - add/remove' stamp: 'mt 10/19/2010 14:11:43.32'!
removeVerticalHeader

	self removeMorph: vHeaderScroller.
	self updateLayout.! !

!UiAbstractItemView methodsFor: 'model access' stamp: 'mt 10/14/2010 21:02:31.888'!
reset
	self viewport clear.
	
	self fillViewportFor: nil animated: false.
	self resetHeaderItems.
	
	self updateLayout.! !

!UiAbstractItemView methodsFor: 'model access' stamp: 'mt 10/14/2010 13:06:56.299'!
resetHeaderItems

	| index item |
	self model ifNil: [^ self].
	
	self hasVerticalHeader ifTrue: [
		1 to: (self model rowCountFor: nil) do: [:row |
			index := self model indexRow: row column: 0 parent: nil.
			item := (self itemDelegateFor: index) itemFor: index.
			verticalHeader width: (verticalHeader width max: item width).
			self viewport setHeaderItem: item atRow: row]].
	
	self hasHorizontalHeader ifTrue: [
		1 to: (self model columnCountFor: nil) do: [:col |
			index := self model indexRow: 0 column: col parent: nil.
			item := (self itemDelegateFor: index) itemFor: index.
			horizontalHeader height: (horizontalHeader height max: item height).
			self viewport setHeaderItem: item atColumn: col]].! !

!UiAbstractItemView methodsFor: 'signals' stamp: 'mt 2/28/2011 13:29:07.566'!
returnPressed: aModelIndex

	self emitAlways.! !

!UiAbstractItemView methodsFor: 'scrolling' stamp: 'mt 2/20/2011 18:15:12.777'!
scrollToBottom

	self scrollToShow: (self viewport bottomLeft extent: 1@1)! !

!UiAbstractItemView methodsFor: 'selection' stamp: 'mt 11/3/2010 10:03:09.07'!
selection
	"Return all selected model indices."
	
	^ self viewport selectedModelIndices! !

!UiAbstractItemView methodsFor: 'selection' stamp: 'mt 2/20/2011 19:20:28.508'!
selectionBehavior
	
	^ self viewport selectionBehavior! !

!UiAbstractItemView methodsFor: 'selection' stamp: 'mt 10/19/2010 10:21:08.2'!
selectionBehavior: aSymbol
	"#selectCells, #selectRows, #selectColumns"
	
	self viewport selectionBehavior: aSymbol.! !

!UiAbstractItemView methodsFor: 'signals' stamp: 'mt 10/20/2010 13:42:53.216'!
selectionChanged: someModelIndices

	self emitAlways.! !

!UiAbstractItemView methodsFor: 'selection' stamp: 'mt 2/20/2011 19:21:34.624'!
selectionColor

	^ self viewport selectionColor! !

!UiAbstractItemView methodsFor: 'selection' stamp: 'mt 10/19/2010 10:24:52.272'!
selectionColor: aColor

	self viewport selectionColor: aColor.! !

!UiAbstractItemView methodsFor: 'selection' stamp: 'mt 2/20/2011 19:23:16.66'!
selectionMode

	^ self viewport selectionMode! !

!UiAbstractItemView methodsFor: 'selection' stamp: 'mt 10/19/2010 10:26:27.009'!
selectionMode: aSelectionClass
	"Use can use all subclasses of UiViewSelection here."

	self viewport selectionMode: aSelectionClass.! !

!UiAbstractItemView methodsFor: 'rows/columns - alignment' stamp: 'mt 2/20/2011 18:39:36.834'!
setHAlignmentForColumn: anIndex to: aSymbol
	"#left, #center, #right"
	
	(self viewport columnAt: anIndex)
		hAlignment: aSymbol.
		
	self updateLayout.! !

!UiAbstractItemView methodsFor: 'rows/columns - resizing' stamp: 'mt 10/14/2010 13:10:06.532'!
setHeightForRow: anIndex to: anInteger

	| row |
	row := self viewport rowAt: anIndex.
	row resizeMode ~= #rigid
		ifTrue: [^ self].
		
	row height: anInteger.
		
	self updateLayout.! !

!UiAbstractItemView methodsFor: 'rows/columns - resizing' stamp: 'mt 10/14/2010 13:10:12.957'!
setResizeModeForColumn: anIndex to: aSymbol

	(self viewport columnAt: anIndex)
		resizeMode: aSymbol.
		
	self updateLayout.! !

!UiAbstractItemView methodsFor: 'rows/columns - resizing' stamp: 'mt 10/14/2010 13:10:24.149'!
setResizeModeForRow: anIndex to: aSymbol

	(self viewport rowAt: anIndex)
		resizeMode: aSymbol.
		
	self updateLayout.! !

!UiAbstractItemView methodsFor: 'rows/columns - alignment' stamp: 'mt 2/20/2011 18:39:44.874'!
setVAlignmentForColumn: anIndex to: aSymbol
	"#top, #center, #bottom"
	
	(self viewport columnAt: anIndex)
		vAlignment: aSymbol.
		
	self updateLayout.! !

!UiAbstractItemView methodsFor: 'rows/columns - resizing' stamp: 'mt 10/14/2010 13:10:34.713'!
setWidthForColumn: anIndex to: anInteger

	| col |
	col := self viewport columnAt: anIndex.
	col resizeMode ~= #rigid
		ifTrue: [^ self].
		
	col width: anInteger.
		
	self updateLayout.! !

!UiAbstractItemView methodsFor: 'layouting' stamp: 'mt 3/7/2011 13:53:38.896'!
updateLayout

	super updateLayout.

	self verticalScrollBar
		height: self transformMorph bottom - self top.
		
	self horizontalScrollBar
		width: self transformMorph right - self left.

	hHeaderScroller
		height: horizontalHeader height;
		width: self transformMorph width;
		topLeft: self transformMorph left @ self top.
		
	vHeaderScroller
		height: self transformMorph height;
		width: verticalHeader width;
		topLeft: self left @ self transformMorph top.
	
	self viewport ifNotNil: [:v | v updateLayout].! !

!UiAbstractItemView methodsFor: 'headers - add/remove' stamp: 'mt 10/28/2010 10:06:51.888'!
verticalHeaderVisible

	^ self hasVerticalHeader! !

!UiAbstractItemView methodsFor: 'headers - add/remove' stamp: 'mt 10/28/2010 10:06:21.13'!
verticalHeaderVisible: aBoolean

	aBoolean
		ifTrue: [self addVerticalHeader]
		ifFalse: [self removeVerticalHeader].! !

!UiAbstractItemView methodsFor: 'accessing - private' stamp: 'mt 3/7/2011 11:50:41.566'!
viewport
	"Return the morph that is scrolled."
	
	^ self widget! !

!UiAbstractItemView methodsFor: 'geometry' stamp: 'mt 3/7/2011 13:15:40.105'!
viewportBounds

	
	| rect |
	rect := super viewportBounds.
	
	self hasVerticalHeader ifTrue: [
		rect := rect insetBy: (verticalHeader width @ 0 corner: 0@0)].

	self hasHorizontalHeader ifTrue: [
		rect := rect insetBy: (0 @ horizontalHeader height corner: 0@0)].

	^ rect! !

!UiAbstractItemView methodsFor: 'accessing - private' stamp: 'mt 10/14/2010 12:08:54.27'!
viewportClass

	self subclassResponsibility.! !

UiAbstractItemView subclass: #UiListView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Views'!

!UiListView commentStamp: 'mt 10/20/2010 14:02:59.798' prior: 0!
I am a list view that is able to break the line of items in one direction and shows as many items as possible.

I map some signals to ones that only indicate row indices, e.g., selected row indices instead of whole model indices.!

!UiListView class methodsFor: 'accessing' stamp: 'mt 10/19/2010 13:31:39.613'!
isWidgetClass

	^ true! !

!UiListView class methodsFor: 'accessing' stamp: 'mt 10/19/2010 14:03:20.427'!
widgetClassIcon

	^ UiFugueIcons uiListBoxIcon! !

!UiListView class methodsFor: 'accessing' stamp: 'mt 10/19/2010 14:06:46.933'!
widgetClassName

	^ 'List View'! !

!UiListView methodsFor: 'accessing' stamp: 'mt 11/22/2010 15:56:41.789'!
currentRow

	"KLUDGE: Should map to model index and not cell?"
	^ self viewport selection currentCell ifNotNil: [:cc | cc y]! !

!UiListView methodsFor: 'accessing' stamp: 'mt 11/2/2010 11:43:25.511'!
currentRow: anIndex

	"KLUDGE: Should map to model index and not cell?"
	anIndex ifNil: [^ self viewport selection currentCell: nil].
	self viewport selection currentCell: (1@anIndex).! !

!UiListView methodsFor: 'signals' stamp: 'mt 10/20/2010 13:53:08.525'!
currentRowChanged: newRowIndex

	self emit.! !

!UiListView methodsFor: 'geometry' stamp: 'mt 10/14/2010 17:27:16.269'!
extent: aPoint

	super extent: aPoint.
	
	self viewport ifNotNil: [:v |
		v orientation = #default
			ifTrue: [v updateExtent]
			ifFalse: [v updateLayout]].! !

!UiListView methodsFor: 'model access' stamp: 'mt 10/14/2010 17:28:02.87'!
fillViewportFor: aModelIndex animated: aBoolean

	| index item |
	self model ifNil: [^ self].
	
	1 to: (self model rowCountFor: nil) do: [:row |
		index := self model indexRow: row column: 1 parent: nil.
		item := (self itemDelegateFor: index) itemFor: index.
		self viewport addMorph: item atIndex: index.
		aBoolean ifTrue: [item fadeIn]].! !

!UiListView methodsFor: 'accessing' stamp: 'mt 10/14/2010 19:19:09.581'!
hAlignment: aSymbol

	self setHAlignmentForColumn: 1 to: aSymbol.! !

!UiListView methodsFor: 'initialization' stamp: 'mt 10/20/2010 14:02:19.337'!
initialize

	super initialize.
	
	self connect: self viewport signal: #currentIndexChanged: toSelector: #onCurrentIndexChanged:.
	self connect: self viewport signal: #selectionChanged: toSelector: #onSelectionChanged:.! !

!UiListView methodsFor: 'accessing' stamp: 'mt 10/14/2010 15:27:12.646'!
listOrientation

	^ self viewport orientation! !

!UiListView methodsFor: 'accessing' stamp: 'mt 10/14/2010 18:37:15.275'!
listOrientation: aSymbol
	"#default ... no breaks, horzintal scrolling if needed, full row selection
	#vertical ... items go from left to right and break at width -> vertical scrolling
	#horizontal ... items go from top to bottom and break at height -> horizontal scrolling"

	self listOrientation = aSymbol
		ifTrue: [^ self].
	
	self viewport orientation: aSymbol.
	self updateLayout.! !

!UiListView methodsFor: 'updating' stamp: 'mt 10/20/2010 14:44:47.163'!
onCurrentIndexChanged: aModelIndex
	"Map to the row index. Ignore the column in a list."
	
	self currentRowChanged: (aModelIndex ifNotNil: [:m | m row]).! !

!UiListView methodsFor: 'updating' stamp: 'mt 10/20/2010 14:01:11.915'!
onSelectionChanged: someModelIndices

	self selectedRowsChanged: (someModelIndices collect: [:i | i row]).! !

!UiListView methodsFor: 'signals' stamp: 'mt 10/20/2010 14:00:30.024'!
selectedRowsChanged: someRowIndices

	self emit.! !

!UiListView methodsFor: 'geometry' stamp: 'mt 10/26/2010 20:34:36.163'!
useOptimalSize
	"Change the size of the view that only one kind/direction of scrolling is needed."

	self listOrientation = #default ifTrue: [
		self height: self viewport optimalSize y + 8.
		self width: self viewport optimalSize x + self scrollBarThickness + 5 +
			(self hasVerticalHeader ifTrue: [verticalHeader width] ifFalse: [0])].
		
	self listOrientation = #vertical ifTrue: [
		self height: self viewport optimalSize y + 8.
		self width: self viewport optimalSize x + self scrollBarThickness + 5 +
			(self hasVerticalHeader ifTrue: [verticalHeader width] ifFalse: [0])].

	self listOrientation = #horizontal ifTrue: [
		self width: self viewport optimalSize x + 8.
		self height: self viewport optimalSize y + self scrollBarThickness +
			(self hasHorizontalHeader ifTrue: [horizontalHeader width] ifFalse: [0])].! !

!UiListView methodsFor: 'accessing' stamp: 'mt 10/14/2010 19:19:17.877'!
vAlignment: aSymbol

	self setVAlignmentForColumn: 1 to: aSymbol.! !

!UiListView methodsFor: 'accessing - private' stamp: 'mt 11/2/2010 13:26:33.658'!
viewportClass

	^ UiListViewport! !

UiListView subclass: #UiListWidget
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Core'!

!UiListWidget commentStamp: 'mt 10/19/2010 19:32:52.216' prior: 0!
Simple list. Item based. No model required.!

!UiListWidget class methodsFor: 'accessing' stamp: 'mt 10/19/2010 13:33:00.509'!
widgetCategory
	
	^ 'Item Widgets (Item-Based)'! !

!UiListWidget class methodsFor: 'accessing' stamp: 'mt 10/19/2010 11:54:17.534'!
widgetClassIcon

	^ UiFugueIcons uiListBoxBlueIcon! !

!UiListWidget class methodsFor: 'accessing' stamp: 'mt 6/30/2010 21:21:46.085'!
widgetClassName

	^ 'List Widget'! !

!UiListWidget class methodsFor: 'properties' stamp: 'mt 10/28/2010 10:08:58.312'!
widgetPropertiesToIgnore

	^ super widgetPropertiesToIgnore, #(modelClass)! !

!UiListWidget methodsFor: 'add/remove' stamp: 'mt 11/2/2010 13:33:58.778'!
addIcon: anIcon text: aLabel

	self model addItem: (self itemClass new text: aLabel; icon: anIcon).! !

!UiListWidget methodsFor: 'add/remove' stamp: 'mt 11/2/2010 13:34:09.151'!
addIcon: anIcon text: aLabel at: anIndex

	self model insertItem: (self itemClass new text: aLabel; icon: anIcon) at: anIndex.! !

!UiListWidget methodsFor: 'add/remove' stamp: 'mt 11/2/2010 13:34:16.387'!
addText: aLabel

	self model addItem: (self itemClass new text: aLabel).! !

!UiListWidget methodsFor: 'add/remove' stamp: 'mt 11/2/2010 13:34:22.67'!
addText: aLabel at: anIndex

	self model insertItem: (self itemClass new text: aLabel) at: anIndex.! !

!UiListWidget methodsFor: 'accessing' stamp: 'mt 11/2/2010 13:31:23.139'!
clear

	self model: UiListWidgetModel new.! !

!UiListWidget methodsFor: 'accessing' stamp: 'mt 10/20/2010 14:15:08.334'!
currentIcon

	^ self currentItem ifNotNil: [:i | i icon]! !

!UiListWidget methodsFor: 'accessing' stamp: 'mt 10/20/2010 10:30:03.07'!
currentItem

	^ self currentRow ifNotNil: [:cc | self items at: cc]! !

!UiListWidget methodsFor: 'accessing' stamp: 'mt 10/20/2010 14:14:43.107'!
currentText

	^ self currentItem ifNotNil: [:i | i text]! !

!UiListWidget methodsFor: 'signals' stamp: 'mt 6/29/2010 09:53:38.414'!
currentTextChanged: aLabel

	self emit.! !

!UiListWidget methodsFor: 'initialization' stamp: 'mt 11/2/2010 13:31:35.215'!
initialize
	
	super initialize.
	self connect: self viewport signal: #activated: toSelector: #onActivated:.
	self clear.! !

!UiListWidget methodsFor: 'signals' stamp: 'mt 10/20/2010 10:35:08.772'!
itemActivated: aListWidgetItem

	self emit.! !

!UiListWidget methodsFor: 'accessing' stamp: 'mt 11/2/2010 13:33:33.631'!
itemClass

	^ UiListWidgetItem! !

!UiListWidget methodsFor: 'accessing' stamp: 'mt 10/19/2010 19:40:25.443'!
items

	^ self model items! !

!UiListWidget methodsFor: 'updating' stamp: 'mt 10/20/2010 14:40:03.899'!
onActivated: aModelIndex

	self itemActivated: (aModelIndex
		ifNotNil: [self items at: aModelIndex row]).! !

!UiListWidget methodsFor: 'updating' stamp: 'mt 10/20/2010 14:46:04.736'!
onCurrentIndexChanged: aModelIndex

	super onCurrentIndexChanged: aModelIndex.
	self currentTextChanged: (aModelIndex ifNotNil: [:m | (self items at: m row) text]).! !

!UiListWidget methodsFor: 'add/remove' stamp: 'mt 11/2/2010 10:17:41.688'!
removeLastRow

	self model removeItemAt: self size.! !

!UiListWidget methodsFor: 'add/remove' stamp: 'mt 11/2/2010 09:32:32.761'!
removeRowAt: anIndex

	self model removeItemAt: anIndex.! !

!UiListWidget methodsFor: 'accessing' stamp: 'mt 10/20/2010 14:11:43.237'!
size

	^ self items size! !

UiAbstractItemView subclass: #UiTableView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Views'!

!UiTableView commentStamp: 'mt 10/19/2010 10:51:11.46' prior: 0!
I have a vertical header by default and are used for table-like models.!

!UiTableView class methodsFor: 'accessing' stamp: 'mt 10/19/2010 13:31:43.968'!
isWidgetClass

	^ true! !

!UiTableView class methodsFor: 'accessing' stamp: 'mt 10/19/2010 14:07:06.235'!
widgetClassIcon

	^ UiFugueIcons uiScrollPaneTableIcon! !

!UiTableView class methodsFor: 'accessing' stamp: 'mt 10/19/2010 13:32:09.963'!
widgetClassName

	^ 'Table View'! !

!UiTableView methodsFor: 'accessing' stamp: 'mt 11/2/2010 11:40:00.515'!
currentCell

	^ self viewport selection currentCell! !

!UiTableView methodsFor: 'accessing' stamp: 'mt 11/2/2010 11:38:22.661'!
currentCell: aPoint

	self viewport selection currentCell: aPoint.! !

!UiTableView methodsFor: 'initialization' stamp: 'mt 3/7/2011 13:38:04.405'!
initialize

	super initialize.
		
	self
		addMorph: vHeaderScroller;
		addMorph: hHeaderScroller.! !

!UiTableView methodsFor: 'accessing - private' stamp: 'mt 10/14/2010 13:57:19.079'!
viewportClass

	^ UiTableViewport! !

UiTableView subclass: #UiTableWidget
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Sandbox'!

!UiTableWidget commentStamp: 'mt 1/4/2011 10:12:59.4' prior: 0!
Item-based table. No model required.!

!UiTableWidget class methodsFor: 'testing' stamp: 'mt 2/12/2011 12:28:28.334'!
isExperimentalWidgetClass

	^ true! !

!UiTableWidget class methodsFor: 'accessing' stamp: 'mt 11/11/2010 10:16:46.704'!
widgetCategory
	
	^ 'Item Widgets (Item-Based)'! !

!UiTableWidget class methodsFor: 'accessing' stamp: 'mt 11/11/2010 10:32:33.588'!
widgetClassIcon

	^ UiFugueIcons uiScrollPaneTableIcon! !

!UiTableWidget class methodsFor: 'accessing' stamp: 'mt 11/11/2010 10:32:52.199'!
widgetClassName

	^ 'Table Widget'! !

!UiTableWidget class methodsFor: 'accessing' stamp: 'mt 11/11/2010 10:33:02.755'!
widgetPropertiesToIgnore

	^ super widgetPropertiesToIgnore, #(modelClass)! !

!UiTableWidget methodsFor: 'items add/remove' stamp: 'mt 11/3/2010 09:09:07.8'!
clear

	| oldExtent |
	oldExtent := self columnCount @ self rowCount.
	self model: UiTableWidgetModel new.
	self columnCount: oldExtent x.
	self rowCount: oldExtent y.! !

!UiTableWidget methodsFor: 'accessing' stamp: 'mt 11/3/2010 09:09:30.342'!
columnCount

	^ self model columnCount! !

!UiTableWidget methodsFor: 'accessing' stamp: 'mt 11/3/2010 09:09:20.102'!
columnCount: anInteger

	self model columnCount: anInteger.! !

!UiTableWidget methodsFor: 'initialization' stamp: 'mt 11/3/2010 09:13:44.342'!
initialize

	super initialize.
	self model: UiTableWidgetModel new.
	self connect: self viewport signal: #activated: toSelector: #onActivated:.! !

!UiTableWidget methodsFor: 'signals' stamp: 'mt 11/3/2010 09:10:31.601'!
itemActivated: aTableWidgetItem

	self emit.! !

!UiTableWidget methodsFor: 'items add/remove' stamp: 'mt 11/3/2010 10:07:41.427'!
itemAt: aPoint

	^ self model itemAt: aPoint! !

!UiTableWidget methodsFor: 'items add/remove' stamp: 'mt 11/3/2010 10:08:08.994'!
itemAt: aPoint put: aTableWidgetItem

	^ self model itemAt: aPoint put: aTableWidgetItem! !

!UiTableWidget methodsFor: 'updating' stamp: 'mt 11/3/2010 09:12:07.054'!
onActivated: aModelIndex

	self itemActivated: (aModelIndex
		ifNotNil: [self model itemAt: aModelIndex row]).! !

!UiTableWidget methodsFor: 'accessing' stamp: 'mt 11/3/2010 09:09:40.789'!
rowCount

	^ self model rowCount! !

!UiTableWidget methodsFor: 'accessing' stamp: 'mt 11/3/2010 09:09:53.214'!
rowCount: anInteger

	self model rowCount: anInteger.! !

UiAbstractItemView subclass: #UiTreeView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Views'!

!UiTreeView commentStamp: 'mt 10/19/2010 10:51:34.42' prior: 0!
I am a view that supports tree-like models and a tree in the first column.!

!UiTreeView class methodsFor: 'accessing' stamp: 'mt 10/19/2010 13:31:46.249'!
isWidgetClass

	^ true! !

!UiTreeView class methodsFor: 'accessing' stamp: 'mt 10/19/2010 14:04:01.037'!
widgetClassIcon

	^ UiFugueIcons uiScrollPaneTreeIcon! !

!UiTreeView class methodsFor: 'accessing' stamp: 'mt 10/19/2010 13:32:03.461'!
widgetClassName

	^ 'Tree View'! !

!UiTreeView methodsFor: 'model access' stamp: 'mt 2/20/2011 19:04:06.586'!
collapseIndex: aModelIndex

	| row |
	aModelIndex ifNil: [^ self].
	
	row := self viewport rowFor: aModelIndex.
	row isExpanded ifFalse: [^ self].
		
	row items first setProperty: #isExpanded toValue: false.
	self viewport collapseRow: row.
	
	self updateLayout.! !

!UiTreeView methodsFor: 'model access' stamp: 'mt 2/28/2011 13:44:47.37'!
expandAllIndices: aModelIndex
	"Expand the given model index and all sub-indices."
	
	self expandAllIndicesSilently: {aModelIndex}. 
	self updateLayout.! !

!UiTreeView methodsFor: 'model access' stamp: 'mt 2/28/2011 13:51:16.145'!
expandAllIndicesSilently: someModelIndices

	someModelIndices do: [:index |
		self expandIndexSilently: index.
		self expandAllIndicesSilently: ((1 to: (index model rowCountFor: index))
			collect: [:row |	index model indexRow: row column: 1 parent: index])].! !

!UiTreeView methodsFor: 'model access' stamp: 'mt 2/17/2011 23:38:40.87'!
expandIndex: aModelIndex

	self expandIndexSilently: aModelIndex. 
	self updateLayout.! !

!UiTreeView methodsFor: 'model access' stamp: 'mt 2/20/2011 18:51:09.78'!
expandIndexSilently: aModelIndex

	| row |
	aModelIndex ifNil: [^ self].
	
	aModelIndex parent ifNotNil: [:parent |
		self expandIndexSilently: parent].
	
	row := self viewport rowFor: aModelIndex.
	row isExpanded ifTrue: [ ^ self].

	row items first setProperty: #isExpanded toValue: true.
	self
		fillViewportFor: row firstModelIndex
		animated: self isAnimated.! !

!UiTreeView methodsFor: 'event handling' stamp: 'mt 2/28/2011 13:55:59.225'!
handleKeyPress: aKeyCharacter

	aKeyCharacter = $*
		ifTrue: [self expandAllIndices: self viewport currentModelIndex].! !

!UiTreeView methodsFor: 'initialization' stamp: 'mt 3/7/2011 11:55:46.929'!
initialize

	super initialize.
	
	self connect: self viewport signal: #doubleClicked: toSelector: #toggleIndex:.
	self connect: self viewport signal: #decorationClicked: toSelector: #toggleIndex:.
	self connect: self viewport signal: #returnPressed: toSelector: #toggleIndex:.
	self connect: self viewport signal: #keyPressed: toSelector: #handleKeyPress:.
	
	self
		"addMorph: vHeaderScroller;"
		addMorph: hHeaderScroller.! !

!UiTreeView methodsFor: 'rows/columns - sorting' stamp: 'mt 2/20/2011 18:40:24.288'!
moveColumn: sourceIndex to: targetIndex
	"Allows resorting of columns. Indices apply to ACTUALLY VISIBLE indices - not real model data indices."
	
	| map |
	map := self viewport columnOrder map
		ifNil: [(1 to: (self model columnCountFor: nil)) collect: [:i | i]].
	
	map
		at: targetIndex put: sourceIndex;
		at: sourceIndex put: targetIndex.
		
	self viewport columnOrder map: map.
	
	self updateLayout.! !

!UiTreeView methodsFor: 'model access' stamp: 'mt 2/20/2011 18:50:50.01'!
toggleIndex: aModelIndex

	| row |
	aModelIndex ifNil: [^ self].
	
	row := self viewport rowFor: aModelIndex.
	
	row isExpanded
		ifTrue: [
			row items first setProperty: #isExpanded toValue: false.
			self viewport collapseRow: row]
		ifFalse: [
			row items first setProperty: #isExpanded toValue: true.
			self
				fillViewportFor: row firstModelIndex
				animated: self isAnimated].
	
	self updateLayout.! !

!UiTreeView methodsFor: 'expand/collapse' stamp: 'mt 10/19/2010 14:40:36.647'!
toggleTopLevelRow: aRowIndex

	self toggleIndex: ((UiSimpleModelIndex row: aRowIndex column: 1) model: self model).! !

!UiTreeView methodsFor: 'accessing - private' stamp: 'mt 10/14/2010 13:21:16.162'!
viewportClass

	^ UiTreeViewport! !

!UiScrollArea class methodsFor: 'testing' stamp: 'mt 3/7/2011 14:11:32.14'!
isWidgetClass

	^ true! !

!UiScrollArea class methodsFor: 'accessing' stamp: 'mt 3/7/2011 14:26:02.526'!
widgetCategory

	^ 'Containers & Spacer'! !

!UiScrollArea class methodsFor: 'accessing' stamp: 'mt 3/7/2011 14:15:49.82'!
widgetClassIcon

	^ UiFugueIcons uiScrollPaneBothIcon! !

!UiScrollArea class methodsFor: 'accessing' stamp: 'mt 3/7/2011 14:12:38.791'!
widgetClassName

	^ 'Scroll Area'! !

!UiScrollArea class methodsFor: 'properties' stamp: 'mt 3/7/2011 14:19:23.804'!
widgetProperties

	^ {{'Scroll Area'. #yourself} -> {
		#horizontalScrollBarPolicy -> #(asNeeded alwaysOn alwaysOff).
		#verticalScrollBarPolicy -> #(asNeeded alwaysOn alwaysOff)}}! !

!UiScrollArea methodsFor: 'accessing' stamp: 'mt 2/27/2011 16:42:13.512'!
cornerWidget

	^ cornerWidget! !

!UiScrollArea methodsFor: 'accessing' stamp: 'mt 2/27/2011 16:42:13.582'!
cornerWidget: anObject

	cornerWidget := anObject.! !

!UiScrollArea methodsFor: 'geometry' stamp: 'mt 2/27/2011 16:53:51.183'!
extent: aPoint

	super extent: aPoint.
	self updateLayout.! !

!UiScrollArea methodsFor: 'accessing' stamp: 'mt 2/27/2011 16:42:13.015'!
horizontalScrollBar

	^ horizontalScrollBar! !

!UiScrollArea methodsFor: 'accessing' stamp: 'mt 2/27/2011 16:42:13.1'!
horizontalScrollBar: anObject

	horizontalScrollBar := anObject.! !

!UiScrollArea methodsFor: 'accessing' stamp: 'mt 3/7/2011 09:47:50.482'!
horizontalScrollBarPolicy

	^ horizontalScrollBarPolicy ifNil: [#alwaysOn]! !

!UiScrollArea methodsFor: 'accessing' stamp: 'mt 3/7/2011 10:56:19.44'!
horizontalScrollBarPolicy: aSymbol
	"#asNeeded, #alwaysOn, #alwaysOff"
	
	aSymbol = self horizontalScrollBarPolicy ifTrue: [^ self].
	
	horizontalScrollBarPolicy := aSymbol.
	
	self
		updateLayout;
		updateScrollBars.! !

!UiScrollArea methodsFor: 'initialization' stamp: 'mt 3/7/2011 14:27:59.656'!
initialize

	super initialize.
	
	self
		horizontalScrollBar: (UiScrollBar new orientation: #horizontal);
		verticalScrollBar: (UiScrollBar new orientation: #vertical);
		transformMorph: UiTransformMorph new;
		cornerWidget: UiPushButton new removeAllMorphs.
	
	self connect: self transformMorph signal: #layoutChanged toSelector: #updateLayout.
	self connect: self transformMorph signal: #layoutChanged toSelector: #updateScrollBars.
	
	self connect: self transformMorph signal: #verticalOffsetChanged: to: self verticalScrollBar selector: #currentValue:.
	self connect: self transformMorph signal: #horizontalOffsetChanged: to: self horizontalScrollBar selector: #currentValue:.

	self connect: self horizontalScrollBar signal: #valueChanged: to: self transformMorph selector: #horizontalOffset:.
	self connect: self verticalScrollBar signal: #valueChanged: to: self transformMorph selector: #verticalOffset:.
	
	self
		color: Color white;
		extent: 160@100;
		addMorphBack: self transformMorph;
		updateLayout.! !

!UiScrollArea methodsFor: 'testing' stamp: 'mt 3/7/2011 14:06:34.696'!
isHorizontalScrollBarVisible

	^ self horizontalScrollBarPolicy = #alwaysOn
		or: [self horizontalScrollBarPolicy = #asNeeded
			and: [self widget isNil or: [self transformMorph width < self widget width]]]! !

!UiScrollArea methodsFor: 'testing' stamp: 'mt 3/7/2011 14:06:22.788'!
isVerticalScrollBarVisible

	^ self verticalScrollBarPolicy = #alwaysOn
		or: [self verticalScrollBarPolicy = #asNeeded
			and: [self widget isNil or: [self transformMorph height < self widget height]]]! !

!UiScrollArea methodsFor: 'accessing' stamp: 'mt 3/7/2011 11:54:54.001'!
scrollBarThickness

	^ 14! !

!UiScrollArea methodsFor: 'scrolling' stamp: 'mt 3/7/2011 11:41:27.936'!
scrollToShow: aRectangle
	"Scroll to include as much of aRectangle as possible, where aRectangle is in the scroller's local space."
	
	| offset |
	offset := self transformMorph offset.

	((aRectangle top - offset y) >= 0 and: [
		(aRectangle bottom - offset y) <= self transformMorph height])
		ifFalse: [offset := offset x @ (
					(aRectangle top min: self widget height - self transformMorph height))].
	((aRectangle left - offset x) >= 0 and: [
		(aRectangle right - offset x) <= self transformMorph width])
		ifFalse: [offset := (aRectangle left min: self widget width - self transformMorph width) @ offset y].

	self transformMorph offset: offset.! !

!UiScrollArea methodsFor: 'accessing' stamp: 'mt 2/27/2011 16:42:13.643'!
transformMorph

	^ transformMorph! !

!UiScrollArea methodsFor: 'accessing' stamp: 'mt 2/27/2011 16:42:13.719'!
transformMorph: anObject

	transformMorph := anObject.! !

!UiScrollArea methodsFor: 'layouting' stamp: 'mt 3/7/2011 13:46:45.313'!
updateLayout

	self transformMorph bounds: self viewportBounds.
	
	self isVerticalScrollBarVisible
		ifFalse: [self removeMorph: self verticalScrollBar]
		ifTrue: [self addMorph: self verticalScrollBar].  
	
	self verticalScrollBar
		extent: 14 @ self transformMorph height;
		topLeft: self transformMorph right @ self top.

	self isHorizontalScrollBarVisible
		ifFalse: [self removeMorph: self horizontalScrollBar]
		ifTrue: [self addMorph: self horizontalScrollBar].  
		
	self horizontalScrollBar
		extent: self transformMorph width @ 14;
		topLeft: self left @ self transformMorph bottom.

	self isHorizontalScrollBarVisible & self isVerticalScrollBarVisible
		ifFalse: [self removeMorph: self cornerWidget]
		ifTrue: [self addMorph: self cornerWidget].  
		
	self cornerWidget
		extent: 14@14;
		topLeft: self transformMorph bottomRight.! !

!UiScrollArea methodsFor: 'layouting' stamp: 'mt 3/7/2011 10:47:35.526'!
updateScrollBars

	self widget ifNil: [^ self].
	
	self horizontalScrollBar
		maximum: (self widget width - self transformMorph width max: 0);
		pageStep: self transformMorph width;
		currentValue: self transformMorph offset x.
	
	self verticalScrollBar
		maximum: (self widget height - self transformMorph height max: 0);
		pageStep: self transformMorph height;
		currentValue: self transformMorph offset y.! !

!UiScrollArea methodsFor: 'accessing' stamp: 'mt 2/27/2011 16:42:13.303'!
verticalScrollBar

	^ verticalScrollBar! !

!UiScrollArea methodsFor: 'accessing' stamp: 'mt 2/27/2011 16:42:13.362'!
verticalScrollBar: anObject

	verticalScrollBar := anObject.! !

!UiScrollArea methodsFor: 'accessing' stamp: 'mt 3/7/2011 09:47:58.761'!
verticalScrollBarPolicy

	^ verticalScrollBarPolicy ifNil: [#alwaysOn]! !

!UiScrollArea methodsFor: 'accessing' stamp: 'mt 3/7/2011 10:48:43.579'!
verticalScrollBarPolicy: aSymbol
	"#asNeeded, #alwaysOn, #alwaysOff"
	
	aSymbol = self verticalScrollBarPolicy ifTrue: [^ self].
	
	verticalScrollBarPolicy := aSymbol.
	
	self
		updateLayout;
		updateScrollBars.! !

!UiScrollArea methodsFor: 'geometry' stamp: 'mt 3/7/2011 13:13:14.969'!
viewportBounds

	^ self bounds insetBy: (0@0 corner:
		(self isVerticalScrollBarVisible ifTrue: [14] ifFalse: [0])
		@
		(self isHorizontalScrollBarVisible ifTrue: [14] ifFalse: [0]))! !

!UiScrollArea methodsFor: 'accessing' stamp: 'mt 3/7/2011 09:44:22.696'!
widget
	"The morph that is scrolled."
	
	^ self transformMorph submorphs
		ifEmpty: [nil]
		ifNotEmpty: [self transformMorph submorphs first]! !

!UiScrollArea methodsFor: 'accessing' stamp: 'mt 3/7/2011 09:55:41.244'!
widget: aMorph

	self transformMorph removeAllMorphs.
	
	aMorph ifNotNil: [:m |
		self transformMorph addMorph: aMorph].! !

Morph subclass: #UiWidgetPage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Sandbox'!

!UiWidgetPage commentStamp: 'mt 7/14/2010 11:14:35.743' prior: 0!
I am used in a UiStackedWidget.!

!UiWidgetPage class methodsFor: 'properties' stamp: 'mt 7/16/2010 13:14:14.223'!
widgetProperties

	^ {{'Stacked Widget - Layout'. #owner} -> {
		#topLeft -> Point.
		#width -> Integer.
		#height -> Integer.
		#hResizing -> #(rigid spaceFill shrinkWrap).
		#vResizing -> #(rigid spaceFill shrinkWrap)}.
		{'Stacked Widget - Pages'. #owner} -> {
			#currentIndex -> Integer}}! !

!UiWidgetPage class methodsFor: 'properties' stamp: 'mt 7/16/2010 11:29:42.685'!
widgetPropertiesToIgnore

	^ #(hResizing vResizing width height topLeft)! !

!UiWidgetPage methodsFor: 'initialization' stamp: 'mt 7/14/2010 10:32:53.703'!
initialize

	super initialize.
	self
		color: Color transparent;
		hResizing: #spaceFill;
		vResizing: #spaceFill.! !

Morph subclass: #UiWidgetPageButtonContainer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Sandbox'!

!UiWidgetPageButtonContainer commentStamp: 'mt 7/14/2010 11:15:56.239' prior: 0!
I am a container for edit buttons that has a high mouse priority to accept mouse clicks.!

!UiWidgetPageButtonContainer methodsFor: 'events-processing' stamp: 'mt 7/16/2010 12:53:09.338'!
handlerForMouseDown: evt

	^ self submorphs
		detect: [:m | m bounds containsPoint: evt position] ifNone: [self].
		! !

!UiWidgetPageButtonContainer methodsFor: 'events-processing' stamp: 'mt 7/16/2010 12:53:21.162'!
handlerForYellowButtonDown: evt

	^ self submorphs
		detect: [:m | m bounds containsPoint: evt position] ifNone: [self].
		! !

!UiWidgetPageButtonContainer methodsFor: 'initialization' stamp: 'mt 7/16/2010 12:57:41.845'!
initialize

	super initialize.
	self
		color: (Color gray: 0.8);
		changeTableLayout;
		listDirection: #leftToRight;
		borderStyle: (BorderStyle raised width: 1);
		disableTableLayout: true;
		setToAdhereToEdge: #topRight;
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap.! !

!UiWidgetPageButtonContainer methodsFor: 'events-processing' stamp: 'mt 7/14/2010 11:20:22.466'!
mouseDownPriority

	^ 150! !

Morph subclass: #UiWindow
	instanceVariableNames: 'ui'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Dialogs'!

!UiWindow commentStamp: 'mt 11/27/2010 14:01:27.968' prior: 0!
This is an abstract base class for a system window that uses a user interface generated by the Morphic Designer.

Implement #uiClass and override #title to configure the look of this window.!

UiWindow subclass: #UiMessageListDialog
	instanceVariableNames: 'result'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Dialogs'!

!UiMessageListDialog commentStamp: 'mt 10/30/2010 18:36:14.08' prior: 0!
I can show a list of short messages to be confirmed or rejected.!

!UiMessageListDialog methodsFor: 'as yet unclassified' stamp: 'mt 10/30/2010 19:29:44.076'!
addIcon: aForm text: aText

	self ui messageList addIcon: aForm text: aText.! !

!UiMessageListDialog methodsFor: 'as yet unclassified' stamp: 'mt 10/30/2010 19:29:55.52'!
addText: aText

	self ui messageList addText: aText.! !

!UiMessageListDialog methodsFor: 'initialization' stamp: 'mt 11/27/2010 14:03:37.987'!
initialize

	super initialize.
	
	self ui messageList
		hideScrollBarsIndefinitely: true;
		selectionBehavior: UiViewNullSelection;
		color: Color transparent.
		
	self connect: self ui okButton signal: #clicked: toSelector: #result: pattern: #(=true).
	self connect: self ui cancelButton signal: #clicked: toSelector: #result: pattern: #(=false).! !

!UiMessageListDialog methodsFor: 'accessing' stamp: 'mt 10/30/2010 19:29:10.718'!
result

	^ result! !

!UiMessageListDialog methodsFor: 'accessing' stamp: 'mt 10/30/2010 19:27:11.513'!
result: aBoolean

	result := aBoolean.! !

!UiMessageListDialog methodsFor: 'as yet unclassified' stamp: 'mt 10/30/2010 20:06:45.019'!
show: aTitleString
	
	^ self show: aTitleString in: ActiveWorld! !

!UiMessageListDialog methodsFor: 'as yet unclassified' stamp: 'mt 10/30/2010 20:10:23.108'!
show: aTitleString in: aMorph.
	
	self result: nil.
	
	(self openInWindowLabeled: aTitleString)
		center: aMorph center.
		
	[self isInWorld and: [self result isNil]] whileTrue: [ActiveWorld doOneSubCycle].

	self owner delete.

	^ self result! !

!UiMessageListDialog methodsFor: 'accessing' stamp: 'mt 11/27/2010 14:03:28.185'!
uiClass

	^ UiMessageListDialogUi! !

!UiWindow class methodsFor: 'as yet unclassified' stamp: 'mt 11/27/2010 13:55:25.929'!
open

	^ self new open! !

!UiWindow methodsFor: 'initialization' stamp: 'mt 11/27/2010 13:57:48.499'!
initialize

	super initialize.
	self ui setupUi: self.! !

!UiWindow methodsFor: 'open/close' stamp: 'mt 11/27/2010 13:55:39.471'!
open

	self openInWindowLabeled: self title.! !

!UiWindow methodsFor: 'accessing' stamp: 'mt 11/27/2010 17:32:06.393'!
title

	^ 'Unnamed Dialog'! !

!UiWindow methodsFor: 'accessing' stamp: 'mt 11/27/2010 13:56:20.01'!
ui

	^ ui ifNil: [ui := self uiClass new]! !

!UiWindow methodsFor: 'accessing' stamp: 'mt 11/27/2010 13:55:57.56'!
uiClass

	self subclassResponsibility.! !

!String methodsFor: '*widgets-text' stamp: 'mt 11/30/2010 16:33:22.136'!
asHtmlText

	^ UiHtmlTextFormatter toText: self! !

TestCase subclass: #UiHtmlTextFormatterTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Text'!

!UiHtmlTextFormatterTest methodsFor: 'tests' stamp: 'mt 6/22/2010 23:06:07.373'!
test01bold

	| text |
	text := '<b>Hello</b>, World!!'.
	self assert: text equals: text asHtmlText printHtmlString.! !

!UiHtmlTextFormatterTest methodsFor: 'tests' stamp: 'mt 6/22/2010 23:06:48.692'!
test02italic

	| text |
	text := 'Hel<i>lo</i>, W<i>orl</i>d!!'.
	self assert: text equals: text asHtmlText printHtmlString.! !

!UiHtmlTextFormatterTest methodsFor: 'tests' stamp: 'mt 6/22/2010 23:09:02.375'!
test03mixed

	| text |
	text := '<u>Ahahaha!! <b>Hello</b></u>, <i><b>World</b></i>!!'.
	self assert: text ~= text asHtmlText printHtmlString. "Bad Squeak HTML generation."! !

!UiHtmlTextFormatterTest methodsFor: 'tests' stamp: 'mt 6/23/2010 09:04:21.741'!
test04runs

	| runs |
	runs := '<u>A<b>B</b></u>C<i><b>D</b></i>E' asHtmlText runs.
	self
		assert: 5 equals: runs size;
		assert: 1 equals: (runs at: 1) size; "underlined"
		assert: 2 equals: (runs at: 2) size; "underlined, bold"
		assert: 0 equals: (runs at: 3) size;
		assert: 2 equals: (runs at: 4) size; "italic, bold"
		assert: 0 equals: (runs at: 5) size.! !

!UiHtmlTextFormatterTest methodsFor: 'tests' stamp: 'mt 6/23/2010 09:05:50.632'!
test05color

	| text |
	text := '<font color="#FFFF00">A</font>' asHtmlText.
	self assert: Color yellow equals: (text runs first first color)! !

!UiHtmlTextFormatterTest methodsFor: 'tests' stamp: 'mt 10/6/2010 17:08:06.834'!
test06size

	| text |
	text := '<font size="9">A</font>' asHtmlText.
	self assert: 9 equals: (text runs first first font pointSize)! !

!UiHtmlTextFormatterTest methodsFor: 'tests' stamp: 'mt 10/6/2010 17:08:00.418'!
test07sizeAndColor

	| text |
	text := '<font color="#FFFF00" size="9">A</font>' asHtmlText.
	self
		assert: Color yellow equals: (text runs first first color);
		assert: 9 equals: (text runs first second font pointSize)! !

TestCase subclass: #UiHtmlTextTest
	instanceVariableNames: 'sut att1 att2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Text'!

!UiHtmlTextTest methodsFor: 'running' stamp: 'mt 5/3/2010 14:17:07.072'!
setUp
	
	super setUp.
	
	sut := 'The quick brown fox jumps over the lazy dog.' asText.
	att1 := CtTextBackgroundColor yellow.
	att2 := CtTextBackgroundColor red.! !

!UiHtmlTextTest methodsFor: 'tests' stamp: 'mt 5/2/2009 10:19'!
testAttributesOfKind

	| atts |
	sut addAttribute: att1 from: 1 to: 5.
	sut addAttribute: att2 from: 6 to: 10.
	
	atts := sut attributesOfKind: att1 class.
	
	self
		should: atts size = 2;
		should: atts first == att1;
		should: atts second == att2.! !

!UiHtmlTextTest methodsFor: 'tests' stamp: 'mt 5/18/2009 11:14'!
testAttributesOfKindFromTo

	| atts1 atts2 atts3 atts4 atts5 |
	sut addAttribute: att1 from: 1 to: 5.
	sut addAttribute: att2 from: 6 to: 10.
	
	atts1 := sut attributesOfKind: att1 class from: 1 to: 5.
	atts2 := sut attributesOfKind: att2 class from: 6 to: 10.
	atts3 := sut attributesOfKind: att1 class from: 1 to: 10.
	atts4 := sut attributesOfKind: att1 class from: 5 to: 5.
	atts5 := sut attributesOfKind: att1 class from: 5 to: 4.
	
	self
		should: atts1 size = 1;
		should: atts2 size = 1;
		should: atts3 size = 2;
		should: atts4 size = 1;
		should: atts5 size = 1;
		should: atts1 first == att1;
		should: atts2 first == att2;
		should: atts3 first == att1;
		should: atts3 second == att2;
		should: atts4 first == att1;
		should: atts5 first == att1.! !

!UiHtmlTextTest methodsFor: 'tests' stamp: 'mt 5/2/2009 10:24'!
testIncludesAttributesOfKind

	sut addAttribute: att1 from: 1 to: 1.
	self should: (sut includesAttributesOfKind: att1 class).! !

!UiHtmlTextTest methodsFor: 'tests' stamp: 'mt 5/3/2009 18:35'!
testIncludesAttributesOfKindFromTo

	sut addAttribute: att1 from: 1 to: 2.
	self
		should: (sut includesAttributesOfKind: att1 class from: 1 to: 2);
		shouldnt: (sut includesAttributesOfKind: att1 class from: 3 to: 4).! !

!UiHtmlTextTest methodsFor: 'tests' stamp: 'mt 5/2/2009 10:27'!
testRemoveAttribute

	sut addAttribute: att1 from: 1 to: 5.
	sut addAttribute: att2 from: 6 to: 10.
	sut removeAttribute: att1.
		
	self
		should: (sut includesAttributesOfKind: att1 class);
		shouldnt: ((sut attributesOfKind: att1 class) includes: att1);
		should: ((sut attributesOfKind: att1 class) includes: att2).! !

!UiHtmlTextTest methodsFor: 'tests' stamp: 'mt 5/2/2009 10:28'!
testRemoveAttributeAround

	sut addAttribute: att1 from: 1 to: 5.
	sut addAttribute: att2 from: 6 to: 10.
	sut removeAttribute: att1 around: 5.
	sut removeAttribute: att2 around: 5.
		
	self
		should: (sut includesAttributesOfKind: att1 class);
		shouldnt: ((sut attributesOfKind: att1 class) includes: att1);
		should: ((sut attributesOfKind: att1 class) includes: att2).! !

!UiHtmlTextTest methodsFor: 'tests' stamp: 'mt 5/2/2009 10:30'!
testRemoveAttributeAroundAnd

	sut addAttribute: att1 from: 1 to: 5.
	sut addAttribute: att2 from: 6 to: 10.
	sut removeAttribute: att1 around: 4 and: 6.
		
	self
		should: (sut includesAttributesOfKind: att1 class);
		shouldnt: ((sut attributesOfKind: att1 class) includes: att1);
		should: ((sut attributesOfKind: att1 class) includes: att2).! !

!UiHtmlTextTest methodsFor: 'tests' stamp: 'mt 5/2/2009 10:32'!
testRemoveAttributeFromTo

	sut addAttribute: att1 from: 1 to: 5.
	sut addAttribute: att2 from: 6 to: 10.
	sut removeAttribute: att1 from: 1 to: 5.
	sut removeAttribute: att2 from: 6 to: 9.
		
	self
		should: (sut includesAttributesOfKind: att1 class);
		shouldnt: ((sut attributesOfKind: att1 class) includes: att1);
		should: ((sut attributesOfKind: att1 class) includes: att2).! !

TestCase subclass: #UiSliderTests
	instanceVariableNames: 'sut'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Sandbox-Tests'!

!UiSliderTests methodsFor: 'as yet unclassified' stamp: 'mt 2/25/2011 10:52:00.775'!
setUp

	super setUp.
	sut := UiSlider new.! !

!UiSliderTests methodsFor: 'as yet unclassified' stamp: 'mt 2/25/2011 11:00:25.575'!
test01tracking

	sut
		tracking: true;
		sliderPosition: 0.  
	
	self
		assert: sut hasTracking;
		assert: 0 equals: sut sliderPosition;
		assert: sut sliderPosition = sut currentValue.
	
	sut sliderPosition: 10.
	
	self
		assert: 10 equals: sut sliderPosition;
		assert: sut sliderPosition = sut currentValue.
	
	sut
		tracking: false;
		sliderPosition: 0.
		
	self
		assert: sut hasTracking not;
		assert: sut sliderPosition ~= sut currentValue.    ! !

!UiSliderTests methodsFor: 'as yet unclassified' stamp: 'mt 2/25/2011 10:56:34.319'!
test02valueChange

	sut
		tracking: true;
		currentValue: 0. 
	
	self
		assert: 0 equals: sut currentValue;
		assert: sut sliderPosition = sut currentValue.
	
	sut currentValue: 10.
	
	self
		assert: 10 equals: sut currentValue;
		assert: sut sliderPosition = sut currentValue.
	
	"Should even work without tracking."
	sut
		tracking: false;
		currentValue: 0.
		
	self assert: sut sliderPosition = sut currentValue.    
	
	sut currentValue: 10.
	
	self assert: sut sliderPosition = sut currentValue.    ! !

!UiSliderTests methodsFor: 'as yet unclassified' stamp: 'mt 2/25/2011 10:59:37.261'!
test03range

	sut
		minimum: 0;
		maximum: 10.
		
	self assert: 10 equals: sut range extent.
	
	sut minimum: 5.
	
	self assert: 5 equals: sut range extent.
	
	sut range: (1 to: 9).
	
	self
		assert: 1 equals: sut minimum;
		assert: 9 equals: sut maximum;
		assert: 8 equals: sut range extent.! !

!UiSliderTests methodsFor: 'as yet unclassified' stamp: 'mt 2/25/2011 11:15:09.507'!
test04truncate

	sut
		truncate: false;
		minimum: 0.5;
		maximum: 9.5;
		currentValue: 4.5.
		
	self
		assert: 0.5 equals: sut minimum;
		assert: 9.5 equals: sut maximum;
		assert: 4.5 equals: sut currentValue.
	
	sut truncate: true.

	self
		assert: 1 equals: sut minimum;
		assert: 10 equals: sut maximum;
		assert: 5 equals: sut currentValue.
		
	sut
		minimum: 0.5;
		maximum: 9.5;
		currentValue: 4.5.
		
	self
		assert: 1 equals: sut minimum;
		assert: 10 equals: sut maximum;
		assert: 5 equals: sut currentValue.
! !

TestCase subclass: #UiTableWidgetTests
	instanceVariableNames: 'sut'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Sandbox-Tests'!

!UiTableWidgetTests methodsFor: 'running' stamp: 'mt 1/4/2011 10:14:22.99'!
setUp

	super setUp.
	sut := UiTableWidget new.! !

!UiTableWidgetTests methodsFor: 'tests' stamp: 'mt 1/4/2011 10:39:00.552'!
test01rowCount

	| spy signal |
	spy := SignalSpy new
		addSender: sut model signal: #rowsRemovedFor:from:to:;
		addSender: sut model signal: #rowsInsertedFor:from:to:.

	self assert: 0 equals: sut rowCount.
	sut rowCount: 1.
	signal := spy waitForNextSignal.
	self
		assert: #rowsInsertedFor:from:to: equals: signal first;
		assert: 1 equals: signal second second; "from"
		assert: 1 equals: signal second third; "to"
		assert: 1 equals: sut rowCount;
		assert: 1 equals: sut viewport rows size.! !

TestCase subclass: #UiTestCase
	instanceVariableNames: 'sut spy'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Tests'!

!UiTestCase commentStamp: 'mt 3/5/2011 08:24:25.856' prior: 0!
Test environment for widgets. Simulates events and may spy on signals triggered by widgets.

Test class name infers the "subject-under-test"!! Empty subclasses will have the same tests as the base class but with different sut object. See #setUp.!

UiTestCase subclass: #UiButtonTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Tests'!

!UiButtonTests methodsFor: 'tests' stamp: 'mt 3/5/2011 08:06:51.889'!
test01New

	self
		deny: sut checkable;
		deny: sut checked;
		deny: sut autoExclusive;
		deny: sut down;
		assert: sut enabled.! !

!UiButtonTests methodsFor: 'tests' stamp: 'mt 3/5/2011 08:08:59.399'!
test02Checkable

	sut checked: true.
	
	self deny: sut checked.
	
	sut checkable: true.  
	
	self deny: sut checked.
	
	sut checked: true.
	
	self assert: sut checked.
	
	sut checkable: false.
	
	self deny: sut checked.  ! !

!UiButtonTests methodsFor: 'tests' stamp: 'mt 3/5/2011 08:09:54.45'!
test03Toggle

	sut toggle.
	
	self deny: sut checked.
	
	sut checkable: true.  
	
	self deny: sut checked.
	
	sut toggle.
	
	self assert: sut checked.
	
	sut checkable: false.
	
	self deny: sut checked.  ! !

!UiButtonTests methodsFor: 'tests' stamp: 'mt 3/5/2011 08:17:19.892'!
test04AutoExclusive

	| group otherButton |
	group := Morph new.
	otherButton := sut class new.
	
	group addMorph: sut; addMorph: otherButton.  
	
	sut checkable: true.
	otherButton checkable: true.
	
	sut toggle.
	otherButton toggle.
	
	self
		assert: sut checked;
		assert: otherButton checked.

	sut checkable: false.
	otherButton checkable: false.
		
	sut autoExclusive: true.
	otherButton autoExclusive: true.
	
	self assert: sut checkable.
	
	sut toggle.
	otherButton toggle.
	
	self
		deny: sut checked;
		assert: otherButton checked.
		
	otherButton toggle.
	
	self assert: otherButton checked.! !

!UiButtonTests methodsFor: 'tests - keyboard input' stamp: 'mt 3/5/2011 08:26:25.564'!
testK01ReturnPress

	sut checkable: true.  
	
	self
		deny: sut checked;
		keyPress: Character enter;
		assert: sut checked.  ! !

!UiButtonTests methodsFor: 'tests - mouse input' stamp: 'mt 3/5/2011 08:26:33.684'!
testM01Press

	self deny: sut down.
	
	self
		spyOn: #pressed;
		mousePress: #(left).
	
	self
		assert: sut down;
		assert: #pressed equals: spy waitForNextSignal first.! !

!UiButtonTests methodsFor: 'tests - mouse input' stamp: 'mt 3/5/2011 08:26:38.457'!
testM02Release
	
	sut down: true.
	
	self
		spyOn: #released;
		mouseRelease.
	
	self
		deny: sut down;
		assert: #released equals: spy waitForNextSignal first.! !

!UiButtonTests methodsFor: 'tests - mouse input' stamp: 'mt 3/5/2011 08:26:44.481'!
testM03Click
		
	self
		spyOn: #(pressed released clicked:);
		mouseClick: #(left).
	
	self
		deny: sut down;
		assert: #pressed equals: spy waitForNextSignal first;
		assert: #released equals: spy waitForNextSignal first;
		assert: {#clicked:. {false}} equals: spy waitForNextSignal.! !

!UiButtonTests methodsFor: 'tests - mouse input' stamp: 'mt 3/5/2011 08:26:50.571'!
testM04InteractDisabled
		
	sut
		checkable: true;
		enabled: false.
		
	self
		deny: sut checked;
		mouseClick: #(left);
		deny: sut checked.! !

!UiButtonTests methodsFor: 'tests - mouse input' stamp: 'mt 3/5/2011 08:26:56.618'!
testM05InteractEnabled
		
	sut checkable: true.
		
	self
		deny: sut checked;
		mouseClick: #(left);
		assert: sut checked.! !

!UiButtonTests methodsFor: 'tests - mouse input' stamp: 'mt 3/5/2011 08:44:29.168'!
testM06Toggled
	
	sut checkable: true.
		
	self
		spyOn: #toggled:;
		mouseClick: #(left).
	
	self assert: {#toggled:. {true}} equals: spy waitForNextSignal.
	
	self mouseClick: #(left).  
	
	self assert: {#toggled:. {false}} equals: spy waitForNextSignal.! !

UiButtonTests subclass: #UiCheckBoxTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Tests'!

UiCheckBoxTests subclass: #UiCheckBoxShiftedTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Tests'!

!UiCheckBoxShiftedTests commentStamp: 'mt 3/5/2011 08:54:28.885' prior: 0!
Use another mouse position for events.!

!UiCheckBoxShiftedTests methodsFor: 'events - private' stamp: 'mt 3/5/2011 08:56:22.718'!
simulateMouseEvent: aSymbol at: aPoint buttons: someMouseButtons start: aStartPoint morph: aCheckBox

	super
		simulateMouseEvent: aSymbol
		at: (aCheckBox instVarNamed: #box) center
		buttons: someMouseButtons
		start: aStartPoint
		morph: aCheckBox! !

!UiCheckBoxShiftedTests methodsFor: 'running' stamp: 'mt 3/5/2011 08:54:45.893'!
subjectClass

	^ UiCheckBox! !

!UiCheckBoxTests methodsFor: 'tests' stamp: 'mt 3/5/2011 08:39:38.242'!
test01New

	self
		assert: sut checkable;
		deny: sut checked;
		deny: sut autoExclusive;
		deny: sut down;
		assert: sut enabled.! !

!UiCheckBoxTests methodsFor: 'tests' stamp: 'mt 3/5/2011 08:40:29.345'!
test02Checkable

	sut checked: true.
	
	self assert: sut checked.! !

!UiCheckBoxTests methodsFor: 'tests' stamp: 'mt 3/5/2011 08:41:28.931'!
test03Toggle

	sut toggle.
	
	self assert: sut checked.
	
	sut toggle.
	
	self deny: sut checked.! !

!UiCheckBoxTests methodsFor: 'tests - mouse input' stamp: 'mt 3/5/2011 08:45:22.942'!
testM03Click
		
	self
		spyOn: #(pressed released clicked:);
		mouseClick: #(left).
	
	self
		deny: sut down;
		assert: #pressed equals: spy waitForNextSignal first;
		assert: #released equals: spy waitForNextSignal first;
		assert: {#clicked:. {true}} equals: spy waitForNextSignal.! !

UiButtonTests subclass: #UiPushButtonTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Tests'!

UiButtonTests subclass: #UiRadioButtonTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Tests'!

UiRadioButtonTests subclass: #UiRadioButtonShiftedTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Tests'!

!UiRadioButtonShiftedTests commentStamp: 'mt 3/5/2011 12:11:41.409' prior: 0!
Use another mouse position for events.!

!UiRadioButtonShiftedTests methodsFor: 'events - private' stamp: 'mt 3/5/2011 12:11:17.547'!
simulateMouseEvent: aSymbol at: aPoint buttons: someMouseButtons start: aStartPoint morph: aRadioButton

	super
		simulateMouseEvent: aSymbol
		at: (aRadioButton instVarNamed: #box) center
		buttons: someMouseButtons
		start: aStartPoint
		morph: aRadioButton! !

!UiRadioButtonShiftedTests methodsFor: 'running' stamp: 'mt 3/5/2011 12:11:23.45'!
subjectClass

	^ UiRadioButton! !

!UiRadioButtonTests methodsFor: 'tests' stamp: 'mt 3/5/2011 12:06:35.252'!
test01New

	self
		assert: sut checkable;
		deny: sut checked;
		assert: sut autoExclusive;
		deny: sut down;
		assert: sut enabled.! !

!UiRadioButtonTests methodsFor: 'tests' stamp: 'mt 3/5/2011 12:06:44.322'!
test02Checkable

	sut checked: true.
	
	self assert: sut checked.! !

!UiRadioButtonTests methodsFor: 'tests' stamp: 'mt 3/5/2011 12:06:54.738'!
test03Toggle

	sut toggle.
	
	self assert: sut checked.
	
	sut toggle.
	
	self assert: sut checked.! !

!UiRadioButtonTests methodsFor: 'tests - mouse input' stamp: 'mt 3/5/2011 12:09:38.611'!
test04AutoExclusive

	| group otherButton |
	group := Morph new.
	otherButton := sut class new.
	
	group addMorph: sut; addMorph: otherButton.  
	
	sut toggle.
	otherButton toggle.
	
	self
		deny: sut checked;
		assert: otherButton checked.
		
	otherButton toggle.
	
	self
		deny: sut checked;
		assert: otherButton checked.! !

!UiRadioButtonTests methodsFor: 'tests - mouse input' stamp: 'mt 3/5/2011 12:07:12.076'!
testM03Click
		
	self
		spyOn: #(pressed released clicked:);
		mouseClick: #(left).
	
	self
		deny: sut down;
		assert: #pressed equals: spy waitForNextSignal first;
		assert: #released equals: spy waitForNextSignal first;
		assert: {#clicked:. {true}} equals: spy waitForNextSignal.! !

!UiRadioButtonTests methodsFor: 'tests - mouse input' stamp: 'mt 3/5/2011 12:10:18.527'!
testM06Toggled
		
	self
		spyOn: #toggled:;
		mouseClick: #(left).
	
	self assert: {#toggled:. {true}} equals: spy waitForNextSignal.! !

UiButtonTests subclass: #UiToolButtonTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Tests'!

!UiToolButtonTests methodsFor: 'tests' stamp: 'mt 3/5/2011 08:29:09.731'!
test01New

	super test01New.
	
	self
		deny: sut autoRaise;
		assert: sut raised;
		assert: #textBesideIcon equals: sut buttonStyle.! !

!UiToolButtonTests methodsFor: 'tests - mouse input' stamp: 'mt 3/5/2011 08:30:55.651'!
testM01AutoRaise

	self
		assert: sut raised;
		mouseLeave;
		assert: sut raised.
	
	sut autoRaise: true.
	
	self
		deny: sut raised;
		mouseEnter;
		assert: sut raised;
		mouseLeave;
		deny: sut raised.
		
	sut autoRaise: false.
	
	self assert: sut raised.! !

!UiTestCase class methodsFor: 'Accessing' stamp: 'mt 3/5/2011 08:36:39.845'!
testSelectors

	^ (super testSelectors, self superclass testSelectors) asSet asArray sort! !

!UiTestCase methodsFor: 'accessing' stamp: 'mt 3/2/2011 10:26:07.399'!
defaultTimeout

	^ 1 "second"! !

!UiTestCase methodsFor: 'events' stamp: 'mt 3/2/2011 11:17:50.817'!
keyPress: aCharacter

	self
		keyPress: sut
		key: aCharacter
		modifiers: #().! !

!UiTestCase methodsFor: 'events' stamp: 'mt 3/2/2011 11:15:44.657'!
keyPress: aMorph key: aCharacter modifiers: someButtons

	self
		simulateKeyEvent: #keyDown
		key: aCharacter
		buttons: someButtons
		morph: aMorph.! !

!UiTestCase methodsFor: 'events' stamp: 'mt 3/2/2011 11:17:41.493'!
keyPress: aCharacter modifiers: someButtons

	self
		keyPress: sut
		key: aCharacter
		modifiers: someButtons.! !

!UiTestCase methodsFor: 'events' stamp: 'mt 3/2/2011 11:17:23.544'!
keyRelease: aCharacter

	self
		keyRelease: sut
		key: aCharacter
		modifiers: #().! !

!UiTestCase methodsFor: 'events' stamp: 'mt 3/2/2011 11:16:56.901'!
keyRelease: aMorph key: aCharacter modifiers: someButtons

	self
		simulateKeyEvent: #keyUp
		key: aCharacter
		buttons: someButtons
		morph: aMorph.! !

!UiTestCase methodsFor: 'events' stamp: 'mt 3/2/2011 11:17:16.949'!
keyRelease: aCharacter modifiers: someButtons

	self
		keyRelease: sut
		key: aCharacter
		modifiers: someButtons.! !

!UiTestCase methodsFor: 'events' stamp: 'mt 3/2/2011 11:19:38.535'!
keyStroke: aCharacter

	self
		keyStroke: sut
		key: aCharacter
		modifiers: #().! !

!UiTestCase methodsFor: 'events' stamp: 'mt 3/2/2011 11:19:04.99'!
keyStroke: aMorph key: aCharacter modifiers: someButtons

	self
		simulateKeyEvent: #keystroke
		key: aCharacter
		buttons: someButtons
		morph: aMorph.! !

!UiTestCase methodsFor: 'events' stamp: 'mt 3/2/2011 11:19:26.284'!
keyStroke: aCharacter modifiers: someButtons

	self
		keyStroke: sut
		key: aCharacter
		modifiers: someButtons.! !

!UiTestCase methodsFor: 'events - private' stamp: 'mt 3/2/2011 09:39:21.521'!
mapButton: aSymbol

	^ (Dictionary newFrom: {
		#left   -> 16r04. "red"
		#middle -> 16r01. "blue"
		#right  -> 16r02. "yellow"
		#shift  -> 16r08.
		#ctrl   -> 16r10.
		#cmd    -> 16r40. "alt"
	}) at: aSymbol ifAbsent: [Error signal: 'Unknown button symbol!!']
! !

!UiTestCase methodsFor: 'events - private' stamp: 'mt 3/2/2011 10:19:09.928'!
mapButtons: someMouseButtons
	"Maps symbols to the integer equivalent used by morphic events."
	
	^ someMouseButtons
		inject: 0
		into: [:mask :buttonSymbol | mask bitOr: (self mapButton: buttonSymbol)]! !

!UiTestCase methodsFor: 'events' stamp: 'mt 3/2/2011 10:08:47.054'!
mouseClick: someMouseButtons
	"Convenient method for sut."
	
	self mouseClick: sut buttons: someMouseButtons.! !

!UiTestCase methodsFor: 'events' stamp: 'mt 3/2/2011 09:55:27.393'!
mouseClick: aMorph buttons: someMouseButtons

	self
		mousePress: aMorph buttons: someMouseButtons;
		mouseRelease: aMorph buttons: #().! !

!UiTestCase methodsFor: 'events' stamp: 'mt 3/5/2011 08:22:55.718'!
mouseEnter

	self mouseEnter: sut.! !

!UiTestCase methodsFor: 'events' stamp: 'mt 3/5/2011 08:22:46.645'!
mouseEnter: aMorph

	self
		simulateMouseEvent: #mouseEnter
		at: aMorph center
		buttons: #()
		start: 0@0
		morph: aMorph.! !

!UiTestCase methodsFor: 'events' stamp: 'mt 3/5/2011 08:23:21.499'!
mouseLeave

	self mouseLeave: sut.! !

!UiTestCase methodsFor: 'events' stamp: 'mt 3/5/2011 08:23:06.512'!
mouseLeave: aMorph

	self
		simulateMouseEvent: #mouseLeave
		at: aMorph center
		buttons: #()
		start: 0@0
		morph: aMorph.! !

!UiTestCase methodsFor: 'events' stamp: 'mt 3/2/2011 10:09:01.438'!
mousePress: someMouseButtons

	self mousePress: sut buttons: someMouseButtons! !

!UiTestCase methodsFor: 'events' stamp: 'mt 3/2/2011 09:54:12.288'!
mousePress: aMorph buttons: someMouseButtons

	self
		simulateMouseEvent: #mouseDown
		at: aMorph center
		buttons: someMouseButtons
		start: 0@0
		morph: aMorph.! !

!UiTestCase methodsFor: 'events' stamp: 'mt 3/2/2011 11:18:30.142'!
mouseRelease

	self mouseRelease: #().! !

!UiTestCase methodsFor: 'events' stamp: 'mt 3/2/2011 10:09:24.004'!
mouseRelease: someMouseButtons

	self mouseRelease: sut buttons: someMouseButtons.! !

!UiTestCase methodsFor: 'events' stamp: 'mt 3/2/2011 09:54:32.215'!
mouseRelease: aMorph buttons: someMouseButtons

	self
		simulateMouseEvent: #mouseUp
		at: aMorph center
		buttons: someMouseButtons
		start: 0@0
		morph: aMorph.! !

!UiTestCase methodsFor: 'running' stamp: 'mt 3/2/2011 10:04:55.781'!
setUp

	super setUp.
	sut := self subjectClass new.
	spy := SignalSpy new.! !

!UiTestCase methodsFor: 'events - private' stamp: 'mt 3/2/2011 11:25:14.908'!
simulateKeyEvent: aSymbol key: aCharacter buttons: someButtons morph: aMorph

	| morphicEvent hand |
	morphicEvent := MorphicEvent readFrom: ('{1} 0 {2} {3}' format: {
		aSymbol.
		self mapButtons: someButtons.
		aCharacter asciiValue}) readStream.
	
	hand := HandMorph new.
	morphicEvent
		wasHandled: false;
		setHand: hand;
		setPosition: aMorph center.
		
	hand newKeyboardFocus: aMorph.
	
	aMorph processEvent: morphicEvent.  
! !

!UiTestCase methodsFor: 'events - private' stamp: 'mt 3/2/2011 10:43:46.247'!
simulateMouseEvent: aSymbol at: aPoint buttons: someMouseButtons start: aStartPoint morph: aMorph

	| morphicEvent hand |
	morphicEvent := MorphicEvent readFrom: ('{1} 0 {2} {3} {4} {5} {6}' format: {
		aSymbol.
		aPoint x. aPoint y.
		self mapButtons: someMouseButtons.
		aStartPoint x.
		aStartPoint y}) readStream.
	
	hand := HandMorph new.
	morphicEvent
		wasHandled: false;
		setHand: hand.
		
	hand newMouseFocus: aMorph event: morphicEvent.  
	
	aMorph processEvent: morphicEvent.  
! !

!UiTestCase methodsFor: 'signal spy' stamp: 'mt 3/2/2011 10:47:35.438'!
spyOn: aSignalOrArray
	"Convenient method to watch a signal sent by sut."
	
	aSignalOrArray isSymbol
		ifFalse: [aSignalOrArray do: [:s | spy addSender: sut signal: s]]
		ifTrue: [spy addSender: sut signal: aSignalOrArray].! !

!UiTestCase methodsFor: 'running' stamp: 'mt 3/2/2011 10:18:42.758'!
subjectClass
	"Infer subject class from test case class name."
	
	#(Tests TestCase) do: [:suffix |
		(self class name endsWith: suffix)
			ifTrue: [^ Smalltalk at: (self class name allButLast: suffix size) asSymbol]].
		
	self subclassResponsibility.! !

Point subclass: #UiModelIndex
	instanceVariableNames: 'parent model properties'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Views-Support'!

!UiModelIndex commentStamp: 'mt 11/2/2010 12:50:16.623' prior: 0!
Abstract class that represents a wrapper around some data item from a model in a view, i.e., tree view, table view, list view. Concrete implementations need to define which messages will be understood by the model in order to get the data.

No data caching intended here. But may store useful properties in order to be able to navigate quickly in the model whenever confronted with that model index again, e.g. "Please, model, tell me all your child indices based on this parent index."

A model generates all these model indices.!

!UiModelIndex class methodsFor: 'instance creation' stamp: 'mt 10/9/2010 16:37:33.666'!
row: aRow column: aColumn

	^ (self
		x: aColumn
		y: aRow) initialize! !

!UiModelIndex methodsFor: 'comparing' stamp: 'mt 10/9/2010 19:57:29.693'!
= anotherModelIndex

	^ super = anotherModelIndex
		and: [self parent = anotherModelIndex parent]! !

!UiModelIndex methodsFor: 'accessing - data' stamp: 'mt 2/12/2011 12:31:13.384'!
balloonText

	self subclassResponsibility.! !

!UiModelIndex methodsFor: 'accessing - point' stamp: 'mt 10/7/2010 18:41:30.667'!
column

	^ self x! !

!UiModelIndex methodsFor: 'dragging' stamp: 'mt 10/19/2010 15:23:07.236'!
dragLabel

	^ self text asString! !

!UiModelIndex methodsFor: 'testing - hierarchy' stamp: 'mt 10/8/2010 13:58:59.151'!
hasChildren

	self subclassResponsibility.! !

!UiModelIndex methodsFor: 'comparing' stamp: 'mt 10/13/2010 15:07:28.4'!
hash

	^ super hash bitXor: self parent hash! !

!UiModelIndex methodsFor: 'accessing - data' stamp: 'mt 10/7/2010 17:33:40.351'!
icon

	self subclassResponsibility.! !

!UiModelIndex methodsFor: 'properties' stamp: 'mt 10/9/2010 16:52:00.933'!
includesProperty: aSymbol 

	^ properties includesKey: aSymbol! !

!UiModelIndex methodsFor: 'initialization' stamp: 'mt 10/9/2010 16:36:13.61'!
initialize

	super initialize.
	properties := Dictionary new.! !

!UiModelIndex methodsFor: 'accessing - data' stamp: 'mt 11/2/2010 11:24:28.762'!
menu

	self subclassResponsibility.! !

!UiModelIndex methodsFor: 'accessing' stamp: 'mt 10/7/2010 17:24:33.729'!
model

	^ model! !

!UiModelIndex methodsFor: 'accessing' stamp: 'mt 10/7/2010 17:24:45.407'!
model: aModel

	model := aModel.! !

!UiModelIndex methodsFor: 'accessing' stamp: 'mt 10/7/2010 17:24:15.322'!
parent
	"Return parent model index."
	
	^ parent! !

!UiModelIndex methodsFor: 'accessing' stamp: 'mt 10/7/2010 17:24:27.971'!
parent: aModelIndex
	
	parent := aModelIndex.! !

!UiModelIndex methodsFor: 'printing' stamp: 'mt 11/2/2010 11:22:12.064'!
printString
	"Print the complete hierarchy of this model index."
	
	^ self parent
		ifNil: [super printString]
		ifNotNil: [super printString, ' -> ', self parent printString]! !

!UiModelIndex methodsFor: 'properties' stamp: 'mt 10/9/2010 16:33:38.613'!
removeProperty: aSymbol 

	properties ifNil: [^ self].
	properties removeKey: aSymbol ifAbsent: [].! !

!UiModelIndex methodsFor: 'accessing - point' stamp: 'mt 10/7/2010 18:41:24.938'!
row

	^ self y! !

!UiModelIndex methodsFor: 'properties' stamp: 'mt 10/9/2010 16:33:10.368'!
setProperty: aSymbol toValue: anObject 

	anObject ifNil: [^ self removeProperty: aSymbol].
	properties at: aSymbol put: anObject.! !

!UiModelIndex methodsFor: 'accessing - data' stamp: 'mt 10/7/2010 17:30:00.274'!
text

	self subclassResponsibility.! !

!UiModelIndex methodsFor: 'properties' stamp: 'mt 10/9/2010 16:33:49.248'!
valueOfProperty: aSymbol 

	^ self
		valueOfProperty: aSymbol
		ifAbsent: []! !

!UiModelIndex methodsFor: 'properties' stamp: 'mt 10/9/2010 16:38:51.641'!
valueOfProperty: aSymbol ifAbsent: aBlock

	^ properties
		at: aSymbol
		ifAbsent: aBlock! !

UiModelIndex subclass: #UiPluggableModelIndex
	instanceVariableNames: 'textSelector iconSelector hasChildrenSelector menuSelector balloonTextSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Views-Support'!

!UiPluggableModelIndex commentStamp: 'mt 10/16/2010 08:04:49.988' prior: 0!
Customizable model index that may use any selector of a model that is appropriate to get #hasChildren, #text, or #icon.!

!UiPluggableModelIndex methodsFor: 'accessing - data' stamp: 'mt 2/12/2011 12:32:02.134'!
balloonText

	^ model perform: balloonTextSelector with: self! !

!UiPluggableModelIndex methodsFor: 'accessing' stamp: 'mt 2/12/2011 12:31:33.353'!
balloonTextSelector

	^ balloonTextSelector! !

!UiPluggableModelIndex methodsFor: 'accessing' stamp: 'mt 2/12/2011 12:31:45.399'!
balloonTextSelector: aSymbol

	balloonTextSelector := aSymbol.! !

!UiPluggableModelIndex methodsFor: 'accessing - data' stamp: 'mt 10/16/2010 08:03:47.754'!
hasChildren

	^ model perform: hasChildrenSelector with: self! !

!UiPluggableModelIndex methodsFor: 'accessing' stamp: 'mt 10/16/2010 08:04:12.752'!
hasChildrenSelector

	^ hasChildrenSelector! !

!UiPluggableModelIndex methodsFor: 'accessing' stamp: 'mt 10/16/2010 08:04:04.084'!
hasChildrenSelector: aSymbol

	hasChildrenSelector := aSymbol.! !

!UiPluggableModelIndex methodsFor: 'accessing - data' stamp: 'mt 10/8/2010 10:02:19.278'!
icon

	^ model perform: iconSelector with: self! !

!UiPluggableModelIndex methodsFor: 'accessing' stamp: 'mt 10/7/2010 17:58:07.041'!
iconSelector

	^ iconSelector ! !

!UiPluggableModelIndex methodsFor: 'accessing' stamp: 'mt 10/7/2010 17:58:14.566'!
iconSelector: aSymbol

	iconSelector := aSymbol.! !

!UiPluggableModelIndex methodsFor: 'accessing' stamp: 'mt 11/2/2010 11:24:45.126'!
menuSelector

	^ menuSelector! !

!UiPluggableModelIndex methodsFor: 'accessing' stamp: 'mt 11/2/2010 11:24:58.649'!
menuSelector: aSymbol

	menuSelector := aSymbol.! !

!UiPluggableModelIndex methodsFor: 'accessing - data' stamp: 'mt 10/8/2010 10:02:11.707'!
text

	^ model perform: textSelector with: self! !

!UiPluggableModelIndex methodsFor: 'accessing' stamp: 'mt 10/7/2010 17:31:08.265'!
textSelector

	^ textSelector! !

!UiPluggableModelIndex methodsFor: 'accessing' stamp: 'mt 10/7/2010 17:31:00.834'!
textSelector: aSymbol

	textSelector := aSymbol.! !

UiModelIndex subclass: #UiSimpleModelIndex
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Views-Support'!

!UiSimpleModelIndex commentStamp: 'mt 10/16/2010 08:05:34.628' prior: 0!
Simple implementation of a model index that assumes that the model understands some default messages as #textFor:, #iconFor:, and #hasChildrenFor:.!

!UiSimpleModelIndex methodsFor: 'accessing - data' stamp: 'mt 2/12/2011 12:32:18.602'!
balloonText

	^ model balloonTextFor: self! !

!UiSimpleModelIndex methodsFor: 'testing - hierarchy' stamp: 'mt 10/10/2010 11:35:51.993'!
hasChildren

	^ model hasChildrenFor: self! !

!UiSimpleModelIndex methodsFor: 'accessing - data' stamp: 'mt 10/7/2010 17:58:55.129'!
icon

	^ model iconFor: self! !

!UiSimpleModelIndex methodsFor: 'accessing - data' stamp: 'mt 11/2/2010 11:25:19.886'!
menu

	^ model menuFor: self! !

!UiSimpleModelIndex methodsFor: 'accessing - data' stamp: 'mt 10/7/2010 17:32:11.105'!
text

	^ model textFor: self! !

TransformMorph subclass: #UiTransformMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Support'!

!UiTransformMorph commentStamp: 'mt 2/27/2011 17:00:16.811' prior: 0!
A transform morph that provides signals.!

!UiTransformMorph methodsFor: 'accessing' stamp: 'mt 2/27/2011 17:02:46.165'!
angle: aNumber

	self angle = aNumber ifTrue: [^ self] .
	super angle: aNumber.
	self angleChanged: self angle.  ! !

!UiTransformMorph methodsFor: 'signals' stamp: 'mt 2/27/2011 17:00:55.169'!
angleChanged: aNumber

	self emit.! !

!UiTransformMorph methodsFor: 'accessing' stamp: 'mt 3/7/2011 09:33:49.654'!
horizontalOffset

	^ self offset x! !

!UiTransformMorph methodsFor: 'accessing' stamp: 'mt 3/7/2011 09:36:11.99'!
horizontalOffset: aNumber

	aNumber = self horizontalOffset ifTrue: [^ self].
	
	self offset: aNumber @ self offset y.

	self horizontalOffsetChanged: self horizontalOffset.  ! !

!UiTransformMorph methodsFor: 'signals - specific' stamp: 'mt 3/7/2011 09:35:09.391'!
horizontalOffsetChanged: aNumber

	self emit.! !

!UiTransformMorph methodsFor: 'initialization' stamp: 'mt 3/7/2011 13:27:02.976'!
initialize

	super initialize.
	self color: Color transparent.! !

!UiTransformMorph methodsFor: 'signals' stamp: 'mt 2/27/2011 17:09:31.281'!
layoutChanged

	super layoutChanged.
	self emitAlways.! !

!UiTransformMorph methodsFor: 'accessing' stamp: 'mt 3/7/2011 13:58:27.153'!
offset: aPoint

	aPoint = self offset ifTrue: [^ self].

	super offset: aPoint.

	self
		offsetChanged: self offset;
		horizontalOffsetChanged: self offset x;
		verticalOffsetChanged: self offset y.! !

!UiTransformMorph methodsFor: 'signals' stamp: 'mt 2/27/2011 17:00:35.308'!
offsetChanged: aPoint

	self emit.! !

!UiTransformMorph methodsFor: 'accessing' stamp: 'mt 2/27/2011 17:03:04.995'!
scale: aNumber

	self scale = aNumber ifTrue: [^ self] .
	super scale: aNumber.
	self scaleChanged: self scale.! !

!UiTransformMorph methodsFor: 'signals' stamp: 'mt 2/27/2011 17:00:48.104'!
scaleChanged: aNumber

	self emit.! !

!UiTransformMorph methodsFor: 'accessing' stamp: 'mt 3/7/2011 09:33:57.533'!
verticalOffset

	^ self offset y! !

!UiTransformMorph methodsFor: 'accessing' stamp: 'mt 3/7/2011 09:36:39.622'!
verticalOffset: aNumber

	aNumber = self verticalOffset ifTrue: [^ self].
	
	self offset: self offset x @ aNumber.
	
	self verticalOffsetChanged: self verticalOffset.  ! !

!UiTransformMorph methodsFor: 'signals - specific' stamp: 'mt 3/7/2011 09:35:04.739'!
verticalOffsetChanged: aNumber

	self emit.! !

BorderedMorph subclass: #UiContainer
	instanceVariableNames: 'editMode focusRectangle'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Core'!

!UiContainer commentStamp: 'mt 7/13/2010 09:34:37.877' prior: 0!
I am a, normally invisible, container or owner morph for various UI elements. If I am in #editMode, I support drag&drop operations.!

UiContainer subclass: #UiButtonGroup
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Core'!

!UiButtonGroup commentStamp: 'mt 7/13/2010 09:32:47.81' prior: 0!
I am a container for buttons that make my submorphs/buttons auto-exclusive.!

!UiButtonGroup class methodsFor: 'accessing' stamp: 'mt 10/19/2010 11:52:38.557'!
widgetClassIcon

	^ UiFugueIcons uiGroupBoxIcon! !

!UiButtonGroup class methodsFor: 'accessing' stamp: 'mt 7/1/2010 08:07:04.687'!
widgetClassName

	^ 'Button Group'! !

!UiButtonGroup methodsFor: 'submorphs-add/remove' stamp: 'mt 7/1/2010 08:23:06.023'!
addMorphBack: aButton

	super addMorphBack: aButton.
	
	aButton autoExclusive: true.
	
	self
		connect: aButton signal: #clicked: toSelector: #clickButton: pattern: #(0);
		connect: aButton signal: #pressed toSelector: #pressButton: pattern: #(0);
		connect: aButton signal: #released toSelector: #releaseButton: pattern: #(0).! !

!UiButtonGroup methodsFor: 'accessing' stamp: 'mt 7/1/2010 08:16:04.263'!
button: anId

	 self submorphs withIndexDo: [:m :i | i = anId ifTrue: [^ m]].
	
	^ nil! !

!UiButtonGroup methodsFor: 'signals' stamp: 'mt 7/1/2010 08:11:14.563'!
buttonClicked: aButton id: anId

	self emit.! !

!UiButtonGroup methodsFor: 'signals' stamp: 'mt 7/1/2010 08:11:30.004'!
buttonPressed: aButton id: anId

	self emit.! !

!UiButtonGroup methodsFor: 'signals' stamp: 'mt 7/1/2010 08:11:48.494'!
buttonReleased: aButton id: anId

	self emit.! !

!UiButtonGroup methodsFor: 'accessing' stamp: 'mt 7/1/2010 08:10:28.017'!
checkedButton

	^ self submorphs detect: [:m | m isChecked] ifNone: [nil]! !

!UiButtonGroup methodsFor: 'accessing' stamp: 'mt 7/1/2010 08:10:20.631'!
checkedId

	self submorphs withIndexDo: [:m :i | m isChecked ifTrue: [^ i]].
	^ 0! !

!UiButtonGroup methodsFor: 'private' stamp: 'mt 7/1/2010 08:16:32.662'!
clickButton: aButton

	self buttonClicked: aButton id: (self id: aButton)! !

!UiButtonGroup methodsFor: 'accessing' stamp: 'mt 7/1/2010 08:14:12.383'!
id: aButton

	self submorphs withIndexDo: [:m :i | m == aButton ifTrue: [^ i]].
	^ 0! !

!UiButtonGroup methodsFor: 'private' stamp: 'mt 7/1/2010 08:16:44.088'!
pressButton: aButton

	self buttonPressed: aButton id: (self id: aButton)! !

!UiButtonGroup methodsFor: 'private' stamp: 'mt 7/1/2010 08:16:54.688'!
releaseButton: aButton

	self buttonReleased: aButton id: (self id: aButton).! !

!UiButtonGroup methodsFor: 'dropping/grabbing' stamp: 'mt 10/22/2010 12:50:11.311'!
wantsDroppedMorph: aMorph event: evt

	(((aMorph isKindOf: TransferMorph)
		and: [UiButton subclasses includes: (aMorph passenger model widgetAt: aMorph passenger)])
		or: [aMorph isKindOf: UiButton])
		ifTrue: [^ super wantsDroppedMorph: aMorph event: evt].
	
	^ false! !

!UiContainer class methodsFor: 'testing' stamp: 'mt 6/28/2010 21:36:20.651'!
isWidgetClass

	^ true! !

!UiContainer class methodsFor: 'accessing' stamp: 'mt 10/26/2010 19:45:30.19'!
widgetCategory
	
	^ 'Containers & Spacer'! !

!UiContainer class methodsFor: 'accessing' stamp: 'mt 10/19/2010 11:50:47.132'!
widgetClassIcon

	^ UiFugueIcons uiPanelIcon! !

!UiContainer class methodsFor: 'accessing' stamp: 'mt 6/30/2010 21:22:49.177'!
widgetClassName

	^ 'Widget Container'! !

!UiContainer class methodsFor: 'properties' stamp: 'mt 10/28/2010 16:52:48.311'!
widgetProperties

	^ super widgetProperties, {{'Container'. #yourself} -> {
		#color -> Object.
		#borderWidth -> Integer.
		#borderStyle2 -> #(simple inset raised).
		#borderColor -> Object}}! !

!UiContainer methodsFor: 'dropping/grabbing' stamp: 'mt 10/28/2010 10:41:28.447'!
acceptDroppingMorph: aMorph event: evt

	| result |
	(aMorph isKindOf: TransferMorph)
		ifTrue: [ (aMorph passenger model widgetAt: aMorph passenger) ifNotNil: [:widgetClass |
			| widget |
			widget := widgetClass new position: evt position.
			self addMorphBack: widget.
			(widget isKindOf: UiContainer)
				ifTrue: [widget editMode: self editMode].

			self
				changeFocusTo: widget bounds;
				changeSelectionTo: widget.
				
			^ self]].

	result := super acceptDroppingMorph: aMorph event: evt.
	
	self
		changeFocusTo: aMorph bounds;
		changeSelectionTo: aMorph.
	
	^ result! !

!UiContainer methodsFor: 'accessing' stamp: 'mt 10/28/2010 15:29:55.046'!
borderStyle2

	^ self borderColor isSymbol
		ifTrue: [self borderColor]
		ifFalse: [#simple]! !

!UiContainer methodsFor: 'accessing' stamp: 'mt 10/28/2010 15:31:30.474'!
borderStyle2: aSymbol

	aSymbol ifNil: [^ self].
	
	aSymbol = #simple
		ifTrue: [^ self borderColor: Color transparent].
	
	^ self borderColor: aSymbol! !

!UiContainer methodsFor: 'focus' stamp: 'mt 10/23/2010 09:50:30.956'!
changeFocusTo: aRectangle

	(self owner isKindOf: UiContainer)
		ifTrue: [^ self owner changeFocusTo: aRectangle].
	
	aRectangle = self bounds
		ifTrue: [focusRectangle := nil].
	
	focusRectangle := aRectangle ifNotNil: [:r | r outsetBy: (2@2)].
	self redrawLater.! !

!UiContainer methodsFor: 'selection' stamp: 'mt 10/28/2010 16:17:10.322'!
changeSelectionTo: aMorph
	"Talk to root container."

	(self owner isKindOf: UiContainer)
		ifTrue: [self owner changeSelectionTo: aMorph]
		ifFalse: [	self selectionChanged: aMorph].
			
	aMorph addHalo.! !

!UiContainer methodsFor: 'event handling' stamp: 'mt 10/24/2010 11:07:59.575'!
click: evt

"	| clickedMorph |
	clickedMorph := self submorphs detect: [:m | m bounds containsPoint: evt position] ifNone: [self].
	
	evt yellowButtonPressed ifTrue: [
		self showContextMenuForMorph: clickedMorph atHand: evt hand]."
	
	| clickedMorph |
	clickedMorph := self submorphs
		detect: [:m | m bounds containsPoint: evt position] ifNone: [self].
		
	self
		changeFocusTo: clickedMorph bounds;
		changeSelectionTo: clickedMorph.! !

!UiContainer methodsFor: 'event handling' stamp: 'mt 6/27/2010 13:43:16.726'!
doubleClick: evt! !

!UiContainer methodsFor: 'drawing' stamp: 'mt 10/26/2010 20:20:20.839'!
drawFocusOn: aCanvas rectangle: aRect
	
"	aCanvas
		frameRectangle: (aRect insetBy: 1)
		color: (Color r: 0.5 g: 0.5 b: 1.0 alpha: 0.8) muchDarker.
		
	aCanvas
		frameRoundRect: aRect
		radius: 3
		width: 1
		color: (Color r: 0.5 g: 0.5 b: 1.0 alpha: 0.5) muchDarker."! !

!UiContainer methodsFor: 'drawing' stamp: 'mt 10/28/2010 11:08:59.269'!
drawOn: aCanvas

	self editMode
		ifFalse: [^ super drawOn: aCanvas].
	
	aCanvas
		fillRectangle: self bounds
		fillStyle: ((self color = Color transparent)
			ifTrue: [SolidFillStyle color: ((Color gray: 0.3) alpha: 0.1)]
			ifFalse: [self fillStyle])
		borderStyle: self borderStyle.

	focusRectangle ifNotNil: [self drawFocusOn: aCanvas rectangle: focusRectangle].! !

!UiContainer methodsFor: 'accessing' stamp: 'mt 6/30/2010 09:17:26.068'!
editMode

	^ editMode ifNil: [editMode := false]! !

!UiContainer methodsFor: 'accessing' stamp: 'mt 10/28/2010 11:07:21.218'!
editMode: aBoolean

	editMode := aBoolean.
	
	self dropEnabled: editMode.
	self dragEnabled: editMode.
	
	self submorphs
		select: [:m | m isKindOf: UiContainer]
		thenDo: [:m | m editMode: aBoolean].! !

!UiContainer methodsFor: 'signals' stamp: 'mt 6/28/2010 11:03:51.082'!
focusChanged: aBoolean

	self emit.! !

!UiContainer methodsFor: 'event handling' stamp: 'mt 6/30/2010 09:18:46.354'!
handlesMouseDown: evt

	^ self editMode! !

!UiContainer methodsFor: 'initialization' stamp: 'mt 10/26/2010 20:01:29.289'!
initialize

	super initialize.
	self
		extent: 100@100;
		color: Color transparent;
		borderWidth: 0;
		cellInset: 4;
		layoutInset: 4.! !

!UiContainer methodsFor: 'testing' stamp: 'mt 10/27/2010 20:39:00.491'!
isUiContainer

	^ true! !

!UiContainer methodsFor: 'event handling' stamp: 'mt 6/28/2010 11:03:39.618'!
keyboardFocusChange: aBoolean

	self focusChanged: aBoolean.! !

!UiContainer methodsFor: 'event handling' stamp: 'mt 10/23/2010 10:06:01.973'!
mouseDown: evt

	"| clickedMorph |
	clickedMorph := self submorphs
		detect: [:m | m bounds containsPoint: evt position] ifNone: [self].
	
	self submorphs do: [:m |
		m ~~ clickedMorph
			ifTrue: [m setProperty: #hasFocus toValue: false]].
	self setProperty: #hasFocus toValue: false.
	
	clickedMorph setProperty: #hasFocus toValue: true.
	self changeSelectionTo: clickedMorph."

	evt hand
		waitForClicksOrDrag: self
		event: evt
		selectors: {#click:. nil. nil. #startDrag:}
		threshold: 1. "pixel threshold"
		
	"self redrawLater.
	(self owner isKindOf: UiContainer) ifTrue: [self owner redrawLater]."! !

!UiContainer methodsFor: 'events-processing' stamp: 'mt 6/30/2010 09:18:26.354'!
mouseDownPriority
	"Give me ALL events."
	
	self editMode ifFalse: [^ super mouseDownPriority].
	^ 100! !

!UiContainer methodsFor: 'geometry' stamp: 'mt 7/1/2010 17:54:17.265'!
outerBounds

	(self owner isKindOf: UiContainer)
		ifTrue: [^ self bounds outsetBy: (3@3 corner: 3@3)]
		ifFalse: [^ self bounds].! !

!UiContainer methodsFor: 'signals' stamp: 'mt 6/30/2010 09:29:37.854'!
selectionChanged: aMorph

	self emit.! !

!UiContainer methodsFor: 'context menu' stamp: 'mt 6/28/2010 11:13:33.993'!
showContextMenuForMorph: aMorph atHand: aHand

	| menu |
	menu := SBMenu new.
	
	self
		connect: (menu addAction: (SBAction new text: 'vResizing'))
		signal: #triggered
		to: aMorph
		selector: #vResizing:
		pattern: #(=#spaceFill).
	
	"Clean up the menu."
	menu connect: self signal: #focusChanged: toSelector: #delete.
	
	"Get focus and show menu."
	aHand newKeyboardFocus: self.
	menu popUp..! !

!UiContainer methodsFor: 'event handling' stamp: 'mt 10/24/2010 11:08:08.144'!
startDrag: evt

	| morphToDrag |
	morphToDrag := self submorphs
		detect: [:m | m bounds containsPoint: evt position]
		ifNone: [self dragEnabled
			ifTrue: [self]
			ifFalse: [nil]].
	
	self changeFocusTo: nil.
			
	morphToDrag ifNil: [^ self].
	
	evt redButtonPressed
		ifTrue: [evt hand grabMorph: morphToDrag].! !

!UiContainer methodsFor: 'dropping/grabbing' stamp: 'mt 6/28/2010 16:46:21.331'!
wantsDroppedMorph: aMorph event: evt

	self redrawLater.
	^ super wantsDroppedMorph: aMorph event: evt! !

UiContainer subclass: #UiSpacer
	instanceVariableNames: 'orientation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Core'!

!UiSpacer class methodsFor: 'accessing' stamp: 'mt 10/26/2010 19:44:49.988'!
widgetClassIcon

	^ UiFugueIcons uiAccordionIcon! !

!UiSpacer class methodsFor: 'accessing' stamp: 'mt 10/26/2010 19:43:44.923'!
widgetClassName

	^ 'Spacer'! !

!UiSpacer class methodsFor: 'properties' stamp: 'mt 10/26/2010 20:07:37.101'!
widgetProperties

	^ super widgetProperties, {{'Spacer'. #yourself} -> {
		#orientation -> #(horizontal vertical)}}! !

!UiSpacer class methodsFor: 'properties' stamp: 'mt 10/27/2010 09:42:04.578'!
widgetPropertiesToIgnore

	^ #(hResizing vResizing 'TableLayout' 'ProportionalLayout')! !

!UiSpacer methodsFor: 'drawing' stamp: 'mt 10/28/2010 10:58:19.197'!
drawOn: aCanvas

	self editMode ifFalse: [^ self].
	
	self orientation = #horizontal ifTrue: [
		aCanvas
			line: self topLeft to: self bottomLeft color: self color;
			line: self topRight to: self bottomRight color: self color;
			line: self topLeft + (0@(self height // 2)) to: self topRight + (0@(self height // 2)) color: self color].
		
	self orientation = #vertical ifTrue: [
		aCanvas
			line: self topLeft to: self topRight color: self color;
			line: self bottomLeft to: self bottomRight color: self color;
			line: self topLeft + ((self width // 2) @ 0) to: self bottomLeft + ((self width // 2) @ 0) color: self color].! !

!UiSpacer methodsFor: 'initialization' stamp: 'mt 10/26/2010 20:36:06.836'!
initialize

	super initialize.
	self
		color: Color blue;
		orientation: #horizontal.! !

!UiSpacer methodsFor: 'accessing' stamp: 'mt 10/26/2010 19:57:59.594'!
orientation

	^ orientation! !

!UiSpacer methodsFor: 'accessing' stamp: 'mt 10/26/2010 19:57:51.389'!
orientation: aSymbol
	"#horizontal, #vertical"

	orientation == aSymbol
		ifTrue: [^ self].
		
	orientation := aSymbol.
	self updateLayout.! !

!UiSpacer methodsFor: 'geometry' stamp: 'mt 10/26/2010 20:04:04.927'!
outerBounds

	^ self bounds outsetBy: (0@0 corner: 1@1)! !

!UiSpacer methodsFor: 'updating' stamp: 'mt 10/26/2010 20:37:43.15'!
updateLayout

	self orientation = #horizontal
		ifTrue: [self
			hResizing: #spaceFill;
			vResizing: #rigid].
		
	self orientation = #vertical
		ifTrue: [self
			hResizing: #rigid;
			vResizing: #spaceFill].
		
	self redrawLater.! !

!UiSpacer methodsFor: 'dropping/grabbing' stamp: 'mt 10/26/2010 19:37:26.982'!
wantsDroppedMorph: aMorph event: evt

	^ false! !

UiContainer subclass: #UiStackedWidget
	instanceVariableNames: 'pages nextPageButton previousPageButton addPageButton removePageButton currentIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Sandbox'!

!UiStackedWidget class methodsFor: 'testing' stamp: 'mt 2/12/2011 12:28:22.186'!
isExperimentalWidgetClass

	^ true! !

!UiStackedWidget class methodsFor: 'accessing' stamp: 'mt 10/19/2010 11:53:08.176'!
widgetClassIcon

	^ UiFugueIcons uiLayeredPaneIcon! !

!UiStackedWidget class methodsFor: 'accessing' stamp: 'mt 10/19/2010 14:05:23.132'!
widgetClassName

	^ 'Stacked Widget'! !

!UiStackedWidget methodsFor: 'dropping/grabbing' stamp: 'mt 10/26/2010 19:40:20.732'!
acceptDroppingMorph: aMorph event: evt

	(aMorph isKindOf: TransferMorph)
		ifTrue: [(aMorph passenger model widgetAt: aMorph passenger) ifNotNil: [:widgetClass |
			| widget |
			widget := widgetClass new position: evt position.
			self currentPage addMorphBack: widget.
			(widget isKindOf: UiContainer)
				ifTrue: [widget editMode: self editMode].
				
			self
				changeFocusTo: widget bounds;
				changeSelectionTo: widget]]
		ifFalse: [
			self currentPage addMorphBack: aMorph.
			
			self
				changeFocusTo: aMorph bounds;
				changeSelectionTo: aMorph].
		
	"self updateCurrentPage."! !

!UiStackedWidget methodsFor: 'add/remove' stamp: 'mt 7/14/2010 10:40:49.279'!
addPage

	self pages add: UiWidgetPage new.
	self currentIndex: self pages size.! !

!UiStackedWidget methodsFor: 'event handling' stamp: 'mt 10/23/2010 10:03:25.639'!
click: evt

	| clickedMorph |
	clickedMorph := self currentPage submorphs
		detect: [:m | m bounds containsPoint: evt position] ifNone: [self].
	
	clickedMorph == self
		ifTrue: [self
			changeFocusTo: self currentPage bounds;
			changeSelectionTo: self currentPage]
		ifFalse: [self
			changeFocusTo: clickedMorph bounds;
			changeSelectionTo: clickedMorph].! !

!UiStackedWidget methodsFor: 'accessing' stamp: 'mt 7/13/2010 09:54:24.59'!
currentIndex

	^ currentIndex! !

!UiStackedWidget methodsFor: 'accessing' stamp: 'mt 7/13/2010 10:00:45.703'!
currentIndex: anInteger

	(anInteger = currentIndex
		or: [anInteger < 1]
		or: [anInteger > self pages size]) ifTrue: [^ self].
	
	currentIndex := anInteger.
	
	self updateCurrentPage.! !

!UiStackedWidget methodsFor: 'accessing' stamp: 'mt 7/13/2010 10:19:46.577'!
currentPage

	^ self pages at: self currentIndex.! !

!UiStackedWidget methodsFor: 'initialization' stamp: 'mt 7/16/2010 13:12:51.61'!
initialize

	| buttonContainer |
	super initialize.
	
	nextPageButton := UiToolButton new
		autoRaise: true;
		icon: (UiFugueIcons arrow000SmallIcon clippedTo: 8@8);
		buttonStyle: #iconOnly;
		setBalloonText: 'Next Page'.

	self connect: nextPageButton signal: #clicked: toSelector: #nextPage.
		
	previousPageButton := UiToolButton new
		autoRaise: true;
		icon: (UiFugueIcons arrow180SmallIcon clippedTo: 8@8);
		buttonStyle: #iconOnly;
		setBalloonText: 'Previous Page'.
	
	self connect: previousPageButton signal: #clicked: toSelector: #previousPage.

	addPageButton := UiToolButton new
		autoRaise: true;
		icon: (UiFugueIcons plusSmallIcon clippedTo: 8@8);
		buttonStyle: #iconOnly;
		setBalloonText: 'Add Page'.

	self connect: addPageButton signal: #clicked: toSelector: #addPage.

	removePageButton := UiToolButton new
		autoRaise: true;
		icon: (UiFugueIcons minusSmallIcon clippedTo: 8@8);
		buttonStyle: #iconOnly;
		setBalloonText: 'Remove Page'.

	self connect: removePageButton signal: #clicked: toSelector: #removeCurrentPage.
	
	buttonContainer := UiWidgetPageButtonContainer new.
	
	buttonContainer
		addMorphBack: addPageButton;
		addMorphBack: removePageButton;
		addMorphBack: previousPageButton;
		addMorphBack: nextPageButton.
	
	self changeTableLayout.
	self addMorphBack: buttonContainer.
	self addPage. "First empty page."! !

!UiStackedWidget methodsFor: 'navigation' stamp: 'mt 7/13/2010 10:15:59.084'!
nextPage

	self currentIndex: (self currentIndex + 1 min: self pages size).! !

!UiStackedWidget methodsFor: 'accessing' stamp: 'mt 7/13/2010 09:36:45.708'!
pages

	^ pages ifNil: [pages := OrderedCollection new]! !

!UiStackedWidget methodsFor: 'navigation' stamp: 'mt 7/13/2010 10:16:13.279'!
previousPage

	self currentIndex: (self currentIndex - 1 max: 1).! !

!UiStackedWidget methodsFor: 'add/remove' stamp: 'mt 7/16/2010 13:13:05.39'!
removeCurrentPage

! !

!UiStackedWidget methodsFor: 'event handling' stamp: 'mt 7/13/2010 10:09:25.305'!
startDrag: evt

	| morphToDrag |
	morphToDrag := self currentPage submorphs
		detect: [:m | m bounds containsPoint: evt position]
		ifNone: [self dragEnabled
			ifTrue: [self]
			ifFalse: [nil]].
			
	morphToDrag ifNil: [^ self].
	
	evt redButtonPressed
		ifTrue: [evt hand grabMorph: morphToDrag].! !

!UiStackedWidget methodsFor: 'updating' stamp: 'mt 10/23/2010 09:39:13.865'!
updateCurrentPage

	| buttonContainer |
	buttonContainer := nextPageButton owner.
	
	self
		removeAllMorphs;
		addMorphBack: self currentPage;
		addMorphFront: buttonContainer;
		changeFocusTo: self currentPage bounds;
		changeSelectionTo: self currentPage.! !

!Text methodsFor: '*widgets-text' stamp: 'mt 6/22/2010 23:13:43.314'!
asHtmlText
	"No change here."
	
	^ self! !

PluggableTextMorph subclass: #UiTextEdit
	instanceVariableNames: 'text validator outerBorderWidth autoConvert'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Core'!

UiTextEdit subclass: #UiLineEdit
	instanceVariableNames: 'helpText'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Core'!

!UiLineEdit class methodsFor: 'accessing' stamp: 'mt 10/19/2010 11:55:02.739'!
widgetClassIcon

	^ UiFugueIcons uiTextFieldIcon! !

!UiLineEdit class methodsFor: 'accessing' stamp: 'mt 6/30/2010 21:22:05.575'!
widgetClassName

	^ 'Line Edit'! !

!UiLineEdit class methodsFor: 'accessing' stamp: 'mt 10/28/2010 09:38:59.208'!
widgetProperties

	^ super widgetProperties, {{'Line Edit'. #yourself} -> {
		#helpText -> String}}! !

!UiLineEdit class methodsFor: 'accessing' stamp: 'mt 10/27/2010 09:46:54.189'!
widgetPropertiesToIgnore

	^ super widgetPropertiesToIgnore, #(vResizing)! !

!UiLineEdit methodsFor: 'drawing' stamp: 'mt 10/27/2010 13:59:31.849'!
drawHelpTextOn: aCanvas

	| font |
	(self helpText isEmpty or: [self textMorph contents notEmpty]) ifTrue: [^ self].

	font := self textMorph textStyle defaultFont.

	aCanvas
		drawString: self helpText 
		in: ((self topLeft extent: self width @ font height) translateBy: 5 @ (self height - font height // 2))
		font: font
		color: (Color gray: 0.7).! !

!UiLineEdit methodsFor: 'drawing' stamp: 'mt 9/18/2010 15:51:20.667'!
drawOn: aCanvas

	super drawOn: aCanvas.
	self drawHelpTextOn: aCanvas.! !

!UiLineEdit methodsFor: 'accessing' stamp: 'mt 9/18/2010 15:47:25.286'!
helpText

	^ helpText ifNil: [helpText := '']! !

!UiLineEdit methodsFor: 'accessing' stamp: 'mt 9/18/2010 15:52:27.508'!
helpText: aString
	"Drawn whenver #theText is empty."
	
	helpText := aString.
	self redrawLater.! !

!UiLineEdit methodsFor: 'initialization' stamp: 'mt 9/13/2010 11:04:47.018'!
initialize

	super initialize.
	
	self
		hResizing: #spaceFill;
		setProperty: #noVScrollBarPlease toValue: true;
		height: 20.
	
	"Fix initial state."
	self
		setText: 'LineEdit';
		resizeScroller.
	
	self textMorph
		wrapFlag: false;
		acceptOnCR: true.! !

!UiLineEdit methodsFor: 'initialization' stamp: 'mt 9/13/2010 11:08:53.286'!
textMorphClass

	^ UiLineEditTextMorph! !

!UiLineEdit methodsFor: 'updating' stamp: 'mt 9/13/2010 11:14:16.838'!
update: aSymbol

	aSymbol == #appendEntry
		ifTrue: [^ self].
		
	super update: aSymbol.! !

!UiTextEdit class methodsFor: 'testing' stamp: 'mt 9/13/2010 10:59:48.079'!
isWidgetClass

	^ true! !

!UiTextEdit class methodsFor: 'instance creation' stamp: 'mt 9/13/2010 10:59:48.163'!
new

	| instance |
	instance := super new.
	
	instance
		on: instance
		text: #theText
		accept: #theText:
		readSelection: nil
		menu: nil.
	
	^ instance! !

!UiTextEdit class methodsFor: 'accessing' stamp: 'mt 10/19/2010 14:06:19.428'!
widgetCategory

	^ 'Input Widgets'! !

!UiTextEdit class methodsFor: 'accessing' stamp: 'mt 10/19/2010 11:54:49.935'!
widgetClassIcon

	^ UiFugueIcons uiTextAreaIcon! !

!UiTextEdit class methodsFor: 'accessing' stamp: 'mt 9/13/2010 11:00:16.518'!
widgetClassName

	^ 'Text Edit'! !

!UiTextEdit class methodsFor: 'accessing' stamp: 'mt 10/28/2010 16:53:02.624'!
widgetProperties

	^ super widgetProperties, {{'Text Edit'. #yourself} -> {
		#theText -> String.
		#readOnly -> Boolean.
		#outerBorderWidth -> Integer.
		#autoConvert -> Boolean.
		#autoAccept -> Boolean}}! !

!UiTextEdit class methodsFor: 'accessing' stamp: 'mt 10/27/2010 09:46:35.599'!
widgetPropertiesToIgnore

	^ #('TableLayout' 'ProportionalLayout')! !

!UiTextEdit methodsFor: 'model access' stamp: 'mt 9/13/2010 10:59:46.025'!
acceptTextInModel
	"Overridden to ensure String - not Text."
	
	| valueToAccept |
	valueToAccept := self convertedValue.
	
	model perform: setTextSelector with: valueToAccept.
	
	^ true! !

!UiTextEdit methodsFor: 'editing' stamp: 'mt 9/13/2010 10:59:46.129'!
autoAccept

	^ self textMorph autoAccept! !

!UiTextEdit methodsFor: 'editing' stamp: 'mt 9/13/2010 10:59:46.191'!
autoAccept: aBoolean

	self textMorph autoAccept: aBoolean! !

!UiTextEdit methodsFor: 'accessing' stamp: 'mt 10/27/2010 14:07:46.106'!
autoConvert

	^ autoConvert ifNil: [autoConvert := false]! !

!UiTextEdit methodsFor: 'accessing' stamp: 'mt 10/27/2010 14:08:08.635'!
autoConvert: aBoolean
	"If enabled, converts the text after each keystroke."
	
	autoConvert := aBoolean.! !

!UiTextEdit methodsFor: 'validate/convert' stamp: 'mt 10/27/2010 14:08:41.779'!
convertText

	self autoConvert ifFalse: [^ self].
	textMorph contents: self convertedText.! !

!UiTextEdit methodsFor: 'validate/convert' stamp: 'mt 9/13/2010 10:59:46.333'!
convertedText

	^ self convertedValue asString! !

!UiTextEdit methodsFor: 'validate/convert' stamp: 'mt 9/13/2010 10:59:46.43'!
convertedValue

	^ self validator value: textMorph text asString! !

!UiTextEdit methodsFor: 'drawing' stamp: 'mt 2/26/2011 16:11:46.336'!
drawBorderOn: aCanvas

	self outerBorderWidth = 0 ifTrue: [^ self].
	
	aCanvas
		frameRoundRect: self outerBounds
		radius: 3
		width: self outerBorderWidth
		color: (self textMorph hasKeyboard
			ifTrue: [(Color r: 0.5 g: 0.5 b: 1.0) muchDarker]
			ifFalse: [Color gray: 0.3]).! !

!UiTextEdit methodsFor: 'drawing' stamp: 'mt 9/13/2010 10:59:46.602'!
drawOn: aCanvas

	super drawOn: aCanvas.
	self drawBorderOn: aCanvas.! !

!UiTextEdit methodsFor: 'signals' stamp: 'mt 9/13/2010 14:10:29.168'!
editingFinished: text
	"Emitted whenever focus changes or return key pressed."
	
	self emitAlways.! !

!UiTextEdit methodsFor: 'macpal' stamp: 'mt 9/13/2010 10:59:46.796'!
flash

	"No flash."! !

!UiTextEdit methodsFor: 'drawing' stamp: 'mt 9/13/2010 10:59:46.666'!
fullDrawOn: aCanvas
	"Skip adornments."
	
	^ self perform: #fullDrawOn: withArguments: {aCanvas} inSuperclass: ScrollPane.! !

!UiTextEdit methodsFor: 'initialization' stamp: 'mt 11/28/2010 21:25:16.918'!
initialize

	super initialize.
	
	self
		setProperty: #noHScrollBarPlease toValue: true;
		setProperty: #vScrollBarAlways toValue: false;
		width: 150;
		height: 100;
		color: Color white;
		borderStyle: (BorderStyle inset width: 1).
	
	"Fix initial state."
	self
		setText: 'Please enter some text...';
		resizeScroller.
	
	self textMorph wrapFlag: true.
	
	self connect: self textMorph signal: #textEdited: toSelector: #textEdited:.
	self connect: self textMorph signal: #editingFinished: toSelector: #editingFinished:.
	self connect: self textMorph signal: #returnPressed: toSelector: #returnPressed:.! !

!UiTextEdit methodsFor: 'event handling' stamp: 'mt 9/13/2010 10:59:47.028'!
keyStroke: evt

	self acceptTextInModel.
	^ super keyStroke: evt! !

!UiTextEdit methodsFor: 'event handling' stamp: 'mt 2/26/2011 16:18:17.938'!
keyboardFocusChange: aBoolean

	super keyboardFocusChange: aBoolean.
	
	aBoolean
		ifTrue: [self color: (Color r: 0.0 g: 0.0 b: 0.5) muchLighter paler]
		ifFalse: [self color: Color white].! !

!UiTextEdit methodsFor: 'accessing' stamp: 'mt 9/18/2010 15:44:44.435'!
outerBorderWidth

	^ outerBorderWidth ifNil: [outerBorderWidth := 1]! !

!UiTextEdit methodsFor: 'accessing' stamp: 'mt 10/28/2010 10:26:36.223'!
outerBorderWidth: aNumber

	outerBorderWidth := aNumber.
	self redrawLater.! !

!UiTextEdit methodsFor: 'geometry' stamp: 'mt 9/22/2010 09:52:09.653'!
outerBounds

	^ self bounds outsetBy: self outerBorderWidth! !

!UiTextEdit methodsFor: 'accessing' stamp: 'mt 9/13/2010 10:59:47.166'!
readOnly

	^ self textMorph readOnly! !

!UiTextEdit methodsFor: 'accessing' stamp: 'mt 9/13/2010 10:59:47.243'!
readOnly: aBoolean

	self textMorph readOnly: aBoolean! !

!UiTextEdit methodsFor: 'signals' stamp: 'mt 9/13/2010 14:16:48.661'!
returnPressed: text
	
	self emitAlways.! !

!UiTextEdit methodsFor: 'scrolling' stamp: 'mt 9/13/2010 10:59:47.59'!
scrollByKeyboard: event 

	^false! !

!UiTextEdit methodsFor: 'scrolling' stamp: 'mt 9/13/2010 10:59:47.702'!
scrollSelectionIntoView: event 
	"Scroll my text into view if necessary and return true, else return false.
	Redone here to deal with horizontal scrolling!!"
	
	| selRects delta selRect rectToTest transform cpHere |
	selectionInterval := textMorph editor selectionInterval.
	selRects := textMorph paragraph selectionRects.
	selRects isEmpty ifTrue: [^ false].
	rectToTest := selRects first merge: selRects last.
	transform := scroller transformFrom: self.
	(event notNil and: [event anyButtonPressed]) ifTrue:  "Check for autoscroll"
		[cpHere := transform localPointToGlobal: event cursorPoint.
		cpHere y <= self top
			ifTrue: [rectToTest := selRects first topLeft extent: 2@2]
			ifFalse: [cpHere y >= self bottom
					ifTrue: [rectToTest := selRects last bottomRight extent: 2@2]
					ifFalse: [^ false]]].
	selRect := transform localBoundsToGlobal: rectToTest.
	selRect height > bounds height
		ifTrue: [^ false].  "Would not fit, even if we tried to scroll"
	(delta := selRect amountToTranslateWithin: self innerBounds) ~= (0@0) ifTrue:
		["Scroll end of selection into view if necessary"
		self scrollBy: delta truncated.
		^ true].
	^ false! !

!UiTextEdit methodsFor: 'signals' stamp: 'mt 9/13/2010 10:59:47.778'!
textChanged: text

	self emit.! !

!UiTextEdit methodsFor: 'signals' stamp: 'mt 9/13/2010 10:59:47.846'!
textEdited: text
	"Not emitted if text changed programmatically."
	
	self emitAlways.! !

!UiTextEdit methodsFor: 'initialization' stamp: 'mt 9/13/2010 11:06:56.565'!
textMorphClass

	^ UiTextEditTextMorph! !

!UiTextEdit methodsFor: 'accessing' stamp: 'mt 9/13/2010 10:59:47.316'!
theText

	"self hasUnacceptedEdits
		ifTrue: [self acceptTextInModel]."

	^ text! !

!UiTextEdit methodsFor: 'accessing' stamp: 'mt 9/13/2010 10:59:47.389'!
theText: aValue

	aValue == text ifTrue: [^ self].
	
	text := aValue asString.
	self changed: #theText.
	
	self textChanged: text.
	self valueChanged: aValue.! !

!UiTextEdit methodsFor: 'accessing' stamp: 'mt 9/13/2010 10:59:47.45'!
validator
	"Used for conversion purposes of input data."

	^ validator ifNil: [validator := [:raw | raw]]! !

!UiTextEdit methodsFor: 'accessing' stamp: 'mt 9/13/2010 10:59:47.524'!
validator: aBlock
	
	validator := aBlock.! !

!UiTextEdit methodsFor: 'signals' stamp: 'mt 9/13/2010 10:59:47.906'!
valueChanged: convertedValue

	self emit.! !

TextMorphForEditView subclass: #UiTextEditTextMorph
	instanceVariableNames: 'autoAccept readOnly'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Support'!

UiTextEditTextMorph subclass: #UiLineEditTextMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Support'!

!UiLineEditTextMorph methodsFor: 'event handling' stamp: 'mt 9/13/2010 14:17:46.849'!
keyStroke: event
	"A line edit only supports one text line."

	event keyCharacter = Character cr
		ifTrue: [(self acceptOnCR and: [self editView hasUnacceptedEdits])
			ifTrue: [
				self editor accept.
				self editingFinished: self contents.
				self returnPressed: self contents].
			^ self].
		
	^ super keyStroke: event.! !

!UiTextEditTextMorph methodsFor: 'accessing' stamp: 'mt 6/29/2010 15:42:43.58'!
autoAccept

	^ autoAccept ifNil: [autoAccept := false]! !

!UiTextEditTextMorph methodsFor: 'accessing' stamp: 'mt 6/29/2010 15:42:43.64'!
autoAccept: anObject

	autoAccept := anObject.! !

!UiTextEditTextMorph methodsFor: 'signals' stamp: 'mt 9/13/2010 14:11:58.279'!
editingFinished: aText

	self emit.! !

!UiTextEditTextMorph methodsFor: 'macpal' stamp: 'mt 7/21/2010 20:33:37.803'!
flash

	"No flash."! !

!UiTextEditTextMorph methodsFor: 'event handling' stamp: 'mt 11/28/2010 21:20:54.409'!
keyStroke: event
	"Enable auto-accept if necessary."

	self readOnly
		ifTrue: [^ self].
		
	super keyStroke: event.
	
	self autoAccept
		ifTrue: [self editView hasUnacceptedEdits
			ifTrue: [self editor accept]].
		
	self editView convertText.
	self textEdited: self contents.! !

!UiTextEditTextMorph methodsFor: 'event handling' stamp: 'mt 2/26/2011 16:15:54.972'!
keyboardFocusChange: aBoolean

	self editView
		keyboardFocusChange: aBoolean.

	self readOnly
		ifTrue: [self stopBlinking. ^ self].

	aBoolean
		ifFalse: [
			self editor accept.
			self editingFinished: self contents].
		
	^ super keyboardFocusChange: aBoolean! !

!UiTextEditTextMorph methodsFor: 'geometry' stamp: 'mt 6/29/2010 15:42:43.728'!
minExtent
	"gvc 10/17/2008 12:35 - TextMorphForFieldView ---
	Overridden to allow text to shrink to minimum extent rather than being (incorrectly)
	treated as rigid. Should be the same for other morphs too. Bah!!"

	| layout minExtent extra hFit vFit |
	hFit := self hResizing.
	vFit := self vResizing.
	(hFit == #spaceFill or: [vFit == #spaceFill]) 
		ifFalse: 
			["The receiver will not adjust to parents layout by growing or shrinking,
		which means that an accurate layout defines the minimum size."

			^self fullBounds extent].
	layout := self layoutPolicy.
	minExtent := layout isNil 
		ifTrue: [0 @ 0]
		ifFalse: [layout minExtentOf: self in: self layoutBounds].
	minExtent := hFit == #rigid 
		ifTrue: [self fullBounds extent x @ minExtent y]
		ifFalse: 
			[extra := self bounds width - self layoutBounds width.
			(minExtent x + extra) @ minExtent y].
	minExtent := vFit == #rigid 
				ifTrue: [minExtent x @ self fullBounds extent y]
				ifFalse: 
					[extra := self bounds height - self layoutBounds height.
					minExtent x @ (minExtent y + extra)].
	minExtent := minExtent max: self minWidth @ self minHeight.
	^minExtent! !

!UiTextEditTextMorph methodsFor: 'geometry' stamp: 'mt 6/29/2010 15:42:43.773'!
minHeight
	"Answer the height of one line."

	^self minimumExtent y max: super minHeight! !

!UiTextEditTextMorph methodsFor: 'geometry' stamp: 'mt 6/29/2010 15:42:43.817'!
minWidth
	"Answer the minimum width."

	^self minimumExtent x max: super minWidth! !

!UiTextEditTextMorph methodsFor: 'geometry' stamp: 'mt 6/29/2010 15:42:43.846'!
minimumExtent
	"Use the actual paragraph line to take font changes into account."
	
	| minExt |
	textStyle ifNil: [^ 9@16].
	borderWidth ifNil: [^ 9@16].
	minExt := (9@(self paragraph lines first lineHeight ceiling)) + (borderWidth*2).
	margins ifNil: [^ minExt].
	^ ((0@0 extent: minExt) expandBy: margins) extent! !

!UiTextEditTextMorph methodsFor: 'geometry' stamp: 'mt 6/29/2010 15:42:43.89'!
paragraph
	"Paragraph instantiation is lazy -- create it only when needed.
	Don't adjust rightX (as in TexMorph>>paragraph)
	since wrapFlag must be false for layout to work."
	
	paragraph ifNotNil: [^ paragraph].

self setProperty: #CreatingParagraph toValue: true.

	self setDefaultContentsIfNil.

	"...Code here to recreate the paragraph..."
	paragraph := (self paragraphClass new textOwner: self owner).
	paragraph wantsColumnBreaks: successor notNil.
	paragraph
		compose: text
		style: textStyle copy
		from: self startingIndex
		in: self container.
	"don't adjust the right, let it scroll!!"
	paragraph focused: (self currentHand keyboardFocus == self).
	self fit.
self removeProperty: #CreatingParagraph.

	^ paragraph! !

!UiTextEditTextMorph methodsFor: 'accessing' stamp: 'mt 6/29/2010 16:25:25.325'!
readOnly

	^ readOnly ifNil: [readOnly := false]! !

!UiTextEditTextMorph methodsFor: 'accessing' stamp: 'mt 6/29/2010 16:28:43.603'!
readOnly: aBoolean

	readOnly := aBoolean.! !

!UiTextEditTextMorph methodsFor: 'signals' stamp: 'mt 9/13/2010 14:17:29.151'!
returnPressed: text

	self emit.! !

!UiTextEditTextMorph methodsFor: 'signals' stamp: 'mt 6/29/2010 16:16:36.653'!
textEdited: text

	self emit.! !

!Object methodsFor: '*widgets-events' stamp: 'mt 2/26/2011 13:45:37.745'!
isEventHandler

	^ false! !

Object subclass: #UiAbstractItemDelegate
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Views-Support'!

!UiAbstractItemDelegate commentStamp: 'mt 10/9/2010 10:55:10.842' prior: 0!
Create morphs based on a model index. These morphs are read-only items or editors.!

!UiAbstractItemDelegate methodsFor: 'building' stamp: 'mt 10/11/2010 16:55:18.253'!
editorFor: aModelIndex
	"An editor morph must understand #accept."
	
	self subclassResponsibility.! !

!UiAbstractItemDelegate methodsFor: 'building' stamp: 'mt 10/7/2010 17:52:19.828'!
itemFor: aModelIndex

	self subclassResponsibility.! !

UiAbstractItemDelegate subclass: #UiSimpleItemDelegate
	instanceVariableNames: 'orientation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Views-Support'!

!UiSimpleItemDelegate commentStamp: 'mt 10/19/2010 10:50:35.526' prior: 0!
I create simple items that consist of an image morph and a text morph layed out vertically or horizontally.!

!UiSimpleItemDelegate methodsFor: 'layouting - private' stamp: 'mt 10/14/2010 20:21:52.074'!
doLayoutFor: aMorph

	| offset |
	self orientation = #horizontal ifTrue: [
		aMorph height: aMorph submorphs last height. "for smaller items use font height"
		
		"Manual layouting."
		offset := aMorph left + 3.
		aMorph submorphs do: [:m |
			m left: offset.
			offset := offset + m width + 2.
			m top: (aMorph top - (m height - aMorph height // 2))].
	
		"Expand item horizontally to its contents."
		aMorph
			width: aMorph submorphBounds width + 5; "font rendering bugfix"
			height: aMorph height + 1. "font rendering bugfix"
		
		^ self].
	
	self orientation = #vertical ifTrue: [
		aMorph width: aMorph submorphs last width + 10.
			
		"Manual layouting."
		offset := aMorph top + 3.
		aMorph submorphs do: [:m |
			m top: offset.
			offset := offset + m height + 2.
			m left: (aMorph left - (m width - aMorph width // 2))].
	
		aMorph height: aMorph submorphBounds height + 2].! !

!UiSimpleItemDelegate methodsFor: 'building' stamp: 'mt 10/11/2010 16:52:57.182'!
editorFor: aModelIndex

	^ UiLineEdit new
		theText: aModelIndex text.! !

!UiSimpleItemDelegate methodsFor: 'building' stamp: 'mt 2/12/2011 12:35:25.631'!
itemFor: aModelIndex

	| icon text balloonText item |
	icon := aModelIndex icon "ifNil: [Morph new extent: 16@16; color: Color transparent]".
	text := aModelIndex text.
	balloonText := aModelIndex balloonText.
	
	(text isNil and: [icon isNil]) ifTrue: [text := ' ' asText].
	
	item := Morph new color: Color transparent.
	
	icon ifNotNil: [item addMorphBack: icon asMorph].
	text ifNotNil: [
		text isString ifTrue: [text := text asText].
		text isString | text isText ifFalse: [text := text asString asText].
		item addMorphBack: text asMorph lock].
	balloonText ifNotNil: [
		item balloonText: balloonText].
	
	"Store morphs in properties for later access."
	item
		setProperty: #text toValue: text;
		setProperty: #icon toValue: icon;
		setProperty: #balloonText toValue: balloonText.

	self doLayoutFor: item.	

	^ item! !

!UiSimpleItemDelegate methodsFor: 'accessing' stamp: 'mt 10/14/2010 17:38:35.066'!
orientation

	^ orientation ifNil: [orientation := #horizontal]! !

!UiSimpleItemDelegate methodsFor: 'accessing' stamp: 'mt 10/14/2010 17:38:23.964'!
orientation: aSymbol
	"#vertical, #horizontal"

	 orientation := aSymbol.! !

Object subclass: #UiEventHandler
	instanceVariableNames: 'properties'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Support'!

!UiEventHandler commentStamp: 'mt 3/2/2011 11:04:43.004' prior: 0!
An event handler that maps morphic events to signals.

Adds support for #handlesMouseUp: which is not present in Morphic.!

!UiEventHandler methodsFor: 'mouse - handling' stamp: 'mt 2/26/2011 13:37:37.495'!
click: aMouseEvent fromMorph: aMorph

	self mouseClicked: aMouseEvent.  ! !

!UiEventHandler methodsFor: 'mouse - handling' stamp: 'mt 2/26/2011 13:37:50.079'!
doubleClick: aMouseEvent fromMorph: aMorph

	self mouseDoubleClicked: aMouseEvent.  ! !

!UiEventHandler methodsFor: 'mouse - accessing' stamp: 'mt 2/26/2011 13:35:42.618'!
doubleClickTimeout: anEvent fromMorph: aMorph

	^ (self valueOfProperty: #doubleClickTimeout) value! !

!UiEventHandler methodsFor: 'mouse - accessing' stamp: 'mt 2/26/2011 13:36:13.637'!
dragThreshold

	^ (self valueOfProperty: #dragThreshold) value! !

!UiEventHandler methodsFor: 'mouse - accessing' stamp: 'mt 2/26/2011 14:35:29.928'!
dragThreshold: anInteger

	self setProperty: #dragThreshold toValue: [anInteger].! !

!UiEventHandler methodsFor: 'keyboard - signals' stamp: 'mt 2/26/2011 14:00:32.752'!
focusLost

	self emit.! !

!UiEventHandler methodsFor: 'keyboard - signals' stamp: 'mt 2/26/2011 14:00:29.038'!
focusReceived

	self emit.! !

!UiEventHandler methodsFor: 'accessing' stamp: 'mt 2/26/2011 14:46:03.624'!
grabKeyboardOnMouseEnter

	^ self valueOfProperty: #grabKeyboardOnMouseEnter! !

!UiEventHandler methodsFor: 'accessing' stamp: 'mt 2/26/2011 14:44:44.938'!
grabKeyboardOnMouseEnter: aBoolean

	self setProperty: #grabKeyboardOnMouseEnter toValue: aBoolean.! !

!UiEventHandler methodsFor: 'keyboard - shortcuts' stamp: 'mt 2/26/2011 14:42:33.255'!
handleShortcut: aKeyboardEvent

	| map pattern |
	map := {
		aKeyboardEvent commandKeyPressed -> #cmd.
		aKeyboardEvent controlKeyPressed -> #ctrl.
		aKeyboardEvent shiftPressed -> #shift.
	}.
	
	pattern := OrderedCollection new.
	
	map do: [:assoc | assoc key ifTrue: [pattern add: assoc value]].
	
	pattern := pattern sorted asArray -> aKeyboardEvent keyCharacter asLowercase.
	
	(self shortcuts at: pattern ifAbsent: []) ifNotNil: [:target |
		target first first
			ifNotNil: [:receiver | receiver perform: target second]
			ifNil: [self shortcuts removeKey: pattern] "kind of garbage collection here"].! !

!UiEventHandler methodsFor: 'keyboard - testing' stamp: 'mt 2/26/2011 12:22:29.826'!
handlesKeyboard: event

	^ (self valueOfProperty: #handlesKeyboard) cull: event! !

!UiEventHandler methodsFor: 'mouse - testing' stamp: 'mt 3/2/2011 10:58:01.646'!
handlesMouseDown: event

	^ (self valueOfProperty: #handlesMouseDown) cull: event! !

!UiEventHandler methodsFor: 'mouse - testing' stamp: 'mt 2/26/2011 12:22:20.428'!
handlesMouseOver: event

	^ (self valueOfProperty: #handlesMouseOver) cull: event! !

!UiEventHandler methodsFor: 'mouse - testing' stamp: 'mt 2/26/2011 12:22:15.214'!
handlesMouseOverDragging: event

	^ (self valueOfProperty: #handlesMouseOverDragging) cull: event! !

!UiEventHandler methodsFor: 'mouse - testing' stamp: 'mt 2/26/2011 12:22:10.553'!
handlesMouseStillDown: event

	^ (self valueOfProperty: #handlesMouseStillDown) cull: event! !

!UiEventHandler methodsFor: 'mouse - testing' stamp: 'mt 3/2/2011 11:02:56.866'!
handlesMouseUp: event

	^ (self valueOfProperty: #handlesMouseUp) cull: event! !

!UiEventHandler methodsFor: 'initialization' stamp: 'mt 3/2/2011 11:03:11.54'!
initialize

	super initialize.
	
	self
		mouseDownPriority: 0;  
		setProperty: #handlesKeyboard toValue: [true];
		setProperty: #handlesMouseDown toValue: [true];
		setProperty: #handlesMouseUp toValue: [true];
		setProperty: #handlesMouseOver toValue: [true];
		setProperty: #handlesMouseOverDragging toValue: [true];
		setProperty: #handlesMouseStillDown toValue: [false];
		setProperty: #doubleClickTimeout toValue: [20 "ms"];
		dragThreshold: 0 "pixel";
		grabKeyboardOnMouseEnter: true;
		releaseKeyboardOnMouseLeave: false;
		tabAmongFields: false. "not implemented yet"! !

!UiEventHandler methodsFor: 'testing' stamp: 'mt 2/26/2011 13:45:11.154'!
isEventHandler

	^ true! !

!UiEventHandler methodsFor: 'keyboard - handling' stamp: 'mt 3/2/2011 11:34:46.902'!
keyDown: aKeyboardEvent fromMorph: aMorph

	self keyPressed: aKeyboardEvent.
	
	(#(3 13 10) includes: aKeyboardEvent keyValue)
		ifTrue: [self returnPressed].! !

!UiEventHandler methodsFor: 'keyboard - signals' stamp: 'mt 2/26/2011 12:28:56.969'!
keyPressed: aKeyboardEvent

	self emit.! !

!UiEventHandler methodsFor: 'keyboard - signals' stamp: 'mt 2/26/2011 12:29:04.453'!
keyReleased: aKeyboardEvent

	self emit.! !

!UiEventHandler methodsFor: 'keyboard - handling' stamp: 'mt 3/2/2011 11:33:40.694'!
keyStroke: aKeyboardEvent fromMorph: aMorph

	(self tabAmongFields and: [aKeyboardEvent keyCharacter = Character tab])
		ifTrue: [self shouldBeImplemented].

	self
		handleShortcut: aKeyboardEvent;
		keyStroked: aKeyboardEvent.
		
	(#(3 13 10) includes: aKeyboardEvent keyValue)
		ifTrue: [self returnStroked].! !

!UiEventHandler methodsFor: 'keyboard - signals' stamp: 'mt 2/26/2011 12:44:29.785'!
keyStroked: aKeyboardEvent

	self emit.! !

!UiEventHandler methodsFor: 'keyboard - handling' stamp: 'mt 2/26/2011 13:49:48.08'!
keyUp: aKeyboardEvent fromMorph: aMorph

	self keyReleased: aKeyboardEvent.! !

!UiEventHandler methodsFor: 'keyboard - handling' stamp: 'mt 2/26/2011 15:40:11.51'!
keyboardFocusChange: aBoolean fromMorph: aMorph

	"Give the morph a chance to update its appearance."
	aMorph redrawLater.

	aBoolean
		ifTrue: [self focusReceived]
		ifFalse: [self focusLost].! !

!UiEventHandler methodsFor: 'mouse - signals' stamp: 'mt 2/26/2011 13:24:29.576'!
mouseClicked: aMouseEvent

	self emit.! !

!UiEventHandler methodsFor: 'mouse - signals' stamp: 'mt 2/26/2011 13:24:34.692'!
mouseDoubleClicked: aMouseEvent

	self emit.! !

!UiEventHandler methodsFor: 'mouse - handling' stamp: 'mt 2/26/2011 13:37:10.381'!
mouseDown: aMouseEvent fromMorph: aMorph

	aMouseEvent hand
		waitForClicksOrDrag: aMorph
		event: aMouseEvent
		selectors: #(click: doubleClick: doubleClickTimeout: startDrag:)
		threshold: self dragThreshold.
		
	self mousePressed: aMouseEvent.  ! !

!UiEventHandler methodsFor: 'mouse - accessing' stamp: 'mt 2/26/2011 14:28:19.68'!
mouseDownPriority

	^ (self valueOfProperty: #mouseDownPriority) value! !

!UiEventHandler methodsFor: 'mouse - accessing' stamp: 'mt 2/26/2011 14:47:19.021'!
mouseDownPriority: anInteger

	self setProperty: #mouseDownPriority toValue: anInteger.! !

!UiEventHandler methodsFor: 'mouse - signals' stamp: 'mt 2/26/2011 13:41:28.994'!
mouseDragStarted: aMouseEvent

	self emit.! !

!UiEventHandler methodsFor: 'mouse - handling' stamp: 'mt 2/26/2011 14:50:57.641'!
mouseEnter: aMouseEvent fromMorph: aMorph

	self mouseEntered: aMouseEvent.
	
	self grabKeyboardOnMouseEnter
		ifTrue: [aMorph grabKeyboard].! !

!UiEventHandler methodsFor: 'mouse - handling' stamp: 'mt 2/26/2011 14:51:36.244'!
mouseEnterDragging: aMouseEvent fromMorph: aMorph

	^ self mouseEnter: aMouseEvent fromMorph: aMorph! !

!UiEventHandler methodsFor: 'mouse - signals' stamp: 'mt 2/26/2011 13:54:22.461'!
mouseEntered: aMouseEvent

	self emit.! !

!UiEventHandler methodsFor: 'mouse - handling' stamp: 'mt 2/26/2011 14:52:13.115'!
mouseLeave: aMouseEvent fromMorph: aMorph

	self mouseLeaved: aMouseEvent.

	self releaseKeyboardOnMouseLeave
		ifTrue: [aMorph releaseKeyboard].! !

!UiEventHandler methodsFor: 'mouse - handling' stamp: 'mt 2/26/2011 14:51:50.902'!
mouseLeaveDragging: aMouseEvent fromMorph: aMorph

	^ self mouseLeave: aMouseEvent fromMorph: aMorph! !

!UiEventHandler methodsFor: 'mouse - signals' stamp: 'mt 2/26/2011 13:54:27.516'!
mouseLeaved: aMouseEvent

	self emit.! !

!UiEventHandler methodsFor: 'mouse - handling' stamp: 'mt 2/26/2011 13:56:17.454'!
mouseMove: aMouseEvent fromMorph: aMorph

	self mouseMoved: aMouseEvent.! !

!UiEventHandler methodsFor: 'mouse - signals' stamp: 'mt 2/26/2011 13:56:01.172'!
mouseMoved: aMouseMoveEvent

	self emit.! !

!UiEventHandler methodsFor: 'mouse - signals' stamp: 'mt 2/26/2011 13:24:21.32'!
mousePressed: aMouseEvent

	self emit.! !

!UiEventHandler methodsFor: 'mouse - signals' stamp: 'mt 2/26/2011 13:24:26.458'!
mouseReleased: aMouseEvent

	self emit.! !

!UiEventHandler methodsFor: 'mouse - handling' stamp: 'mt 2/26/2011 13:53:35.477'!
mouseStillDown: aMouseEvent fromMorph: aMorph

	self mousePressed: aMouseEvent.  ! !

!UiEventHandler methodsFor: 'mouse - handling' stamp: 'mt 3/2/2011 11:03:56.092'!
mouseUp: aMouseEvent fromMorph: aMorph

	(self handlesMouseUp: aMouseEvent)
		ifTrue: [self mouseReleased: aMouseEvent].! !

!UiEventHandler methodsFor: 'keyboard - shortcuts' stamp: 'mt 2/26/2011 14:42:15.562'!
on: keyPattern send: aSelector to: aReceiver
	"Add a keyboard shortcut that is handled inside this event handler. The case (lower/upper) of the character does not matter. Example:
	self eventHandler on: #ctrl -> $c send: #copy to: self.
	self eventHandler on: #(ctrl shift) -> Character arrowUp send: #pageUp to: self.
	self eventHandler on: Character enter send: #save to: self.
	
	Modifiers: #cmd, #ctrl, #shift"

	| normalizedPattern |
	normalizedPattern := keyPattern isVariableBinding "= association"
		ifTrue: [keyPattern key sorted -> keyPattern value asLowercase]
		ifFalse: [#() -> keyPattern asLowercase "character given only"].

	self shortcuts at: normalizedPattern put: {WeakArray with: aReceiver. aSelector}! !

!UiEventHandler methodsFor: 'accessing' stamp: 'mt 2/26/2011 11:53:31.141'!
properties

	^ properties ifNil: [properties := Dictionary new]! !

!UiEventHandler methodsFor: 'accessing' stamp: 'mt 2/26/2011 14:46:17.804'!
releaseKeyboardOnMouseLeave

	^ self valueOfProperty: #releaseKeyboardOnMouseLeave! !

!UiEventHandler methodsFor: 'accessing' stamp: 'mt 2/26/2011 14:45:45.391'!
releaseKeyboardOnMouseLeave: aBoolean

	self setProperty: #releaseKeyboardOnMouseLeave toValue: aBoolean.! !

!UiEventHandler methodsFor: 'keyboard - shortcuts' stamp: 'mt 2/26/2011 13:02:56.278'!
removeAllShortcuts

	^ self removeProperty: #shortcuts! !

!UiEventHandler methodsFor: 'properties' stamp: 'mt 2/26/2011 11:55:36.248'!
removeProperty: aSymbol

	self properties removeKey: aSymbol ifAbsent: [].! !

!UiEventHandler methodsFor: 'keyboard - signals' stamp: 'mt 3/2/2011 11:33:52.002'!
returnPressed
	
	self emit.! !

!UiEventHandler methodsFor: 'keyboard - signals' stamp: 'mt 3/2/2011 11:32:38.703'!
returnStroked
	"Emitted whenefer Character enter, cr, or lf is stroked."
	
	self emit.! !

!UiEventHandler methodsFor: 'properties' stamp: 'mt 2/26/2011 11:54:47.669'!
setProperty: aSymbol toValue: anObject

	anObject ifNil: [^ self removeProperty: aSymbol].
	self properties at: aSymbol put: anObject.! !

!UiEventHandler methodsFor: 'keyboard - shortcuts' stamp: 'mt 2/26/2011 13:02:33.829'!
shortcuts

	^ self properties at: #shortcuts ifAbsentPut: [Dictionary new]! !

!UiEventHandler methodsFor: 'mouse - handling' stamp: 'mt 2/26/2011 13:41:18.965'!
startDrag: aMouseEvent fromMorph: aMorph

	self mouseDragStarted: aMouseEvent.  ! !

!UiEventHandler methodsFor: 'accessing' stamp: 'mt 2/26/2011 16:30:19.736'!
tabAmongFields
	"Pass keyboard focus to next morph?"
	
	^ self valueOfProperty: #tabAmongFields! !

!UiEventHandler methodsFor: 'accessing' stamp: 'mt 2/26/2011 16:29:49.718'!
tabAmongFields: aBoolean

	self setProperty: #tabAmongFields toValue: aBoolean.! !

!UiEventHandler methodsFor: 'properties' stamp: 'mt 2/26/2011 13:18:22.966'!
valueOfProperty: aSymbol

	^ self valueOfProperty: aSymbol ifAbsent: []! !

!UiEventHandler methodsFor: 'properties' stamp: 'mt 2/26/2011 11:56:30.935'!
valueOfProperty: aSymbol ifAbsent: aBlock

	^ self properties at: aSymbol ifAbsent: aBlock! !

Object subclass: #UiHtmlTextFormatter
	instanceVariableNames: 'offset runStack runArray'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Text'!

!UiHtmlTextFormatter commentStamp: 'mt 6/22/2010 23:09:49.732' prior: 0!
I create a text instance from a given string that contains html tags for emphasis. Examples:

'Hello, <b>World!!</b>' asHtmlText
'<i>Hello</i>, World!!' asHtmlText
'<font color="#00cc00">Hello!!</font>, World!!' asHtmlText
'<font color=#FFFF00>Ahahaha!! <b>Hello</b></font>, <i><b>World</b></i>!!' asHtmlText
'<font color="#0000ff">Ahahaha!! <b><font size="7">Hello</font></b></font>, <i><b>World</b></i>!!' asHtmlText!

!UiHtmlTextFormatter class methodsFor: 'formatting' stamp: 'mt 6/22/2010 22:28:43.544'!
toText: aString

	^ self new toText: aString! !

!UiHtmlTextFormatter methodsFor: 'initialization' stamp: 'mt 6/22/2010 23:01:54.332'!
initialize

	super initialize.
	offset := 0.
	runStack := Stack new.
	runArray := RunArray new.
	
	runStack push: {OrderedCollection new. 1. nil. 0}.! !

!UiHtmlTextFormatter methodsFor: 'mapping' stamp: 'mt 6/22/2010 22:58:36.294'!
mapTagToAttribute: aTag

	| rx strm result |
	aTag = '<b>' ifTrue: [^ {TextEmphasis bold}].
	aTag = '<i>' ifTrue: [^ {TextEmphasis italic}].
	aTag = '<u>' ifTrue: [^ {TextEmphasis underlined}].
	
	result := OrderedCollection new.
	
	"<font color=""#00FFCC"">"
	rx := 'color\s*=\s*"(#\w\w\w\w\w\w)' asRegex.
	strm := aTag readStream.
	[rx searchStream: strm]
		whileTrue: [ result add: (TextColor color: (Color fromString: (rx subexpression: 2)))].
		
	"<font size=""7"">"
	rx := 'size\s*=\s*"(\d+)' asRegex.
	strm := aTag readStream.
	[rx searchStream: strm]
		whileTrue: [result add:  (TextFontReference toFont: 
			(TextStyle default fontOfPointSize: (rx subexpression: 2) asInteger))].
		
	^ result! !

!UiHtmlTextFormatter methodsFor: 'parsing' stamp: 'mt 6/22/2010 23:21:32.33'!
parseString: anHtmlString

	| tag lookForNewTag result start end attrs escapeNextCharacter |
	lookForNewTag := true.
	tag := OrderedCollection new.
	result := OrderedCollection new.
	escapeNextCharacter := false.
	
	anHtmlString withIndexDo: [:character :index |
		escapeNextCharacter
			ifTrue: [result add: character. escapeNextCharacter := false]
			ifFalse: [
				character = $\
					ifTrue: [offset := offset + 1. escapeNextCharacter := true]
					ifFalse: [
						character = $< ifTrue: [lookForNewTag := false].
						character = $> ifTrue: [lookForNewTag := true].
		
						(lookForNewTag and: [character ~= $>])
							ifTrue: [result add: character]
							ifFalse: [tag add: character. offset := offset + 1]..
			
						(tag notEmpty and: [tag last = $>]) ifTrue: [ |tmp|
							tmp := String withAll: tag.
							tmp second ~= $/
								ifTrue: [self processStartTag: tmp pos: index]
								ifFalse: [self processEndTag: tmp pos: index].			
							tag := OrderedCollection new.
							lookForNewTag := true]]]].
	
	"Add last run."
	
	"Set end index."
	runStack top at: 3 put: anHtmlString size - offset.
	
	"Write to run array."
	start := runStack top second.
	end := runStack top third.
	attrs := runStack top first.
	runArray addLast: attrs times: end - start + 1.
	
	^ String withAll: result! !

!UiHtmlTextFormatter methodsFor: 'parsing' stamp: 'mt 6/22/2010 22:27:58.149'!
processEndTag: aTag pos: index

	|start end attrs|
	"De-Accumulate adjacent tags."
	runStack top at: 4 put: runStack top fourth - 1.
	runStack top fourth > 0
		ifTrue: [^ self "not yet"].
		
	"Set end index."
	runStack top at: 3 put: index - offset.
	
	"Write to run array."
	start := runStack top second.
	end := runStack top third.
	attrs := runStack top first.
	runArray addLast: attrs times: end - start + 1.

	runStack pop.
	runStack top at: 2 put: index - offset + 1.! !

!UiHtmlTextFormatter methodsFor: 'parsing' stamp: 'mt 6/22/2010 22:59:18.727'!
processStartTag: aTag pos: index

	|start end attrs|
	"Accumulate adjacent tags."
	(runStack size > 1 and: [runStack top second = (index - offset + 1)])
		ifTrue: [
			runStack top at: 1 put: (runStack top first copy addAll: (self mapTagToAttribute: aTag); yourself).
			runStack top at: 4 put: (runStack top fourth + 1). "increase number of open tags"
			^self].
			
	"Set end index."
	runStack top at: 3 put: index - offset.
	"Write to run array."
	start := runStack top second.
	end := runStack top third.
	attrs := runStack top first.
	runArray addLast: attrs times: end - start + 1.
	"Remove start/end info to reuse attributes later."
	runStack top at: 2 put: nil.
	runStack top at: 3 put: nil.
	"Copy attr list and add new attr."
	runStack push: ({runStack top first copy addAll: (self mapTagToAttribute: aTag); yourself. index - offset + 1. nil. 1}).! !

!UiHtmlTextFormatter methodsFor: 'formatting' stamp: 'mt 6/22/2010 23:21:59.959'!
toText: aString
	"Parse all known HTML attributes in the given string to text attributes."
	
	^ [Text string: (self parseString: aString) runs: runArray]
		on: Error
		do: [:e | aString asText]! !

Object subclass: #UiItemModel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Views-Support'!

!UiItemModel commentStamp: 'mt 10/19/2010 10:48:27.86' prior: 0!
Subclass me if you want to create tree-structured models.!

UiItemModel subclass: #UiDirectoryModel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Views-Models'!

!UiDirectoryModel commentStamp: 'mt 10/19/2010 11:04:03.304' prior: 0!
Simple model for the files structure on the harddisk. See class-side examples.!

!UiDirectoryModel class methodsFor: 'examples' stamp: 'mt 10/19/2010 11:01:04.143'!
ex01sortedTree

	UiTreeView new
		autoSortBlock: [:i1 :i2 |
			"Folder before files, sort alphabetically then. May need a change if an icon does not indicate a folder anymore."
			((i1 valueOfProperty: #icon) notNil and: [(i2 valueOfProperty: #icon) isNil])
				or: [
					(((i1 valueOfProperty: #icon) notNil and: [(i2 valueOfProperty: #icon) notNil])
						or: [(i1 valueOfProperty: #icon) isNil and: [(i2 valueOfProperty: #icon) isNil]])
						and: [(i1 valueOfProperty: #text) asString <= (i2 valueOfProperty: #text) asString]]];
		model: UiDirectoryModel new;
		topLeft: 50@50;
		extent: 600@300;
		openInWorld.! !

!UiDirectoryModel methodsFor: 'accessing' stamp: 'mt 10/7/2010 18:29:06.62'!
columnCountFor: aParentModelIndex
	"name, size, date"
	
	^ 3! !

!UiDirectoryModel methodsFor: 'accessing - data' stamp: 'mt 10/10/2010 14:52:32.637'!
iconFor: aModelIndex

	aModelIndex row = 0
		ifTrue: [^ nil].

	aModelIndex column = 1
		ifTrue: [^ (aModelIndex valueOfProperty: #entry) isDirectory
			ifTrue: [UiSilkIcons folderIcon]
			ifFalse: [nil "UiSilkIcons pageWhiteIcon"]].
	
	aModelIndex column = 3
		ifTrue: [^ (aModelIndex valueOfProperty: #entry) modificationDateAndTime year = 2010
			ifTrue: [UiSilkIcons newIcon]
			ifFalse: []].
		
	^ nil! !

!UiDirectoryModel methodsFor: 'accessing' stamp: 'mt 10/10/2010 14:50:53.383'!
indexRow: aRowNumber column: aColumnNumber parent: aParentModelIndex

	(aRowNumber = 0 or: [aColumnNumber = 0])
		ifTrue: [^ (UiSimpleModelIndex row: aRowNumber column: aColumnNumber)
			model: self;
			parent: aParentModelIndex].

	^ (UiSimpleModelIndex row: aRowNumber column: aColumnNumber)
		model: self;
		parent: aParentModelIndex;
		setProperty: #entry toValue: ((aParentModelIndex
			ifNil: [self root]
			ifNotNil: [:index | (index valueOfProperty: #entry) asFileDirectory]) entries at: aRowNumber)! !

!UiDirectoryModel methodsFor: 'accessing' stamp: 'mt 10/19/2010 11:03:33.743'!
root

	^ FileDirectory root! !

!UiDirectoryModel methodsFor: 'accessing' stamp: 'mt 10/9/2010 16:45:58.07'!
rowCountFor: aParentModelIndex
	
	^ aParentModelIndex
		ifNil: [self root entries size]
		ifNotNil: [((aParentModelIndex valueOfProperty: #entry) isDirectory and: [aParentModelIndex column = 1])
			ifTrue: [(aParentModelIndex valueOfProperty: #entry) asFileDirectory entries size]
			ifFalse: [0]]! !

!UiDirectoryModel methodsFor: 'accessing - data' stamp: 'mt 10/10/2010 14:52:41.794'!
textFor: aModelIndex

	aModelIndex row = 0
		ifTrue: [
			aModelIndex column = 1 ifTrue: [^ 'Name'].
			aModelIndex column = 2 ifTrue: [^ 'Size'].
			aModelIndex column = 3 ifTrue: [^ 'Modification Date and Time']].


	aModelIndex column = 1
		ifTrue: [^ (aModelIndex valueOfProperty: #entry) name asText].
		
	aModelIndex column = 2
		ifTrue: [^ (aModelIndex valueOfProperty: #entry) fileSize asString asText].
		
	aModelIndex column = 3
		ifTrue: [^ (aModelIndex valueOfProperty: #entry) modificationDateAndTime asString asText].
		
	^ nil! !

!UiItemModel methodsFor: 'model data' stamp: 'mt 2/12/2011 12:30:59.59'!
balloonTextFor: aModelIndex

	^ nil! !

!UiItemModel methodsFor: 'counts' stamp: 'mt 10/13/2010 12:55:38.571'!
columnCountFor: aParentModelIndex

	self subclassResponsibility.! !

!UiItemModel methodsFor: 'signals' stamp: 'mt 10/14/2010 10:20:34.546'!
columnsChangedFor: aParentModelIndex from: start to: end
	"Emitted whenever all model indices in some columns need are invalid."

	self emit.! !

!UiItemModel methodsFor: 'signals' stamp: 'mt 10/13/2010 13:12:46.124'!
columnsInsertedFor: aParentModelIndex from: start to: end

	self emit.! !

!UiItemModel methodsFor: 'signals' stamp: 'mt 10/13/2010 13:12:56.304'!
columnsRemovedFor: aParentModelIndex from: start to: end

	self emit.! !

!UiItemModel methodsFor: 'signals' stamp: 'mt 10/14/2010 10:21:09.141'!
dataChangedFrom: topLeftModelIndex to: bottomRightModelIndex

	self emit.! !

!UiItemModel methodsFor: 'testing' stamp: 'mt 10/10/2010 10:26:18.507'!
hasChildrenFor: aModelIndex

	^ (self rowCountFor: aModelIndex) > 0! !

!UiItemModel methodsFor: 'model data' stamp: 'mt 10/13/2010 12:56:42.192'!
iconFor: aModelIndex

	^ nil! !

!UiItemModel methodsFor: 'index generation' stamp: 'mt 10/13/2010 13:02:11.53'!
indexRow: aRowNumber column: aColumnNumber parent: aParentModelIndex
	"A 'nil' parent indicates the root node. Vertical header indices have 'aColumnNumber = 0'; horizontal header indices have 'aRowNumber = 0'."
	
	self subclassResponsibility.! !

!UiItemModel methodsFor: 'model data' stamp: 'mt 11/2/2010 11:25:57.912'!
menuFor: aModelIndex

	^ nil! !

!UiItemModel methodsFor: 'signals' stamp: 'mt 10/13/2010 12:54:02.23'!
modelReset
	"The internal state has been invalidated. A view needs to refetch all indices."
	
	self emit.! !

!UiItemModel methodsFor: 'initialization' stamp: 'mt 10/13/2010 12:57:50.04'!
reset

	self modelReset.! !

!UiItemModel methodsFor: 'counts' stamp: 'mt 10/13/2010 12:55:43.688'!
rowCountFor: aParentModelIndex

	self subclassResponsibility.! !

!UiItemModel methodsFor: 'signals' stamp: 'mt 10/14/2010 10:20:20.707'!
rowsChangedFor: aParentModelIndex from: start to: end
	"Emitted whenever all model indices in some rows need are invalid."
	
	self emit.! !

!UiItemModel methodsFor: 'signals' stamp: 'mt 10/13/2010 13:13:06.617'!
rowsInsertedFor: aParentModelIndex from: start to: end

	self emit.! !

!UiItemModel methodsFor: 'signals' stamp: 'mt 10/13/2010 13:13:02.4'!
rowsRemovedFor: aParentModelIndex from: start to: end

	self emit.! !

!UiItemModel methodsFor: 'model data' stamp: 'mt 10/13/2010 12:56:45.936'!
textFor: aModelIndex

	^ nil! !

UiItemModel subclass: #UiListModel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Views-Support'!

!UiListModel commentStamp: 'mt 10/19/2010 10:46:42.816' prior: 0!
A simple version of the generic model that only supports 1 column. Subclass it and implement #rowCount, #textAt:, and #iconAt: to create a simple list model.!

UiListModel subclass: #UiIconModel
	instanceVariableNames: 'iconSet showText nameFilter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Views-Models'!

!UiIconModel commentStamp: 'mt 10/14/2010 19:53:08.979' prior: 0!
Supports all subclasses of UiIcons as #iconSet.!

!UiIconModel class methodsFor: 'examples' stamp: 'mt 11/2/2010 13:25:16.249'!
ex01silk

	UiListView new
		listOrientation: #vertical;
		model: (UiIconModel new
			iconSet: UiSilkIcons;
			showText: false);
		topLeft: 50@50;
		extent: 600@300;
		openInWorld.! !

!UiIconModel class methodsFor: 'examples' stamp: 'mt 11/2/2010 13:25:16.334'!
ex02silkWithText

	UiListView new
		listOrientation: #vertical;
		model: (UiIconModel new
			iconSet: UiSilkIcons;
			showText: true);
		topLeft: 50@50;
		extent: 600@300;
		openInWorld.! !

!UiIconModel methodsFor: 'model data' stamp: 'mt 2/12/2011 12:36:24.796'!
balloonTextAt: anIndex

	^ (self iconSelectors at: anIndex) allButLast: 4 "remove icon suffix"! !

!UiIconModel methodsFor: 'accessing' stamp: 'mt 10/14/2010 20:38:17.087'!
codeSnippetFor: aModelIndex

	aModelIndex ifNil: [^ ''].
	
	^ self iconSet name, ' ', (self iconSelectors at: aModelIndex row)! !

!UiIconModel methodsFor: 'model data' stamp: 'mt 10/14/2010 19:49:44.229'!
iconAt: anIndex

	^ self iconSet perform: (self iconSelectors at: anIndex)! !

!UiIconModel methodsFor: 'accessing' stamp: 'mt 11/14/2010 15:26:19.716'!
iconSelectors

	self iconSet ifNil: [^ #()].
	^ (self iconSet class organization listAtCategoryNamed: #accessing)
		select: [:iconName | self nameFilter isNil or: [iconName asLowercase includesSubString: self nameFilter asLowercase]]! !

!UiIconModel methodsFor: 'accessing' stamp: 'mt 10/14/2010 19:45:12.099'!
iconSet

	^ iconSet! !

!UiIconModel methodsFor: 'accessing' stamp: 'mt 10/14/2010 19:44:20.126'!
iconSet: anIconSet

	iconSet := anIconSet.
	self reset.! !

!UiIconModel methodsFor: 'accessing' stamp: 'mt 11/14/2010 15:24:39.02'!
nameFilter

	^ nameFilter! !

!UiIconModel methodsFor: 'accessing' stamp: 'mt 11/14/2010 15:29:51.723'!
nameFilter: aString

	nameFilter := aString ifEmpty: [nil].
	self reset.! !

!UiIconModel methodsFor: 'counts' stamp: 'mt 10/14/2010 19:48:31.26'!
rowCount

	^ self iconSelectors size! !

!UiIconModel methodsFor: 'accessing' stamp: 'mt 10/14/2010 19:58:51.741'!
showText

	^ showText ifNil: [showText := true]! !

!UiIconModel methodsFor: 'accessing' stamp: 'mt 10/14/2010 19:58:43.53'!
showText: aBoolean

	showText := aBoolean.
	self reset.! !

!UiIconModel methodsFor: 'model data' stamp: 'mt 10/14/2010 19:59:09.323'!
textAt: anIndex

	^ self showText
		ifFalse: [nil]
		ifTrue: [(self iconSelectors at: anIndex) allButLast: 4 "remove icon suffix"]! !

!UiListModel methodsFor: 'model data' stamp: 'mt 2/12/2011 12:33:35.16'!
balloonTextAt: anRow

	^ nil! !

!UiListModel methodsFor: 'model data' stamp: 'mt 2/12/2011 12:32:50.2'!
balloonTextFor: aModelIndex

	^ self balloonTextAt: aModelIndex row! !

!UiListModel methodsFor: 'counts' stamp: 'mt 10/14/2010 19:38:56.514'!
columnCountFor: aParentModelIndex

	^ 1! !

!UiListModel methodsFor: 'model data' stamp: 'mt 2/12/2011 12:33:30.934'!
iconAt: anRow

	^ nil! !

!UiListModel methodsFor: 'model data' stamp: 'mt 10/14/2010 19:46:47.469'!
iconFor: aModelIndex

	^ self iconAt: aModelIndex row! !

!UiListModel methodsFor: 'index generation' stamp: 'mt 10/14/2010 19:43:12.236'!
indexRow: aRowNumber column: aColumnNumber parent: aParentModelIndex

	^ (UiSimpleModelIndex row: aRowNumber column: aColumnNumber)
		model: self;
		parent: aParentModelIndex! !

!UiListModel methodsFor: 'model data' stamp: 'mt 2/12/2011 12:33:25.658'!
menuAt: anRow

	^ nil! !

!UiListModel methodsFor: 'model data' stamp: 'mt 11/2/2010 11:27:47.268'!
menuFor: aModelIndex

	^ self menuAt: aModelIndex row! !

!UiListModel methodsFor: 'counts' stamp: 'mt 10/14/2010 19:39:44.025'!
rowCount

	self subclassResponsibility.! !

!UiListModel methodsFor: 'counts' stamp: 'mt 10/14/2010 19:39:33.408'!
rowCountFor: aParentModelIndex

	^ self rowCount! !

!UiListModel methodsFor: 'model data' stamp: 'mt 2/12/2011 12:33:21.576'!
textAt: anRow

	^ nil! !

!UiListModel methodsFor: 'model data' stamp: 'mt 10/19/2010 19:53:37.273'!
textFor: aModelIndex

	^ self textAt: aModelIndex row! !

UiListModel subclass: #UiListWidgetModel
	instanceVariableNames: 'items'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Support'!

!UiListWidgetModel commentStamp: 'mt 10/20/2010 14:12:24.921' prior: 0!
I am the hidden model used in the item-based UiListWidget.!

!UiListWidgetModel methodsFor: 'add/remove items' stamp: 'mt 10/19/2010 20:02:09.394'!
addItem: aListWidgetItem

	self items add: aListWidgetItem.
	aListWidgetItem model: self.
	
	self triggerItemAddedAt: (self items indexOf: aListWidgetItem).! !

!UiListWidgetModel methodsFor: 'model data' stamp: 'mt 10/19/2010 19:38:05.057'!
iconAt: integer

	^ (self items at: integer) icon! !

!UiListWidgetModel methodsFor: 'accessing' stamp: 'mt 11/2/2010 16:08:35.329'!
indexOf: anItem

	^ self items indexOf: anItem! !

!UiListWidgetModel methodsFor: 'add/remove items' stamp: 'mt 11/2/2010 09:30:55.602'!
insertItem: aListWidgetItem at: anIndex

	self items add: aListWidgetItem beforeIndex: anIndex.
	aListWidgetItem model: self.
	
	self triggerItemAddedAt: anIndex.! !

!UiListWidgetModel methodsFor: 'accessing' stamp: 'mt 10/19/2010 19:37:20.66'!
items

	^ items ifNil: [items := OrderedCollection new]! !

!UiListWidgetModel methodsFor: 'model data' stamp: 'mt 11/2/2010 11:50:14.899'!
menuAt: integer

	^ (self items at: integer) menu! !

!UiListWidgetModel methodsFor: 'add/remove items' stamp: 'mt 11/2/2010 11:19:33.278'!
removeItem: aListWidgetItem

	| index |
	index := self items indexOf: aListWidgetItem.
	self items remove: aListWidgetItem.	
	self triggerItemRemovedAt: index.! !

!UiListWidgetModel methodsFor: 'add/remove items' stamp: 'mt 11/2/2010 09:29:25.448'!
removeItemAt: anIndex

	self items removeAt: anIndex.
	self triggerItemRemovedAt: anIndex.! !

!UiListWidgetModel methodsFor: 'counts' stamp: 'mt 10/19/2010 19:37:11.329'!
rowCount

	^ self items size! !

!UiListWidgetModel methodsFor: 'model data' stamp: 'mt 10/19/2010 19:37:49.039'!
textAt: integer

	^ (self items at: integer) text! !

!UiListWidgetModel methodsFor: 'signal triggering' stamp: 'mt 10/19/2010 19:55:58.253'!
triggerItemAddedAt: index

	self rowsInsertedFor: nil from: index to: index.! !

!UiListWidgetModel methodsFor: 'signal triggering' stamp: 'mt 10/19/2010 19:56:13.227'!
triggerItemChangedAt: index

	self rowsChangedFor: nil from: index to: index.! !

!UiListWidgetModel methodsFor: 'signal triggering' stamp: 'mt 10/19/2010 19:56:25.038'!
triggerItemRemovedAt: index

	self rowsRemovedFor: nil from: index to: index.! !

UiItemModel subclass: #UiSmalltalkModel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Views-Models'!

!UiSmalltalkModel commentStamp: 'mt 10/19/2010 11:04:26.59' prior: 0!
More complex model to navigate the Smalltalk system structure. See class-side examples.!

!UiSmalltalkModel class methodsFor: 'examples' stamp: 'mt 11/2/2010 13:25:16.601'!
ex01iconicList

	UiListView new
		listOrientation: #vertical;
		defaultItemDelegate: (UiSimpleItemDelegate new orientation: #vertical);
		hAlignment: #center;
		model: UiSmalltalkModel new;
		topLeft: 50@50;
		extent: 600@300;
		openInWorld.! !

!UiSmalltalkModel class methodsFor: 'examples' stamp: 'mt 10/14/2010 17:59:12.416'!
ex02tree

	UiTreeView new
		model: UiSmalltalkModel new;
		topLeft: 50@50;
		extent: 600@300;
		openInWorld.! !

!UiSmalltalkModel class methodsFor: 'examples' stamp: 'mt 10/14/2010 19:23:15.693'!
ex03table

	UiTableView new
		setHAlignmentForColumn: 2 to: #right;
		setHAlignmentForColumn: 3 to: #center;
		model: UiSmalltalkModel new;
		topLeft: 50@50;
		extent: 600@300;
		openInWorld.! !

!UiSmalltalkModel class methodsFor: 'examples' stamp: 'mt 11/2/2010 13:25:16.525'!
ex04simpleList

	UiListView new
		model: UiSmalltalkModel new;
		topLeft: 50@50;
		extent: 600@300;
		openInWorld.! !

!UiSmalltalkModel class methodsFor: 'examples' stamp: 'mt 11/2/2010 13:25:16.479'!
ex05horizontalList

	UiListView new
		listOrientation: #horizontal;
		model: UiSmalltalkModel new;
		topLeft: 50@50;
		extent: 600@300;
		openInWorld.! !

!UiSmalltalkModel methodsFor: 'counts' stamp: 'mt 10/11/2010 16:30:56.086'!
columnCountFor: aParentModelIndex
	"name, childCount, type"
	
	^ 3! !

!UiSmalltalkModel methodsFor: 'model data' stamp: 'mt 10/11/2010 16:34:34.161'!
iconFor: aModelIndex

	| col package systemCategory class protocol method |
	col := aModelIndex column.
	package := aModelIndex valueOfProperty: #package ifAbsent: [].
	systemCategory := aModelIndex valueOfProperty: #systemCategory  ifAbsent: [].
	class := aModelIndex valueOfProperty: #class ifAbsent: [].
	protocol := aModelIndex valueOfProperty: #protocol ifAbsent: [].
	method := aModelIndex valueOfProperty: #method ifAbsent: [].
	
	"Horizontal headers."
	aModelIndex row = 0 ifTrue: [
		col = 1 ifTrue: [^ UiSilkIcons fontIcon].
		col = 2 ifTrue: [^ UiSilkIcons chartBarIcon].
		col = 3 ifTrue: [^ UiSilkIcons informationIcon]].
	
	package ifNotNil: [:p | 
		col = 1 ifTrue: [^ UiSilkIcons packageIcon]].
	
	"systemCategory ifNotNil: [:cat | ].
	
	class ifNotNil: [:c |].

	protocol ifNotNil: [:p | ].
	
	method ifNotNil: [:m | ]."
		
	^ nil! !

!UiSmalltalkModel methodsFor: 'index generation' stamp: 'mt 10/10/2010 14:19:12.733'!
indexRow: aRowNumber column: aColumnNumber parent: aParentModelIndex

	| index |
	index := (UiSimpleModelIndex row: aRowNumber column: aColumnNumber)
		model: self;
		parent: aParentModelIndex.
	
	"Header indices."
	(aRowNumber = 0 or: [aColumnNumber = 0])
		ifTrue: [^ index].
	
	aParentModelIndex ifNil: [
		index setProperty: #package toValue: (PackageOrganizer default packages at: aRowNumber).
		^ index].
	
	(aParentModelIndex includesProperty: #package) ifTrue: [
		index
			setProperty: #systemCategory
			toValue: ((aParentModelIndex valueOfProperty: #package) systemCategories at: aRowNumber).
		index
			setProperty: #systemCategoryPrefix
			toValue: (aParentModelIndex valueOfProperty: #package) systemCategoryPrefix.
		^ index].
	
	(aParentModelIndex includesProperty: #systemCategory) ifTrue: [
		index
			setProperty: #class
			toValue: ((SystemOrganization
				listAtCategoryNamed: (aParentModelIndex valueOfProperty: #systemCategory))
				at: aRowNumber).
		^ index].
	
	(aParentModelIndex includesProperty: #class) ifTrue: [ | class |
		class := Smalltalk at: (aParentModelIndex valueOfProperty: #class).
		index
			setProperty: #organization
			toValue: class organization.
		index
			setProperty: #protocol
			toValue: (class organization categories at: aRowNumber).
		^ index].

	(aParentModelIndex includesProperty: #protocol) ifTrue: [ | organization protocol |
		organization := aParentModelIndex valueOfProperty: #organization.
		protocol := aParentModelIndex valueOfProperty: #protocol.
		index
			setProperty: #method
			toValue: ((organization listAtCategoryNamed: protocol) at: aRowNumber).
		^ index].! !

!UiSmalltalkModel methodsFor: 'initialization' stamp: 'mt 10/14/2010 19:36:09.409'!
initialize

	"SystemChangeNotifier uniqueInstance
		notify: self ofAllSystemChangesUsing: #processNotification:."! !

!UiSmalltalkModel methodsFor: 'notifications' stamp: 'mt 10/14/2010 11:43:56.986'!
processNotification: anEvent

	| pkg pkgIndex sysIndex classIndex |
	(anEvent itemKind ~= #category and: [anEvent itemKind ~= #class])
		ifTrue: [^ self].
	
	pkg := PackageOrganizer default
		packageOfSystemCategory: anEvent itemCategory
		ifNone: [^ self].
	pkgIndex := (UiSimpleModelIndex
		row: (PackageOrganizer default packages indexOf: pkg)
		column: 1)
		model: self;
		setProperty: #package toValue: pkg.
	sysIndex := self
		indexRow: (pkg systemCategories indexOf: anEvent itemCategory)
		column: 1
		parent: pkgIndex.
	classIndex := self
		indexRow: ((SystemOrganization listAtCategoryNamed: anEvent itemCategory) indexOf: anEvent itemClass name)
		column: 1
		parent: sysIndex.
	
	anEvent itemKind = #category ifTrue: [
		anEvent isAdded ifTrue: [
			self rowsInsertedFor: pkgIndex from: sysIndex row to: sysIndex row.
			self rowsChangedFor: nil from: pkgIndex row to: pkgIndex row].
		anEvent isRemoved ifTrue: [
			self rowsRemovedFor: pkgIndex from: sysIndex row to: sysIndex row.
			self rowsChangedFor: nil from: pkgIndex row to: pkgIndex row].
		anEvent isRenamed ifTrue: [
			sysIndex := self
				indexRow: (pkg systemCategories indexOf: anEvent newName)
				column: 1
				parent: pkgIndex.
			self rowsChangedFor: pkgIndex from: sysIndex row to: sysIndex row]].

	anEvent itemKind = #class ifTrue: [
		anEvent isAdded ifTrue: [
			self rowsInsertedFor: sysIndex from: classIndex row to: classIndex row.
			self rowsChangedFor: pkgIndex from: sysIndex row to: sysIndex row].
		anEvent isRenamed ifTrue: [
			self rowsChangedFor: sysIndex from: classIndex row to: classIndex row].
		anEvent isRemoved ifTrue: [
			self rowsRemovedFor: sysIndex from: classIndex row to: classIndex row.
			self rowsChangedFor: pkgIndex from: sysIndex row to: sysIndex row]
		].
	
	anEvent itemKind = #method ifTrue: [
		].! !

!UiSmalltalkModel methodsFor: 'counts' stamp: 'mt 10/10/2010 14:13:30.029'!
rowCountFor: aParentModelIndex
	
	aParentModelIndex ifNil: [
		^ PackageOrganizer default packages size].
	
	aParentModelIndex column ~= 1 ifTrue: [^ 0].
	
	(aParentModelIndex includesProperty: #package) ifTrue: [
		^ (aParentModelIndex valueOfProperty: #package) systemCategories size].
	
	(aParentModelIndex includesProperty: #systemCategory) ifTrue: [
		^ (SystemOrganization
				listAtCategoryNamed: (aParentModelIndex valueOfProperty: #systemCategory)) size].
	
	(aParentModelIndex includesProperty: #class) ifTrue: [ | class |
		^ (Smalltalk at: (aParentModelIndex valueOfProperty: #class)) organization categories size].

	(aParentModelIndex includesProperty: #protocol) ifTrue: [ | organization protocol |
		organization := aParentModelIndex valueOfProperty: #organization.
		protocol := aParentModelIndex valueOfProperty: #protocol.
		^ (organization listAtCategoryNamed: protocol) size].
	
	^ 0! !

!UiSmalltalkModel methodsFor: 'model data' stamp: 'mt 10/14/2010 13:26:32.98'!
textFor: aModelIndex

	| col package systemCategory class protocol method |
	col := aModelIndex column.
	package := aModelIndex valueOfProperty: #package ifAbsent: [].
	systemCategory := aModelIndex valueOfProperty: #systemCategory  ifAbsent: [].
	class := aModelIndex valueOfProperty: #class ifAbsent: [].
	protocol := aModelIndex valueOfProperty: #protocol ifAbsent: [].
	method := aModelIndex valueOfProperty: #method ifAbsent: [].
	
	"Horizontal headers."
	aModelIndex row = 0 ifTrue: [
		col = 1 ifTrue: [^ '<b>Name</b>' asHtmlText].
		col = 2 ifTrue: [^ '<b>Size</b>' asHtmlText].
		col = 3 ifTrue: [^ '<b>Type</b>' asHtmlText]].
	
	"Vertical headers."
	aModelIndex column = 0 ifTrue: [
		^ aModelIndex row asString].
	
	package ifNotNil: [:p | 
		col = 1 ifTrue: [^ p name].
		col = 2 ifTrue: [^ ('<font color="#555555">', p systemCategories size asString, '</font>') asHtmlText].
		col = 3 ifTrue: [^ '<font color="#555555">package</font>' asHtmlText]].
	
	systemCategory ifNotNil: [:cat | 
		| prefix |
		prefix := aModelIndex valueOfProperty: #systemCategoryPrefix.
		
		col = 2 ifTrue: [^ ('<font color="#555555">', (SystemOrganization listAtCategoryNamed: cat) size asString, '</font>') asHtmlText].
		
		cat = prefix ifFalse: [cat := cat allButFirst: prefix size + 1].
		col = 1 ifTrue: [^ cat].
		col = 3 ifTrue: [^ '<font color="#555555">system category</font>' asHtmlText]].
	
	class ifNotNil: [:c |
		col = 1 ifTrue: [^ c].
		col = 2 ifTrue: [^ ('<font color="#555555">', (Smalltalk at: c) organization categories size asString, '</font>') asHtmlText].
		col = 3 ifTrue: [^ '<font color="#555555">class</font>' asHtmlText]].

	protocol ifNotNil: [:p |
		| organization |
		organization := aModelIndex valueOfProperty: #organization.
		col = 1 ifTrue: [^ p].
		col = 2 ifTrue: [^ ('<font color="#555555">', (organization listAtCategoryNamed: p) size asString, '</font>') asHtmlText].
		col = 3 ifTrue: [^ '<font color="#555555">protocol</font>' asHtmlText]].
	
	method ifNotNil: [:m |
		col = 1 ifTrue: [^ '#', m].
		col = 3 ifTrue: [^ '<font color="#555555">method</font>' asHtmlText]].
		
	^ nil! !

UiItemModel subclass: #UiTableModel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Views-Support'!

!UiTableModel commentStamp: 'mt 10/24/2010 11:09:38.118' prior: 0!
An abstract base class for a table-like model. Implement #rowCount and #columnCount and the data accessing functions, e.g., #textFor: and #iconFor:.!

UiTableModel subclass: #UiRessourceMonitorModel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Views-Models'!

!UiRessourceMonitorModel commentStamp: 'mt 12/14/2010 10:44:05.029' prior: 0!
Simple table model that accesses system state, e.g., number of world submorphs. See and extend #data.!

!UiRessourceMonitorModel methodsFor: 'counts' stamp: 'mt 10/24/2010 12:17:47.645'!
columnCount

	^ self data first size! !

!UiRessourceMonitorModel methodsFor: 'model data' stamp: 'mt 12/14/2010 13:28:05.699'!
data

	^ {
		{'world submorphs'. [ActiveWorld submorphs size]. nil. 'The number of all submorphs in the active world (<b>PasteUpMorph</b>)' asHtmlText}.
		{'event handlers'. [EventHandler allInstances size]. 2000. 'The number of all <b>EventHandler</b> instances.' asHtmlText}.
		{'signal emitters'. [SignalConnectionsRepository instance size]. 500. 'The number of all registered objects that have signals connected to somewhere.'}.
		{'icons'. Form allInstances count: [:f | f extent = (16@16)]. nil. 'The number of all 16x16 forms.'}.
		{'packages'. [PackageOrganizer default packages size]. nil. 'The number of all packages in this image.'}.
		{'classes'. [Smalltalk allClasses size]. nil. 'The number of all classes in this image.'}.
		{'traits'. [Smalltalk allTraits size]. nil. 'The number of all traits in this image.'}.
		{'system change sends'. [((SystemChangeNotifier uniqueInstance instVarNamed: #eventSource) actionMap values collect: [:list | list size]) sum]. nil. 'The number of all targets if a system change event occurs.'}}! !

!UiRessourceMonitorModel methodsFor: 'model data' stamp: 'mt 10/24/2010 12:26:46.923'!
iconFor: aModelIndex

	aModelIndex row = 0 ifTrue: [^ nil].
	
	aModelIndex column = 3 ifTrue: [
		| threshold value |
		threshold := (self data at: aModelIndex row) at: 3.
		value := ((self data at: aModelIndex row) at: 2) value.
		(threshold notNil and: [value > threshold])
			ifTrue: [^ UiDiagonaIcons icon0150Normal]
			ifFalse: [^ UiSilkIcons acceptIcon]].
	
	^ nil! !

!UiRessourceMonitorModel methodsFor: 'counts' stamp: 'mt 10/24/2010 12:17:29.637'!
rowCount

	^ self data size! !

!UiRessourceMonitorModel methodsFor: 'model data' stamp: 'mt 10/24/2010 12:21:47.164'!
textFor: aModelIndex

	aModelIndex row = 0 ifTrue: [
		aModelIndex column = 1 ifTrue: [^ 'Ressource'].
		aModelIndex column = 2 ifTrue: [^ 'Value'].
		aModelIndex column = 3 ifTrue: [^ 'Threshold'].
		aModelIndex column = 4 ifTrue: [^ 'Comments']].
	
	aModelIndex column = 0 ifTrue: [^ nil].
	

	^ ((self data at: aModelIndex row) at: aModelIndex column) value! !

!UiTableModel methodsFor: 'counts' stamp: 'mt 10/19/2010 10:45:41.824'!
columnCount

	self subclassResponsibility.! !

!UiTableModel methodsFor: 'counts' stamp: 'mt 10/19/2010 10:46:02.014'!
columnCountFor: aParentModelIndex

	^ self columnCount! !

!UiTableModel methodsFor: 'index generation' stamp: 'mt 10/19/2010 10:47:07.46'!
indexRow: aRowNumber column: aColumnNumber parent: aParentModelIndex

	^ (UiSimpleModelIndex row: aRowNumber column: aColumnNumber)
		model: self! !

!UiTableModel methodsFor: 'counts' stamp: 'mt 10/19/2010 10:45:38.172'!
rowCount

	self subclassResponsibility.! !

!UiTableModel methodsFor: 'counts' stamp: 'mt 10/19/2010 10:45:51.277'!
rowCountFor: aParentModelIndex

	^ self rowCount! !

UiTableModel subclass: #UiTableWidgetModel
	instanceVariableNames: 'items'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Sandbox'!

!UiTableWidgetModel methodsFor: 'counts' stamp: 'mt 11/2/2010 13:40:38.646'!
columnCount

	self items ifEmpty: [^ 0].
	^ self items first size! !

!UiTableWidgetModel methodsFor: 'counts' stamp: 'mt 11/2/2010 15:58:28.051'!
columnCount: anInteger

	| oldSize |
	anInteger = self columnCount ifTrue: [^ self].
	
	oldSize := self columnCount.

	self items do: [:row | 
		[row size < anInteger] whileTrue: [row addLast: UiTableWidgetItem new].
		[row size > anInteger] whileTrue: [row removeLast]].

	oldSize > self columnCount
		ifTrue: [self columnsRemovedFor: nil from: self columnCount + 1 to: oldSize]
		ifFalse: [self columnsInsertedFor: nil from: oldSize + 1 to: self columnCount].! !

!UiTableWidgetModel methodsFor: 'model data' stamp: 'mt 11/2/2010 16:22:35.439'!
iconFor: aPoint

	(aPoint x = 0 or: [aPoint y = 0])
		ifTrue: [^ nil].

	^ (self itemAt: aPoint) icon! !

!UiTableWidgetModel methodsFor: 'accessing' stamp: 'mt 11/2/2010 16:12:19.839'!
indexOf: anItem

	| row column |
	row := self items detect: [:r | r includes: anItem].
	^ (row indexOf: anItem)! !

!UiTableWidgetModel methodsFor: 'accessing' stamp: 'mt 11/2/2010 16:02:48.304'!
itemAt: aPoint

	^ (self items at: aPoint y) at: aPoint x! !

!UiTableWidgetModel methodsFor: 'accessing' stamp: 'mt 11/3/2010 10:09:35.64'!
itemAt: aPoint put: aTableWidgetItem

	((self items at: aPoint y) at: aPoint x) put: aTableWidgetItem.
	self triggerItemChangedAt: aPoint.! !

!UiTableWidgetModel methodsFor: 'accessing' stamp: 'mt 1/4/2011 10:31:05.482'!
items
	"Two-dimensional array of UiTableWidgetItem instances."
	
	^ items ifNil: [items := OrderedCollection new]! !

!UiTableWidgetModel methodsFor: 'model data' stamp: 'mt 11/2/2010 16:22:26.377'!
menuFor: aPoint

	(aPoint x = 0 or: [aPoint y = 0])
		ifTrue: [^ nil].
		
	^ (self itemAt: aPoint) menu! !

!UiTableWidgetModel methodsFor: 'counts' stamp: 'mt 11/2/2010 13:40:23.294'!
rowCount

	^ self items size! !

!UiTableWidgetModel methodsFor: 'counts' stamp: 'mt 11/3/2010 10:15:49.239'!
rowCount: anInteger

	| oldSize |
	self rowCount = anInteger ifTrue: [^ self].
	
	oldSize := self rowCount.

	[self rowCount > anInteger] whileTrue: [self items removeLast].	
	[self rowCount < anInteger] whileTrue: [self items addLast: ((Array new: self columnCount) collect: [:e | UiTableWidgetItem new]) asOrderedCollection].

	oldSize > self rowCount
		ifTrue: [self rowsRemovedFor: nil from: self rowCount + 1 to: oldSize]
		ifFalse: [self rowsInsertedFor: nil from: oldSize + 1 to: self rowCount].! !

!UiTableWidgetModel methodsFor: 'model data' stamp: 'mt 11/2/2010 16:21:50.017'!
textFor: aPoint

	aPoint x = 0 ifTrue: [^ aPoint y asString].
	aPoint y = 0 ifTrue: [^ aPoint x asString].
	
	^ (self itemAt: aPoint) text! !

!UiTableWidgetModel methodsFor: 'signal triggering' stamp: 'mt 1/4/2011 10:32:32.793'!
triggerItemChangedAt: aPoint

	"KLUDGE: Optimze this!! Not the whole row but a single item changed..."
	self rowsChangedFor: nil from: aPoint y to: aPoint y.! !

Object subclass: #UiItemOrder
	instanceVariableNames: 'map sortBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Views-Support'!

!UiItemOrder commentStamp: 'mt 10/16/2010 14:45:30.134' prior: 0!
A cached order of some items. Needs to be updated frequently.!

!UiItemOrder methodsFor: 'accessing' stamp: 'mt 10/16/2010 19:08:23.107'!
items: someItems at: anIndex
	
	self map ifNil: [^ someItems at: anIndex].
	^ someItems at: (self map at: anIndex)! !

!UiItemOrder methodsFor: 'enumerating' stamp: 'mt 10/16/2010 15:03:57.143'!
items: someItems collect: aBlock

	self map ifNil: [^ someItems collect: aBlock].
	^ map collect: [:index | aBlock value: (someItems at: index)]! !

!UiItemOrder methodsFor: 'enumerating' stamp: 'mt 10/16/2010 15:03:42.612'!
items: someItems do: aBlock

	self map ifNil: [^ someItems do: aBlock].
	map do: [:index | aBlock value: (someItems at: index)]! !

!UiItemOrder methodsFor: 'enumerating' stamp: 'mt 10/16/2010 19:12:41.82'!
items: someItems withIndexDo: aBlock

	self map ifNil: [^ someItems withIndexDo: aBlock].
	map do: [:index | aBlock value: (someItems at: index) value: index]! !

!UiItemOrder methodsFor: 'accessing' stamp: 'mt 10/16/2010 14:57:00.465'!
map

	^ map! !

!UiItemOrder methodsFor: 'accessing' stamp: 'mt 10/16/2010 14:57:44.975'!
map: anArray
	"Example: #(5 4 3 2 1) will revert a list with 5 items."

	map := anArray.! !

!UiItemOrder methodsFor: 'manual mapping' stamp: 'mt 10/16/2010 20:11:53.792'!
mapIndex: anIndex

	self map ifNil: [^ anIndex].
	^ self map at: anIndex! !

!UiItemOrder methodsFor: 'accessing' stamp: 'mt 10/16/2010 15:04:46.949'!
sortBlock

	^ sortBlock! !

!UiItemOrder methodsFor: 'accessing' stamp: 'mt 10/16/2010 14:44:45.717'!
sortBlock: aBlock

	sortBlock := aBlock.! !

!UiItemOrder methodsFor: 'manual mapping' stamp: 'mt 10/16/2010 20:12:05.571'!
unmapIndex: anIndex

	self map ifNil: [^ anIndex].
	^ self map indexOf: anIndex! !

!UiItemOrder methodsFor: 'updating' stamp: 'mt 10/16/2010 15:05:08.919'!
updateWith: someItems

	| sortedCopy |
	self sortBlock ifNil: [^ self map: nil].	
	
	sortedCopy := someItems copy sortBy: self sortBlock.
	map := Array new: someItems size.
	sortedCopy withIndexDo: [:item :index |
		map at: index put: (someItems indexOf: item)].! !

UiItemOrder subclass: #UiTreeItemOrder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Views-Support'!

!UiTreeItemOrder commentStamp: 'mt 11/2/2010 13:09:33.58' prior: 0!
An item order that considers the model index hierarchy (i.e., parent indices) while sorting.!

!UiTreeItemOrder methodsFor: 'updating' stamp: 'mt 10/16/2010 18:57:52.003'!
parent: currentParent list: aList result: result

	aList do: [:each |
		| index |
		index := each valueOfProperty: #modelIndex.
		index parent = currentParent ifTrue: [
			result add: each.
			self parent: index list: (aList copyWithout: each) result: result]].! !

!UiTreeItemOrder methodsFor: 'updating' stamp: 'mt 10/16/2010 18:59:59.151'!
rebuildTreeStructure: items

	| result |
	result := OrderedCollection new.
	self parent: nil list: items result: result.
	^ result! !

!UiTreeItemOrder methodsFor: 'updating' stamp: 'mt 10/16/2010 19:00:21.046'!
updateWith: someItems

	| sortedCopy |
	self sortBlock ifNil: [^ self map: nil].	
	
	sortedCopy := someItems copy sortBy: self sortBlock.
	sortedCopy := self rebuildTreeStructure: sortedCopy.
	
	map := Array new: someItems size.
	sortedCopy withIndexDo: [:item :index |
		map at: index put: (someItems indexOf: item)].! !

Object subclass: #UiItemWidgetItem
	instanceVariableNames: 'icon text menu enabled model'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Support'!

!UiItemWidgetItem commentStamp: 'mt 2/11/2011 14:49:11.463' prior: 0!
Container for item information to be used by item-based views.!

!UiItemWidgetItem methodsFor: 'actions' stamp: 'mt 11/2/2010 11:18:48.653'!
delete

	self model removeItem: self.! !

!UiItemWidgetItem methodsFor: 'accessing' stamp: 'mt 6/28/2010 21:22:12.894'!
enabled

	^ enabled ifNil: [enabled := true]! !

!UiItemWidgetItem methodsFor: 'accessing' stamp: 'mt 10/19/2010 20:05:01.021'!
enabled: aBoolean

	enabled := aBoolean.
	self triggerItemChanged.! !

!UiItemWidgetItem methodsFor: 'accessing' stamp: 'mt 6/28/2010 17:08:41.322'!
icon
	^ icon! !

!UiItemWidgetItem methodsFor: 'accessing' stamp: 'mt 10/19/2010 20:05:09.972'!
icon: anObject

	icon := anObject.
	self triggerItemChanged.! !

!UiItemWidgetItem methodsFor: 'accessing' stamp: 'mt 11/2/2010 11:30:12.165'!
menu

	^ menu! !

!UiItemWidgetItem methodsFor: 'accessing' stamp: 'mt 11/2/2010 11:30:36.258'!
menu: aMenuMorph

	menu := aMenuMorph.
	self triggerItemChanged.! !

!UiItemWidgetItem methodsFor: 'accessing' stamp: 'mt 10/19/2010 20:02:38.97'!
model

	^ model! !

!UiItemWidgetItem methodsFor: 'accessing' stamp: 'mt 10/19/2010 20:02:44.327'!
model: aModel

	model := aModel.! !

!UiItemWidgetItem methodsFor: 'accessing' stamp: 'mt 6/28/2010 17:08:41.407'!
text
	^ text! !

!UiItemWidgetItem methodsFor: 'accessing' stamp: 'mt 10/19/2010 20:04:56.723'!
text: anObject

	text := anObject.
	self triggerItemChanged.! !

!UiItemWidgetItem methodsFor: 'signal triggering' stamp: 'mt 11/2/2010 16:08:45.345'!
triggerItemChanged

	self model ifNotNil: [:m |
		m triggerItemChangedAt: (m indexOf: self)].! !

UiItemWidgetItem subclass: #UiListWidgetItem
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Support'!

!UiListWidgetItem commentStamp: 'mt 2/11/2011 14:49:26.64' prior: 0!
To be used in UiListWidget (item-based view).!

UiItemWidgetItem subclass: #UiTableWidgetItem
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Sandbox'!

Object subclass: #UiViewInfo
	instanceVariableNames: 'size items resizeMode headerItem'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Views-Support'!

!UiViewInfo commentStamp: 'mt 11/2/2010 12:54:36.518' prior: 0!
A information holder for columns and rows in a viewport. Stores extent and resizing behavior.

Represents an index of a viewports items.!

UiViewInfo subclass: #UiViewColumnInfo
	instanceVariableNames: 'vAlignment hAlignment'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Views-Support'!

!UiViewColumnInfo commentStamp: 'mt 10/9/2010 11:38:45.048' prior: 0!
Useful index element for tree viewport.!

!UiViewColumnInfo methodsFor: 'private' stamp: 'mt 10/14/2010 13:31:56.097'!
formatHeaderItem

	| backgroundColor |
	backgroundColor := Color gray: 0.85.
	headerItem
		vResizing: #spaceFill;
		fillStyle: ((GradientFillStyle ramp: {
			0.0 -> Color white.
			0.1-> (backgroundColor adjustBrightness: 0.05).
			0.6 -> (backgroundColor darker)})
			origin: headerItem topLeft;
			direction: 0 @ headerItem height);
		borderStyle: (BorderStyle raised width: 1).! !

!UiViewColumnInfo methodsFor: 'accessing' stamp: 'mt 10/14/2010 19:08:25.869'!
hAlignment

	^ hAlignment! !

!UiViewColumnInfo methodsFor: 'accessing' stamp: 'mt 10/14/2010 19:08:34.152'!
hAlignment: aSymbol

	hAlignment := aSymbol.! !

!UiViewColumnInfo methodsFor: 'initialization' stamp: 'mt 10/14/2010 19:08:54.097'!
initialize

	super initialize.
	self
		resize: 150;
		vAlignment: #top;
		hAlignment: #left.! !

!UiViewColumnInfo methodsFor: 'geometry' stamp: 'mt 10/19/2010 19:53:10.558'!
optimalSize
	"Return the width of the largest item."
	
	| max |
	max := 0.
	items do: [:item | 
		item hResizing ~= #spaceFill
			ifTrue: [max := max max: (item width + (item valueOfProperty: #indent))]].
	self headerItem submorphs ifNotEmpty: [
		max := max max: self headerItem submorphBounds width + 5. "font rendering bugfix" ].
	^ max! !

!UiViewColumnInfo methodsFor: 'geometry' stamp: 'mt 10/11/2010 16:28:52.324'!
resize: anInteger

	super resize: anInteger.
	self headerItem width: anInteger.
	self items do: [:item | 
		item hResizing = #spaceFill
			ifTrue: [item width: self width]].! !

!UiViewColumnInfo methodsFor: 'accessing' stamp: 'mt 10/14/2010 19:08:11.098'!
vAlignment

	^ vAlignment! !

!UiViewColumnInfo methodsFor: 'accessing' stamp: 'mt 10/14/2010 19:08:17.674'!
vAlignment: aSymbol

	vAlignment := aSymbol.! !

!UiViewColumnInfo methodsFor: 'accessing' stamp: 'mt 10/10/2010 12:52:12.794'!
width

	^ size! !

!UiViewColumnInfo methodsFor: 'accessing' stamp: 'mt 10/9/2010 18:15:41.705'!
width: anInteger

	self resize: anInteger.! !

!UiViewInfo methodsFor: 'initialization' stamp: 'mt 10/11/2010 17:51:31.693'!
clear

	items removeAll.! !

!UiViewInfo methodsFor: 'private' stamp: 'mt 10/14/2010 13:28:47.076'!
formatHeaderItem! !

!UiViewInfo methodsFor: 'accessing' stamp: 'mt 10/10/2010 12:46:28.423'!
headerItem

	^ headerItem! !

!UiViewInfo methodsFor: 'accessing' stamp: 'mt 10/19/2010 19:52:28.016'!
headerItem: aMorph
		
	headerItem := aMorph.
	self formatHeaderItem.! !

!UiViewInfo methodsFor: 'testing' stamp: 'mt 10/9/2010 19:57:43.188'!
includes: aModelIndex

	^ items anySatisfy: [:item | (item valueOfProperty: #modelIndex) = aModelIndex]! !

!UiViewInfo methodsFor: 'initialization' stamp: 'mt 10/11/2010 16:38:47.653'!
initialize

	super initialize.
	
	items := OrderedCollection new.
	resizeMode := #shrinkWrap.
	
	self headerItem: (Morph new extent: 5@5). "dummy header item"! !

!UiViewInfo methodsFor: 'accessing' stamp: 'mt 10/13/2010 15:42:39.671'!
itemAt: aModelIndex

	^ items detect: [:item | (item valueOfProperty: #modelIndex) = aModelIndex]! !

!UiViewInfo methodsFor: 'items query' stamp: 'mt 10/9/2010 18:19:16.151'!
itemBefore: anItem

	^ items before: anItem ifAbsent: []! !

!UiViewInfo methodsFor: 'items query' stamp: 'mt 10/9/2010 19:58:04.261'!
itemIndexFor: aModelIndex

	items withIndexDo: [:item :index |
		(item valueOfProperty: #modelIndex) = aModelIndex
			ifTrue: [^ index]].
	
	Error signal: 'Not found.'.! !

!UiViewInfo methodsFor: 'accessing' stamp: 'mt 10/9/2010 18:13:57.129'!
items

	^ items! !

!UiViewInfo methodsFor: 'geometry' stamp: 'mt 10/9/2010 18:16:09.336'!
optimalSize

	self subclassResponsibility.	! !

!UiViewInfo methodsFor: 'geometry' stamp: 'mt 10/10/2010 12:50:22.763'!
resize: aNumber

	size := aNumber.! !

!UiViewInfo methodsFor: 'accessing' stamp: 'mt 10/9/2010 18:09:54.303'!
resizeMode

	^ resizeMode! !

!UiViewInfo methodsFor: 'accessing' stamp: 'mt 10/9/2010 18:09:57.107'!
resizeMode: aSymbol
	"#rigid, #shrinkWrap, #spaceFill"

	resizeMode := aSymbol.! !

!UiViewInfo methodsFor: 'geometry' stamp: 'mt 10/9/2010 18:18:18.674'!
updateSize

	self resizeMode = #shrinkWrap
		ifTrue: [self resize: self optimalSize].! !

UiViewInfo subclass: #UiViewRowInfo
	instanceVariableNames: 'height'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Views-Support'!

!UiViewRowInfo commentStamp: 'mt 10/9/2010 11:38:35.657' prior: 0!
Useful index element for tree viewport.!

!UiViewRowInfo methodsFor: 'accessing' stamp: 'mt 10/9/2010 18:21:06.63'!
firstModelIndex
	
	^ items
		ifEmpty: [nil]
		ifNotEmpty: [(items first valueOfProperty: #modelIndex)]! !

!UiViewRowInfo methodsFor: 'private' stamp: 'mt 10/14/2010 13:37:25.357'!
formatHeaderItem

	| backgroundColor |
	backgroundColor := Color gray: 0.85.
	headerItem
		hResizing: #spaceFill;
		fillStyle: ((GradientFillStyle ramp: {
			0.0 -> Color white.
			0.1-> (backgroundColor adjustBrightness: 0.05).
			0.6 -> (backgroundColor darker)})
			origin: headerItem topLeft;
			direction: headerItem width @ 0);
		borderStyle: (BorderStyle raised width: 1).! !

!UiViewRowInfo methodsFor: 'accessing' stamp: 'mt 10/10/2010 12:51:44.846'!
height

	^ size! !

!UiViewRowInfo methodsFor: 'accessing' stamp: 'mt 10/9/2010 18:20:41.803'!
height: anInteger

	self resize: anInteger.! !

!UiViewRowInfo methodsFor: 'initialization' stamp: 'mt 10/14/2010 18:47:11.649'!
initialize

	super initialize.
	self resize: Preferences standardListFont height.! !

!UiViewRowInfo methodsFor: 'testing' stamp: 'mt 10/10/2010 10:27:44.554'!
isCollapsed

	^ self isExpanded not! !

!UiViewRowInfo methodsFor: 'testing' stamp: 'mt 10/10/2010 10:27:36.67'!
isExpanded

	^ items notEmpty and: [items first valueOfProperty: #isExpanded]! !

!UiViewRowInfo methodsFor: 'geometry' stamp: 'mt 10/19/2010 19:53:29.205'!
optimalSize
	"Return the height of the largest item."
	
	| max |
	max := 0.
	items do: [:item |
		item vResizing ~= #spaceFill
			ifTrue: [max := max max: item height]].
	self headerItem submorphs ifNotEmpty: [
		max := max max: self headerItem submorphBounds height].
	^ max! !

!UiViewRowInfo methodsFor: 'accessing' stamp: 'mt 10/9/2010 12:36:24.14'!
parentModelIndex
	"All items in a row should have the same parent model index. So take the first item to access."
	
	^ items
		ifEmpty: [nil]
		ifNotEmpty: [(items first valueOfProperty: #modelIndex) parent]! !

!UiViewRowInfo methodsFor: 'geometry' stamp: 'mt 10/11/2010 16:29:08.358'!
resize: anInteger

	super resize: anInteger.
	self headerItem height: anInteger.
	self items do: [:item | 
		item vResizing = #spaceFill
			ifTrue: [item height: self height]].! !

Object subclass: #UiViewSelection
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Views-Support'!

!UiViewSelection commentStamp: 'mt 11/2/2010 13:06:42.058' prior: 0!
A view selection keeps track of all selected cells in a viewport as well as the current cell which is normally only the last selected cell.!

UiViewSelection subclass: #UiViewExtendedSelection
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Views-Support'!

UiViewSelection subclass: #UiViewMultiSelection
	instanceVariableNames: 'cells'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Views-Support'!

!UiViewMultiSelection methodsFor: 'as yet unclassified' stamp: 'mt 10/11/2010 14:58:34.066'!
add: aCellIndex event: aUserInputEvent

	"Invert the cell."
	self cells
		remove: aCellIndex
		ifAbsent: [self cells add: aCellIndex].
		
	self selectionChanged.! !

!UiViewMultiSelection methodsFor: 'as yet unclassified' stamp: 'mt 10/11/2010 14:56:08.346'!
cells

	^ cells ifNil: [cells := Set new]! !

UiViewSelection subclass: #UiViewNullSelection
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Views-Support'!

!UiViewNullSelection commentStamp: 'mt 10/11/2010 14:09:45.699' prior: 0!
No selection of cells possible.!

!UiViewNullSelection methodsFor: 'add/remove' stamp: 'mt 10/11/2010 14:09:04.349'!
add: aCellIndex event: aUserInputEvent

	"Ignore."! !

!UiViewNullSelection methodsFor: 'accessing' stamp: 'mt 10/11/2010 14:08:50.077'!
cells

	^ #()! !

!UiViewNullSelection methodsFor: 'accessing' stamp: 'mt 10/23/2010 10:00:00.921'!
currentCell

	^ nil! !

!UiViewNullSelection methodsFor: 'accessing' stamp: 'mt 10/23/2010 10:00:08.721'!
currentCell: anIndex

! !

!UiViewSelection methodsFor: 'add/remove' stamp: 'mt 10/11/2010 09:07:25.205'!
add: aCellIndex event: aUserInputEvent! !

!UiViewSelection methodsFor: 'accessing' stamp: 'mt 10/11/2010 09:13:15.101'!
cells
	"Return an array with all selected cells."
	
	self subclassResponsibility.! !

!UiViewSelection methodsFor: 'add/remove' stamp: 'mt 10/11/2010 17:57:02.818'!
clear
! !

!UiViewSelection methodsFor: 'accessing' stamp: 'mt 10/16/2010 08:15:39.961'!
currentCell
	"Return the current cell. Normally the last added one."

	self subclassResponsibility.! !

!UiViewSelection methodsFor: 'accessing' stamp: 'mt 10/16/2010 14:23:46.96'!
currentCell: aPoint

	self subclassResponsibility.! !

!UiViewSelection methodsFor: 'signals' stamp: 'mt 10/16/2010 14:26:07.47'!
currentCellChanged

	self emit.! !

!UiViewSelection methodsFor: 'signals' stamp: 'mt 10/11/2010 09:12:03.242'!
selectionChanged

	self emit.! !

UiViewSelection subclass: #UiViewSingleSelection
	instanceVariableNames: 'selectedCell'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Views-Support'!

!UiViewSingleSelection methodsFor: 'add/remove' stamp: 'mt 10/30/2010 18:29:34.958'!
add: aCellIndex event: aUserInputEvent

	aCellIndex ifNil: [^ self].
	selectedCell := aCellIndex.
	self
		selectionChanged;
		currentCellChanged.! !

!UiViewSingleSelection methodsFor: 'accessing' stamp: 'mt 10/11/2010 14:35:26.499'!
cells

	^ selectedCell
		ifNil: [#()]
		ifNotNil: [{selectedCell}]! !

!UiViewSingleSelection methodsFor: 'add/remove' stamp: 'mt 10/11/2010 17:57:25.989'!
clear

	selectedCell := nil.
	self selectionChanged.! !

!UiViewSingleSelection methodsFor: 'accessing' stamp: 'mt 10/16/2010 08:16:06.717'!
currentCell

	^ selectedCell! !

!UiViewSingleSelection methodsFor: 'accessing' stamp: 'mt 10/16/2010 14:26:19.682'!
currentCell: aPoint

	selectedCell := aPoint.
	self currentCellChanged.! !

Object subclass: #UserInterface
	instanceVariableNames: 'panel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Core'!

!UserInterface commentStamp: 'mt 6/27/2010 09:43:15.463' prior: 0!
I am the abstract base class of an auto-generated User Interface.!

UserInterface subclass: #UiMessageListDialogUi
	instanceVariableNames: 'messageList unnamedMorph1 unnamedMorph2 okButton cancelButton unnamedMorph3'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Dialogs'!

!UiMessageListDialogUi methodsFor: 'accessing' stamp: 'mt 10/30/2010 18:40:00.302'!
cancelButton
	"nil"
	
	^ cancelButton! !

!UiMessageListDialogUi methodsFor: 'ui - private' stamp: 'mt 10/30/2010 18:40:00.356'!
initializePanel
	"This code is auto-generated. DO NOT modify it because another generation step will overwrite all changes."
	
	panel := UiContainer new.
	panel changeTableLayout.
	panel extent: (250@150).
	panel position: (0@0).
	panel hResizing: (#rigid).
	panel vResizing: (#rigid).
	panel cellInset: (4).
	panel cellPositioning: (#center).
	panel cellSpacing: (#none).
	panel layoutInset: (4).
	panel listCentering: (#topLeft).
	panel listDirection: (#topToBottom).
	panel listSpacing: (#none).
	panel maxCellSize: (1073741823).
	panel minCellSize: (0).
	panel wrapCentering: (#topLeft).
	panel wrapDirection: (#none).
	panel frameFractions: (0@0 corner: 1@1).
	panel frameOffsets: (0@0 corner: 0@0).
	panel balloonText: (nil).
	panel balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.945)).
	panel color: ((Color r: 0.8 g: 0.8 b: 0.8)).
	panel borderWidth: (0).
	panel borderStyle2: (#simple).
	panel borderColor: (Color black).
	panel setProperty: #objectName toValue: 'panel'.
	messageList := UiListWidget new.
	messageList extent: (242@115).
	messageList position: (4@4).
	messageList hResizing: (#spaceFill).
	messageList vResizing: (#spaceFill).
	messageList cellInset: (0).
	messageList cellPositioning: (#center).
	messageList cellSpacing: (#none).
	messageList layoutInset: (0).
	messageList listCentering: (#topLeft).
	messageList listDirection: (#topToBottom).
	messageList listSpacing: (#none).
	messageList maxCellSize: (1073741823).
	messageList minCellSize: (0).
	messageList wrapCentering: (#topLeft).
	messageList wrapDirection: (#none).
	messageList frameFractions: (0@0 corner: 1@1).
	messageList frameOffsets: (0@0 corner: 0@0).
	messageList balloonText: (nil).
	messageList balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.949)).
	messageList modelClass: (UiListWidgetModel).
	messageList horizontalHeaderVisible: (false).
	messageList verticalHeaderVisible: (false).
	messageList setProperty: #objectName toValue: 'messageList'.
	panel addMorphBack: messageList.
	unnamedMorph1 := UiContainer new.
	unnamedMorph1 changeTableLayout.
	unnamedMorph1 extent: (242@22).
	unnamedMorph1 position: (4@123).
	unnamedMorph1 hResizing: (#spaceFill).
	unnamedMorph1 vResizing: (#shrinkWrap).
	unnamedMorph1 cellInset: (4).
	unnamedMorph1 cellPositioning: (#center).
	unnamedMorph1 cellSpacing: (#none).
	unnamedMorph1 layoutInset: (0).
	unnamedMorph1 listCentering: (#topLeft).
	unnamedMorph1 listDirection: (#leftToRight).
	unnamedMorph1 listSpacing: (#none).
	unnamedMorph1 maxCellSize: (1073741823).
	unnamedMorph1 minCellSize: (0).
	unnamedMorph1 wrapCentering: (#topLeft).
	unnamedMorph1 wrapDirection: (#none).
	unnamedMorph1 frameFractions: (0@0 corner: 1@1).
	unnamedMorph1 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph1 balloonText: (nil).
	unnamedMorph1 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.945)).
	unnamedMorph1 color: (Color transparent).
	unnamedMorph1 borderWidth: (0).
	unnamedMorph1 borderStyle2: (#simple).
	unnamedMorph1 borderColor: (Color black).
	unnamedMorph2 := UiSpacer new.
	unnamedMorph2 extent: (61@20).
	unnamedMorph2 position: (4@124).
	unnamedMorph2 hResizing: (#spaceFill).
	unnamedMorph2 vResizing: (#rigid).
	unnamedMorph2 cellInset: (4).
	unnamedMorph2 cellPositioning: (#center).
	unnamedMorph2 cellSpacing: (#none).
	unnamedMorph2 layoutInset: (4).
	unnamedMorph2 listCentering: (#topLeft).
	unnamedMorph2 listDirection: (#topToBottom).
	unnamedMorph2 listSpacing: (#none).
	unnamedMorph2 maxCellSize: (1073741823).
	unnamedMorph2 minCellSize: (0).
	unnamedMorph2 wrapCentering: (#topLeft).
	unnamedMorph2 wrapDirection: (#none).
	unnamedMorph2 frameFractions: (0@0 corner: 1@1).
	unnamedMorph2 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph2 balloonText: (nil).
	unnamedMorph2 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.945)).
	unnamedMorph2 color: (Color blue).
	unnamedMorph2 borderWidth: (0).
	unnamedMorph2 borderStyle2: (#simple).
	unnamedMorph2 borderColor: (Color black).
	unnamedMorph2 orientation: (#horizontal).
	unnamedMorph1 addMorphBack: unnamedMorph2.
	okButton := UiPushButton new.
	okButton changeTableLayout.
	okButton extent: (42@21).
	okButton position: (69@123).
	okButton hResizing: (#shrinkWrap).
	okButton vResizing: (#shrinkWrap).
	okButton cellInset: (4).
	okButton cellPositioning: (#center).
	okButton cellSpacing: (#none).
	okButton layoutInset: (2@0 corner: 2@0).
	okButton listCentering: (#topLeft).
	okButton listDirection: (#leftToRight).
	okButton listSpacing: (#none).
	okButton maxCellSize: (1073741823).
	okButton minCellSize: (0).
	okButton wrapCentering: (#topLeft).
	okButton wrapDirection: (#none).
	okButton frameFractions: (0@0 corner: 1@1).
	okButton frameOffsets: (0@0 corner: 0@0).
	okButton balloonText: (nil).
	okButton balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.945)).
	okButton setProperty: #iconByDesigner toValue: 'UiSilkIcons acceptIcon'.
	okButton icon: (UiSilkIcons acceptIcon).
	okButton text: ('OK').
	okButton color: ((Color r: 0.8 g: 0.8 b: 0.8)).
	okButton checkable: (false).
	okButton checked: (false).
	okButton autoExclusive: (false).
	okButton setProperty: #objectName toValue: 'okButton'.
	unnamedMorph1 addMorphBack: okButton.
	cancelButton := UiPushButton new.
	cancelButton changeTableLayout.
	cancelButton extent: (62@21).
	cancelButton position: (117@123).
	cancelButton hResizing: (#shrinkWrap).
	cancelButton vResizing: (#shrinkWrap).
	cancelButton cellInset: (4).
	cancelButton cellPositioning: (#center).
	cancelButton cellSpacing: (#none).
	cancelButton layoutInset: (2@0 corner: 2@0).
	cancelButton listCentering: (#topLeft).
	cancelButton listDirection: (#leftToRight).
	cancelButton listSpacing: (#none).
	cancelButton maxCellSize: (1073741823).
	cancelButton minCellSize: (0).
	cancelButton wrapCentering: (#topLeft).
	cancelButton wrapDirection: (#none).
	cancelButton frameFractions: (0@0 corner: 1@1).
	cancelButton frameOffsets: (0@0 corner: 0@0).
	cancelButton balloonText: (nil).
	cancelButton balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.945)).
	cancelButton setProperty: #iconByDesigner toValue: 'UiFugueIcons crossCircleIcon'.
	cancelButton icon: (UiFugueIcons crossCircleIcon).
	cancelButton text: ('Cancel').
	cancelButton color: ((Color r: 0.8 g: 0.8 b: 0.8)).
	cancelButton checkable: (false).
	cancelButton checked: (false).
	cancelButton autoExclusive: (false).
	cancelButton setProperty: #objectName toValue: 'cancelButton'.
	unnamedMorph1 addMorphBack: cancelButton.
	unnamedMorph3 := UiSpacer new.
	unnamedMorph3 extent: (61@20).
	unnamedMorph3 position: (185@124).
	unnamedMorph3 hResizing: (#spaceFill).
	unnamedMorph3 vResizing: (#rigid).
	unnamedMorph3 cellInset: (4).
	unnamedMorph3 cellPositioning: (#center).
	unnamedMorph3 cellSpacing: (#none).
	unnamedMorph3 layoutInset: (4).
	unnamedMorph3 listCentering: (#topLeft).
	unnamedMorph3 listDirection: (#topToBottom).
	unnamedMorph3 listSpacing: (#none).
	unnamedMorph3 maxCellSize: (1073741823).
	unnamedMorph3 minCellSize: (0).
	unnamedMorph3 wrapCentering: (#topLeft).
	unnamedMorph3 wrapDirection: (#none).
	unnamedMorph3 frameFractions: (0@0 corner: 1@1).
	unnamedMorph3 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph3 balloonText: (nil).
	unnamedMorph3 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.945)).
	unnamedMorph3 color: (Color blue).
	unnamedMorph3 borderWidth: (0).
	unnamedMorph3 borderStyle2: (#simple).
	unnamedMorph3 borderColor: (Color black).
	unnamedMorph3 orientation: (#horizontal).
	unnamedMorph1 addMorphBack: unnamedMorph3.
	panel addMorphBack: unnamedMorph1.
	panel setProperty: #uiClassName toValue: 'UiMessageListDialog'.! !

!UiMessageListDialogUi methodsFor: 'accessing' stamp: 'mt 10/30/2010 18:40:00.183'!
messageList
	"nil"
	
	^ messageList! !

!UiMessageListDialogUi methodsFor: 'accessing' stamp: 'mt 10/30/2010 18:40:00.266'!
okButton
	"nil"
	
	^ okButton! !

UserInterface subclass: #UiSaveDesignUi
	instanceVariableNames: 'unnamedMorph1 unnamedMorph2 unnamedMorph3 unnamedMorph4 okButton cancelButton'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Sandbox'!

!UiSaveDesignUi methodsFor: 'accessing' stamp: 'mt 12/30/2010 13:40:37.024'!
cancelButton
	"nil"
	
	^ cancelButton! !

!UiSaveDesignUi methodsFor: 'ui - private' stamp: 'mt 12/30/2010 13:40:37.105'!
initializePanel
	"This code is auto-generated. DO NOT modify it because another generation step will overwrite all changes."
	
	panel := UiContainer new.
	panel changeTableLayout.
	panel extent: (713@450).
	panel position: (0@0).
	panel hResizing: (#rigid).
	panel vResizing: (#rigid).
	panel cellInset: (4).
	panel cellPositioning: (#center).
	panel cellSpacing: (#none).
	panel layoutInset: (4).
	panel listCentering: (#topLeft).
	panel listDirection: (#topToBottom).
	panel listSpacing: (#none).
	panel maxCellSize: (1073741823).
	panel minCellSize: (0).
	panel wrapCentering: (#topLeft).
	panel wrapDirection: (#none).
	panel frameFractions: (0@0 corner: 1@1).
	panel frameOffsets: (0@0 corner: 0@0).
	panel balloonText: (nil).
	panel balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.945)).
	panel color: (Color transparent).
	panel borderWidth: (0).
	panel borderStyle2: (#simple).
	panel borderColor: (Color black).
	panel setProperty: #objectName toValue: 'panel'.
	unnamedMorph1 := UiContainer new.
	unnamedMorph1 extent: (705@415).
	unnamedMorph1 position: (4@4).
	unnamedMorph1 hResizing: (#spaceFill).
	unnamedMorph1 vResizing: (#spaceFill).
	unnamedMorph1 cellInset: (4).
	unnamedMorph1 cellPositioning: (#center).
	unnamedMorph1 cellSpacing: (#none).
	unnamedMorph1 layoutInset: (4).
	unnamedMorph1 listCentering: (#topLeft).
	unnamedMorph1 listDirection: (#topToBottom).
	unnamedMorph1 listSpacing: (#none).
	unnamedMorph1 maxCellSize: (1073741823).
	unnamedMorph1 minCellSize: (0).
	unnamedMorph1 wrapCentering: (#topLeft).
	unnamedMorph1 wrapDirection: (#none).
	unnamedMorph1 frameFractions: (0@0 corner: 1@1).
	unnamedMorph1 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph1 balloonText: (nil).
	unnamedMorph1 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.945)).
	unnamedMorph1 color: (Color transparent).
	unnamedMorph1 borderWidth: (0).
	unnamedMorph1 borderStyle2: (#simple).
	unnamedMorph1 borderColor: (Color black).
	unnamedMorph2 := UiListView new.
	unnamedMorph2 extent: (389@217).
	unnamedMorph2 position: (171@117).
	unnamedMorph2 hResizing: (#rigid).
	unnamedMorph2 vResizing: (#rigid).
	unnamedMorph2 cellInset: (0).
	unnamedMorph2 cellPositioning: (#center).
	unnamedMorph2 cellSpacing: (#none).
	unnamedMorph2 layoutInset: (0).
	unnamedMorph2 listCentering: (#topLeft).
	unnamedMorph2 listDirection: (#topToBottom).
	unnamedMorph2 listSpacing: (#none).
	unnamedMorph2 maxCellSize: (1073741823).
	unnamedMorph2 minCellSize: (0).
	unnamedMorph2 wrapCentering: (#topLeft).
	unnamedMorph2 wrapDirection: (#none).
	unnamedMorph2 frameFractions: (0@0 corner: 1@1).
	unnamedMorph2 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph2 modelClass: (nil).
	unnamedMorph2 horizontalHeaderVisible: (false).
	unnamedMorph2 verticalHeaderVisible: (false).
	unnamedMorph2 selectionBehavior: (#selectRows).
	unnamedMorph1 addMorphBack: unnamedMorph2.
	panel addMorphBack: unnamedMorph1.
	unnamedMorph3 := UiContainer new.
	unnamedMorph3 changeTableLayout.
	unnamedMorph3 extent: (705@22).
	unnamedMorph3 position: (4@423).
	unnamedMorph3 hResizing: (#spaceFill).
	unnamedMorph3 vResizing: (#shrinkWrap).
	unnamedMorph3 cellInset: (4).
	unnamedMorph3 cellPositioning: (#center).
	unnamedMorph3 cellSpacing: (#none).
	unnamedMorph3 layoutInset: (0).
	unnamedMorph3 listCentering: (#topLeft).
	unnamedMorph3 listDirection: (#leftToRight).
	unnamedMorph3 listSpacing: (#none).
	unnamedMorph3 maxCellSize: (1073741823).
	unnamedMorph3 minCellSize: (0).
	unnamedMorph3 wrapCentering: (#topLeft).
	unnamedMorph3 wrapDirection: (#none).
	unnamedMorph3 frameFractions: (0@0 corner: 1@1).
	unnamedMorph3 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph3 balloonText: (nil).
	unnamedMorph3 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.945)).
	unnamedMorph3 color: (Color transparent).
	unnamedMorph3 borderWidth: (0).
	unnamedMorph3 borderStyle2: (#simple).
	unnamedMorph3 borderColor: (Color black).
	unnamedMorph4 := UiSpacer new.
	unnamedMorph4 extent: (581@20).
	unnamedMorph4 position: (4@424).
	unnamedMorph4 hResizing: (#spaceFill).
	unnamedMorph4 vResizing: (#rigid).
	unnamedMorph4 cellInset: (4).
	unnamedMorph4 cellPositioning: (#center).
	unnamedMorph4 cellSpacing: (#none).
	unnamedMorph4 layoutInset: (4).
	unnamedMorph4 listCentering: (#topLeft).
	unnamedMorph4 listDirection: (#topToBottom).
	unnamedMorph4 listSpacing: (#none).
	unnamedMorph4 maxCellSize: (1073741823).
	unnamedMorph4 minCellSize: (0).
	unnamedMorph4 wrapCentering: (#topLeft).
	unnamedMorph4 wrapDirection: (#none).
	unnamedMorph4 frameFractions: (0@0 corner: 1@1).
	unnamedMorph4 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph4 balloonText: (nil).
	unnamedMorph4 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.945)).
	unnamedMorph4 color: (Color blue).
	unnamedMorph4 borderWidth: (0).
	unnamedMorph4 borderStyle2: (#simple).
	unnamedMorph4 borderColor: (Color black).
	unnamedMorph4 orientation: (#horizontal).
	unnamedMorph3 addMorphBack: unnamedMorph4.
	okButton := UiPushButton new.
	okButton changeTableLayout.
	okButton extent: (50@21).
	okButton position: (589@423).
	okButton hResizing: (#shrinkWrap).
	okButton vResizing: (#shrinkWrap).
	okButton cellInset: (4).
	okButton cellPositioning: (#center).
	okButton cellSpacing: (#none).
	okButton layoutInset: (2@0 corner: 2@0).
	okButton listCentering: (#topLeft).
	okButton listDirection: (#leftToRight).
	okButton listSpacing: (#none).
	okButton maxCellSize: (1073741823).
	okButton minCellSize: (0).
	okButton wrapCentering: (#topLeft).
	okButton wrapDirection: (#none).
	okButton frameFractions: (0@0 corner: 1@1).
	okButton frameOffsets: (0@0 corner: 0@0).
	okButton balloonText: (nil).
	okButton balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.945)).
	okButton setProperty: #iconByDesigner toValue: 'UiSilkIcons diskIcon'.
	okButton icon: (UiSilkIcons diskIcon).
	okButton text: ('Save').
	okButton color: ((Color r: 0.8 g: 0.8 b: 0.8)).
	okButton checkable: (false).
	okButton checked: (false).
	okButton autoExclusive: (false).
	okButton setProperty: #objectName toValue: 'okButton'.
	unnamedMorph3 addMorphBack: okButton.
	cancelButton := UiPushButton new.
	cancelButton changeTableLayout.
	cancelButton extent: (62@21).
	cancelButton position: (645@423).
	cancelButton hResizing: (#shrinkWrap).
	cancelButton vResizing: (#shrinkWrap).
	cancelButton cellInset: (4).
	cancelButton cellPositioning: (#center).
	cancelButton cellSpacing: (#none).
	cancelButton layoutInset: (2@0 corner: 2@0).
	cancelButton listCentering: (#topLeft).
	cancelButton listDirection: (#leftToRight).
	cancelButton listSpacing: (#none).
	cancelButton maxCellSize: (1073741823).
	cancelButton minCellSize: (0).
	cancelButton wrapCentering: (#topLeft).
	cancelButton wrapDirection: (#none).
	cancelButton frameFractions: (0@0 corner: 1@1).
	cancelButton frameOffsets: (0@0 corner: 0@0).
	cancelButton balloonText: (nil).
	cancelButton balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.945)).
	cancelButton setProperty: #iconByDesigner toValue: 'UiFugueIcons crossCircleIcon'.
	cancelButton icon: (UiFugueIcons crossCircleIcon).
	cancelButton text: ('Cancel').
	cancelButton color: ((Color r: 0.8 g: 0.8 b: 0.8)).
	cancelButton checkable: (false).
	cancelButton checked: (false).
	cancelButton autoExclusive: (false).
	cancelButton setProperty: #objectName toValue: 'cancelButton'.
	unnamedMorph3 addMorphBack: cancelButton.
	panel addMorphBack: unnamedMorph3.
	panel setProperty: #uiClassName toValue: 'UiSaveDesign'.! !

!UiSaveDesignUi methodsFor: 'accessing' stamp: 'mt 12/30/2010 13:40:36.895'!
okButton
	"nil"
	
	^ okButton! !

UserInterface subclass: #UiSystemBrowserUi
	instanceVariableNames: 'unnamedMorph1 unnamedMorph2 unnamedMorph3 unnamedMorph4 unnamedMorph5 packageTree unnamedMorph6 unnamedMorph7 classTree unnamedMorph8 unnamedMorph9 unnamedMorph10 unnamedMorph11 unnamedMorph12 unnamedMorph13 unnamedMorph14 unnamedMorph15 protocolTree unnamedMorph16 unnamedMorph17 unnamedMorph18 unnamedMorph19 unnamedMorph20 unnamedMorph21'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Dialogs'!

!UiSystemBrowserUi methodsFor: 'accessing' stamp: 'mt 11/14/2010 16:40:25.704'!
classTree
	"nil"
	
	^ classTree! !

!UiSystemBrowserUi methodsFor: 'ui - private' stamp: 'mt 11/14/2010 16:40:25.832'!
initializePanel
	"This code is auto-generated. DO NOT modify it because another generation step will overwrite all changes."
	
	panel := UiContainer new.
	panel extent: (952@629).
	panel position: (0@0).
	panel hResizing: (#rigid).
	panel vResizing: (#rigid).
	panel cellInset: (4).
	panel cellPositioning: (#center).
	panel cellSpacing: (#none).
	panel layoutInset: (4).
	panel listCentering: (#topLeft).
	panel listDirection: (#topToBottom).
	panel listSpacing: (#none).
	panel maxCellSize: (1073741823).
	panel minCellSize: (0).
	panel wrapCentering: (#topLeft).
	panel wrapDirection: (#none).
	panel frameFractions: (0@0 corner: 1@1).
	panel frameOffsets: (0@0 corner: 0@0).
	panel balloonText: (nil).
	panel balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.949)).
	panel color: (Color transparent).
	panel borderWidth: (0).
	panel borderStyle2: (#simple).
	panel borderColor: (Color black).
	panel setProperty: #objectName toValue: 'panel'.
	panel setProperty: #objectDescription toValue: 'This is the refreshed version of the classic Squeak system browser.'.
	unnamedMorph1 := UiContainer new.
	unnamedMorph1 changeProportionalLayout.
	unnamedMorph1 extent: (464@210).
	unnamedMorph1 position: (38@19).
	unnamedMorph1 hResizing: (#rigid).
	unnamedMorph1 vResizing: (#rigid).
	unnamedMorph1 cellInset: (4).
	unnamedMorph1 cellPositioning: (#center).
	unnamedMorph1 cellSpacing: (#none).
	unnamedMorph1 layoutInset: (4).
	unnamedMorph1 listCentering: (#topLeft).
	unnamedMorph1 listDirection: (#topToBottom).
	unnamedMorph1 listSpacing: (#none).
	unnamedMorph1 maxCellSize: (1073741823).
	unnamedMorph1 minCellSize: (0).
	unnamedMorph1 wrapCentering: (#topLeft).
	unnamedMorph1 wrapDirection: (#none).
	unnamedMorph1 frameFractions: (0@0 corner: 1@1).
	unnamedMorph1 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph1 balloonText: (nil).
	unnamedMorph1 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.949)).
	unnamedMorph1 color: (Color transparent).
	unnamedMorph1 borderWidth: (0).
	unnamedMorph1 borderStyle2: (#simple).
	unnamedMorph1 borderColor: (Color black).
	unnamedMorph2 := UiContainer new.
	unnamedMorph2 changeTableLayout.
	unnamedMorph2 extent: (91@202).
	unnamedMorph2 position: (42@23).
	unnamedMorph2 hResizing: (#spaceFill).
	unnamedMorph2 vResizing: (#spaceFill).
	unnamedMorph2 cellInset: (5).
	unnamedMorph2 cellPositioning: (#center).
	unnamedMorph2 cellSpacing: (#none).
	unnamedMorph2 layoutInset: (0).
	unnamedMorph2 listCentering: (#topLeft).
	unnamedMorph2 listDirection: (#topToBottom).
	unnamedMorph2 listSpacing: (#none).
	unnamedMorph2 maxCellSize: (1073741823).
	unnamedMorph2 minCellSize: (0).
	unnamedMorph2 wrapCentering: (#topLeft).
	unnamedMorph2 wrapDirection: (#none).
	unnamedMorph2 frameFractions: (0@0 corner: 0.2@1).
	unnamedMorph2 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph2 balloonText: (nil).
	unnamedMorph2 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.949)).
	unnamedMorph2 color: (Color transparent).
	unnamedMorph2 borderWidth: (0).
	unnamedMorph2 borderStyle2: (#simple).
	unnamedMorph2 borderColor: (Color black).
	unnamedMorph3 := UiContainer new.
	unnamedMorph3 changeTableLayout.
	unnamedMorph3 extent: (91@20).
	unnamedMorph3 position: (42@23).
	unnamedMorph3 hResizing: (#spaceFill).
	unnamedMorph3 vResizing: (#shrinkWrap).
	unnamedMorph3 cellInset: (5).
	unnamedMorph3 cellPositioning: (#center).
	unnamedMorph3 cellSpacing: (#none).
	unnamedMorph3 layoutInset: (0).
	unnamedMorph3 listCentering: (#topLeft).
	unnamedMorph3 listDirection: (#leftToRight).
	unnamedMorph3 listSpacing: (#none).
	unnamedMorph3 maxCellSize: (1073741823).
	unnamedMorph3 minCellSize: (0).
	unnamedMorph3 wrapCentering: (#topLeft).
	unnamedMorph3 wrapDirection: (#none).
	unnamedMorph3 frameFractions: (0@0 corner: 1@1).
	unnamedMorph3 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph3 balloonText: (nil).
	unnamedMorph3 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.949)).
	unnamedMorph3 color: (Color transparent).
	unnamedMorph3 borderWidth: (0).
	unnamedMorph3 borderStyle2: (#simple).
	unnamedMorph3 borderColor: (Color black).
	unnamedMorph4 := UiToolButton new.
	unnamedMorph4 changeTableLayout.
	unnamedMorph4 extent: (22@18).
	unnamedMorph4 position: (42@24).
	unnamedMorph4 hResizing: (#shrinkWrap).
	unnamedMorph4 vResizing: (#shrinkWrap).
	unnamedMorph4 cellInset: (4).
	unnamedMorph4 cellPositioning: (#center).
	unnamedMorph4 cellSpacing: (#none).
	unnamedMorph4 layoutInset: (2@0 corner: 2@0).
	unnamedMorph4 listCentering: (#center).
	unnamedMorph4 listDirection: (#leftToRight).
	unnamedMorph4 listSpacing: (#none).
	unnamedMorph4 maxCellSize: (1073741823).
	unnamedMorph4 minCellSize: (0).
	unnamedMorph4 wrapCentering: (#topLeft).
	unnamedMorph4 wrapDirection: (#none).
	unnamedMorph4 frameFractions: (0@0 corner: 1@1).
	unnamedMorph4 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph4 balloonText: ('Show packages in a tree.').
	unnamedMorph4 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.949)).
	unnamedMorph4 setProperty: #iconByDesigner toValue: 'UiFugueIcons blueDocumentTreeIcon'.
	unnamedMorph4 icon: (UiFugueIcons blueDocumentTreeIcon).
	unnamedMorph4 text: ('').
	unnamedMorph4 color: ((Color r: 0.8 g: 0.8 b: 0.8)).
	unnamedMorph4 checkable: (true).
	unnamedMorph4 checked: (true).
	unnamedMorph4 autoExclusive: (true).
	unnamedMorph4 autoRaise: (false).
	unnamedMorph4 buttonStyle: (#iconOnly).
	unnamedMorph3 addMorphBack: unnamedMorph4.
	unnamedMorph5 := UiLineEdit new.
	unnamedMorph5 extent: (64@20).
	unnamedMorph5 position: (69@23).
	unnamedMorph5 hResizing: (#spaceFill).
	unnamedMorph5 vResizing: (#rigid).
	unnamedMorph5 cellInset: (0).
	unnamedMorph5 cellPositioning: (#center).
	unnamedMorph5 cellSpacing: (#none).
	unnamedMorph5 layoutInset: (0).
	unnamedMorph5 listCentering: (#topLeft).
	unnamedMorph5 listDirection: (#topToBottom).
	unnamedMorph5 listSpacing: (#none).
	unnamedMorph5 maxCellSize: (1073741823).
	unnamedMorph5 minCellSize: (0).
	unnamedMorph5 wrapCentering: (#topLeft).
	unnamedMorph5 wrapDirection: (#none).
	unnamedMorph5 frameFractions: (0@0 corner: 1@1).
	unnamedMorph5 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph5 balloonText: (nil).
	unnamedMorph5 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.949)).
	unnamedMorph5 theText: (nil).
	unnamedMorph5 readOnly: (false).
	unnamedMorph5 outerBorderWidth: (0).
	unnamedMorph5 autoConvert: (false).
	unnamedMorph5 autoAccept: (false).
	unnamedMorph5 helpText: ('Search...').
	unnamedMorph3 addMorphBack: unnamedMorph5.
	unnamedMorph2 addMorphBack: unnamedMorph3.
	packageTree := UiTreeView new.
	packageTree extent: (91@177).
	packageTree position: (42@48).
	packageTree hResizing: (#spaceFill).
	packageTree vResizing: (#spaceFill).
	packageTree cellInset: (0).
	packageTree cellPositioning: (#center).
	packageTree cellSpacing: (#none).
	packageTree layoutInset: (0).
	packageTree listCentering: (#topLeft).
	packageTree listDirection: (#topToBottom).
	packageTree listSpacing: (#none).
	packageTree maxCellSize: (1073741823).
	packageTree minCellSize: (0).
	packageTree wrapCentering: (#topLeft).
	packageTree wrapDirection: (#none).
	packageTree frameFractions: (0@0 corner: 1@1).
	packageTree frameOffsets: (0@0 corner: 0@0).
	packageTree modelClass: (nil).
	packageTree horizontalHeaderVisible: (true).
	packageTree verticalHeaderVisible: (false).
	packageTree setProperty: #objectName toValue: 'packageTree'.
	unnamedMorph2 addMorphBack: packageTree.
	unnamedMorph1 addMorphBack: unnamedMorph2.
	unnamedMorph6 := UiContainer new.
	unnamedMorph6 changeTableLayout.
	unnamedMorph6 extent: (183@202).
	unnamedMorph6 position: (133@23).
	unnamedMorph6 hResizing: (#spaceFill).
	unnamedMorph6 vResizing: (#spaceFill).
	unnamedMorph6 cellInset: (5).
	unnamedMorph6 cellPositioning: (#center).
	unnamedMorph6 cellSpacing: (#none).
	unnamedMorph6 layoutInset: (0).
	unnamedMorph6 listCentering: (#topLeft).
	unnamedMorph6 listDirection: (#topToBottom).
	unnamedMorph6 listSpacing: (#none).
	unnamedMorph6 maxCellSize: (1073741823).
	unnamedMorph6 minCellSize: (0).
	unnamedMorph6 wrapCentering: (#topLeft).
	unnamedMorph6 wrapDirection: (#none).
	unnamedMorph6 frameFractions: (0.2@0 corner: 0.6@1).
	unnamedMorph6 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph6 balloonText: (nil).
	unnamedMorph6 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.949)).
	unnamedMorph6 color: (Color transparent).
	unnamedMorph6 borderWidth: (0).
	unnamedMorph6 borderStyle2: (#simple).
	unnamedMorph6 borderColor: (Color black).
	unnamedMorph7 := UiLineEdit new.
	unnamedMorph7 extent: (183@20).
	unnamedMorph7 position: (133@23).
	unnamedMorph7 hResizing: (#spaceFill).
	unnamedMorph7 vResizing: (#rigid).
	unnamedMorph7 cellInset: (0).
	unnamedMorph7 cellPositioning: (#center).
	unnamedMorph7 cellSpacing: (#none).
	unnamedMorph7 layoutInset: (0).
	unnamedMorph7 listCentering: (#topLeft).
	unnamedMorph7 listDirection: (#topToBottom).
	unnamedMorph7 listSpacing: (#none).
	unnamedMorph7 maxCellSize: (1073741823).
	unnamedMorph7 minCellSize: (0).
	unnamedMorph7 wrapCentering: (#topLeft).
	unnamedMorph7 wrapDirection: (#none).
	unnamedMorph7 frameFractions: (0@0 corner: 1@1).
	unnamedMorph7 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph7 balloonText: (nil).
	unnamedMorph7 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.949)).
	unnamedMorph7 theText: ('').
	unnamedMorph7 readOnly: (false).
	unnamedMorph7 outerBorderWidth: (0).
	unnamedMorph7 autoConvert: (false).
	unnamedMorph7 autoAccept: (false).
	unnamedMorph7 helpText: ('Search...').
	unnamedMorph6 addMorphBack: unnamedMorph7.
	classTree := UiTreeView new.
	classTree extent: (183@149).
	classTree position: (133@48).
	classTree hResizing: (#spaceFill).
	classTree vResizing: (#spaceFill).
	classTree cellInset: (0).
	classTree cellPositioning: (#center).
	classTree cellSpacing: (#none).
	classTree layoutInset: (0).
	classTree listCentering: (#topLeft).
	classTree listDirection: (#topToBottom).
	classTree listSpacing: (#none).
	classTree maxCellSize: (1073741823).
	classTree minCellSize: (0).
	classTree wrapCentering: (#topLeft).
	classTree wrapDirection: (#none).
	classTree frameFractions: (0@0 corner: 1@1).
	classTree frameOffsets: (0@0 corner: 0@0).
	classTree modelClass: (nil).
	classTree horizontalHeaderVisible: (true).
	classTree verticalHeaderVisible: (false).
	classTree setProperty: #objectName toValue: 'classTree'.
	unnamedMorph6 addMorphBack: classTree.
	unnamedMorph8 := UiButtonGroup new.
	unnamedMorph8 changeTableLayout.
	unnamedMorph8 extent: (183@23).
	unnamedMorph8 position: (133@202).
	unnamedMorph8 hResizing: (#spaceFill).
	unnamedMorph8 vResizing: (#shrinkWrap).
	unnamedMorph8 cellInset: (0).
	unnamedMorph8 cellPositioning: (#center).
	unnamedMorph8 cellSpacing: (#none).
	unnamedMorph8 layoutInset: (0).
	unnamedMorph8 listCentering: (#topLeft).
	unnamedMorph8 listDirection: (#leftToRight).
	unnamedMorph8 listSpacing: (#none).
	unnamedMorph8 maxCellSize: (1073741823).
	unnamedMorph8 minCellSize: (0).
	unnamedMorph8 wrapCentering: (#topLeft).
	unnamedMorph8 wrapDirection: (#none).
	unnamedMorph8 frameFractions: (0@0 corner: 1@1).
	unnamedMorph8 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph8 balloonText: (nil).
	unnamedMorph8 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.949)).
	unnamedMorph8 color: ((Color r: 0.8 g: 0.8 b: 0.8)).
	unnamedMorph8 borderWidth: (1).
	unnamedMorph8 borderStyle2: (#inset).
	unnamedMorph8 borderColor: (#inset).
	unnamedMorph9 := UiToolButton new.
	unnamedMorph9 changeTableLayout.
	unnamedMorph9 extent: (89@21).
	unnamedMorph9 position: (134@203).
	unnamedMorph9 hResizing: (#spaceFill).
	unnamedMorph9 vResizing: (#shrinkWrap).
	unnamedMorph9 cellInset: (4).
	unnamedMorph9 cellPositioning: (#center).
	unnamedMorph9 cellSpacing: (#none).
	unnamedMorph9 layoutInset: (2@0 corner: 2@0).
	unnamedMorph9 listCentering: (#center).
	unnamedMorph9 listDirection: (#leftToRight).
	unnamedMorph9 listSpacing: (#none).
	unnamedMorph9 maxCellSize: (1073741823).
	unnamedMorph9 minCellSize: (0).
	unnamedMorph9 wrapCentering: (#topLeft).
	unnamedMorph9 wrapDirection: (#none).
	unnamedMorph9 frameFractions: (0@0 corner: 1@1).
	unnamedMorph9 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph9 balloonText: ('instance').
	unnamedMorph9 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.949)).
	unnamedMorph9 setProperty: #iconByDesigner toValue: 'UiFugueIcons documentMediumIcon'.
	unnamedMorph9 icon: (UiFugueIcons documentMediumIcon).
	unnamedMorph9 text: ('instance').
	unnamedMorph9 color: ((Color r: 0.8 g: 0.8 b: 0.8)).
	unnamedMorph9 checkable: (true).
	unnamedMorph9 checked: (true).
	unnamedMorph9 autoExclusive: (true).
	unnamedMorph9 autoRaise: (false).
	unnamedMorph9 buttonStyle: (#textBesideIcon).
	unnamedMorph8 addMorphBack: unnamedMorph9.
	unnamedMorph10 := UiToolButton new.
	unnamedMorph10 changeTableLayout.
	unnamedMorph10 extent: (22@18).
	unnamedMorph10 position: (223@204).
	unnamedMorph10 hResizing: (#shrinkWrap).
	unnamedMorph10 vResizing: (#shrinkWrap).
	unnamedMorph10 cellInset: (4).
	unnamedMorph10 cellPositioning: (#center).
	unnamedMorph10 cellSpacing: (#none).
	unnamedMorph10 layoutInset: (2@0 corner: 2@0).
	unnamedMorph10 listCentering: (#topLeft).
	unnamedMorph10 listDirection: (#leftToRight).
	unnamedMorph10 listSpacing: (#none).
	unnamedMorph10 maxCellSize: (1073741823).
	unnamedMorph10 minCellSize: (0).
	unnamedMorph10 wrapCentering: (#topLeft).
	unnamedMorph10 wrapDirection: (#none).
	unnamedMorph10 frameFractions: (0@0 corner: 1@1).
	unnamedMorph10 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph10 balloonText: ('comment').
	unnamedMorph10 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.949)).
	unnamedMorph10 setProperty: #iconByDesigner toValue: 'UiFugueIcons balloonIcon'.
	unnamedMorph10 icon: (UiFugueIcons balloonIcon).
	unnamedMorph10 text: ('ToolButton').
	unnamedMorph10 color: ((Color r: 0.8 g: 0.8 b: 0.8)).
	unnamedMorph10 checkable: (true).
	unnamedMorph10 checked: (false).
	unnamedMorph10 autoExclusive: (true).
	unnamedMorph10 autoRaise: (false).
	unnamedMorph10 buttonStyle: (#iconOnly).
	unnamedMorph8 addMorphBack: unnamedMorph10.
	unnamedMorph11 := UiToolButton new.
	unnamedMorph11 changeTableLayout.
	unnamedMorph11 extent: (70@21).
	unnamedMorph11 position: (245@203).
	unnamedMorph11 hResizing: (#spaceFill).
	unnamedMorph11 vResizing: (#shrinkWrap).
	unnamedMorph11 cellInset: (4).
	unnamedMorph11 cellPositioning: (#center).
	unnamedMorph11 cellSpacing: (#none).
	unnamedMorph11 layoutInset: (2@0 corner: 2@0).
	unnamedMorph11 listCentering: (#center).
	unnamedMorph11 listDirection: (#leftToRight).
	unnamedMorph11 listSpacing: (#none).
	unnamedMorph11 maxCellSize: (1073741823).
	unnamedMorph11 minCellSize: (0).
	unnamedMorph11 wrapCentering: (#topLeft).
	unnamedMorph11 wrapDirection: (#none).
	unnamedMorph11 frameFractions: (0@0 corner: 1@1).
	unnamedMorph11 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph11 balloonText: ('class').
	unnamedMorph11 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.949)).
	unnamedMorph11 setProperty: #iconByDesigner toValue: 'UiFugueIcons bookIcon'.
	unnamedMorph11 icon: (UiFugueIcons bookIcon).
	unnamedMorph11 text: ('class').
	unnamedMorph11 color: ((Color r: 0.8 g: 0.8 b: 0.8)).
	unnamedMorph11 checkable: (true).
	unnamedMorph11 checked: (false).
	unnamedMorph11 autoExclusive: (true).
	unnamedMorph11 autoRaise: (false).
	unnamedMorph11 buttonStyle: (#textBesideIcon).
	unnamedMorph8 addMorphBack: unnamedMorph11.
	unnamedMorph6 addMorphBack: unnamedMorph8.
	unnamedMorph1 addMorphBack: unnamedMorph6.
	unnamedMorph12 := UiContainer new.
	unnamedMorph12 changeTableLayout.
	unnamedMorph12 extent: (182@202).
	unnamedMorph12 position: (316@23).
	unnamedMorph12 hResizing: (#spaceFill).
	unnamedMorph12 vResizing: (#spaceFill).
	unnamedMorph12 cellInset: (5).
	unnamedMorph12 cellPositioning: (#center).
	unnamedMorph12 cellSpacing: (#none).
	unnamedMorph12 layoutInset: (0).
	unnamedMorph12 listCentering: (#topLeft).
	unnamedMorph12 listDirection: (#topToBottom).
	unnamedMorph12 listSpacing: (#none).
	unnamedMorph12 maxCellSize: (1073741823).
	unnamedMorph12 minCellSize: (0).
	unnamedMorph12 wrapCentering: (#topLeft).
	unnamedMorph12 wrapDirection: (#none).
	unnamedMorph12 frameFractions: (0.6@0 corner: 1@1).
	unnamedMorph12 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph12 balloonText: (nil).
	unnamedMorph12 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.949)).
	unnamedMorph12 color: (Color transparent).
	unnamedMorph12 borderWidth: (0).
	unnamedMorph12 borderStyle2: (#simple).
	unnamedMorph12 borderColor: (Color black).
	unnamedMorph13 := UiContainer new.
	unnamedMorph13 changeTableLayout.
	unnamedMorph13 extent: (182@20).
	unnamedMorph13 position: (316@23).
	unnamedMorph13 hResizing: (#spaceFill).
	unnamedMorph13 vResizing: (#shrinkWrap).
	unnamedMorph13 cellInset: (4).
	unnamedMorph13 cellPositioning: (#center).
	unnamedMorph13 cellSpacing: (#none).
	unnamedMorph13 layoutInset: (0).
	unnamedMorph13 listCentering: (#topLeft).
	unnamedMorph13 listDirection: (#leftToRight).
	unnamedMorph13 listSpacing: (#none).
	unnamedMorph13 maxCellSize: (1073741823).
	unnamedMorph13 minCellSize: (0).
	unnamedMorph13 wrapCentering: (#topLeft).
	unnamedMorph13 wrapDirection: (#none).
	unnamedMorph13 frameFractions: (0@0 corner: 1@1).
	unnamedMorph13 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph13 balloonText: (nil).
	unnamedMorph13 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.949)).
	unnamedMorph13 color: (Color transparent).
	unnamedMorph13 borderWidth: (0).
	unnamedMorph13 borderStyle2: (#simple).
	unnamedMorph13 borderColor: (Color black).
	unnamedMorph14 := UiToolButton new.
	unnamedMorph14 changeTableLayout.
	unnamedMorph14 extent: (22@18).
	unnamedMorph14 position: (316@24).
	unnamedMorph14 hResizing: (#shrinkWrap).
	unnamedMorph14 vResizing: (#shrinkWrap).
	unnamedMorph14 cellInset: (4).
	unnamedMorph14 cellPositioning: (#center).
	unnamedMorph14 cellSpacing: (#none).
	unnamedMorph14 layoutInset: (2@0 corner: 2@0).
	unnamedMorph14 listCentering: (#center).
	unnamedMorph14 listDirection: (#leftToRight).
	unnamedMorph14 listSpacing: (#none).
	unnamedMorph14 maxCellSize: (1073741823).
	unnamedMorph14 minCellSize: (0).
	unnamedMorph14 wrapCentering: (#topLeft).
	unnamedMorph14 wrapDirection: (#none).
	unnamedMorph14 frameFractions: (0@0 corner: 1@1).
	unnamedMorph14 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph14 balloonText: ('Show packages in a tree.').
	unnamedMorph14 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.949)).
	unnamedMorph14 setProperty: #iconByDesigner toValue: 'UiFugueIcons blueDocumentTreeIcon'.
	unnamedMorph14 icon: (UiFugueIcons blueDocumentTreeIcon).
	unnamedMorph14 text: ('').
	unnamedMorph14 color: ((Color r: 0.8 g: 0.8 b: 0.8)).
	unnamedMorph14 checkable: (true).
	unnamedMorph14 checked: (true).
	unnamedMorph14 autoExclusive: (true).
	unnamedMorph14 autoRaise: (false).
	unnamedMorph14 buttonStyle: (#iconOnly).
	unnamedMorph13 addMorphBack: unnamedMorph14.
	unnamedMorph15 := UiLineEdit new.
	unnamedMorph15 extent: (156@20).
	unnamedMorph15 position: (342@23).
	unnamedMorph15 hResizing: (#spaceFill).
	unnamedMorph15 vResizing: (#rigid).
	unnamedMorph15 cellInset: (0).
	unnamedMorph15 cellPositioning: (#center).
	unnamedMorph15 cellSpacing: (#none).
	unnamedMorph15 layoutInset: (0).
	unnamedMorph15 listCentering: (#topLeft).
	unnamedMorph15 listDirection: (#topToBottom).
	unnamedMorph15 listSpacing: (#none).
	unnamedMorph15 maxCellSize: (1073741823).
	unnamedMorph15 minCellSize: (0).
	unnamedMorph15 wrapCentering: (#topLeft).
	unnamedMorph15 wrapDirection: (#none).
	unnamedMorph15 frameFractions: (0@0 corner: 1@1).
	unnamedMorph15 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph15 balloonText: (nil).
	unnamedMorph15 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.949)).
	unnamedMorph15 theText: (nil).
	unnamedMorph15 readOnly: (false).
	unnamedMorph15 outerBorderWidth: (0).
	unnamedMorph15 autoConvert: (false).
	unnamedMorph15 autoAccept: (false).
	unnamedMorph15 helpText: ('Search...').
	unnamedMorph13 addMorphBack: unnamedMorph15.
	unnamedMorph12 addMorphBack: unnamedMorph13.
	protocolTree := UiTreeView new.
	protocolTree extent: (182@177).
	protocolTree position: (316@48).
	protocolTree hResizing: (#spaceFill).
	protocolTree vResizing: (#spaceFill).
	protocolTree cellInset: (0).
	protocolTree cellPositioning: (#center).
	protocolTree cellSpacing: (#none).
	protocolTree layoutInset: (0).
	protocolTree listCentering: (#topLeft).
	protocolTree listDirection: (#topToBottom).
	protocolTree listSpacing: (#none).
	protocolTree maxCellSize: (1073741823).
	protocolTree minCellSize: (0).
	protocolTree wrapCentering: (#topLeft).
	protocolTree wrapDirection: (#none).
	protocolTree frameFractions: (0@0 corner: 1@1).
	protocolTree frameOffsets: (0@0 corner: 0@0).
	protocolTree modelClass: (nil).
	protocolTree horizontalHeaderVisible: (true).
	protocolTree verticalHeaderVisible: (false).
	protocolTree setProperty: #objectName toValue: 'protocolTree'.
	unnamedMorph12 addMorphBack: protocolTree.
	unnamedMorph1 addMorphBack: unnamedMorph12.
	panel addMorphBack: unnamedMorph1.
	unnamedMorph16 := UiContainer new.
	unnamedMorph16 extent: (787@122).
	unnamedMorph16 position: (65@357).
	unnamedMorph16 hResizing: (#rigid).
	unnamedMorph16 vResizing: (#rigid).
	unnamedMorph16 cellInset: (4).
	unnamedMorph16 cellPositioning: (#center).
	unnamedMorph16 cellSpacing: (#none).
	unnamedMorph16 layoutInset: (4).
	unnamedMorph16 listCentering: (#topLeft).
	unnamedMorph16 listDirection: (#topToBottom).
	unnamedMorph16 listSpacing: (#none).
	unnamedMorph16 maxCellSize: (1073741823).
	unnamedMorph16 minCellSize: (0).
	unnamedMorph16 wrapCentering: (#topLeft).
	unnamedMorph16 wrapDirection: (#none).
	unnamedMorph16 frameFractions: (0@0 corner: 1@1).
	unnamedMorph16 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph16 balloonText: (nil).
	unnamedMorph16 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.949)).
	unnamedMorph16 color: (Color transparent).
	unnamedMorph16 borderWidth: (0).
	unnamedMorph16 borderStyle2: (#simple).
	unnamedMorph16 borderColor: (Color black).
	unnamedMorph17 := UiButtonGroup new.
	unnamedMorph17 changeTableLayout.
	unnamedMorph17 extent: (90@20).
	unnamedMorph17 position: (275@403).
	unnamedMorph17 hResizing: (#shrinkWrap).
	unnamedMorph17 vResizing: (#shrinkWrap).
	unnamedMorph17 cellInset: (0).
	unnamedMorph17 cellPositioning: (#center).
	unnamedMorph17 cellSpacing: (#none).
	unnamedMorph17 layoutInset: (0).
	unnamedMorph17 listCentering: (#topLeft).
	unnamedMorph17 listDirection: (#leftToRight).
	unnamedMorph17 listSpacing: (#none).
	unnamedMorph17 maxCellSize: (1073741823).
	unnamedMorph17 minCellSize: (0).
	unnamedMorph17 wrapCentering: (#topLeft).
	unnamedMorph17 wrapDirection: (#none).
	unnamedMorph17 frameFractions: (0@0 corner: 1@1).
	unnamedMorph17 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph17 balloonText: (nil).
	unnamedMorph17 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.949)).
	unnamedMorph17 color: ((Color r: 0.8 g: 0.8 b: 0.8)).
	unnamedMorph17 borderWidth: (1).
	unnamedMorph17 borderStyle2: (#inset).
	unnamedMorph17 borderColor: (#inset).
	unnamedMorph18 := UiToolButton new.
	unnamedMorph18 changeTableLayout.
	unnamedMorph18 extent: (22@18).
	unnamedMorph18 position: (276@404).
	unnamedMorph18 hResizing: (#shrinkWrap).
	unnamedMorph18 vResizing: (#shrinkWrap).
	unnamedMorph18 cellInset: (4).
	unnamedMorph18 cellPositioning: (#center).
	unnamedMorph18 cellSpacing: (#none).
	unnamedMorph18 layoutInset: (2@0 corner: 2@0).
	unnamedMorph18 listCentering: (#center).
	unnamedMorph18 listDirection: (#leftToRight).
	unnamedMorph18 listSpacing: (#none).
	unnamedMorph18 maxCellSize: (1073741823).
	unnamedMorph18 minCellSize: (0).
	unnamedMorph18 wrapCentering: (#topLeft).
	unnamedMorph18 wrapDirection: (#none).
	unnamedMorph18 frameFractions: (0@0 corner: 1@1).
	unnamedMorph18 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph18 balloonText: ('instance').
	unnamedMorph18 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.949)).
	unnamedMorph18 setProperty: #iconByDesigner toValue: 'UiSilkIcons pageWhiteTextIcon'.
	unnamedMorph18 icon: (UiSilkIcons pageWhiteTextIcon).
	unnamedMorph18 text: ('').
	unnamedMorph18 color: ((Color r: 0.8 g: 0.8 b: 0.8)).
	unnamedMorph18 checkable: (true).
	unnamedMorph18 checked: (true).
	unnamedMorph18 autoExclusive: (true).
	unnamedMorph18 autoRaise: (false).
	unnamedMorph18 buttonStyle: (#iconOnly).
	unnamedMorph17 addMorphBack: unnamedMorph18.
	unnamedMorph19 := UiToolButton new.
	unnamedMorph19 changeTableLayout.
	unnamedMorph19 extent: (22@18).
	unnamedMorph19 position: (298@404).
	unnamedMorph19 hResizing: (#shrinkWrap).
	unnamedMorph19 vResizing: (#shrinkWrap).
	unnamedMorph19 cellInset: (4).
	unnamedMorph19 cellPositioning: (#center).
	unnamedMorph19 cellSpacing: (#none).
	unnamedMorph19 layoutInset: (2@0 corner: 2@0).
	unnamedMorph19 listCentering: (#center).
	unnamedMorph19 listDirection: (#leftToRight).
	unnamedMorph19 listSpacing: (#none).
	unnamedMorph19 maxCellSize: (1073741823).
	unnamedMorph19 minCellSize: (0).
	unnamedMorph19 wrapCentering: (#topLeft).
	unnamedMorph19 wrapDirection: (#none).
	unnamedMorph19 frameFractions: (0@0 corner: 1@1).
	unnamedMorph19 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph19 balloonText: ('pretty print').
	unnamedMorph19 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.949)).
	unnamedMorph19 setProperty: #iconByDesigner toValue: 'UiSilkIcons pageIcon'.
	unnamedMorph19 icon: (UiSilkIcons pageIcon).
	unnamedMorph19 text: ('').
	unnamedMorph19 color: ((Color r: 0.8 g: 0.8 b: 0.8)).
	unnamedMorph19 checkable: (true).
	unnamedMorph19 checked: (false).
	unnamedMorph19 autoExclusive: (true).
	unnamedMorph19 autoRaise: (false).
	unnamedMorph19 buttonStyle: (#iconOnly).
	unnamedMorph17 addMorphBack: unnamedMorph19.
	unnamedMorph20 := UiToolButton new.
	unnamedMorph20 changeTableLayout.
	unnamedMorph20 extent: (22@18).
	unnamedMorph20 position: (320@404).
	unnamedMorph20 hResizing: (#shrinkWrap).
	unnamedMorph20 vResizing: (#shrinkWrap).
	unnamedMorph20 cellInset: (4).
	unnamedMorph20 cellPositioning: (#center).
	unnamedMorph20 cellSpacing: (#none).
	unnamedMorph20 layoutInset: (2@0 corner: 2@0).
	unnamedMorph20 listCentering: (#topLeft).
	unnamedMorph20 listDirection: (#leftToRight).
	unnamedMorph20 listSpacing: (#none).
	unnamedMorph20 maxCellSize: (1073741823).
	unnamedMorph20 minCellSize: (0).
	unnamedMorph20 wrapCentering: (#topLeft).
	unnamedMorph20 wrapDirection: (#none).
	unnamedMorph20 frameFractions: (0@0 corner: 1@1).
	unnamedMorph20 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph20 balloonText: ('decompile').
	unnamedMorph20 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.949)).
	unnamedMorph20 setProperty: #iconByDesigner toValue: 'UiSilkIcons pageWhiteGearIcon'.
	unnamedMorph20 icon: (UiSilkIcons pageWhiteGearIcon).
	unnamedMorph20 text: ('').
	unnamedMorph20 color: ((Color r: 0.8 g: 0.8 b: 0.8)).
	unnamedMorph20 checkable: (true).
	unnamedMorph20 checked: (false).
	unnamedMorph20 autoExclusive: (true).
	unnamedMorph20 autoRaise: (false).
	unnamedMorph20 buttonStyle: (#iconOnly).
	unnamedMorph17 addMorphBack: unnamedMorph20.
	unnamedMorph21 := UiToolButton new.
	unnamedMorph21 changeTableLayout.
	unnamedMorph21 extent: (22@18).
	unnamedMorph21 position: (342@404).
	unnamedMorph21 hResizing: (#shrinkWrap).
	unnamedMorph21 vResizing: (#shrinkWrap).
	unnamedMorph21 cellInset: (4).
	unnamedMorph21 cellPositioning: (#center).
	unnamedMorph21 cellSpacing: (#none).
	unnamedMorph21 layoutInset: (2@0 corner: 2@0).
	unnamedMorph21 listCentering: (#center).
	unnamedMorph21 listDirection: (#leftToRight).
	unnamedMorph21 listSpacing: (#none).
	unnamedMorph21 maxCellSize: (1073741823).
	unnamedMorph21 minCellSize: (0).
	unnamedMorph21 wrapCentering: (#topLeft).
	unnamedMorph21 wrapDirection: (#none).
	unnamedMorph21 frameFractions: (0@0 corner: 1@1).
	unnamedMorph21 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph21 balloonText: ('byte codes').
	unnamedMorph21 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.949)).
	unnamedMorph21 setProperty: #iconByDesigner toValue: 'UiSilkIcons pageWhiteCodeIcon'.
	unnamedMorph21 icon: (UiSilkIcons pageWhiteCodeIcon).
	unnamedMorph21 text: ('').
	unnamedMorph21 color: ((Color r: 0.8 g: 0.8 b: 0.8)).
	unnamedMorph21 checkable: (true).
	unnamedMorph21 checked: (false).
	unnamedMorph21 autoExclusive: (true).
	unnamedMorph21 autoRaise: (false).
	unnamedMorph21 buttonStyle: (#iconOnly).
	unnamedMorph17 addMorphBack: unnamedMorph21.
	unnamedMorph16 addMorphBack: unnamedMorph17.
	panel addMorphBack: unnamedMorph16.
	panel setProperty: #uiClassName toValue: 'UiSystemBrowser'.! !

!UiSystemBrowserUi methodsFor: 'accessing' stamp: 'mt 11/14/2010 16:40:25.663'!
packageTree
	"nil"
	
	^ packageTree! !

!UiSystemBrowserUi methodsFor: 'accessing' stamp: 'mt 11/14/2010 16:40:25.754'!
protocolTree
	"nil"
	
	^ protocolTree! !

!UserInterface class methodsFor: 'testing' stamp: 'mt 10/30/2010 13:10:11.609'!
isTemplate
	"This is an indicator for the designer to use this user interface as design template."
	
	^ false! !

!UserInterface methodsFor: 'ui - private' stamp: 'mt 6/27/2010 09:48:47.906'!
initializePanel
	"Subclass will contain auto-generated code for this."
	
	self subclassResponsibility.! !

!UserInterface methodsFor: 'ui - private' stamp: 'mt 6/27/2010 09:45:06.967'!
panel
	"Returns the root panel for this UI."
	
	^ panel! !

!UserInterface methodsFor: 'ui - general' stamp: 'mt 10/28/2010 16:20:46.228'!
setupUi: aMorph
	"Configures this UI to be used in the given morph."
	
	self initializePanel.
	
	aMorph extent < self panel extent
		ifTrue: [aMorph extent: self panel extent].
	
	self panel
		hResizing: #spaceFill;
		vResizing: #spaceFill.
	
	aMorph
		changeTableLayout;
		color: self panel color;
		addMorphBack: self panel.! !

!Form methodsFor: '*widgets-support' stamp: 'mt 9/2/2010 11:52:12.191'!
asGrayScale2

	^ self collectColors: [:c | c isTransparent
		ifTrue: [c]
		ifFalse: [Color gray: c luminance]]! !

!Form methodsFor: '*widgets-support' stamp: 'mt 7/16/2010 13:08:02.826'!
clippedTo: aPoint
 	"Return a copy of this form that is clipped to the given size around the center."
	
	| newForm |
	newForm := self class extent: aPoint depth: depth.
	^ newForm copyBits: ((0@0 corner: aPoint) translateBy: (self extent - aPoint) // 2) from: self at: 0@0
		clippingBox: newForm boundingBox rule: Form over fillColor: nil! !
